unit AprarP1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Winsock, ScktComp, OleCtrls, isp3;

type
  TFormHTH = class(TForm)
    RichEdit1: TRichEdit;
    Button1: TButton;
    ServerSocket1: TServerSocket;
    ClientSocket1: TClientSocket;
    Edit1: TEdit;
    Button2: TButton;
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ServerSocket1ClientRead(Sender: TObject;
      Socket: TCustomWinSocket);
    procedure Button1Click(Sender: TObject);
  private
    param: array [0..255] of string;
    Server: Boolean;
    My_Host, My_Ip: string;
    function GetIPFromHost(var HostName, IPaddr, WSAErr: string): Boolean;
    function RegisterEXE(const aExeFileName:  string; aRegister: boolean): boolean;
    { Private declarations }
  public
    { Public declarations }
  end;

var
  FormHTH: TFormHTH;

implementation

{$R *.DFM}


procedure TFormHTH.FormActivate(Sender: TObject);
var
  count: integer;
  Host, IP, Err: string;
begin
   for count := 0 to ParamCount do begin
      param[count] := ParamStr(count);
      if param[count] = '-server' then Server := not server;
      end;

   for count := Paramcount+1 to 255 do
     param[count] := '';

   RichEdit1.Lines.Clear;
   for count := 0 to 255 do
     if Param[count] <> '' then
     Richedit1.Lines.Add(Param[count]);

   if GetIPFromHost(Host, IP, Err) then begin
         RichEdit1.lines.add(Host);
         RichEdit1.lines.add(IP);
         My_Host := Host;
         My_Ip := IP;
   end else
          MessageDlg(Err, mtError, [mbOk], 0);


   if Server then begin
      ServerSocket1.Port := 23;
      ServerSocket1.Active := True;
      FormHTH.Caption := 'HTH server';
   end else begin
      ClientSocket1.Port :=  23;
      //local TCP/IP address of the server
      ClientSocket1.Host :=  My_Host;
      ClientSocket1.Active :=  true;
      FormHTH.Caption := 'HTH patron';
   end;
end;

function TFormHTH.GetIPFromHost(var HostName, IPaddr, WSAErr: string): Boolean;
type
  Name = array[0..100] of Char;
  PName = ^Name;
var
  HEnt: pHostEnt;
  HName: PName;
  WSAData: TWSAData;
  i: Integer;
begin
  Result := False;
  if WSAStartup($0101, WSAData) <> 0 then begin
    WSAErr := 'Winsock is not responding."';
    Exit;
  end;
  IPaddr := '';
  New(HName);
  if GetHostName(HName^, SizeOf(Name)) = 0 then
  begin
    HostName := StrPas(HName^);
    HEnt := GetHostByName(HName^);
    for i := 0 to HEnt^.h_length - 1 do
     IPaddr :=
      Concat(IPaddr,
      IntToStr(Ord(HEnt^.h_addr_list^[i])) + '.');
    SetLength(IPaddr, Length(IPaddr) - 1);
    Result := True;
  end
  else begin
   case WSAGetLastError of
    WSANOTINITIALISED:WSAErr:='WSANotInitialised';
    WSAENETDOWN      :WSAErr:='WSAENetDown';
    WSAEINPROGRESS   :WSAErr:='WSAEInProgress';
   end;
  end;
  Dispose(HName);
  WSACleanup;
end;

procedure TFormHTH.FormClose(Sender: TObject; var Action: TCloseAction);
begin
  if Server then
     ServerSocket1.Active := false
  else
     ClientSocket1.Active := false;
end;

procedure TFormHTH.ServerSocket1ClientRead(Sender: TObject;
  Socket: TCustomWinSocket);
var
  i:integer;
  sRec : string;
begin
  for i := 0 to ServerSocket1.Socket.ActiveConnections-1 do
  begin
    with ServerSocket1.Socket.Connections[i] do
    begin
      sRec := ReceiveText;
      if sRec <> '' then
      begin
        RichEdit1.Lines.Add(RemoteAddress + ' sends :') ;
        RichEdit1.Lines.Add(sRec);
      end;
    end;
  end;
end;

procedure TFormHTH.Button1Click(Sender: TObject);
begin
  if ClientSocket1.Active then begin
    ClientSocket1.Socket.SendText(Edit1.Text);
    RichEdit1.Lines.Add('me: '+Edit1.Text);
  end;
  if ServerSocket1.Active then begin
    ClientSocket1.Socket.SendText(Edit1.Text);
    RichEdit1.Lines.Add('me: '+Edit1.Text);
  end;
end;

function  TFormHTH.RegisterEXE(const aExeFileName:  string; aRegister: boolean): boolean;
const
  cRegCmdArr: array[boolean] of string = (' /unregserver', ' /regserver');
var
  vSI: TStartupInfo;
  vPI: TProcessInformation;
begin
  FillChar(vSI, SizeOf(vSI), 0);
  vSI.cb := SizeOf(vSI);
  Result := Win32Check(CreateProcess(PChar(aExeFileName), PChar(aExeFileName +
    cRegCmdArr[aRegister]), nil, nil, True, 0, nil, nil, vSI, vPI));
  CloseHandle(vPI.hThread);
  CloseHandle(vPI.hProcess);
end;

end.
