unit HeatP;

interface

uses
  Windows, Messages, SysUtils, Classes,
  Graphics, Controls, Forms, Dialogs,
  OpenGL, MMSystem, Count,
  Light, Material, Trans, cOpenGL, Transform;

type
  TForm1 = class(TForm)
    OpenGL1: TOpenGL;
    Material1: TMaterial;
    Light1: TLight;
    Transform1: TTransform;
    Transform2: TTransform;
    Material2: TMaterial;
    Transform3: TTransform;
    Transform4: TTransform;
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure Transform1Paint(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Transform2Paint(Sender: TObject);
    procedure Transform3Paint(Sender: TObject);
    procedure Transform4Paint(Sender: TObject);
  private
     Buffer: array[1..64] of GLuint;
     Startms,
     ms256,
     Counter256,
     lCounter: integer;
     bCounter: byte;
     procedure Selection(px,py:GLdouble);
     procedure SelectionDone;
     procedure InitMapData;
     procedure Idle(Sender:TObject;var Done: boolean);
     procedure Cube;
     procedure Dome;
     procedure DomeTop;
     procedure StrafeBase;
     procedure CylnderBase;
     procedure CylnderTop;
     procedure Cylnder;
    { Private declarations }
  public
    { Public declarations }
  end;

  PHit = ^THit;
  THit=packed record
    ncount,
    dnear,
    dfar: GLuint;
    names: array[1..32] of GLuint;
  end; //THit

    BinData = record
         valid: boolean;
         x,y,z: glFloat;
         PressMin,
         PressMax,
         TempMin,
         TempMax: integer;
         Name: String;
         end;

    It = record
          animation: integer;
          Selected: integer;
          Old_Selected: integer;
          View_Ang: integer;
          TotalRows,
          TotalColums: Integer;
          end;


var
  Form1: TForm1;
  Scale: GLFloat;
  dlTank: GLuint;
  Cmap: array[1..24,1..24] of BinData;
  It1: It;
  circX,
  circY,
  circZ,
  strafeX,
  strafeY: array[0..360] of glFloat;
  circleX,
  circleY,
  circleZ: array[0..35] of glFloat;
  KeepItSquare,
  ChamberSize,
  viewSize: Double;

implementation

{$R *.DFM}

procedure TForm1.Selection(px,py:GLdouble);
TYPE
  TViewPort = packed record
    left,bottom,width,height: GLint;
  end;
var
  viewport: TViewport;
begin
  glRenderMode(GL_SELECT);
  glInitNames;
  glPushName(0);
  glMatrixMode(GL_PROJECTION);
  glPushMatrix;
  glLoadIdentity;
  glGetIntegerv(GL_VIEWPORT,@viewport);
  py := viewport.height-py;
  gluPickMatrix(px,py,2.0,2.0,@viewport);
  with OpenGL1 do
    glFrustum(prxLeft,prxRight,prxBottom,prxTop,prxNear,prxFar);
end;

procedure TForm1.SelectionDone;
const
   countElement=1;
   nearElement=1;
   farElement=1;
var
   place,
   nm,
   hit,
   hits: GLint;
   ahit: Phit;
   nameList: string;
begin
     glMatrixMode(GL_PROJECTION);
     glPopMatrix;
     hits := glRenderMode(GL_RENDER);
     place := 1;
     with Form2,ListBox1,Items do
     begin
        Clear;
        Add(Format('Hits = %d',[hits]));
        for hit := 1 to hits do
        begin
           ahit := @Buffer[place];
           with ahit^ do
           begin
              place := place+countElement+nearElement+farElement+ncount;
              Add(Format('  hit#%d    count=%d',[hit,ncount]));
              Add(Format('     near= %d',[dnear]));
              Add(Format('      far= %d',[dfar]));
              nameList := '    names:';
              for nm := 1 to ncount do
                 nameList := nameList+' '+IntToSTr(names[nm]);
              Add(nameList);
              it1.selected := names[1];
           end;  // with ahit^
        end;  // for hit
     end;  // with Form2,ListBox1,Items
end;

procedure TForm1.InitMapData;
var
   count,
   count2: integer;
begin
     for count := 1 to 24 do
     begin
        for count2 := 1 to 24 do
        begin
             Cmap[count,count2].Valid := True;//False;
             Cmap[count,count2].X := count-1;
             Cmap[count,count2].Y := 0;
             Cmap[count,count2].Z := -count2-1;
        end;
     end;
     it1.Selected := 1;
     it1.Old_Selected := 1;
     it1.View_Ang := 0;
     it1.TotalRows := 1;
     it1.TotalColums := 4;
end;

procedure TForm1.Idle(Sender:TObject;var Done:boolean);
var
  difms: integer;
  DeltaX,
  DeltaZ: GlFloat;
begin
  inc(lCounter);
  inc(bCounter);
  difms := TimeGetTime-Startms;
  DeltaX := difms*(OpenGl1.prxFar-OPenGl1.prxNear)/(lCounter*500.0);
  if Form2.Button2.Caption <> 'Animate' then
  begin
        it1.Animation := 1;
     if Form2.Button2.Caption = 'down' then
        it1.Animation := -1;
     if (it1.View_Ang >= 0) and
        (it1.View_Ang <= 90) then
        it1.View_Ang := it1.View_Ang +round(deltaX*it1.animation);
     if (it1.View_Ang > 90) then
        it1.View_Ang := 90;
     if (it1.View_Ang < 0) then
        it1.View_Ang := 0;
  end
  else
  begin
      it1.View_Ang := Form2.TrackBar3.Position;
  end;
//  Form1.Transform3.TranZ := Form1.Transform3.TranZ-0.25;
//  Form1.Caption := FloatToStr(Form1.Transform3.TranZ);
  with OpenGL1,Transform1 do
  begin
    Material1.difAlpha := Form2.Trackbar1.Position / 20;
    Scale := Form2.TrackBar2.Position / 20;
    if bCounter = 0 then
    begin
         Form2.Label1.Caption := 'Frames Per Second: '+
                                 Format('%d',[lCounter*1000 div difms]);
         Form2.Label2.Caption := 'Total Average FPS: '+
                                 Format('%d',[
                                (lCounter-Counter256)*1000 div (difms-ms256)]);
         Counter256 := lCounter;
         ms256 := difms;
    end;
  end; {with}
  Done := false;
  FormPaint(nil);
end;

procedure TForm1.StrafeBase;
var
   around: integer;
   pi360: double;
begin
   pi360:= pi / 137;
   for around := 0 to 90 do
   begin
     strafeX[around] := viewSize*sin((around)*pi360);
     strafeY[around] := -viewSize*cos((around)*pi360);
   end;
end;  //  Form1.StrafeBase;

procedure TForm1.CylnderBase;
var
   around: integer;
   pi18: double;
begin
   pi18 := pi / 18.0;
   for around := 0 to 35 do
   begin
     circleX[around] := ChamberSize*sin(around*pi18);
     circleY[around] := ChamberSize*cos(around*pi18);
   end;
end;

procedure TForm1.CylnderTop;
var
   around: integer;
   pi18: double;
begin
   pi18 := pi / 18.0;
   for around := 0 to 35 do
   begin
     circX[around] := ChamberSize*sin(around*pi18);
     circY[around] := ChamberSize*cos(around*pi18);
   end;
end;

procedure TForm1.Cylnder;
var
   around: integer;
begin
   glFrontFace(GL_CCW);
   glBegin(GL_TRIANGLE_STRIP);
     for around := 0 to 35 do
     begin
       glVertex3f(circX[around],circY[around],-1.0);
       glVertex3f(circX[around],circY[around],1.0);
     end; // for
     glVertex3f(circX[0],circY[0],-1.0);
     glVertex3f(circX[0],circY[0],1.0);
   glEnd;
end;

procedure TForm1.Dome;
var
  olddiam,
  oldlayer,
  diam,
  layer: double;
  place,
  around: integer;
begin
  olddiam := 0;
  oldlayer := 0;
  for place := 1 to 9 do
  begin
    layer := circleY[place]+1;
    diam := circleX[place]*2.5;
    if place = 1 then
    begin
      glFrontFace(GL_CCW);
      glBEgin(GL_TRIANGLE_FAN);
        glVertex3f(0.0,0.0,ChamberSize+1);
        FOR around := 35 downto 0 do
          glVertex3f(circleX[around]*diam, circley[around]*diam,layer);
        glVertex3f(circleX[35]*diam,circleY[35]*diam, layer);
    end
    else
    begin
      glFrontFace(GL_CW);
      glBegin(GL_TRIANGLE_STRIP);
        for around := 0 to 35 do
        begin
          glVertex3f(circleX[around]*olddiam,circleY[around]*olddiam,oldlayer);
          glVertex3f(circleX[around]*diam,circleY[around]*diam,layer);
        end;  // for
        glVertex3f(circleX[0]*olddiam, circleY[0]*olddiam,oldlayer);
        glVertex3f(circleX[0]*diam,circleY[0]*diam, layer);
    end;
    glEnd;
    olddiam := diam;
    oldLayer := Layer;
  end;  // for
end;

procedure TForm1.Dometop;
var
  olddiam,
  oldlayer,
  diam,
  layer: double;
  place,
  around: integer;
begin
  olddiam := 0;
  oldlayer := 0;
  for place := 1 to 9 do
  begin
    layer := -circleY[place]-1;
    diam := -circleX[place]*2.5;
    if place = 1 then
    begin
      glFrontFace(GL_CW);
      glBEgin(GL_TRIANGLE_FAN);
        glVertex3f(0.0,0.0,(-1 -ChamberSize));
        FOR around := 35 downto 0 do
          glVertex3f(circleX[around]*diam, circley[around]*diam,layer);
          glVertex3f(circleX[35]*diam,circleY[35]*diam, layer);
    end
    else
    begin
      glFrontFace(GL_CCW);
      glBegin(GL_TRIANGLE_STRIP);
        for around := 0 to 35 do
        begin
          glVertex3f(circleX[around]*olddiam,circley[around]*olddiam,oldlayer);
          glVertex3f(circleX[around]*diam,circleY[around]*diam,layer);
        end;  // for
        glVertex3f(circleX[0]*olddiam, circleY[0]*olddiam,oldlayer);
        glVertex3f(circleX[0]*diam,circleY[0]*diam, layer);
    end;
    glEnd;
    olddiam := diam;
    oldLayer := Layer;
  end;  // for
end;

procedure TForm1.Cube;
begin
      glFrontFace(GL_CCW);
  glBegin(GL_POLYGON);
    glVertex3f(-ChamberSize,-ChamberSize,+ChamberSize);
    glVertex3f(+ChamberSize,-ChamberSize,+ChamberSize);
    glVertex3f(+ChamberSize,+ChamberSize,+ChamberSize);
    glVertex3f(-ChamberSize,+ChamberSize,+ChamberSize);
  glEnd;

  glBegin(GL_POLYGON);
    glVertex3f(+ChamberSize,-ChamberSize,+ChamberSize);
    glVertex3f(+ChamberSize,-ChamberSize,-ChamberSize);
    glVertex3f(+ChamberSize,+ChamberSize,-ChamberSize);
    glVertex3f(+ChamberSize,+ChamberSize,+ChamberSize);
  glEnd;

  glBegin(GL_POLYGON);
    glVertex3f(-ChamberSize,-ChamberSize,-ChamberSize);
    glVertex3f(-ChamberSize,-ChamberSize,+ChamberSize);
    glVertex3f(-ChamberSize,+ChamberSize,+ChamberSize);
    glVertex3f(-ChamberSize,+ChamberSize,-ChamberSize);
  glEnd;

  glBegin(GL_POLYGON);
    glVertex3f(+ChamberSize,-ChamberSize,-ChamberSize);
    glVertex3f(-ChamberSize,-ChamberSize,-ChamberSize);
    glVertex3f(-ChamberSize,+ChamberSize,-ChamberSize);
    glVertex3f(+ChamberSize,+ChamberSize,-ChamberSize);
  glEnd;

  glBegin(GL_POLYGON);
    glVertex3f(-ChamberSize,+ChamberSize,+ChamberSize);
    glVertex3f(+ChamberSize,+ChamberSize,+ChamberSize);
    glVertex3f(+ChamberSize,+ChamberSize,-ChamberSize);
    glVertex3f(-ChamberSize,+ChamberSize,-ChamberSize);
  glEnd;

end;

procedure TForm1.FormPaint(Sender: TObject);
var
   count,
   count2: integer;
begin
     if OpenGL1.Ready then
     begin
//        GlMatrixMode(GL_MODELVIEW);
  with OpenGL1 do
  begin
    if Form2.Button1.Caption = 'Perspective' then
    begin
        OpenGl1.Projection := PERSPECTIVE;
        GlMatrixMode(GL_MODELVIEW);
        glClear(GL_COLOR_BUFFER_BIT OR GL_DEPTH_BUFFER_BIT);
        glLoadIdentity;
    end
    else
    begin
        Projection := ORTHOGRAPHIC;
        glClear(GL_COLOR_BUFFER_BIT);
        GlMatrixMode(GL_MODELVIEW);
        glLoadIdentity;
        glOrtho(prxLeft,prxRight,prxBottom,prxTop,prxNear,prxFar);
    end;
  end;  // with OpenGL1 do
          Transform3.Apply;
        glScalef(scale,scale,scale);
        glRotatef(it1.view_ang,0.0,0.1,0.0);
        glTranslatef(StrafeX[it1.view_ang],0,StrafeY[it1.view_ang]);

//        Trans1.TranX := Cmap[it1.selected,1].X;
//        Trans1.TranY := Cmap[it1.selected,1].Y;
//        Trans1.TranZ := Cmap[it1.selected,1].Z;
//        Trans1.Apply;
        Transform4.TranX := Cmap[it1.selected,1].X;
        Transform4.TranY := Cmap[it1.selected,1].Y;
        Transform4.TranZ := Cmap[it1.selected,1].Z;
        Transform4.Apply;
        for count := 1 to 7 do
        begin
          glLoadName(count);
          for count2 := 1 to 1 do
          begin
          if Cmap[count,count2].valid = True then
          begin
             Transform1.TranX := Cmap[count,count2].x;
             Transform1.TranY := Cmap[count,count2].y;
             Transform1.TranZ := Cmap[count,count2].Z;
             Transform1.Apply;
          end; // end of    if Imap[count].valid
          end;
        end; // end of         for count := 1 to 24
       OpenGL1.Swap;
       OpenGL1.ErrorCheck('FormPaint');
  end; // end of {opengl.ready  else}
end;

procedure TForm1.FormResize(Sender: TObject);
begin
     KeepItSquare := Form1.ClientHeight / Form1.ClientWidth;
     Form1.Transform1.TScaleX := KeepItSquare;
     Form1.Transform4.TScaleX := KeepItSquare;
     if OpenGL1.Smaller then
       FormPaint(Sender);
end;


procedure TForm1.FormCreate(Sender: TObject);
begin
     InitMapData;
     it1.animation := 0;
     ViewSize := 5.0;
     StrafeBase;
     ChamberSize := 0.4;
     Scale := 0.3;
     Application.OnIdle := Idle;
     CylnderBase;
     CylnderTop;
     dlTank := glGenLists(1);
     glNewList(dlTank,GL_COMPILE);
       DomeTop;
       Dome;
       Cylnder;
     glEndList;
     glSelectBuffer(64,@Buffer);
     glLightModeli(GL_LIGHT_MODEL_TWO_SIDE,GL_TRUE);
     glEnable(GL_BLEND);
     glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
     Startms := timeGetTime;
     bCounter := 240;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if Button = mbRight then
     begin
          if ssShift in Shift then
          begin
               if Form2.Visible then
                  Form2.Hide
               else
                  Form2.Show;
          end;
     end
     else
     begin
        Selection(x,y);
        FormPaint(nil);
        SelectionDone;
     end;

end;

procedure TForm1.Transform1Paint(Sender: TObject);
begin
     Material1.Apply;
     glCallList(dlTank);
end;

procedure TForm1.Transform2Paint(Sender: TObject);
begin
     Material2.Apply;
     glCallList(dlTank);
end;

procedure TForm1.Transform3Paint(Sender: TObject);
begin
     Light1.Apply;
end;

procedure TForm1.Transform4Paint(Sender: TObject);
begin
     Material2.Apply;
     Cylnder;
end;

end.
