(*-------------------------------------------*)
(* TParser Component  2000 by Pedro Antunes *)
(*                                           *)
(* If you have trouble using this component, *)
(* please e-mail me at pedro@becrev.com.     *)
(*                                           *)
(* This component is freeware.               *)
(*-------------------------------------------*)

unit Parser;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  DsgnIntf, StdCtrls, ExtCtrls, ShellAPI, Buttons;


type
  TAbout = class(TPersistent)
  end;

  TAboutProperty = class(TClassProperty)
  public
    procedure Edit; override;
    function GetAttributes: TPropertyAttributes; override;
  end;

type
  TParser = class(TComponent)
  private
    { Private declarations }
  protected
    { Protected declarations }
    FAbout: TAbout;
    DivStr: String;
    CS: Boolean;
    FStrings: TStringList;
    procedure DoParse(Value: String);
  public
    { Public declarations }
    property Strings: TStringList read FStrings;
    property StringToParse: String write DoParse;
  published
    { Published declarations }
    constructor Create(Owner: TComponent); override;
    destructor Destroy; override;
    property About: TAbout read FAbout write FAbout stored False;
    property DividingString: String read DivStr write DivStr;
    property CaseSensitive: Boolean read CS write CS;
  end;

procedure Register;

implementation

procedure Register;
begin
  RegisterComponents('Standard', [TParser]);
  RegisterPropertyEditor(TypeInfo(TAbout), nil, '', TAboutProperty);
end;

procedure TAboutProperty.Edit;
var AboutBox: TForm; Panel1: TPanel;
    Label1, Label2, Label3: TLabel; Btn: TBitBtn;
begin
  AboutBox := TForm.Create(Application);
  With AboutBox do begin
       Caption:='About TParser';
       BorderIcons := [];
       BorderStyle := bsDialog;
       ClientHeight := 159;
       ClientWidth := 240;
       Position := poScreenCenter;
  end;
  Panel1:=TPanel.Create(AboutBox);
  With Panel1 do begin
    Left := 8;
    Top := 8;
    Width := 225;
    Height := 113;
    BevelInner := bvRaised;
    BevelOuter := bvLowered;
    TabOrder := 0;
    end;

    AboutBox.InsertControl(Panel1);

    Label1:=TLabel.Create(Panel1);
    with Label1 do begin
      Caption := 'TParser v2.2 Written by     Pedro Antunes Copyright  2000';
      Left := 53;
      Top := 8;
      Width := 118;
      Height := 39;
      Alignment := taCenter;
      WordWrap := True;
    end;
    Panel1.InsertControl(Label1);

    Label2:=TLabel.Create(Panel1);
    with Label2 do begin
      Caption := 'Comments, suggestions  and bug reports should be sent to';
      Left := 43;
      Top := 56;
      Width := 138;
      Height := 26;
      WordWrap := True;
    end;
    Panel1.InsertControl(Label2);

    Label3:=TLabel.Create(Panel1);
    with Label3 do begin
      Caption := 'pedro@becrev.com';
      Left := 66;
      Top := 88;
      Width := 94;
      Height := 13;
    end;
    Panel1.InsertControl(Label3);

  Btn:=TBitBtn.Create(AboutBox);
  with Btn do begin
    Left := 83;
    Top := 128;
    Width := 75;
    Height := 25;
    Kind := bkOk;
    Caption := '&OK';
    ModalResult := 1;
    TabOrder := 1;
    NumGlyphs := 2;
  end;
  AboutBox.InsertControl(Btn);
  AboutBox.ShowModal;
  AboutBox.Free;
end;

function TAboutProperty.GetAttributes: TPropertyAttributes;
begin
  Result := [paDialog];
end;

constructor TParser.Create(Owner: TComponent);
begin
inherited Create(Owner);
FStrings := TStringList.Create;
CS := False;
DivStr := '';
end;

destructor TParser.Destroy;
begin
FStrings.Free;
inherited Destroy;
end;

procedure TParser.DoParse(Value: String);
var
  I: Integer;
  S: string;
begin
  S := Value;
  FStrings.Clear;

  while (True) do begin
    if CS then {$IFDEF VER130} {Delphi 5}
               I := Pos(DivStr, S)
               {$ELSE}
               I := Pos(DivStr, S)
               {$ENDIF}
    else {$IFDEF VER130}
         I:=Pos(UpperCase(DivStr), UpperCase(S));
         {$ELSE}
         I := Pos(UpperCase(DivStr), UpperCase(S));
         {$ENDIF}
    if I = 0 then begin
      if (Length(S) > 0) then FStrings.Add(S);
      break;
    end;

    FStrings.Add(System.Copy(S, 1, I-1));
    System.Delete(S, 1, I-1 + Length(DivStr));
  end;
end;

end.
