unit Plan83P;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Light, Material, Transfrm, cOpenGL, OpenGL, MMsystem, ExtCtrls,
  math, ComCtrls, StdCtrls;

type
  TForm1 = class(TForm)
    OpenGL1: TOpenGL;
    TRansformLight: TTRansform;
    TRansformFloor: TTRansform;
    TRansformWall: TTRansform;
    MaterialLight: TMaterial;
    MaterialFloor: TMaterial;
    MaterialWall: TMaterial;
    Light1: TLight;
    TRansformPole: TTRansform;
    MaterialPole: TMaterial;
    MaterialOpen: TMaterial;
    TRansformGlobe: TTRansform;
    MaterialGlobe: TMaterial;
    TRansformLand: TTRansform;
    MaterialLand: TMaterial;
    TRansformDust: TTRansform;
    MaterialDust: TMaterial;
    Timer1: TTimer;
    TRansformCanvas: TTRansform;
    MaterialCanvas: TMaterial;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    TRansformBall: TTRansform;
    MaterialBall: TMaterial;
    Light2: TLight;
    TrackBar1: TTrackBar;
    Button1: TButton;
    TRansformSun: TTRansform;
    MaterialSun: TMaterial;
    TRansformJupiter: TTRansform;
    MaterialJupiter: TMaterial;
    TrackBar2: TTrackBar;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    TRansformSaturn: TTRansform;
    MaterialSaturn: TMaterial;
    TRansformNeptune: TTRansform;
    MaterialNeptune: TMaterial;
    TRansformUranus: TTRansform;
    MaterialUranus: TMaterial;
    Button2: TButton;
    Button3: TButton;
    Button4: TButton;
    UpDown1: TUpDown;
    Button5: TButton;
    Button6: TButton;
    Button7: TButton;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure UpDown1Click(Sender: TObject; Button: TUDBtnType);
    procedure AbolishTime(mult: Double);
    procedure Button5Click(Sender: TObject);
    procedure Button6Click(Sender: TObject);
    procedure Button7Click(Sender: TObject);
  private
        theta,
     ang, angl, ang2, ang3, rspeed, speed, tran, rot, alt, wx, wy, wz,
     Vu_ang, Vl_ang, cercent,
     scale_dust,
     trnX, trnY, trnZ,
     scalum, Pscale,
     day_in_seconds, remainder_in_seconds: Double;
     frames, elapsed, start, TimeDif2, elapsed2, start2, Rider,
     pass, small, last_small, f1, f2,
     cur, so_far, trio,
     selected_dust, startX, startY,
     count_spread, opus_maximus,
     active_planets, active_second, bad_variable,
     Time_warp, Time_bump: integer;
     MY_UP, MY_DOWN, MY_LEFT, MY_RIGHT,
     MY_LEFT2, MY_RIGHT2, MY_E, MY_D, MY_B, MY_T, MY_G, MY_TREB, MY_Y,
     dustinator, triangulator, readyToRun: Boolean;
     startShift: TShiftState;
     procedure Idle(Sender: TObject; var Done: boolean);
     procedure Adjust;
     procedure Selection(px,py:GLdouble);
     function SelectionDone: GLint;
     procedure DrawPlanets;
     procedure DrawPlanet(count: integer);
     procedure TimeCodeBegin;
     procedure TimeCodeEnd;
     procedure DrawTriangles;
     procedure DrawBallTriangles;
     procedure NormalizeTreb;
     procedure AverageDist;
     procedure Grav(count, count2: integer);
     procedure GravOnEarth(count2: integer);
     procedure RectifySeconds;
     procedure InitSolarSystem;
     procedure InitPlanet(count: integer);
    { Private declarations }
  public
     procedure LoadPlanets;
     procedure SavePlanets;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
   Level = 0;
   Border = 0;
   ColorComps =3;
   MAX_DUST2 = 1447;//1461;
   MAX_DUST = 1461;
   RADI = 1.0;
   au = 149597870691.0;
   GRAVITY_CONSTANT = 0.00000000006672;
   RADIUS_PLAY = 1000;
   VECTOR_PLAY = 1000; // convert km to meters
   PLANET_MASS_SCALAR = 24;//24;
   PSCALE_START = 5000;
   RIDER_START = 1;
   MAX_PLANET = 144;


type
   TRGB = packed record
      r,g,b: byte;
   end;

   TWrap = array[0..0] of TRGB;

   TPoint = packed record
     x,y,z: GLFloat;
   end;

   PHit=^THit;
   THit=packed record
      ncount, dnear, dfar: GLuint;
      names: array[1..256] of GLuint;
   end;

   TPlanet = packed record
      ref_planet: integer;
      radius, Corona_radius,
      mass, au, axis, Inclination, day,  // au = au maximum
      year, AU_circumference, Au_avg,
      albedo: GLfloat;
      vec, place: TPoint;
   end;

   TPoint2D = packed record
      x,y,
      angle, ang_abso: GLfloat;
   end;

   TCoord = packed record
      a,b,c: TPoint2D;
   end;

   TAdj3 = packed record
      a12, a23, a31: integer;
   end;

   TTerrainRow=array[1..66] of TPoint;
   TTerrain = array[-32..32] of TTerrainRow;
   TDust = packed array[1..MAX_DUST,0..1] of TPoint;
   TDusty = packed array[1..MAX_DUST] of TPoint;
   TTri = packed array[1.. (MAX_DUST * 6)] of TPoint;
   TTriang = packed array[1.. (MAX_DUST * 6)] of integer;
   TSolar = packed array [0..MAX_PLANET] of TPlanet;
   TTTC = packed array [1..(MAX_DUST *6)] of TCoord;

var
   pi180: double = pi/180;
   circleX, circleY : array [0..35] of glFloat;
   wall: array[1..28] of TPoint;
   didymus: TPoint;
   sBulk, tBulk,
   sBrick, tBrick,
   sWorld, tWorld, sGrass, tGrass,
   sSun, tSun, sJupiter, tJupiter, sSaturn, tSaturn,
   sNeptune, tNeptune, sUranus, tUranus: GLsizei;
   globe, world, bulk, brick, grass,
   Sun, Jupiter, Saturn, Neptune, Uranus: pointer;
   ter: TTerrain;
   Dust: TDust;
   LastDustSun: TPoint;
   Dusty: TDusty;
//   dlTerrain: GLuint;
   PickBuffer: array[1..512] of GLuint;
   Tri: TTri;
   Triang: TTriang;
   Treb: array [1..(MAX_DUST *2)] of TPoint;
   TreAd: array [1..(MAX_DUST *2)] of TAdj3;
   BallVect: TPoint;
   Sol: TSolar;
   TTC: TTTC;
   lastSpot: TPoint;

function ReadBitmap(const FilePath: string; var sWidth,tHeight:GLsizei): pointer;
const
   szh = SizeOf(TBitmapFileHeader);
   szi = SizeOf(TBitmapInfoHeader);
var
   bmpfile: file;
   bfh: TBitmapFileHeader;
   bmi: TBitmapInfoHeader;
   t: byte;
   x1, size: integer;
begin
   assignFile(bmpfile, FilePath);
   reset(bmpfile,1);
   size := FileSize(bmpfile)-szh-szi;
   blockread(bmpfile, bfh, szh);
   if Bfh.BfType<>$4D42 then
      raise EInvalidGraphic.Create('invalid bitmap');
   blockread(bmpfile,bmi,szi);
   with bmi do
   begin
      sWidth := biWidth;
      tHeight := biHeight;
   end;
   getmem(result,size);
   blockRead(bmpfile,result^,size);
   for x1 := 0 to sWidth * tHeight -1 do
   with TWrap(result^)[x1] do
   begin
      t := r;
      r := b;
      b := t;
   end;
end;

procedure TForm1.Selection(px,py:GLdouble);
type
   TViewPort=packed record
      left,bottom, width, height: GLint;
   end;
var
   viewport: TViewPort;
begin
   glRenderMode(GL_SELECT);
   glInitNames;
   glPushName(0);
   glMatrixMode(GL_PROJECTION);
   glPushMatrix;
   glLoadIdentity;
   glGetIntegerv(GL_VIEWPORT,@viewport);
   py := viewport.height-py;
   gluPickMatrix(px,py,2.0,2.0, @Viewport);
end;

function TForm1.SelectionDone:GLint;
begin
   glMatrixMode(GL_PROJECTION);
   glPopMatrix;
   result := glRenderMode(GL_RENDER);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   Application.OnIdle := Idle;
   start := TimeGetTime;
   speed := 0.1;
   rspeed := 7.0;
   scalum := 1;
   wz := -8.0 * scalum;
   wx := -1.35 * scalum;
   wy := -1.5 * scalum;
   tran := 0.0 * scalum;
   Pscale := 3 / au * PSCALE_START;
   Rider := RIDER_START;
   active_planets := 1; //MAX_PLANET; //27;
//   active_second := 0;
   bad_variable := 0;
   day_in_seconds := 2700;
//   remainder_in_seconds := 86400;
   remainder_in_seconds := 86400 / day_in_seconds;

   UpDown1.Max := MAX_PLANET;
   active_second := UpDown1.Position;
//  Pscale := 1;

   Time_warp := 10000;
   Time_bump := 0;

   MY_UP := False;
   MY_DOWN := False;
   MY_LEFT := False;
   MY_RIGHT := False;
   MY_LEFT2 := False;
   MY_RIGHT2 := False;
   MY_B := False;
   MY_D := False;
   MY_E := False;
   MY_G := False;
   MY_T := False;

   pass := 0;
   last_small := 0;
   small := 0;
   f1 := 1;
   f2 := 2;
   cercent := 1.2;

   glSelectBuffer(128,@PickBuffer);
   cur := 0;
   so_far := 0;
   trio := 0;

   opus_maximus := 1;
   readyToRun := False;
end;

procedure TForm1.NormalizeTreb;
var
   count, count2: integer;
   x1,x2,x3,
   y1,y2,y3,
   z1,z2,z3: GLFloat;
begin
   //
   MY_TREB := not MY_TREB;
   if MY_TREB then
   begin
   count := 0;
   count2 := 0;
   while count < so_far do
   begin
      inc(count);
      x1 := Tri[count].x;
      y1 := Tri[count].y;
      z1 := Tri[count].z;
      inc(count);
      x2 := Tri[count].x;
      y2 := Tri[count].y;
      z2 := Tri[count].z;
      inc(count);
      x3 := Tri[count].x;
      y3 := Tri[count].y;
      z3 := Tri[count].z;
      inc(count2);   
      Treb[count2].x := ((x1 +x2 +x3)/3);
      Treb[count2].y := ((y1 +y2 +y3)/3);
      Treb[count2].z := ((z1 +z2 +z3)/3);
   end;
   end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//   messageDlg(IntToStr(ord(key)),mtWarning,[mbOk],0);
   case Key of
      VK_UP: MY_UP := TRUE;
      VK_DOWN: MY_DOWN := TRUE;
      VK_LEFT: MY_LEFT := TRUE;
      VK_RIGHT: MY_RIGHT := TRUE;
      VK_ESCAPE: Close;
      ord('B'): begin
            MY_B := not MY_B;
            end;
      ord('C'): begin
            inc(opus_maximus);
            end;
      ord('D'): begin
            MY_D := True;
            end;
      ord('E'): begin
             MY_E := True;
             end;
      ord('F'): begin
             MY_RIGHT2 := TRUE; end;
      ord('G'): begin
             MY_G := not MY_G;
             end;
      ord('J'): begin
            count_spread := count_spread +10;
            end;
      ord('M'): begin
            AverageDist;
            end;
      ord('N'): begin
            NormalizeTreb;
            end;
      ord('P'): begin
               Pscale := Pscale * 1.2;
            end;
      ord('Q'): begin
               Pscale := Pscale * 0.8;
            end;
      ord('R'): Begin
         if ssShift in Shift then
            rspeed := rspeed +0.01
         else begin
            if rspeed > 0.01 then
               rspeed := rspeed -0.01;
            end;
         end;
      ord('S'): begin
             MY_LEFT2 := TRUE; end;
      ord('T'): begin
             MY_T := not MY_T;
             end;
      ord('X'): begin
         if ssShift in Shift then
            speed := speed +0.001
         else begin
            if speed > 0.001 then
               speed := speed -0.001;
            end;
         end;
      ord('Y'): begin
            MY_Y := not MY_Y;
            end;
      ord('['): wz := wz -100;
      ord(']'): wz := wz +100;
      ord('0'): Rider := 0; //cercent  := 1.02;
      ord('1'): Rider := 1; //cercent  := 1.05;
      ord('2'): Rider := 2; //cercent  := 1.10;
      ord('3'): Rider := 3; //cercent  := 1.12;
      ord('4'): Rider := 4; //cercent  := 1.14;
      ord('5'): Rider := 5; //cercent  := 1.16;
      ord('6'): Rider := 6; //cercent  := 1.18;
      ord('7'): Rider := 7; //cercent  := 1.2;
      ord('8'): Rider := 8; //cercent  := 1.25;
      ord('9'): Rider := 9; //cercent  := 1.30;
      VK_F1: Rider := 10;
      VK_F2: Rider := 11;
      VK_F3: Rider := 12;
      VK_F4: Rider := 13;
      VK_F5: Rider := 14;
   end; {case}
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   case Key of
      VK_UP: begin
             MY_UP := False;
             tran := 0.0;
             end;
      VK_DOWN: begin
             MY_DOWN := False;
             tran := 0.0;
             end;
      VK_LEFT: begin
             MY_LEFT := False;
             rot := 0.0;
             end;
      VK_RIGHT: begin
             MY_RIGHT := False;
             rot := 0.0;
             end;
      ord('S'): begin
             MY_LEFT2 := False;
             rot := 0.0;
             end;
      ord('F'): begin
             MY_RIGHT2 := False;
             rot := 0.0;
             end;
      ord('B'): begin
               //MY_B := False;
             end;
      ord('D'): begin
             MY_D := False;
             alt := 0.0;
             end;
      ord('E'): begin
             MY_E := False;
             alt := 0.0;
             end;
   end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity;

   glScalef(scalum,scalum, scalum);
    glRotatef(angl,0.0,1.0,0.0);

   glTranslatef(-Sol[Rider].Place.x * PScale,-Sol[Rider].Place.y * PScale,wz );
   DrawPlanets;

   OpenGL1.Swap;
   OpenGL1.ErrorCheck('formpaint');

   Label1.Refresh;
   Label2.Refresh;
   Label3.Refresh;
   Label4.Refresh;
end;

procedure TForm1.DrawPlanets;
var
   count: integer;
begin
   for count := 0 to Active_planets do
   begin
      DrawPlanet(count);
   end;
end;

procedure TForm1.DrawPlanet(count: integer);
begin

 case count of
  0: begin
   TransformSun.TranX := Sol[count].Place.x * Pscale;
   TransformSun.TranY := Sol[count].Place.y * Pscale;
   TransformSun.TranZ := Sol[count].Place.z * Pscale;
   TransformSun.ScaleX := Sol[count].radius * Pscale;
   TransformSun.ScaleY := Sol[count].radius * Pscale;
   TransformSun.ScaleZ := Sol[count].radius * Pscale;

   TransformSun.Apply;

   glPointSize(7.0);
   glColor3f(1.0,1.0,0.0);
   glColor3f(0.5,1.0,0.3);
   glBegin(GL_POINTS);
      with TransFormSun do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;
  end;

  1: begin
   TransformJupiter.TranX := Sol[count].Place.x * Pscale;
   TransformJupiter.TranY := Sol[count].Place.y * Pscale;
   TransformJupiter.TranZ := Sol[count].Place.z * Pscale;
   TransformJupiter.ScaleX := Sol[count].radius * Pscale;
   TransformJupiter.ScaleY := Sol[count].radius * Pscale;
   TransformJupiter.ScaleZ := Sol[count].radius * Pscale;

   TransformJupiter.Apply;

   glPointSize(7.0);
   glColor3f(0.5,1.0,0.3);
   glBegin(GL_POINTS);
      with TransformJupiter do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;
  end;

  2: begin
   TransformSaturn.TranX := Sol[count].Place.x * Pscale;
   TransformSaturn.TranY := Sol[count].Place.y * Pscale;
   TransformSaturn.TranZ := Sol[count].Place.z * Pscale;
   TransformSaturn.ScaleX := Sol[count].radius * Pscale;
   TransformSaturn.ScaleY := Sol[count].radius * Pscale;
   TransformSaturn.ScaleZ := Sol[count].radius * Pscale;

   TransformSaturn.Apply;

   glPointSize(7.0);
   glColor3f(0.5,1.0,0.3);
   glBegin(GL_POINTS);
      with TransformSaturn do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;
  end;

  3: begin
   TransformNeptune.TranX := Sol[count].Place.x * Pscale;
   TransformNeptune.TranY := Sol[count].Place.y * Pscale;
   TransformNeptune.TranZ := Sol[count].Place.z * Pscale;
   TransformNeptune.ScaleX := Sol[count].radius * Pscale;
   TransformNeptune.ScaleY := Sol[count].radius * Pscale;
   TransformNeptune.ScaleZ := Sol[count].radius * Pscale;

   TransformNeptune.Apply;

   glPointSize(7.0);
   glColor3f(0.5,1.0,0.3);
   glBegin(GL_POINTS);
      with TransformNeptune do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;
  end;

  4: begin
   TransformUranus.TranX := Sol[count].Place.x * Pscale;
   TransformUranus.TranY := Sol[count].Place.y * Pscale;
   TransformUranus.TranZ := Sol[count].Place.z * Pscale;
   TransformUranus.ScaleX := Sol[count].radius * Pscale;
   TransformUranus.ScaleY := Sol[count].radius * Pscale;
   TransformUranus.ScaleZ := Sol[count].radius * Pscale;

   TransformUranus.Apply;

   glPointSize(7.0);
   glColor3f(0.5,1.0,0.3);
   glBegin(GL_POINTS);
      with TransformUranus do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;
  end;

  5 .. MAX_PLANET: begin
   TransFormDust.TranX := Sol[count].Place.x * Pscale;
   TransFormDust.TranY := Sol[count].Place.y * Pscale;
   TransFormDust.TranZ := Sol[count].Place.z * Pscale;
   TransformDust.ScaleX := Sol[count].radius * Pscale;
   TransformDust.ScaleY := Sol[count].radius * Pscale;
   TransformDust.ScaleZ := Sol[count].radius * Pscale;

   TransformDust.Apply;

   glPointSize(7.0);
   glColor3f(0.0,0.0,1.0);
   glBegin(GL_POINTS);
      with TransFormDust do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;
  end;
 end;

end;

procedure TForm1.TimeCodeBegin;
begin
   start2 := TimeGetTime;
end;

procedure TForm1.TimeCodeEnd;
begin
   elapsed2 := TimeGetTime;
   timedif2 := (elapsed2 - start2);
//   Form1.Caption := Format('Pscale: %2.12f,   wz: %6.6f,   timedif: %6d',[Pscale, wz, timedif2]);
end;

procedure TForm1.DrawTriangles;
var
   count, count2: integer;
begin
   //
   count2 := 0;

   if so_far > 2 then
   begin
     glBegin(GL_TRIANGLES);

    if triangulator then
    begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         end;
      end;



    end else begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);
            if count2 = 1 then
            begin
            end;

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         end;
      end;
    end; //if Triangulator
   glEnd;
   end;
end;


procedure TForm1.DrawBallTriangles;
var
   count, count2: integer;
begin
   //
   count2 := 0;

   if so_far > 2 then

    if triangulator then
    begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);




//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

      glEnd;
         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);



//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

      glEnd;
         end;
      end;



    end else begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);



            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

      glEnd;
         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);


            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);
            if count2 = 1 then
            begin
            end;

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

      glEnd;
         end;
      end;

    end; //if Triangulator
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   TrackBar2.Top := Form1.ClientHeight - 72;
   Label1.Top := TrackBar2.Top;

   if OpenGL1.Smaller then
      FormPaint(Sender);

end;

function SubtractVector(v1,v2: TPoint): TPoint;
begin
   with Result do
   begin
      x := v1.x - v2.x;
      y := v1.y - v2.y;
      z := v1.z - v2.z;
   end;
end;

function Normalize(N: TPoint):TPoint;
var
   d, m: GLFloat;
begin
   d := sqrt(N.x*N.x + N.y*N.y + N.z*N.z);
   m := RADI / d;
   Result.x := N.x * m;
   Result.y := N.y * m;
   Result.z := N.z * m;
end;

function DistanceSqr(N1, N2: TPoint): GLFloat;
var
   xd,yd,zd: GLFloat;
begin
   xd := N2.x-N1.x;
   yd := N2.y-N1.y;
   zd := N2.z-N1.z;
   Result := (xd*xd + yd*yd + zd*zd);
end;

function Distance(N1, N2: TPoint): GLFloat;
var
   xd,yd,zd: GLFloat;
begin
   xd := N2.x-N1.x;
   yd := N2.y-N1.y;
   zd := N2.z-N1.z;
   Result := sqrt(xd*xd + yd*yd + zd*zd);
end;

function Closest(p: TPoint): integer;
var
   count: integer;
   d, m: GLfloat;
begin
   m := 1000.0;
   result := 0;
      for count := 1 to MAX_DUST do
      begin
            d := Distance(p, Dust[count,0]);

            if d < m then
            begin
               m := d;
               result := count;
            end;

      end;
end;

function ClosestDot(p: TPoint): integer;
var
   count: integer;
   d, m: GLfloat;
   dp: TPoint;
begin
   m := 1000.0;
   result := 0;
      for count := 1 to MAX_DUST do
      begin
         with Form1.TransformDust do
         begin
           dp.x := Dust[count,0].x +TranX;
           dp.y := Dust[count,0].y +TranY;
           dp.z := Dust[count,0].z +TranZ;
         end;
            d := Distance(p, dp);

            if d < m then
            begin
               m := d;
               result := count;
            end;

      end;
end;

procedure TForm1.AverageDist;
var
   count, count2, count3: integer;
   d: GLfloat;
begin
   d := 0.0;
   count2 := 1;
   count3 := 0;
   for count := 1 to (so_far div 3) do
   begin
      d := d +Distance(Tri[count2   ],Tri[count2 +1]);
      inc(count3);
      d := d +Distance(Tri[count2 +1],Tri[count2 +2]);
      inc(count3);
      d := d +Distance(Tri[count2 +2],Tri[count2  ]);
      inc(count3);
      count2 := count2 +3;
   end;
   d := d / count3;
//   Form1.Caption := FloatToStr(d);
end;

procedure TForm1.Idle(Sender: TObject; var Done: boolean);
begin
//
end;


procedure TForm1.Adjust;
var
   savex,
   savey,
   savez: GLfloat;

function restore: boolean;
   begin
      result := true;
      wx := savex;
      wy := saveY;
      wz := savez;
   end;
begin
   if MY_T then begin
      scale_dust := scale_dust * 1.05;
      TransformDust.ScaleX := scale_dust;
      TransformDust.ScaleY := scale_dust;
      TransformDust.ScaleZ := scale_dust;
   end;
   if MY_G then begin
      scale_dust := scale_dust * 0.95;
      TransformDust.ScaleX := scale_dust;
      TransformDust.ScaleY := scale_dust;
      TransformDust.ScaleZ := scale_dust;
   end;
   if MY_UP then
   begin
      tran := +speed;
   end;
   if MY_DOWN then
   begin
      tran := -speed;
   end;
   if MY_LEFT then rot := -rspeed;
   if MY_LEFT2 then
   begin
      ang2 := ang2 + rspeed;
      if ang2 > 360.0 then ang2 := ang2 -360.0;
   end;
   if MY_RIGHT then rot := +rspeed;
   if MY_RIGHT2 then
   begin
      ang2 := ang2 - rspeed;
      if ang2 <   0.0 then ang2 := ang2 +360.0;
   end;
   if MY_E then
   begin
      ang3 := ang3 + rspeed;
      if ang3 > 360.0 then ang3 := ang3 -360.0;
   end;
   if MY_D then
   begin
      ang3 := ang3 - rspeed;
      if ang3 <   0.0 then ang3 := ang3 +360.0;
   end;

   angl := angl+rot;
   if angl > 360.0 then angl := angl -360.0;
   if angl <   0.0 then angl := angl +360.0;

   theta := angl *pi180;
   savex := wx;
   wx := wx -tran *sin(theta);
   savez := wz;
   wz := wz +tran *cos(theta);

   wy := wy +alt;
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    FreeMem(bulk);
    FreeMem(Brick);
    FreeMem(world);
    freeMem(grass);
    freeMem(Sun);
    freeMem(Neptune);
    gluDeleteQuadric(globe);
end;



procedure TForm1.Timer1Timer(Sender: TObject);
const
   rollover = 10;
   mspersec = 1000.0;
   half = 1/60000.0;
   fullrot = 360.0;
var
   deltaAngle,
   averageTime,
   timedif: GLfloat;
   count, count2: integer;
begin
   Adjust;
   inc(frames);
   elapsed := TimeGetTime;
   timedif := (elapsed - start);
   averageTime := timedif/frames;
   deltaAngle := fullrot*averageTime*half;
   ang := ang+deltaAngle;
   if ang>= 360.0 then
      ang := ang-360.0;


   if frames >= rollover then
   begin
      start := elapsed;
      frames := 0;
   end;

   TimeCodeBegin;

   inc(Time_Bump);

   for count := Active_planets downto 0 do begin
      Sol[count].Axis := Sol[count].Axis + (360 / Sol[count].Day / Time_warp);
      if Sol[count].Axis >= 360.0 then
         Sol[count].Axis := Sol[count].Axis-360.0;


      if Time_bump >= Time_warp then begin

    button5.caption := inttostr(active_planets);
         for count2 := 0 to Active_planets do
         begin
            if count <> count2 then
               grav(count, count2);
         end;

      end;
   end;


   if Time_bump >= Time_warp then
      Time_bump := Time_bump - Time_warp;
   FormPaint(Self);
   TimeCodeEnd;
end;


procedure TForm1.SavePlanets;
var
   SaveStream: TFileStream;
   i, count: integer;
   f: GLfloat;
   p: TPoint;
   s: string;
begin
   s := ExtractFileDir(Application.ExeName);
   SaveDialog1.InitialDir := s;
   SaveDialog1.FileName := 'aapla2.pla';
      try
         SaveStream := TFileStream.Create(SaveDialog1.FileName, fmOpenWrite or fmCreate);

         i := active_planets;
         SaveStream.Write(i, sizeof(integer));
         i := Rider;
         SaveStream.Write(i, sizeof(integer));
         f := Pscale;
         SaveStream.Write(f, sizeof(GLfloat));
         f := day_in_seconds;
         SaveStream.Write(f, sizeof(GLfloat));

         for count := 0 to active_planets do
         begin
            i := Sol[count].Ref_planet;
            SaveStream.Write(i, sizeof(integer));
            f := Sol[count].radius;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].corona_radius;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].mass;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].au;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].axis;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].Inclination;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].day;
            SaveStream.Write(f, sizeof(GLfloat));

            f := Sol[count].year;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].AU_circumference;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].Au_avg;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].Albedo;
            SaveStream.Write(f, sizeof(GLfloat));

            p := Sol[count].vec;
            SaveStream.Write(p, sizeof(TPoint));
            p := Sol[count].place;
            SaveStream.Write(p, sizeof(TPoint));
         end;


         for count := active_planets+1 to MAX_PLANET do
         begin
//            i := -1;
            i := Sol[count].Ref_planet;

            SaveStream.Write(i, sizeof(integer));
            f := Sol[count].radius;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].corona_radius;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].mass;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].au;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].axis;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].Inclination;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].day;
            SaveStream.Write(f, sizeof(GLfloat));

            f := Sol[count].year;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].AU_circumference;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].Au_avg;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].Albedo;
            SaveStream.Write(f, sizeof(GLfloat));

            p := Sol[count].vec;
            SaveStream.Write(p, sizeof(TPoint));
            p := Sol[count].place;
            SaveStream.Write(p, sizeof(TPoint));
         end;
      finally
         SaveStream.Free;
      end;
end;

procedure TForm1.LoadPlanets;
var
   LoadStream: TFileStream;
   i, count: integer;
   f: GLfloat;
   p: TPoint;
begin
   OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   OpenDialog1.FileName := 'aapla2.pla';
   if FileExists(openDialog1.Filename) then
        try
         LoadStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);

         LoadStream.Read(i, sizeof(integer));
         active_planets := i;
         LoadStream.Read(i, sizeof(integer));
         Rider := i;
         LoadStream.Read(f, sizeof(GLfloat));
         Pscale := f;
         LoadStream.Read(f, sizeof(GLfloat));
         day_in_seconds := f;
         remainder_in_seconds := 86400 / day_in_seconds;

         for count := 0 to MAX_PLANET do
         begin
            LoadStream.Read(i, sizeof(integer));
            if i > -1 then begin
                  Sol[count].Ref_planet := i;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].radius := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].corona_radius := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].mass := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].au := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].axis := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].Inclination := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].day := f;

                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].year := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].AU_circumference := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].Au_avg := f;
                  LoadStream.Read(f, sizeof(GLfloat));
                  Sol[count].Albedo := f;

                  LoadStream.Read(p, sizeof(TPoint));
                  Sol[count].vec := p;
                  LoadStream.Read(p, sizeof(TPoint));
                  Sol[count].place := p;
            end else begin
               initPlanet(count);
                  RectifySeconds;

               // the following block is just to clear the load stream
               // for that planets' data
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));

                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));
                  LoadStream.Read(f, sizeof(GLfloat));

                  LoadStream.Read(p, sizeof(TPoint));
                  LoadStream.Read(p, sizeof(TPoint));

            end;
         end;
       finally
         LoadStream.Free;
         OpenGL1.ErrorCheck(OpenDialog1.FileName);
       end
   else
      InitSolarSystem;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   center_x, center_y,
   deltaX, deltaY: integer;
   pi18: double;
   ratio, changeX, changeY: GLfloat;
begin
   if ssShift in Shift then
   begin
      pi18 := pi/18.0;
      center_x := Form1.ClientWidth div 2;
      center_y := Form1.ClientHeight div 2;

      Vu_ang := (y -center_y) *-Pi18;
      Vl_ang := (center_x -x) *Pi18;
   end else begin
      if startX<0 then
         exit;

      deltaX := x-startX;
      deltaY := starty-y;
      with dust[selected_dust,0],OpenGL1 do
      begin
         ratio := -z/prxNear;
         changeX := deltaX*(prxRight-prxLeft)/ClientWidth;
         changeY := deltaY*(prxTop-prxBottom)/ClientHeight;
         x := trnX+changeX*ratio;
         y := trnY+changeY*ratio;
         //dippy
      end;
      dust[selected_dust,0] := Normalize(dust[selected_dust,0]);
   end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
   countElement=1;
   nearElement=1;
   farElement=1;
var
   selno, place: integer;
   hit, hits: GLint;
   ahit: PHit;
   mx, nearer, nearest: double;
begin
   Selection(x,y);
   with OpenGL1 do
      glFrustum(prxLeft,prxRight,prxBottom,prxTop,prxNear,prxFar);
   FormPaint(nil);
   hits := SelectionDone;
   if (hits<1) then
      exit;
   place := 1;
   nearest := 9e33;
   mx := maxint;

   selno := 0;
   for hit := 1 to hits do
   begin
      ahit := @PickBuffer[place];
      with ahit^ do
      begin
         nearer := dnear;
         if nearer<0 then
         begin
            nearer := mx+nearer;
            nearer := mx+nearer;
         end;
         if nearer<nearest then
         begin
            nearest := nearer;
            selno := names[1];
         end;
         place := place+countElement+nearElement+farElement+ncount;
      end;
   end;

   if (selno > 0) and
      (selno < MAX_DUST+1) then
   begin
      selected_dust := selNo;
      StartX := X;
      StartY := Y;
      startShift := Shift;
      with dust[selno,0] do
      begin
         trnX := x;
         trnY := y;
         trnZ := z;
      end;

   end;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   StartX := -1;
end;

procedure TForm1.RectifySeconds;
begin
   if day_in_seconds > 86400 then day_in_seconds := 86400;
   remainder_in_seconds := 86400 / day_in_seconds;
end;

procedure TForm1.InitSolarSystem;
var
   count : integer;
begin
   Rider := 0;

   rectifySeconds;

   for count := 0 to MAX_PLANET do
       InitPlanet(count);

end;

procedure TForm1.InitPlanet(count: integer);
begin
 case count of
 0: begin
   // sol
   Sol[0].Ref_planet := 0;
   Sol[0].radius   := 695000.0 * RADIUS_PLAY;
   Sol[0].corona_radius   := Sol[0].radius * 2.0;
   Sol[0].mass     := 1989000.0 * power(10, PLANET_MASS_SCALAR);
   Sol[0].au       := 0.0;
   Sol[0].axis     := 0.0;
   Sol[0].Inclination     := 7.25;
   Sol[0].day      := 25.3800;

   Sol[0].year     := 0.0;
   Sol[0].AU_circumference      := 0;
   Sol[0].Au_avg   := 0.0;
   Sol[0].Albedo   := 1.0;

   Sol[0].vec.x    := 0.0;
   Sol[0].vec.y    := 0.0;
   Sol[0].vec.z    := 0.0;
   Sol[0].place.x  := 0.0;
   Sol[0].place.y  := 0.0;
   Sol[0].place.z  := 0.0;
 end;
 1: begin
   // Jupiter
   Sol[1].Ref_planet := 0;
   Sol[1].radius := 71492.0 * RADIUS_PLAY;
   Sol[1].corona_radius   := Sol[1].radius * 0.01;
   Sol[1].mass := 1899.0 * power(10, PLANET_MASS_SCALAR);
   Sol[1].au := 5.20336301 * au;  // aphelion
   Sol[1].axis     := 3.13;
   Sol[1].Inclination := 1.30530;
   Sol[1].day      := 0.413538021;
   Sol[1].year     := 4333.2867 * DAY_IN_SECONDS;
   Sol[1].AU_circumference      := 32.675 * au;
   Sol[1].Au_avg   := 5.20336301 * au; // semi-major axis
   Sol[1].Albedo   := 0.52;
   MaterialJupiter.difRed   := Sol[1].Albedo;
   MaterialJupiter.difGreen := Sol[1].Albedo;
   MaterialJupiter.difBlue  := Sol[1].Albedo;
{   Sol[1].vec.x    := 0.0;
   Sol[1].vec.y    := (Sol[1].Au_circumference / Sol[1].year / active_planets)
                      +Sol[Sol[1].Ref_planet].vec.y;
   Sol[1].vec.z    := 0.0;
   Sol[1].place.x  := Sol[Sol[1].Ref_planet].Place.x
                     +Sol[Sol[1].Ref_planet].radius
                     +Sol[1].Au;
   Sol[1].place.y  := Sol[Sol[1].Ref_planet].Place.y;
   Sol[1].place.z  := Sol[Sol[1].Ref_planet].Place.z;
}

   Sol[1].vec.x    := 617540.0 * remainder_in_seconds / active_planets / -6.66;
   Sol[1].vec.y    := 717400.0 * remainder_in_seconds / active_planets / 100;
   Sol[1].vec.z    := 0.0;
   Sol[1].place.x  := Sol[Sol[1].Ref_planet].Place.x
                     +Sol[Sol[1].Ref_planet].radius;
   Sol[1].place.y  := Sol[Sol[1].Ref_planet].Place.y;
   Sol[1].place.z  := Sol[Sol[1].Ref_planet].Place.z;
 end;

 2: begin   // Saturn
   Sol[2].Ref_planet := 0;
   Sol[2].radius := 60268.0 * RADIUS_PLAY;
   Sol[2].corona_radius   := Sol[2].radius * 0.0;
   Sol[2].mass := 568.46 * power(10, PLANET_MASS_SCALAR);
   Sol[2].au := 9.53707032 * au;  // aphelion
   Sol[2].axis     := 0.0;
   Sol[2].Inclination := 26.73;
   Sol[2].day      := 24.0;
   Sol[2].year     := 10756.1995 * DAY_IN_SECONDS;
   Sol[2].AU_circumference      := 59.879 * au;
   Sol[2].Au_avg   := 9.53707032 * au; // semi-major axis
   Sol[2].Albedo   := 0.47;
   MaterialSaturn.difRed   := Sol[2].Albedo;
   MaterialSaturn.difGreen := Sol[2].Albedo;
   MaterialSaturn.difBlue  := Sol[2].Albedo;

   Sol[2].vec.x    := 0.0;
   Sol[2].vec.y    := (Sol[2].Au_circumference / Sol[2].year / active_planets)
                      +Sol[Sol[2].Ref_planet].vec.y;
//   Sol[2].vec.y    :=  9.137 *VECTOR_PLAY; // minimum orbital speed
   Sol[2].vec.z    := 0.0;
   Sol[2].place.x  := Sol[Sol[2].Ref_planet].Place.x
                     +Sol[Sol[2].Ref_planet].radius
                     +Sol[2].Au;
   Sol[2].place.y  := Sol[Sol[2].Ref_planet].Place.y;
   Sol[2].place.z  := Sol[Sol[2].Ref_planet].Place.z;
 end;

 3: begin   // Neptune
   Sol[3].Ref_planet := 0;
   Sol[3].radius := 24764.0 * RADIUS_PLAY;
   Sol[3].corona_radius   := Sol[3].radius * 0.0;
   Sol[3].mass := 102.43 * power(10, PLANET_MASS_SCALAR);
   Sol[3].au := 30.06896348 * au;  // aphelion
   Sol[3].axis     := 0.0;
   Sol[3].Inclination := 28.32;
   Sol[3].day      := 0.67125;
   Sol[3].year     := 	60223.3528 * DAY_IN_SECONDS;
   Sol[3].AU_circumference      := 188.925 * au;
   Sol[3].Au_avg   := 30.06896348 * au; // semi-major axis
   Sol[3].Albedo   := 0.41;
   MaterialNeptune.difRed   := Sol[3].Albedo;
   MaterialNeptune.difGreen := Sol[3].Albedo;
   MaterialNeptune.difBlue  := Sol[3].Albedo;

   Sol[3].vec.x    := 0.0;
   Sol[3].vec.y    := (Sol[3].Au_circumference / Sol[3].year / active_planets)
                      +Sol[Sol[3].Ref_planet].vec.y;
//   Sol[3].vec.y    := 5.385 *VECTOR_PLAY; // minimum orbital speed
   Sol[3].vec.z    := 0.0;
   Sol[3].place.x  := Sol[Sol[3].Ref_planet].Place.x
                     +Sol[Sol[3].Ref_planet].radius
                     +Sol[3].Au;
   Sol[3].place.y  := Sol[Sol[3].Ref_planet].Place.y;
   Sol[3].place.z  := Sol[Sol[3].Ref_planet].Place.z;
 end;

 4: begin   // Uranus
   Sol[4].Ref_planet := 0;
   Sol[4].radius := 25559.0 * RADIUS_PLAY;
   Sol[4].corona_radius   := Sol[4].radius * 0.0;
   Sol[4].mass := 86.832 * power(10, PLANET_MASS_SCALAR);
   Sol[4].au := 19.19126393 * au;
   Sol[4].axis     := 0.0;
   Sol[4].Inclination := 97.77;
   Sol[4].day      := -0.718333333;
   Sol[4].year     := 30707.4896 * DAY_IN_SECONDS;
   Sol[4].AU_circumference      := 120.515 * au;
   Sol[4].Au_avg   := 19.19126393 * au; // semi-major axis
   Sol[4].Albedo   := 0.51;
   MaterialUranus.difRed   := Sol[4].Albedo;
   MaterialUranus.difGreen := Sol[4].Albedo;
   MaterialUranus.difBlue  := Sol[4].Albedo;

   Sol[4].vec.x    := 0.0;
   Sol[4].vec.y    := (Sol[4].Au_circumference / Sol[4].year / active_planets)
                      +Sol[Sol[4].Ref_planet].vec.y;
// 6.486 *VECTOR_PLAY;
   Sol[4].vec.z    := 0.0;
   Sol[4].place.x  := Sol[Sol[4].Ref_planet].Place.x
                     +Sol[Sol[4].Ref_planet].radius
                     +Sol[4].Au;
   Sol[4].place.y  := Sol[Sol[4].Ref_planet].Place.y;
   Sol[4].place.z  := Sol[Sol[4].Ref_planet].Place.z;
 end;

 5: begin   // terra
   Sol[5].Ref_planet := 0;
   Sol[5].radius := 6372.795 * RADIUS_PLAY;
   Sol[5].corona_radius   := Sol[5].radius * 0.0;
   Sol[5].mass := 5.9736 * power(10, PLANET_MASS_SCALAR);
   Sol[5].au := 1.0000001124 * au; // aphelion
   Sol[5].axis := 0.0;
   Sol[5].Inclination     := 0.0;
   Sol[5].day      := 24.0;
   Sol[5].year     := 365.25641 * DAY_IN_SECONDS;
   Sol[5].AU_circumference      := 6.1790699007 * au;

   Sol[5].vec.x    := 0.0;
   Sol[5].vec.y    := (Sol[5].Au_circumference / Sol[5].year / active_planets)
                      +Sol[Sol[5].Ref_planet].vec.y;
   Sol[5].vec.z    := 0.0;
   Sol[5].place.x  := Sol[Sol[5].Ref_planet].Place.x +Sol[5].Au;
   Sol[5].place.y  := Sol[Sol[5].Ref_planet].Place.y;
   Sol[5].place.z  := Sol[Sol[5].Ref_planet].Place.z;
 end;

 6: begin   // venus
   Sol[6].Ref_planet := 0;
   Sol[6].radius := 6051.8 * RADIUS_PLAY;
   Sol[6].corona_radius   := Sol[6].radius * 0.0;
   Sol[6].mass := 4.869 * power(10, PLANET_MASS_SCALAR);
   Sol[6].au := 0.72333199 * au; // semi-major axis
   Sol[6].axis := 0.0;
   Sol[6].Inclination     := 0.0;
   Sol[6].day      := 24.0;
   Sol[6].year     := 224.70069 * DAY_IN_SECONDS;
   Sol[6].AU_circumference      := 4.545 * au;

   Sol[6].vec.x    := 0.0;
   Sol[6].vec.y    := (Sol[6].Au_circumference / Sol[6].year / active_planets)
                      +Sol[Sol[6].Ref_planet].vec.y;
// 34.784 *VECTOR_PLAY; // minimum orbital speed
   Sol[6].vec.z    := 0.0;
   Sol[6].place.x  := Sol[Sol[6].Ref_planet].Place.x +Sol[6].Au;
   Sol[6].place.y  := Sol[Sol[6].Ref_planet].Place.y;
   Sol[6].place.z  := Sol[Sol[6].Ref_planet].Place.z;
 end;

 7: begin   // mars
   Sol[7].Ref_planet := 0;
   Sol[7].radius := 3397.0 * RADIUS_PLAY;
   Sol[7].corona_radius   := Sol[7].radius * 0.0;
   Sol[7].mass := 0.64219 * power(10, PLANET_MASS_SCALAR);
   Sol[7].au := 1.52366231 * au;  // semi-major axis
   Sol[7].axis := 0.0;
   Sol[7].Inclination     := 0.0;
   Sol[7].day      := 24.0;
   Sol[7].year     := 686.9600 * DAY_IN_SECONDS;
   Sol[7].AU_circumference      := 9.553 * au;

   Sol[7].vec.x    := 0.0;
   Sol[7].vec.y    := (Sol[7].Au_circumference / Sol[7].year / active_planets)
                      +Sol[Sol[7].Ref_planet].vec.y;
   Sol[7].vec.z    := 0.0;
   Sol[7].place.x  := Sol[Sol[7].Ref_planet].Place.x +Sol[7].Au;
   Sol[7].place.y  := Sol[Sol[7].Ref_planet].Place.y;
   Sol[7].place.z  := Sol[Sol[7].Ref_planet].Place.z;
 end;

 8: begin   // mercury
   Sol[8].Ref_planet := 0;
   Sol[8].radius := 2440.0 * RADIUS_PLAY;
   Sol[8].corona_radius   := Sol[8].radius * 0.0;
   Sol[8].mass := 0.330 * power(10, PLANET_MASS_SCALAR);
   Sol[8].au := 0.38709893 * au; // aphelion
   Sol[8].axis := 0.0;
   Sol[8].Inclination     := 0.0;
   Sol[8].day      := 24.0;
   Sol[8].year     := 87.96934 * DAY_IN_SECONDS;
   Sol[8].AU_circumference      := 2.406 * au;

   Sol[8].vec.x    := 0.0;
   Sol[8].vec.y    := (Sol[8].Au_circumference / Sol[8].year / active_planets)
                      +Sol[Sol[8].Ref_planet].vec.y;
   Sol[8].vec.z    := 0.0;
   Sol[8].place.x  := Sol[Sol[8].Ref_planet].Place.x +Sol[8].Au;
   Sol[8].place.y  := Sol[Sol[8].Ref_planet].Place.y;
   Sol[8].place.z  := Sol[Sol[8].Ref_planet].Place.z;
 end;

 9: begin   // ganymede
   Sol[9].Ref_planet := 1;
   Sol[9].radius := 2631.2 * RADIUS_PLAY;
   Sol[9].corona_radius   := Sol[9].radius * 0.0;
   Sol[9].mass := 0.14819 * power(10, PLANET_MASS_SCALAR);
   Sol[9].au := 0.007163 * au; // Apoapsis
   Sol[9].axis := 0.0;
   Sol[9].Inclination     := 0.0;
   Sol[9].day      := 7.15455296;
   Sol[9].year     := 7.15455296 * DAY_IN_SECONDS;
   Sol[9].AU_circumference      := 0.045 * au;

   Sol[9].vec.x    := 0.0 +Sol[Sol[9].Ref_planet].vec.x;
   Sol[9].vec.y    := (Sol[9].Au_circumference / Sol[9].year / active_planets)
                      +Sol[Sol[9].Ref_planet].vec.y;
   Sol[9].vec.z    := 0.0 +Sol[Sol[9].Ref_planet].vec.z;
   Sol[9].place.x  := Sol[Sol[9].Ref_planet].Place.x
                     +Sol[Sol[9].Ref_planet].radius
                     +Sol[9].Au;
   Sol[9].place.y  := Sol[Sol[9].Ref_planet].Place.y;
   Sol[9].place.z  := Sol[Sol[9].Ref_planet].Place.z;
 end;

 10: begin   // Titan
   Sol[10].Ref_planet := 2;
   Sol[10].radius := 2575.0 * RADIUS_PLAY;
   Sol[10].corona_radius   := Sol[10].radius * 0.0;
   Sol[10].mass := 0.1345 * power(10, PLANET_MASS_SCALAR);
//   Sol[10].au := 0.0040840503486 * au;
   Sol[10].au := 0.0081681 * au;
   Sol[10].axis := 0.0;
   Sol[10].Inclination     := 0.0;
   Sol[10].day      := 15.94542;
   Sol[10].year     := 15.94542 * DAY_IN_SECONDS;
   Sol[10].AU_circumference      := 0.051321712469 * au;

   Sol[10].vec.x    := 0.0 +Sol[Sol[10].Ref_planet].vec.x;
   Sol[10].vec.y    := (Sol[10].Au_circumference / Sol[10].year / active_planets)
                      +Sol[Sol[10].Ref_planet].vec.y;
   Sol[10].vec.z    := 0.0 +Sol[Sol[10].Ref_planet].vec.z;
   Sol[10].place.x  := Sol[Sol[10].Ref_planet].Place.x
                      +Sol[Sol[10].Ref_planet].radius
                      +Sol[10].Au;
   Sol[10].place.y  := Sol[Sol[10].Ref_planet].Place.y;
   Sol[10].place.z  := Sol[Sol[10].Ref_planet].Place.z;
 end;

 11: begin   // Calisto
   Sol[11].Ref_planet := 1;
   Sol[11].radius := 2410.3 * RADIUS_PLAY;
   Sol[11].corona_radius   := Sol[11].radius * 0.0;
   Sol[11].mass := 0.10759 * power(10, PLANET_MASS_SCALAR);
   Sol[11].au := 0.012585 * au; // mean orbital radius
   Sol[11].axis := 0.0;
   Sol[11].Inclination     := 0.0;
   Sol[11].day      := 16.6890184;
   Sol[11].year     := 16.6890184 * DAY_IN_SECONDS;
   Sol[11].AU_circumference      := 0.079 * au;

   Sol[11].vec.x    := 0.0 +Sol[Sol[11].Ref_planet].vec.x;
   Sol[11].vec.y    := (Sol[11].Au_circumference / Sol[11].year / active_planets)
                      +Sol[Sol[11].Ref_planet].vec.y;
   Sol[11].vec.z    := 0.0 +Sol[Sol[11].Ref_planet].vec.z;
   Sol[11].place.x  := Sol[Sol[11].Ref_planet].Place.x
                     +Sol[Sol[11].Ref_planet].radius
                     +Sol[11].Au;
   Sol[11].place.y  := Sol[Sol[11].Ref_planet].Place.y;
   Sol[11].place.z  := Sol[Sol[11].Ref_planet].Place.z;
 end;

 12: begin   // Io
   Sol[12].Ref_planet := 1;
   Sol[12].radius := 1821.3 * RADIUS_PLAY;
   Sol[12].corona_radius   := Sol[12].radius * 0.0;
   Sol[12].mass := 0.089319 * power(10, PLANET_MASS_SCALAR);
   Sol[12].au := 0.00281889038963 * au; // Apoapsis
   Sol[12].axis := 0.0;
   Sol[12].Inclination     := 0.0;
   Sol[12].day      := 1.769137786;
   Sol[12].year     := 1.769137786 * DAY_IN_SECONDS;
   Sol[12].AU_circumference      := 0.017711482 * au;

   Sol[12].vec.x    := 0.0 +Sol[Sol[12].Ref_planet].vec.x;
   Sol[12].vec.y    := (Sol[12].Au_circumference / Sol[12].year / active_planets)
                      +Sol[Sol[12].Ref_planet].vec.y;
   Sol[12].vec.z    := 0.0 +Sol[Sol[12].Ref_planet].vec.z;
   Sol[12].place.x  := Sol[Sol[12].Ref_planet].Place.x
                      +Sol[Sol[12].Ref_planet].radius
                      +Sol[12].Au;
   Sol[12].place.y  := Sol[Sol[12].Ref_planet].Place.y;
   Sol[12].place.z  := Sol[Sol[12].Ref_planet].Place.z;
 end;

 13: begin   // luna
   Sol[13].Ref_planet := 5;
   Sol[13].radius := 1738.1 * RADIUS_PLAY;
   Sol[13].corona_radius   := Sol[13].radius * 0.0;
   Sol[13].mass := 0.0734673 * power(10, PLANET_MASS_SCALAR);
   Sol[13].au := 0.0025695552899 * au;   // semi-major axis
   Sol[13].axis := 5.145396;
   Sol[13].Inclination     := 1.5424;
   Sol[13].day      := 27.32166155;
   Sol[13].year     := 27.32166155 * DAY_IN_SECONDS;
   Sol[13].AU_circumference      := 0.01615264969 * au;

   Sol[13].vec.x    := 0.0 +Sol[Sol[13].Ref_planet].vec.x;
   Sol[13].vec.y    := (Sol[13].Au_circumference / Sol[13].year / active_planets)
                      +Sol[Sol[13].Ref_planet].vec.y;
   Sol[13].vec.z    := 0.0 +Sol[Sol[13].Ref_planet].vec.z;
   Sol[13].place.x  := Sol[Sol[13].Ref_planet].Place.x
                      +Sol[Sol[13].Ref_planet].radius
                      +Sol[13].Au;
   Sol[13].place.y  := Sol[Sol[13].Ref_planet].Place.y;
   Sol[13].place.z  := Sol[Sol[13].Ref_planet].Place.z;
 end;

 14: begin   // Europa
   Sol[14].Ref_planet := 1;
   Sol[14].radius := 1560.8 * RADIUS_PLAY;
   Sol[14].corona_radius   := Sol[14].radius * 0.0;
   Sol[14].mass := 0.048 * power(10, PLANET_MASS_SCALAR);
   Sol[14].au := 0.00453 * au; // Apoapsis
   Sol[14].axis := 0.0;
   Sol[14].Inclination     := 0.0;
   Sol[14].day      := 3.551181041;
   Sol[14].year     := 3.551181041 * DAY_IN_SECONDS;
   Sol[14].AU_circumference      := 0.028 * au;

   Sol[14].vec.x    := 0.0 +Sol[Sol[14].Ref_planet].vec.x;
   Sol[14].vec.y    := (Sol[14].Au_circumference / Sol[14].year / active_planets)
                      +Sol[Sol[14].Ref_planet].vec.y;
   Sol[14].vec.z    := 0.0 +Sol[Sol[14].Ref_planet].vec.z;
   Sol[14].place.x  := Sol[Sol[14].Ref_planet].Place.x
                     +Sol[Sol[14].Ref_planet].radius
                     +Sol[14].Au;
   Sol[14].place.y  := Sol[Sol[14].Ref_planet].Place.y;
   Sol[14].place.z  := Sol[Sol[14].Ref_planet].Place.z;
 end;

 15: begin   // Triton
   Sol[15].Ref_planet := 3;
   Sol[15].radius := 1353.0 * RADIUS_PLAY;
   Sol[15].corona_radius   := Sol[15].radius * 0.0;
   Sol[15].mass := 0.02147 * power(10, PLANET_MASS_SCALAR);
   Sol[15].au := 0.0023716915 * au; // Apoapsis
   Sol[15].axis := 0.0;
   Sol[15].Inclination     := 0.0;
   Sol[15].day      := -5.877;
   Sol[15].year     := 5.877 * DAY_IN_SECONDS;
   Sol[15].AU_circumference      := 0.014901777 * au;

   Sol[15].vec.x    := 0.0 +Sol[Sol[15].Ref_planet].vec.x;
   Sol[15].vec.y    := (Sol[15].Au_circumference / Sol[15].year / active_planets)
                      +Sol[Sol[15].Ref_planet].vec.y;
   Sol[15].vec.z    := 0.0 +Sol[Sol[15].Ref_planet].vec.z;
   Sol[15].place.x  := Sol[Sol[15].Ref_planet].Place.x
                    //  -Sol[Sol[15].Ref_planet].radius
                      -Sol[15].Au;
   Sol[15].place.y  := Sol[Sol[15].Ref_planet].Place.y;
   Sol[15].place.z  := Sol[Sol[15].Ref_planet].Place.z;
 end;

 16: begin   // Pluto
   Sol[16].Ref_planet := 0;
   Sol[16].radius := 1153.0 * RADIUS_PLAY;
   Sol[16].corona_radius   := Sol[16].radius * 0.0825;
   Sol[16].mass := 0.01305 * power(10, PLANET_MASS_SCALAR);
   Sol[16].au := 39.48168677 * au; // semi-major axis
   Sol[16].axis := 122.54;
   Sol[16].Inclination     := 17.14176;
   Sol[16].day      := -6.387230;
   Sol[16].year     := 90613.3055 * DAY_IN_SECONDS;
   Sol[16].AU_circumference      := 244.186 * au;

   Sol[16].vec.x    := 0.0 +Sol[Sol[16].Ref_planet].vec.x;
   Sol[16].vec.y    := (Sol[16].Au_circumference / Sol[16].year / active_planets)
                      +Sol[Sol[16].Ref_planet].vec.y;
   Sol[16].vec.z    := 0.0 +Sol[Sol[16].Ref_planet].vec.z;
   Sol[16].place.x  := Sol[Sol[16].Ref_planet].Place.y
                     +Sol[Sol[16].Ref_planet].radius
                     +Sol[16].Au;
   Sol[16].place.y  := Sol[Sol[16].Ref_planet].Place.y;
   Sol[16].place.z  := Sol[Sol[16].Ref_planet].Place.z;
 end;

 17: begin   // 2003 EL61 a.k.a. Santa
   Sol[17].Ref_planet := 0;
   Sol[17].radius := 2410.3 * RADIUS_PLAY;
   Sol[17].corona_radius   := Sol[17].radius * 0.0825;
   Sol[17].mass := 0.0042 * power(10, PLANET_MASS_SCALAR);
   Sol[17].au := 43.335 * au; // Semi-major Axis
   Sol[17].axis := 0.0;
   Sol[17].Inclination     := 28.19;
   Sol[17].day      := 0.16314;
   Sol[17].year     := 104234.0 * DAY_IN_SECONDS;
   Sol[17].AU_circumference      := 272.28183 * au;

   Sol[17].vec.x    := 0.0 +Sol[Sol[17].Ref_planet].vec.x;
   Sol[17].vec.y    := (Sol[17].Au_circumference / Sol[17].year / active_planets)
                      +Sol[Sol[17].Ref_planet].vec.y;
   Sol[17].vec.z    := 0.0 +Sol[Sol[17].Ref_planet].vec.z;
   Sol[17].place.x  := Sol[Sol[17].Ref_planet].Place.x
                     +Sol[Sol[17].Ref_planet].radius
                     +Sol[17].Au;
   Sol[17].place.y  := Sol[Sol[17].Ref_planet].Place.y;
   Sol[17].place.z  := Sol[Sol[17].Ref_planet].Place.z;
 end;

 18: begin
   // Titania
   Sol[18].Ref_planet := 4;
   Sol[18].radius := 788.9 * RADIUS_PLAY;
   Sol[18].corona_radius   := Sol[18].radius * 0.0825;
   Sol[18].mass := 0.003526 * power(10, PLANET_MASS_SCALAR);
   Sol[18].au := 0.00145824 * au; // mean radius
   Sol[18].axis := 0.0;
   Sol[18].Inclination     := 0.340;
   Sol[18].day      := 24.0;
   Sol[18].year     := 8.706 * DAY_IN_SECONDS;
   Sol[18].AU_circumference      := 0.00916239 * au;

   Sol[18].vec.x    := 0.0 +Sol[Sol[18].Ref_planet].vec.x;
   Sol[18].vec.y    := (Sol[18].Au_circumference / Sol[18].year / active_planets)
                      +Sol[Sol[18].Ref_planet].vec.y;
   Sol[18].vec.z    := 0.0 +Sol[Sol[18].Ref_planet].vec.z;
   Sol[18].place.x  := Sol[Sol[18].Ref_planet].Place.x
                     +Sol[Sol[18].Ref_planet].radius
                     +Sol[18].Au;
   Sol[18].place.y  := Sol[Sol[18].Ref_planet].Place.y;
   Sol[18].place.z  := Sol[Sol[18].Ref_planet].Place.z;
 end;

 19: begin   // Oberon
   Sol[19].Ref_planet := 4;
   Sol[19].radius := 761.4 * RADIUS_PLAY;
   Sol[19].corona_radius   := Sol[19].radius * 0.0825;
   Sol[19].mass := 0.003014 * power(10, PLANET_MASS_SCALAR);
   Sol[19].au := 0.00195029 * au; // mean radius
   Sol[19].axis := 0.0;
   Sol[19].Inclination     := 0.058;
   Sol[19].day      := 24.0;
   Sol[19].year     := 12.463234 * DAY_IN_SECONDS;
   Sol[19].AU_circumference      := 0.01225404 * au;

   Sol[19].vec.x    := 0.0 +Sol[Sol[19].Ref_planet].vec.x;
   Sol[19].vec.y    := (Sol[19].Au_circumference / Sol[19].year / active_planets)
                      +Sol[Sol[19].Ref_planet].vec.y;
   Sol[19].vec.z    := 0.0 +Sol[Sol[19].Ref_planet].vec.z;
   Sol[19].place.x  := Sol[Sol[19].Ref_planet].Place.x
                     +Sol[Sol[19].Ref_planet].radius
                     +Sol[19].Au;
   Sol[19].place.y  := Sol[Sol[19].Ref_planet].Place.y;
   Sol[19].place.z  := Sol[Sol[19].Ref_planet].Place.z;
 end;

 20: begin   // Sedna
   Sol[20].Ref_planet := 0;
   Sol[20].radius := 745.0 * RADIUS_PLAY;
   Sol[20].corona_radius   := Sol[20].radius * 0.0825;
   Sol[20].mass := 0.003014 * power(10, PLANET_MASS_SCALAR);
   Sol[20].au := 0.000003900580022 * au; // mean orbital radius
   Sol[20].axis := 0.0;
   Sol[20].Inclination     := 0.0;
   Sol[20].day      := 24.0;
   Sol[20].vec.x    := 0.0;
   Sol[20].vec.y    := 1.04 *VECTOR_PLAY;
   Sol[20].vec.z    := 0.0;
   Sol[20].place.x  := Sol[Sol[20].Ref_planet].Place.x
                     +Sol[Sol[20].Ref_planet].radius
                     +Sol[20].Au;
   Sol[20].place.y  := Sol[Sol[20].Ref_planet].Place.y;
   Sol[20].place.z  := Sol[Sol[20].Ref_planet].Place.z;
 end;

 21: begin   // Rhea
   Sol[21].Ref_planet := 2;
   Sol[21].radius := 764.0 * RADIUS_PLAY;
   Sol[21].corona_radius   := Sol[21].radius * 0.0825;
   Sol[21].mass := 0.0023166 * power(10, PLANET_MASS_SCALAR);
   Sol[21].au := 0.0000035234963 * au; // semimajor axis
   Sol[21].axis := 0.0;
   Sol[21].Inclination     := 0.0;
   Sol[21].day      := 24.0;
   Sol[21].vec.x    := 0.0;
   Sol[21].vec.y    := (8.49 *VECTOR_PLAY) +Sol[Sol[21].Ref_planet].vec.y;
   Sol[21].vec.z    := 0.0;
   Sol[21].place.x  := Sol[Sol[21].Ref_planet].Place.x
                     +Sol[Sol[21].Ref_planet].radius
                     +Sol[21].Au;
   Sol[21].place.y  := Sol[Sol[21].Ref_planet].Place.y;
   Sol[21].place.z  := Sol[Sol[21].Ref_planet].Place.z;
 end;

 22: begin   //  Quaoar a.k.a. 2002 LM60
   Sol[22].Ref_planet := 0;
   Sol[22].radius := 583.75 * RADIUS_PLAY;
   Sol[22].corona_radius   := Sol[22].radius * 0.0825;
   Sol[22].mass := 0.0026 * power(10, PLANET_MASS_SCALAR);
   Sol[22].au := 43.405 * au; // Apoapsis
   Sol[22].axis := 0.0;
   Sol[22].Inclination     := 0.0;
   Sol[22].day      := 24.0;
   Sol[22].vec.x    := 0.0;
   Sol[22].vec.y    := 4.52 *VECTOR_PLAY;
   Sol[22].vec.z    := 0.0;
   Sol[22].place.x  := Sol[Sol[22].Ref_planet].Place.x
                     +Sol[Sol[22].Ref_planet].radius
                     +Sol[22].Au;
   Sol[22].place.y  := Sol[Sol[22].Ref_planet].Place.y;
   Sol[22].place.z  := Sol[Sol[22].Ref_planet].Place.z;
 end;

 23: begin   // Iapetus
   Sol[23].Ref_planet := 2;
   Sol[23].radius := 718.0 * RADIUS_PLAY;
   Sol[23].corona_radius   := Sol[23].radius * 0.0825;
   Sol[23].mass := 0.0019739 * power(10, PLANET_MASS_SCALAR);
   Sol[23].au := 0.00002380259 * au; // Apoapsis
   Sol[23].axis := 0.0;
   Sol[23].Inclination     := 0.0;
   Sol[23].day      := 24.0;
   Sol[23].vec.x    := 0.0;
   Sol[23].vec.y    := (3.27 *VECTOR_PLAY) +Sol[Sol[23].Ref_planet].vec.y;
   Sol[23].vec.z    := 0.0;
   Sol[23].place.x  := Sol[Sol[23].Ref_planet].Place.x
                     +Sol[Sol[23].Ref_planet].radius
                     +Sol[23].Au;
   Sol[23].place.y  := Sol[Sol[23].Ref_planet].Place.y;
   Sol[23].place.z  := Sol[Sol[23].Ref_planet].Place.z;
 end;

 24: begin   // Charon
   Sol[24].Ref_planet := 18;
   Sol[24].radius := 602.5 * RADIUS_PLAY;
   Sol[24].corona_radius   := Sol[24].radius * 0.0825;
   Sol[24].mass := 0.00152 * power(10, PLANET_MASS_SCALAR);
   Sol[24].au := 0.13082394149654 * au; // semimajor axis
   Sol[24].axis := 0.0;
   Sol[24].Inclination     := 0.0;
   Sol[24].day      := 24.0;
   Sol[24].vec.x    := 0.0;
   Sol[24].vec.y    := (0.23 *VECTOR_PLAY) +Sol[Sol[24].Ref_planet].vec.y;
   Sol[24].vec.z    := 0.0;
   Sol[24].place.x  := Sol[Sol[24].Ref_planet].Place.x
                     +Sol[Sol[24].Ref_planet].radius
                     +Sol[24].Au;
   Sol[24].place.y  := Sol[Sol[24].Ref_planet].Place.y;
   Sol[24].place.z  := Sol[Sol[24].Ref_planet].Place.z;
 end;

 25: begin   // Ariel
   Sol[25].Ref_planet := 4;
   Sol[25].radius := 578.9 * RADIUS_PLAY;
   Sol[25].corona_radius   := Sol[25].radius * 0.0825;
   Sol[25].mass := 0.00135 * power(10, PLANET_MASS_SCALAR);
   Sol[25].au := 0.000001276086578 * au; // Apoapsis
   Sol[25].axis := 0.0;
   Sol[25].Inclination     := 0.0;
   Sol[25].day      := 24.0;
   Sol[25].vec.x    := 0.0;
   Sol[25].vec.y    := (5.52 *VECTOR_PLAY) +Sol[Sol[25].Ref_planet].vec.y;
   Sol[25].vec.z    := 0.0;
   Sol[25].place.x  := Sol[Sol[25].Ref_planet].Place.x
                     +Sol[Sol[25].Ref_planet].radius
                     +Sol[25].Au;
   Sol[25].place.y  := Sol[Sol[25].Ref_planet].Place.y;
   Sol[25].place.z  := Sol[Sol[25].Ref_planet].Place.z;
 end;

 26: begin   // Umbriel
   Sol[26].Ref_planet := 4;
   Sol[26].radius := 584.7 * RADIUS_PLAY;
   Sol[26].corona_radius   := Sol[26].radius * 0.0825;
   Sol[26].mass := 0.0012 * power(10, PLANET_MASS_SCALAR);
   Sol[26].au := 0.000001784783219 * au; // Apastron
   Sol[26].axis := 0.0;
   Sol[26].Inclination     := 0.0;
   Sol[26].day      := 24.0;
   Sol[26].vec.x    := 0.0;
   Sol[26].vec.y    := (4.650 *VECTOR_PLAY) +Sol[Sol[26].Ref_planet].vec.y;
   Sol[26].vec.z    := 0.0;
   Sol[26].place.x  := Sol[Sol[26].Ref_planet].Place.x
                     +Sol[Sol[26].Ref_planet].radius
                     +Sol[26].Au;
   Sol[26].place.y  := Sol[Sol[26].Ref_planet].Place.y;
   Sol[26].place.z  := Sol[Sol[26].Ref_planet].Place.z;
 end;

 27: begin   // Dione
   Sol[27].Ref_planet := 2;
   Sol[27].radius := 559.0 * RADIUS_PLAY;
   Sol[27].corona_radius   := Sol[27].radius * 0.0825;
   Sol[27].mass := 0.001096 * power(10, PLANET_MASS_SCALAR);
   Sol[27].au := 0.000002255351 * au; // Apoapsis
   Sol[27].axis := 0.0;
   Sol[27].Inclination     := 0.0;
   Sol[27].day      := 24.0;
   Sol[27].vec.x    := 0.0;
   Sol[27].vec.y    := (10.03 *VECTOR_PLAY) +Sol[Sol[27].Ref_planet].vec.y;
   Sol[27].vec.z    := 0.0;
   Sol[27].place.x  := Sol[Sol[27].Ref_planet].Place.x
                     +Sol[Sol[27].Ref_planet].radius
                     +Sol[27].Au;
   Sol[27].place.y  := Sol[Sol[27].Ref_planet].Place.y;
   Sol[27].place.z  := Sol[Sol[27].Ref_planet].Place.z;
 end;

 28 .. 82: begin
        //
        Sol[count].Ref_planet := 0;
        Sol[count].radius := 1.0 * RADIUS_PLAY;
        Sol[count].corona_radius   := Sol[count].radius * 0.0825;
        Sol[count].mass := 1.0 * power(10, PLANET_MASS_SCALAR);
        Sol[count].au := 1.0 * au;
        Sol[count].axis := 1.0;
        Sol[count].Inclination     := 1.0;
        Sol[count].day      := 24.0;
        Sol[count].vec.x    := 0.0;
        Sol[count].vec.y    := (0.0 *VECTOR_PLAY) +Sol[Sol[count].Ref_planet].vec.y;
        Sol[count].vec.z    := 0.0;
        Sol[count].place.x  := Sol[Sol[count].Ref_planet].Place.x
                     +Sol[Sol[count].Ref_planet].radius
                     +Sol[count].Au;
        Sol[count].place.y  := Sol[Sol[count].Ref_planet].Place.y;
        Sol[count].place.z  := Sol[Sol[count].Ref_planet].Place.z;
   end;

 83: begin   // phobos
   Sol[83].Ref_planet := 7;
   Sol[83].radius := 11.1 * RADIUS_PLAY;
   Sol[83].corona_radius   := Sol[83].radius * 0.0825;
   Sol[83].mass := 0.0000000108 * power(10, PLANET_MASS_SCALAR);
   Sol[83].au := 0.000062688 * au;
   Sol[83].axis := 0.0;
   Sol[83].Inclination     := 0.0;
   Sol[83].day      := 0.31891023;
   Sol[83].year     := 0.31891023 * DAY_IN_SECONDS;
   Sol[83].AU_circumference      := 0.000000393842255 * au;

   Sol[83].vec.x    := 0.0 +Sol[Sol[83].Ref_planet].vec.x;
   Sol[83].vec.y    := Sol[83].Au_circumference / Sol[83].year
                      +Sol[Sol[83].Ref_planet].vec.y;
   Sol[83].vec.z    := 0.0 +Sol[Sol[83].Ref_planet].vec.z;
   Sol[83].place.x  := Sol[Sol[83].Ref_planet].Place.x
                      +Sol[Sol[83].Ref_planet].radius
                      +Sol[83].Au;
   Sol[83].place.y  := Sol[Sol[83].Ref_planet].Place.y;
   Sol[83].place.z  := Sol[Sol[83].Ref_planet].Place.z;
 end;

 84.. 86: begin     //
        Sol[count].Ref_planet := 0;
        Sol[count].radius := 1.0 * RADIUS_PLAY;
        Sol[count].corona_radius   := Sol[count].radius * 0.0825;
        Sol[count].mass := 1.0 * power(10, PLANET_MASS_SCALAR);
        Sol[count].au := 1.0 * au;
        Sol[count].axis := 1.0;
        Sol[count].Inclination     := 1.0;
        Sol[count].day      := 24.0;
        Sol[count].vec.x    := 0.0;
        Sol[count].vec.y    := (0.0 *VECTOR_PLAY) +Sol[Sol[count].Ref_planet].vec.y;
        Sol[count].vec.z    := 0.0;
        Sol[count].place.x  := Sol[Sol[count].Ref_planet].Place.x
                     +Sol[Sol[count].Ref_planet].radius
                     +Sol[count].Au;
        Sol[count].place.y  := Sol[Sol[count].Ref_planet].Place.y;
        Sol[count].place.z  := Sol[Sol[count].Ref_planet].Place.z;
   end;

 87: begin  // deimos
   Sol[87].Ref_planet := 7;
   Sol[87].radius := 6.3 * RADIUS_PLAY;
   Sol[87].corona_radius   := Sol[87].radius * 0.0825;
   Sol[87].mass := 0.0000000018 * power(10, PLANET_MASS_SCALAR);
   Sol[87].au := 0.00015681 * au;
   Sol[87].axis := 0.0;
   Sol[87].Inclination     := 0.0;
   Sol[87].day      := 24.0;
   Sol[87].vec.x    := 0.0;
   Sol[87].vec.y    := (1.36 *VECTOR_PLAY) +Sol[Sol[87].Ref_planet].vec.y;
   Sol[87].vec.z    := 0.0;
   Sol[87].place.x  := Sol[Sol[87].Ref_planet].Place.x
                     +Sol[Sol[87].Ref_planet].radius
                     +Sol[87].Au;
   Sol[87].place.y  := Sol[Sol[87].Ref_planet].Place.y;
   Sol[87].place.z  := Sol[Sol[87].Ref_planet].Place.z;
 end;

 88 .. MAX_PLANET: begin    //
        Sol[count].Ref_planet := 0;
        Sol[count].radius := 1.0 * RADIUS_PLAY;
        Sol[count].mass := 1.0 * power(10, PLANET_MASS_SCALAR);
        Sol[count].au := 1.0 * au;
        Sol[count].axis := 1.0;
        Sol[count].Inclination     := 1.0;
        Sol[count].day      := 24.0;
        Sol[count].vec.x    := 0.0;
        Sol[count].vec.y    := (0.0 *VECTOR_PLAY) +Sol[Sol[count].Ref_planet].vec.y;
        Sol[count].vec.z    := 0.0;
        Sol[count].place.x  := Sol[Sol[count].Ref_planet].Place.x
                     +Sol[Sol[count].Ref_planet].radius
                     +Sol[count].Au;
        Sol[count].place.y  := Sol[Sol[count].Ref_planet].Place.y;
        Sol[count].place.z  := Sol[Sol[count].Ref_planet].Place.z;
   end;
 end;

end;

function GetVector(p1, p2: TPoint): TPoint;
begin
   with Result do
   begin
      x := p2.x - p1.x;
      y := p2.y - p1.y;
      z := p2.z - p1.z;
   end;
end;

function Dot(v1, v2: Tpoint): GLfloat;
begin
   //
   v1 := normalize(v1);
   v2 := normalize(v2);
      Result :=
              +(v1.x * v2.x)
              +(v1.y * v2.y)
              +(v1.z * v2.z);
end;




procedure TForm1.Grav(count, count2: integer);
var
   d, scalar: GLFloat;
   m1, m2, r1, r2: double;
   p1, p2, p3, p4, p5: TPoint;
   dot : integer;
begin
   p1.x := Sol[count].place.x;
   p1.y := Sol[count].place.Y;
   p1.z := Sol[count].place.Z;

   p2.x := Sol[count2].place.x;
   p2.y := Sol[count2].place.Y;
   p2.z := Sol[count2].place.Z;

   m1 := Sol[count].mass;
   m2 := Sol[count2].mass;

   r1 := Sol[count].radius;
   r2 := Sol[count2].radius;

   d := DistanceSqr(p1,p2);
   d := d - (sol[count2].corona_radius * sol[count2].corona_radius);
   d := 1/d;
   d := d * m2 * GRAVITY_CONSTANT *REMAINDER_IN_SECONDS *REMAINDER_IN_SECONDS;
   d := d / active_planets;

   p3.x := p2.x-p1.x;
   p3.y := p2.y-p1.y;
   p3.z := p2.z-p1.z;

   p3 := normalize(p3);

   with Sol[count].vec do
   begin
      X := X +(p3.x *d);
      Y := Y +(p3.y *d);
      Z := Z +(p3.z *d);
   end;

   with Sol[count].place do
   begin
      X := X +Sol[count].vec.x;
      Y := Y +Sol[count].vec.y;
      Z := Z +Sol[count].vec.z;
   end;
end;

Procedure TForm1.GravOnEarth(count2: integer);
var
   d, scalar: GLFloat;
   m1, m2, r1, r2: double;
   p1, p2, p3, p4, p5: TPoint;
   dot : integer;
begin
   p1.x := Sol[count2].place.x;
   p1.y := Sol[count2].place.Y + sol[count2].radius;
   p1.z := Sol[count2].place.Z;

   p2.x := Sol[count2].place.x;
   p2.y := Sol[count2].place.Y;
   p2.z := Sol[count2].place.Z;

   m2 := Sol[count2].mass;

   r2 := Sol[count2].radius;

   d := DistanceSqr(p1,p2);
   d := d -(sol[count2].corona_radius * sol[count2].corona_radius);
   d := 1/d;
   d := d * m2 * GRAVITY_CONSTANT;

   p3.x := p2.x-p1.x;
   p3.y := p2.y-p1.y;
   p3.z := p2.z-p1.z;

   p3 := normalize(p3);

   with didymus do
   begin
      X := (p3.x *d);
      Y := (p3.y *d);
      Z := (p3.z *d);
   end;

end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   TransformLight.TranZ := -500 + (Trackbar1.Position *10);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    SavePlanets;
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
  InitSolarSystem;
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
begin
  Time_Warp := TrackBar2.Position;
  Label1.Caption := 'div: '+ IntToStr(Time_warp);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   gravonearth(0);
   form1.caption := Format('mps surface of earth? :%4.16f  %4.16f  %4.16f', [didymus.x, didymus.y, didymus.z]);

end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   form1.caption := Format('vector of Ganymede? :%4.16f  %4.16f  %4.16f', [sol[rider].vec.x, sol[rider].vec.y, sol[rider].vec.z]);

end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   Sol[Rider].Ref_planet := -1;
end;

procedure TForm1.UpDown1Click(Sender: TObject; Button: TUDBtnType);
begin
  Active_second := UpDown1.Position;
  Button3.Caption := IntToStr(Active_second);
end;

procedure TForm1.AbolishTime(mult: Double);
var
  count, old_warp: integer;
begin
   old_warp := Time_Warp;
   Time_warp := 10000;

   day_in_seconds := day_in_seconds * mult;
   remainder_in_seconds := 86400 / day_in_seconds;

   for count := 1 to active_planets do begin
      Sol[count].vec.x := Sol[count].vec.x / mult;
      Sol[count].vec.y := Sol[count].vec.y / mult;
      Sol[count].vec.z := Sol[count].vec.z / mult;

      Sol[count].vec.x := Sol[count].vec.x * active_planets/ (active_planets+1);
      Sol[count].vec.y := Sol[count].vec.y * active_planets/ (active_planets+1);
      Sol[count].vec.z := Sol[count].vec.z * active_planets/ (active_planets+1);
   end;
   inc(active_planets);
   initPlanet(active_planets);

   button7.caption := inttostr(active_planets);
   button5.Caption := inttostr(active_planets);

   Time_Warp := old_warp;
end;


procedure TForm1.Button5Click(Sender: TObject);
begin
   AbolishTime(1);
end;

procedure TForm1.Button6Click(Sender: TObject);
var
  count: integer;
begin

  If active_planets < 1 then begin

      day_in_seconds := 1440;
      remainder_in_seconds := 86400 / day_in_seconds;

      for count := 1 to active_planets do begin
         Sol[count].vec.x := Sol[count].vec.x / 1440;
         Sol[count].vec.y := Sol[count].vec.y / 1440;
         Sol[count].vec.z := Sol[count].vec.z / 1440;

         Sol[count].vec.x := Sol[count].vec.x * active_planets/ (active_planets-1);
         Sol[count].vec.y := Sol[count].vec.y * active_planets/ (active_planets-1);
         Sol[count].vec.z := Sol[count].vec.z * active_planets/ (active_planets-1);
      end;

      dec(active_planets);
   button7.caption := inttostr(active_planets);
   button5.Caption := inttostr(active_planets);
  end;
end;

procedure TForm1.Button7Click(Sender: TObject);
begin
   AbolishTime(10)
end;

end.
