unit Set_DirP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, filectrl, ExtCtrls, Registry;

type
  TDir_Form1 = class(TForm)
    Dir_Edit1: TEdit;
    Dir_Button1: TButton;
    Dir_Button2: TButton;
    Dir_Button3: TButton;
    Dir_Panel1: TPanel;
    Dir_Panel2: TPanel;
    Dir_Memo1: TMemo;
    Dir_Image1: TImage;
    Dir_Label1: TLabel;
    Dir_Label2: TLabel;
    Dir_Label3: TLabel;
    Dir_Label4: TLabel;
    Dir_Label5: TLabel;
    Dir_Image2: TImage;
    Dir_Image3: TImage;
    Dir_Image4: TImage;
    Dir_Image5: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Dir_Form1: TDir_Form1;

implementation

{$R *.DFM}
var
   step: integer;
   Path, id1, maps, User_Total_Saved: string;
   Qexe, GLQexe: Boolean;
   Tex0, Tex1, Tex2, Tex3, Tex4, Tex5: string;
   IniFile: TRegIniFile;

procedure TDir_Form1.Dir_FormCreate(Sender: TObject);
begin
     IniFile := TRegIniFile.Create('software\Branya');
     Step := 0;
     Path := 'C:\Quake';
     Dir_Edit1.Text := Path;
     Qexe := False;
     GLQexe := False;
     id1 := 'id1';
     maps := 'maps';
     tex0 :=
          '     To run Hex_Lab maps in quake the .BSP file '
          +' needs to be in the \QUAKE\ID1\MAPS directory.  '
          +'Listed above are a few steps'
          +' that will ensure this goes smoothly.  Click continue'
          +' when ready.';
     tex1 :=
          '     Testing for Quake directory...';
     Tex2 :=
          '     Testing for Quake.exe';
     Tex3 :=
          '     Testing for ID1 directory';
     Tex4 :=
          '     Testing for MAPS directory...';
     Tex5 :=
          '     Writing path info to    '+
          'HKEY_CURRENT_USER\Software\Branya\Hex_Lab';
end;

procedure TDir_Form1.Dir_FormPaint(Sender: TObject);
begin

     if Step = 0 then
     begin
          Dir_Memo1.Text := Tex0;
     end;
end;

procedure TDir_Form1.Dir_Button3Click(Sender: TObject);
begin
     Step := Step + 1;
     if Step = 0 then
     begin
          Dir_Label1.Caption :=
              'Path to Quake directory';
          Dir_Memo1.Text := Tex0;
     end;

     if Step > 1 then
        Dir_Button2.Visible := True;

     if step = 1 then
     begin
          Dir_Memo1.Text := Tex1;
          Dir_Edit1.Text := Path;
          if DirectoryExists(Dir_edit1.text) then
          begin
               Dir_Image1.Visible := True;
               Dir_Memo1.Text := Dir_Memo1.Text + '  '+
                  'Directory found.  Click Continue.';
          end
          else
          begin
             messagedlg('Directory does not exist.'+
                '  Please enter your Quake path in the'+
                ' edit window, or click on the Browse button',
                mtinformation,[mbok],0);
             step := step -1;
             Dir_Button1.Visible := True;
          end;
     end;

     If step = 2 then
     begin
          Dir_Button1.Visible := False;
          Dir_Memo1.Text := Tex2;
          if FileSearch('quake.exe',path)<> '' then
          begin
               Dir_memo1.Text := Memo1.Text + '  '+
                  'File quake.exe';
               Dir_Image2.Visible := True;
               Qexe := True;

               if FileSearch('glquake.exe',path)<> '' then
               begin
                    Dir_memo1.Text := Memo1.Text +
                    ', and glquake.exe';
                    Dir_Image2.Visible := True;
                    GLQexe := True;
               end;
               Dir_Memo1.Text := Dir_Memo1.Text + ' exists. Continue.';
          end
          else
          begin
               if FileSearch('glquake.exe',path)<> '' then
               begin
                    Dir_memo1.Text := Dir_Memo1.Text + '  '+
                    'OK, file glquake.exe exists.  Continue.';
                    Dir_Image2.Visible := True;
                    GLQexe := True;
               end
               else
               begin
                     messagedlg(
                       '  Neither Quake.exe or GLQuake.exe exist in the '+
                       path+' directory.  Go back and make sure the directory '+
                       ' selected is correct.  If this message continues to pop '+
                       ' up, make sure Quake is properly installed.'
                       ,mtinformation,[mbok],0);

                     step := step -1;

               end;
          end;
     end;

     If step = 3 then
     begin
          Memo1.Text := Tex3;
          if DirectoryExists(Path+ '\' +id1) then
          begin
               Dir_Image3.Visible := True;
               Dir_Edit1.Text := Path + '\' + id1;
               Dir_Memo1.Text := Dir_Memo1.Text + '  '+
                  'Directory found.  Click Continue.';
          end
          else
          begin
             messagedlg('Directory does not exist.'+
                '  This is highly irregular.  ID1 is part'+
                ' of the standard quake install.  Try going'+
                ' back or reinstalling quake.'
                ,mtinformation,[mbok],0);
             Dir_Memo1.Text := Tex2;
             Dir_Image2.Visible := False;
             step := step -2;
          end;
     end;

     If step = 4 then
     begin
          Dir_Memo1.Text := Tex4;
          if DirectoryExists(Dir_Edit1.Text+ '\' +maps) then
          begin
               Dir_Image4.Visible := True;
               Dir_Edit1.Text := Path +'\'+ id1 +'\'+ maps;
               Dir_Memo1.Text := Memo1.Text + '  '+
                  'Directory found.  Click Continue.';
          end
          else
          begin
               if
             messagedlg('Directory does not exist.'+
                '  This is normal.  \MAPS will now be added'+
                ' to '+Dir_Edit1.Text+'.  All maps run in Hex_Lab'+
                ' will have the .BSP files stored in this directory.'
                ,mtinformation,[mbok, mbCancel],0) = mrok then
                begin
                     Dir_Edit1.Text := Path +  '\' +id1+ '\' +maps;
                     ForceDirectories(Dir_Edit1.Text);
                     Dir_Image4.Visible := True;
                end
                else
                begin
                     Dir_Memo1.Text := Tex3;
                     Dir_Image3.Visible := False;
                     step := step -2;
                end;
          end;
     end;

     If step = 5 then
     begin
          Dir_Memo1.Text := Tex5;
          IniFile.WriteString('Hex_Lab','Qpath', Path);
          IniFile.WriteBool('Hex_Lab','Qexe', Qexe);
          IniFile.WriteBool('Hex_Lab','GLQexe', GLQexe);
          User_Total_Saved := IntToStr(0);
          IniFile.WriteInteger('Hex_Lab','User_Total_Saved',StrToInt(User_Total_Saved));


          Dir_Memo1.Text := Memo1.Text + '                                        '+
          '              CLICK CONTINUE TO EXIT.';
          Dir_Image5.Visible := True;

     end;

     If Step > 5 then
     begin
          Application.Terminate;
     end;

end;

procedure TDir_Form1.Dir_Button1Click(Sender: TObject);
var
   Text: string;
begin
   Text := Path;
   if SelectDirectory (Text, [
       sdAllowCreate,
       sdPerformCreate,
       sdPrompt
       ],0) then
   begin
        Dir_Edit1.Text := Text;
        Path := Text;
        Dir_Button1.Visible := False;
        Dir_Label1.Caption :=
            'Path to '+
            Dir_Edit1.Text +
            ' directory';
        Dir_Memo1.Text := Memo1.Text + '  '+
           'Directory found.  Click Continue.';
        Dir_Image1.Visible := True;
        Step := Step + 1;
   end;

end;

procedure TDir_Form1.Dir_Button2Click(Sender: TObject);
begin
     if step = 1 then
     begin
        Image1.Visible := False;
        Memo1.Text := Tex0;
        Dir_Edit1.Text := 'C:\quake';
        Path := 'C:\quake';
        Button2.Visible := False;
        step := 0;
     end;

     if step = 2 then
     begin
        Image2.Visible := False;
        Memo1.Text := Tex1;
        step := 1;
     end;

     if step = 3 then
     begin
        Image3.Visible := False;
        Memo1.Text := Tex2;
        step := 2;
     end;

     if step = 4 then
     begin
        Image4.Visible := False;
        Memo1.Text := Tex3;
        step := 3;
     end;

     if step = 5 then
     begin
        Image5.Visible := False;
        Memo1.Text := Tex4;
        step := 4;
     end;

end;

procedure TDir_Form1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     IniFile.Destroy;
end;

end.
