unit Trans;

interface

uses
  Classes,
  OpenGL;

type
  TTrans=class(TComponent)
  private
    FTranX,
    FTranY,
    FTranZ,
    FAxisX,
    FAxisY,
    FAxisZ,
    FAngle,
    FScaleX,
    FScaleY,
    FScaleZ: GLfloat;
    FOnPaint: TNotifyEvent;

  protected
    procedure Paint; virtual;
  public
    constructor Create(AOwner:TComponent); override;
    procedure Apply;
  published
    property TranX: GLfloat read FTranX write FTranX;
    property TranY: GLfloat read FTranY write FTranY;
    property TranZ: GLfloat read FTranZ write FTranZ;
    property TAxisX: GLfloat read FAxisX write FAxisX;
    property TAxisY: GLfloat read FAxisY write FAxisY;
    property TAxisZ: GLfloat read FAxisZ write FAxisZ;
    property TAngle: GLfloat read FAngle write FAngle;
    property TScaleX: GLfloat read FScaleX write FScaleX;
    property TScaleY: GLfloat read FScaleY write FScaleY;
    property TScaleZ: GLfloat read FScaleZ write FScaleZ;
    property OnPaint: TNotifyEvent read FOnPaint write FOnPaint;
end; {TTrans}

procedure Register;

implementation

constructor TTrans.Create(AOwner:TComponent);
begin
  inherited Create(AOwner);
  FScaleX := 1.0;
  FScaleY := 1.0;
  FScaleZ := 1.0;
end;

procedure TTrans.Apply;
begin
  glMatrixMode(GL_MODELVIEW);
  glPushMatrix;
  glScalef(FScaleX,FScaleY,FScaleZ);
  glRotatef(Fangle,FAxisX,FAxisY,FAxisZ);
  glTranslatef(TranX,TranY,TranZ);
  paint;
  glPopMatrix;
end;

procedure TTrans.Paint;
begin
  if Assigned(FOnPaint) then
    FOnPaint(Self);
end;

procedure Register;
begin
  RegisterComponents('OpenGL',[TTrans]);
end;

end.
