unit TypesDMG;

interface

uses
   Math;


type
TStatDMG = record
   c1,c2,c3,c4,c5: string;
   ST, adj_ST, max_ST,
   DX, adj_DX, max_DX,
   IQ, adj_IQ, max_IQ,
   MA, adj_MA,
   MA_fly, adj_MA_fly,
   MA_swim, adj_MA_swim,
   HTH_D, HTH_mod,
   Armor,
   extra,
   Cost,
   Hexes,
   Half_life,
   Age,
   Race_number,
   Race_sub: integer;
   Kg: double;
   end;

type
TFloura_FaunaDMG = record
   Race,
   Race_Plural: string;
   Flavor: array [1..17] of string;
   Stat: array [1..17] of TStatDMG;
   end;

type
TJobDMG = record
     number: integer;
     name,
     list,
     guild: string;
     guild_dues: double;
     dues,
     dues_paid: integer;
     pay_dues,
     warrant_officer: boolean;
     prereq1,
     prereq2,
     prereq3,
     prereq4,
     prereq5,
     prereq6,
     prereq7,
     prereq8,
     prereq9: string;
     pay: string;
     Pay_d,
     risk_low,
     risk_high,
     Extra_points_to_date,
     weeks_to_date,
     weeks_left: integer;
     work_record: array [1..3224] of char;
  end;


type
TAbilityDMG = record
   Enabled: boolean;
   Name: string;
   cost,
   cost_per_hex,
   cost_to_maintain,
   IQ,
   Race: integer;
   prereq_or,
   prereq1,
   prereq2,
   prereq3,
   Free,
   Free2,
   Free3: string;
   Free_N,
   Free2_N,
   Free3_N: integer;
   Stype: char;
   Jtype: char;
   BookLength,
   BookCost: integer;
   Book_Kg,
   BookWeeks: double;
   ScrollCost: integer;
   end;

type
TEquipmentDMG = record
   name: string;
   Name_alt: array [1..8] of string;
   cost: double;
   final_cost: integer;
   note: char;
   weeks: Double;
   STday: integer;
   CostWeek: integer;
   Notes1: string;
   Notes2: string;
   Notes3: string;
   Notes4: string;
   Notes5: string;
   count: integer;
   IQ: integer;
   D: integer;
   Plus: integer;
   ST: integer;
   D2: integer;
   Plus2: integer;
   BookLength: integer;
   BookCost: integer;

   Kg: double;

   Cost_per_carat: double;
   Kg_per_carat: double;
   Carats: double;
   Total_cost: double;
   Total_Kg: double;

   weapon,
   Talent: string;
   Armor,
   DX_mod,
   MA_mod: integer;
   end;

type
TCharacterDMG = class
   Name,
   Race,
   Sex,
   Training: string;
   Stat: TStatDMG;
   Armor: integer;
   Armor_worn: Boolean;
   Job: TJobDMG;
   extra: integer;
   alive,
   revival_attempt: boolean;
   Wounds: array [-1..32] of integer;
   Fatigue: array [-2..32] of boolean;
   Abilities: array [-5..294] of boolean;
   Studied: array [-4..3] of integer;
   Ability_Str: array [1..7] of String;
   Study_Str: string;
   Ready_left, Ready_right, Ready_left2, Ready_right2,
   Ready_left_sub, Ready_right_sub, Ready_left2_sub,
   Ready_right2_sub: integer;
   Ready_left_Str, Ready_right_Str,
   Ready_left2_Str, Ready_right2_Str: String;
   Secondary1, Secondary2,
   Secondary1_Sub, Secondary2_Sub: integer;
   Secondary1_Str, Secondary2_Str: string;
   On_belt: array [1..8] of integer;
   On_belt_sub: array [1..8] of integer;
   On_belt_Str: array [1..2] of string;
   Hidden: array [1..5] of integer;
   Hidden_sub: array [1..5] of integer;
   Hidden_Str: array [1..2] of string;
   Worn: array [1..8] of integer;
   Worn_Sub: array [1..8] of integer;
   Worn_Str: array [1..2] of string;
   Total_KG,
   Total_KG_minus_back: double;
   MA_minus_2,
   MA_minus_4,
   MA_minus_6,
   MAX,
   Enc,
   EP,
   EP_running_total: integer;
   Quiver: array [1..20] of integer;
   money_pouch: double;
   Pouch: array [1..10] of integer;
   Pack: array [1..40] of integer;
   Active_Magic: array [1..5] of integer;
   Notes: array [1..3] of string;
   constructor init;
   procedure Assign(Sent: TCharacterDMG);
   end;

implementation

procedure Stat_init(Sent: TStatDMG);
begin
   With Sent do
   begin
   c1 := '';
   c2 := '';
   c3 := '';
   c4 := '';
   c5 := '';
   ST := 0;
   adj_ST := 0;
   max_ST := 665;
   DX := 0;
   adj_DX := 0;
   max_DX := 665;
   IQ := 0;
   adj_IQ := 0;
   max_IQ := 665;
   MA := 0;
   adj_MA := 0;
   MA_fly := 0;
   adj_MA_fly := 0;
   MA_swim := 0;
   adj_MA_swim := 0;
   HTH_D := 0;
   HTH_mod := 0;
   extra := 0;
   Cost := 0;
   Hexes := 0;
   Kg := 0.0;
   end;
end;

function Job_set_zero: TJobDMG;
begin
  With Result do
  begin
     pay_dues := True;
     number := 0;
        name := '';
        list := '';
        guild := '';
        guild_dues := 0.0;
        dues := 0;
        dues_paid := 0;
        prereq1 := '';
        prereq2 := '';
        prereq3 := '';
        prereq4 := '';
        prereq5 := '';
        prereq6 := '';
        prereq7 := '';
        prereq8 := '';
        prereq9 := '';
        pay := '';
        pay_d := 0;
        risk_low := 0;
        risk_high := 0;
        Extra_points_to_date := 0;
        weeks_to_date := 0;
     end;
end;

constructor TCharacterDMG.init;
var
   count: integer;
begin
   Name := '';
   Race := '';
   Sex := '';
   Training := '';
   Stat_Init(Self.Stat);
   Armor := 0;
   Armor_worn := False;

   Job := Job_set_zero;
   Alive := True;
   revival_attempt := false;
   for count := -1 to 32 do
      Wounds[count] := 0;
   for count := -2 to 32 do
      Fatigue[count] := False;
   for count := -13 to 365 do
      Abilities[count] := False;
   for count := -4 to 3 do
      Studied[count] := -7;
   for count := 1 to 7 do
     Ability_Str[count] := '';
   Study_Str := '';
   Ready_left := 0;
   Ready_right := 0;
   Ready_left2 := 0;
   Ready_right2 := 0;
   Secondary1 := 0;
   Secondary2 := 0;
   for count := 1 to 8 do
   begin
      On_belt[count] := 0;
      On_belt_Sub[count] := 0;
   end;
   for count := 1 to 5 do
   begin
      Hidden[count] := 0;
      Hidden_Sub[count] := 0;
   end;
   for count := 1 to 8 do
   begin
      Worn[count] := 0;
      Worn_Sub[count] := 0;
   end;
   for count := 1 to 2 do
   begin
      On_belt_Str[count] := '';
      Hidden_Str[count] := '';
      Worn_Str[count] := '';
   end;

   Total_KG := 0;
   Total_KG_minus_back := 0;
   MA_minus_2 := 0;
   MA_minus_4 := 0;
   MA_minus_6 := 0;
   MAX := 0;
   EP := 0;
   EP_running_total := 0;
   for count := 1 to 20 do
      Quiver[count] := 0;
   money_pouch := 0.0;
   for count := 1 to 10 do
      Pouch[count] := 0;
   for count := 1 to 40 do
      Pack[count] := 0;
   for count := 1 to 5 do
      Active_Magic[count] := 0;
   for count := 1 to 3 do
      Notes[count] := '';
end;

procedure Stat_Assign(Sub: TStatDMG; Sent: TStatDMG);
begin
  with Sub do
  begin
   c1 := Sent.c1;
   c2 := Sent.c2;
   c3 := Sent.c3;
   c4 := Sent.c4;
   c5 := Sent.c5;
   ST := Sent.ST;
   adj_ST := Sent.adj_ST;
   DX := Sent.DX;
   adj_DX := Sent.adj_DX;
   IQ := Sent.IQ;
   adj_IQ := Sent.adj_IQ;
   MA := Sent.MA;
   adj_MA := Sent.adj_MA;
   MA_fly := Sent.MA_fly;
   adj_MA_fly := Sent.adj_MA_fly;
   MA_swim := Sent.MA_swim;
   adj_MA_swim := Sent.adj_MA_swim;
   HTH_D := Sent.HTH_D;
   HTH_mod := Sent.HTH_mod;
   extra := Sent.extra;
   Cost := Sent.Cost;
   Hexes := Sent.Hexes;
   Kg := Sent.Kg;
  end;
end;

procedure Job_Assign(Sub: TJobDMG; Sent: TJobDMG);
begin
    With Sub do
    begin
     number := Sent.number;
     name := Sent.name;
     prereq1 := Sent.prereq1;
     prereq2 := Sent.prereq2;
     prereq3 := Sent.prereq3;
     prereq4 := Sent.prereq4;
     prereq5 := Sent.prereq5;
     prereq6 := Sent.prereq6;
     prereq7 := Sent.prereq7;
     prereq8 := Sent.prereq8;
     prereq9 := Sent.prereq9;
     pay := Sent.pay;
     risk_low := Sent.risk_low;
     risk_high := Sent.risk_high;
    end;
end;

procedure TCharacterDMG.Assign(Sent: TCharacterDMG);
var
   count: integer;
begin
   Name := Sent.Name;
   Race := Sent.Race;
   Sex := Sent.Sex;
   Training := Sent.Training;
   Stat_Assign(Stat, Sent.Stat);
   Armor := Sent.Armor;
   Armor_worn := Sent.Armor_worn;
   Job_Assign(Self.Job, Sent.Job);
   Alive := Sent.Alive;
   for count := 1 to 32 do
      Wounds[count] := Sent.Wounds[count];
   for count := -2 to 32 do
      Fatigue[count] := Sent.Fatigue[count];

   for count := -3 to 365 do
      Abilities[count] := False;
   for count := -4 to 3 do
      Studied[count] := 0;
   Ready_left := 0;
   Ready_right := 0;
   Ready_left2 := 0;
   Ready_right2 := 0;
   Secondary1 := 0;
   Secondary2 := 0;
   for count := 1 to 8 do
   begin
      On_belt[count] := 0;
      On_belt_sub[count] := 0;
      Worn[count] := 0;
      Worn_Sub[count] := 0;
   end;
   for count := 1 to 5 do
   begin
      Hidden[count] := 0;
      Hidden_Sub[count] := 0;
   end;

   Total_KG := Sent.Total_KG;
   Total_KG_minus_back := Sent.Total_KG_minus_back;
   MA_minus_2 := Sent.MA_minus_2;
   MA_minus_4 := Sent.MA_minus_4;
   MA_minus_6 := Sent.MA_minus_6;
   MAX := Sent.MAX;
   EP := Sent.EP;
   EP_running_total := Sent.EP_running_total;

   for count := 1 to 20 do
      Quiver[count] := 0;
   for count := 1 to 10 do
      Pouch[count] := 0;
   for count := 1 to 40 do
      Pack[count] := 0;
   for count := 1 to 5 do
      Active_Magic[count] := 0;
   for count := 1 to 3 do
      Notes[count] := Sent.Notes[count];
end;

end.
