unit Unit1;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, filectrl, ExtCtrls, IniFiles;

type
  TForm1 = class(TForm)
    Edit1: TEdit;
    Button1: TButton;
    Button2: TButton;
    Button3: TButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Memo1: TMemo;
    Image1: TImage;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Image2: TImage;
    Image3: TImage;
    Image4: TImage;
    Image5: TImage;
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}
var
   step: integer;
   Path, qexe, id1, maps: string;
   Tex0, Tex1, Tex2, Tex3, Tex4, Tex5, Tex6: string;
   IniFile: TiniFile;


procedure TForm1.FormCreate(Sender: TObject);
begin
     IniFile := TIniFile.Create('inione.ini');
     Step := 0;
     Path := 'C:\Quake';
     Edit1.Text := Path;
     qexe := '';
     id1  := '';
     maps := '';
     tex0 :=
          '     To run Hex_Lab maps in quake the .BSP file '
          +' needs to be in the \QUAKE\ID1\MAPS directory.  '
          +'From the quake console type MAP <MAPNAME> and it'
          +' should run.  Listed above are a few steps'
          +' that will ensure this goes smoothly.  Click continue'
          +' when ready.';
     tex1 :=
          '     Testing for Quake directory...';
     Tex2 :=
          '     Testing for Quake.exe';
     Tex3 :=
          '     Testing for ID1 directory';
     Tex4 :=
          '     Testing for MAPS directory...';
     Tex5 :=
          '     Writing path info to    '+
          'HKEY_CURRENT_USER\Software\Branya\Hex_Lab';
end;

procedure TForm1.FormPaint(Sender: TObject);
begin

     if Step = 0 then
     begin
          Memo1.Text := Tex0;
     end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
     Step := Step + 1;
     if Step = 0 then
     begin
          Label1.Caption :=
              'Path to Quake directory';
          Memo1.Text := Tex0;
     end;

     if Step > 1 then
        Button2.Visible := True;

     if step = 1 then
     begin
          Memo1.Text := Tex1;

          if DirectoryExists(edit1.text) then
          begin
               Image1.Visible := True;
               Memo1.Text := Memo1.Text + '  '+
                  'Directory found.  Click Continue.';
          end
          else
          begin
             messagedlg('Directory does not exist.'+
                '  Please enter your Quake path in the'+
                ' edit window, or click on the Browse button',
                mtinformation,[mbok],0);
             step := step -1;
             Button1.Visible := True;
          end;
     end;

     If step = 2 then
     begin
          Button1.Visible := False;
          Memo1.Text := Tex2;
          if FileSearch('quake.exe',path)<> '' then
          begin
               memo1.Text := Memo1.Text + '  '+
                  'OK, file quake.exe exists.  Click continue';
               Image2.Visible := True;
          end
          else
          begin
               if FileSearch('glquake.exe',path)<> '' then
               begin
                    memo1.Text := Memo1.Text + '  '+
                    'OK, file glquake.exe exists.  Click continue';
                    Image2.Visible := True;
               end
               else
               begin
                     messagedlg(
                       '  Neither Quake.exe or GLQuake.exe exist in the '+
                       path+' directory.  Go back and make sure the directory '+
                       ' selected is correct.  If this message continues to pop '+
                       ' up, make sure Quake is properly installed.'
                       ,mtinformation,[mbok],0);

                     step := step -1;

               end;
          end;
     end;

     If step = 3 then
     begin
          Memo1.Text := Tex3;
          if DirectoryExists(Path+'\ID1') then
          begin
               Image3.Visible := True;
               Edit1.Text := Edit1.Text + '\ID1';
               Memo1.Text := Memo1.Text + '  '+
                  'Directory found.  Click Continue.';
          end
          else
          begin
             messagedlg('Directory does not exist.'+
                '  This is highly irregular.  ID1 is part'+
                ' of the standard quake install.  Try going'+
                ' back or reinstalling quake.'
                ,mtinformation,[mbok],0);
             Memo1.Text := Tex2;
             Image2.Visible := False;
             step := step -2;
          end;
     end;

     If step = 4 then
     begin
          Memo1.Text := Tex4;
          if DirectoryExists(Edit1.Text+'\MAPS') then
          begin
               Image4.Visible := True;
               Edit1.Text := Edit1.Text + '\MAPS';
               Memo1.Text := Memo1.Text + '  '+
                  'Directory found.  Click Continue.';
          end
          else
          begin
               if
             messagedlg('Directory does not exist.'+
                '  This is normal.  \MAPS will now be added'+
                ' to '+Edit1.Text+'.  All maps run in Hex_Lab'+
                ' will have the .BSP files stored in this directory.'
                ,mtinformation,[mbok, mbCancel],0) = mrok then
                begin
                     Edit1.Text := Path + '\id1\MAPS';
                     ForceDirectories(Edit1.Text);
                     Image4.Visible := True;
                end
                else
                begin
                     Memo1.Text := Tex3;
                     Image3.Visible := False;
                     step := step -2;
                end;
          end;
     end;

     If step = 5 then
     begin
          Memo1.Text := Tex5;
          IniFile.WriteString('Hex_Lab','Qpath', Edit1.Text);
          Memo1.Text := Memo1.Text + '                                        '+
          '              CLICK CONTINUE TO EXIT.';
          Image5.Visible := True;

     end;

     If Step > 5 then
     begin
          Application.Terminate;
     end;

end;

procedure TForm1.Button1Click(Sender: TObject);
var
   text: string;
begin
   Text := Edit1.Text;
   if SelectDirectory (Text, [
       //sdAllowCreate,
       //sdPerformCreate,
       sdPrompt
       ],0) then
   begin
        Edit1.Text := Text;
        Path := Text;
        Button1.Visible := False;
        Label1.Caption :=
            'Path to '+
            Edit1.Text +
            ' directory';
        Memo1.Text := Memo1.Text + '  '+
           'Directory found.  Click Continue.';
        Image1.Visible := True;
        Step := Step + 1;
   end;

end;

procedure TForm1.Button2Click(Sender: TObject);
begin
     if step = 1 then
     begin
        Image1.Visible := False;
        Memo1.Text := Tex0;
        Edit1.Text := 'C:\quake';
        Button2.Visible := False;
        step := 0;
     end;

     if step = 2 then
     begin
        Image2.Visible := False;
        Memo1.Text := Tex1;
        step := 1;
     end;

     if step = 3 then
     begin
        Image3.Visible := False;
        Memo1.Text := Tex2;
        step := 2;
     end;

     if step = 4 then
     begin
        Image4.Visible := False;
        Memo1.Text := Tex3;
        step := 3;
     end;

     if step = 5 then
     begin
        Image5.Visible := False;
        Memo1.Text := Tex4;
        step := 4;
     end;

end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     IniFile.Destroy;
end;

end.
