unit WeapMultP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    ListBox1: TListBox;
    Panel1: TPanel;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    Button1: TButton;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
  private
    total_so_far, found: integer;
    procedure initWeapons;
    { Private declarations }
  public
    procedure ListWeapons;
    procedure ListWeapon(count: integer);
    procedure ListChosenWeapon(this_one: integer);
    { Public declarations }
  end;

type
  TWeaper = record
    mult: double;
    name: shortstring;
    nameP: shortstring;
    page: char;
    hand: shortString;
    body: Uint;
    oldBody: Uint;
    avg: double;
    dice: Uint;
    d_mod: integer;
    acc: Uint;
    bog: double;
    cost: double;
  end;

const
  max_weapon_set = 585;
  nameWidth      =  16;

var
  Form1: TForm1;
  weapon: array [1..max_weapon_set] of TWeaper;

implementation

{$R *.DFM}

procedure TForm1.InitWeapons;
var
   count, body: integer;
   f, i: double;
begin
    count := 1;
    weapon[count].name := 'quarrel';
    weapon[count].nameP := 'quarrels';
    weapon[count].page := 'R';
    weapon[count].hand := '';
    weapon[count].mult := 0.080024;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'arrow';
    weapon[count].nameP := 'arrows';
    weapon[count].page := 'B';
    weapon[count].hand := '';
    weapon[count].mult := 0.090007;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'tetsubishi';
    weapon[count].nameP := 'tetsubishi';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.120070;
    weapon[count].bog := 0.07;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'blowgun';
    weapon[count].nameP := 'glowguns';
    weapon[count].page := 'B';
    weapon[count].hand := '#';
    weapon[count].mult := 0.140070;
    weapon[count].bog := 0.05;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'shurikens';
    weapon[count].nameP := 'shuriken';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.140070;
    weapon[count].bog := 0.05;
    weapon[count].cost := 3.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'cat-o-nine-tails';
    weapon[count].nameP := 'tail';
    weapon[count].page := 'F';
    weapon[count].hand := '';
    weapon[count].mult := 0.180080;
    weapon[count].bog := 0.4;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'amentum';
    weapon[count].nameP := 'amentums';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.200070;
    weapon[count].bog := 0.2;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'atl';
    weapon[count].nameP := 'atls';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.200070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sling';
    weapon[count].nameP := 'slings';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.210060;
    weapon[count].bog := 0.3;
    weapon[count].cost := 2.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'knife';
    weapon[count].nameP := 'knives';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.230070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'chain';
    weapon[count].nameP := 'chains';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.230100;
    weapon[count].bog := 2.0;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bola';
    weapon[count].nameP := 'bolas';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.240090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'lasso';
    weapon[count].nameP := 'lassos';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.240110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'fist';
    weapon[count].nameP := 'fists';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.240090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 0.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'boomerang';
    weapon[count].nameP := 'boomerangs';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.240090;
    weapon[count].bog := 1.5;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'crossbow';
    weapon[count].nameP := 'crossbows';
    weapon[count].page := 'R';
    weapon[count].hand := '#';
    weapon[count].mult := 0.550120;
    weapon[count].bog := 3.0;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'arbalest';
    weapon[count].nameP := 'arbalests';
    weapon[count].page := 'R';
    weapon[count].hand := '#';
    weapon[count].mult := 0.670150;
    weapon[count].bog := 5.0;
    weapon[count].cost := 80.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bottle';
    weapon[count].nameP := 'bottles';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.260070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'mug';
    weapon[count].nameP := 'mugs';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.260070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'stiletto';
    weapon[count].nameP := 'stilettos';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.260070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'dagger';
    weapon[count].nameP := 'daggers';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'dirk';
    weapon[count].nameP := 'dirks';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'main-gauche';
    weapon[count].nameP := 'main-gauches';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sword breaker';
    weapon[count].nameP := 'sword breakers';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'javelin';
    weapon[count].nameP := 'javelins';
    weapon[count].page := 'P';
    weapon[count].hand := '';
    weapon[count].mult := 0.270090;
    weapon[count].bog := 1.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'blade';
    weapon[count].nameP := 'blades';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.270090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'chair';
    weapon[count].nameP := 'chairs';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.290120;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'tanto';
    weapon[count].nameP := 'tantos';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.290090;
    weapon[count].bog := 0.2;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'baton';
    weapon[count].nameP := 'batons';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.300090;
    weapon[count].bog := 1.0;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sap';
    weapon[count].nameP := 'saps';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.300080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'net';
    weapon[count].nameP := 'nets';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.300100;
    weapon[count].bog := 1.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bullwhip';
    weapon[count].nameP := 'bullwhips';
    weapon[count].page := 'F';
    weapon[count].hand := '';
    weapon[count].mult := 0.310090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'kama';
    weapon[count].nameP := 'kamas';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.310100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'lance';
    weapon[count].nameP := 'lances';
    weapon[count].page := 'P';
    weapon[count].hand := '';
    weapon[count].mult := 0.270090;
    weapon[count].bog := 2.0;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'spear';
    weapon[count].nameP := 'spears';
    weapon[count].page := 'P';
    weapon[count].hand := '';
    weapon[count].mult := 0.310110;
    weapon[count].bog := 3.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'rock';
    weapon[count].nameP := 'rocks';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 0.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'cudgel';
    weapon[count].nameP := 'cudgels';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.5;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'club';
    weapon[count].nameP := 'clubs';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.330080;
    weapon[count].bog := 1.5;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'crowbar';
    weapon[count].nameP := 'crowbars';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.330080;
    weapon[count].bog := 2.0;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'kiseru';
    weapon[count].nameP := 'kiser';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'escrima';
    weapon[count].nameP := 'escrim';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'small sword';
    weapon[count].nameP := 'small swords';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'tessun';
    weapon[count].nameP := 'tessu';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.5;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'stool';
    weapon[count].nameP := 'stools';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.330090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'tonfa';
    weapon[count].nameP := 'tonfas';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.330090;
    weapon[count].bog := 1.5;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'hunting bow';
    weapon[count].nameP := 'hunting bows';
    weapon[count].page := 'B';
    weapon[count].hand := '';
    weapon[count].mult := 0.350070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'ashiko';
    weapon[count].nameP := 'ashik';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.350110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'trident';
    weapon[count].nameP := 'tridents';
    weapon[count].page := 'P';
    weapon[count].hand := '';
    weapon[count].mult := 0.350100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'spear';
    weapon[count].nameP := 'spear';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.370110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'pike';
    weapon[count].nameP := 'pikes';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.360120;
    weapon[count].bog := 0.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bo staff';
    weapon[count].nameP := 'bo staves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.370080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'shinobi-zue';
    weapon[count].nameP := 'shinob-zue';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.370110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'nunchucka';
    weapon[count].nameP := 'nunchucks';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.380080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 35.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'epee';
    weapon[count].nameP := 'epee';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'hatchet';
    weapon[count].nameP := 'hatchets';
    weapon[count].page := 'M';
    weapon[count].hand := '';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 1.0;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'horse bow';
    weapon[count].nameP := 'horse bows';
    weapon[count].page := 'B';
    weapon[count].hand := '';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 2.0;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'rapier';
    weapon[count].nameP := 'rapiers';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'stool';
    weapon[count].nameP := 'stools';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 4.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'hammer';
    weapon[count].nameP := 'hammers';
    weapon[count].page := 'M';
    weapon[count].hand := '*';
    weapon[count].mult := 0.380100;
    weapon[count].bog := 2.0;
    weapon[count].cost := 25.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bench';
    weapon[count].nameP := 'benches';
    weapon[count].page := 'I';
    weapon[count].hand := '';
    weapon[count].mult := 0.380110;
    weapon[count].bog := 8.0;
    weapon[count].cost := 25.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'table';
    weapon[count].nameP := 'tables';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.390120;
    weapon[count].bog := 20.0;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sai';
    weapon[count].nameP := 'sai';
    weapon[count].page := 'O';
    weapon[count].hand := '';
    weapon[count].mult := 0.400080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'naginata';
    weapon[count].nameP := 'naginatas';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.400100;
    weapon[count].bog := 4.0;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'scythe';
    weapon[count].nameP := 'scythes';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.400110;
    weapon[count].bog := 4.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sectional';
    weapon[count].nameP := 'staves';
    weapon[count].page := 'F';
    weapon[count].hand := '';
    weapon[count].mult := 0.420100;
    weapon[count].bog := 3.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'foil';
    weapon[count].nameP := 'foils';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.450100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'lance';
    weapon[count].nameP := 'lances';
    weapon[count].page := 'P';
    weapon[count].hand := '';
    weapon[count].mult := 0.450110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'glave';
    weapon[count].nameP := 'glaves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.450120;
    weapon[count].bog := 6.0;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'longbow';
    weapon[count].nameP := 'longbows';
    weapon[count].page := 'B';
    weapon[count].hand := '#';
    weapon[count].mult := 0.460110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'quarterstaff';
    weapon[count].nameP := 'quarterstaves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.460110;
    weapon[count].bog := 1.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'small axe';
    weapon[count].nameP := 'small axes';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.460110;
    weapon[count].bog := 2.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bisen-toh';
    weapon[count].nameP := 'bisen-toh';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.500120;
    weapon[count].bog := 7.0;
    weapon[count].cost := 80.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'pike axe';
    weapon[count].nameP := 'pike axes';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.500150;
    weapon[count].bog := 10.0;
    weapon[count].cost := 130.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'cutlass';
    weapon[count].nameP := 'cutlass';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.530100;
    weapon[count].bog := 1.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'halberd';
    weapon[count].nameP := 'halberds';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.530130;
    weapon[count].bog := 8.0;
    weapon[count].cost := 70.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'mace';
    weapon[count].nameP := 'maces';
    weapon[count].page := 'M';
    weapon[count].hand := '';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 3.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sabre';
    weapon[count].nameP := 'sabres';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'short sword';
    weapon[count].nameP := 'short sword';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'wakazashi';
    weapon[count].nameP := 'wakazashis';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'military pick';
    weapon[count].nameP := 'military picks';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.560120;
    weapon[count].bog := 4.0;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'boomerang';
    weapon[count].nameP := 'boomerangs';
    weapon[count].page := 'T';
    weapon[count].hand := '';
    weapon[count].mult := 0.560120;
    weapon[count].bog := 1.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'flail';
    weapon[count].nameP := 'flails';
    weapon[count].page := 'F';
    weapon[count].hand := '';
    weapon[count].mult := 0.580120;
    weapon[count].bog := 4.0;
    weapon[count].cost := 70.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'broadsword';
    weapon[count].nameP := 'broadswrods';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.600120;
    weapon[count].bog := 2.5;
    weapon[count].cost := 80.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'ninja-toh';
    weapon[count].nameP := 'ninja-toh';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.600120;
    weapon[count].bog := 2.5;
    weapon[count].cost := 180.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'sword';
    weapon[count].nameP := 'sword';
    weapon[count].page := 'S';
    weapon[count].hand := '3';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'katana';
    weapon[count].nameP := 'katanas';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'maul';
    weapon[count].nameP := 'mauls';
    weapon[count].page := 'O';
    weapon[count].hand := '#';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 6.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'morning star';
    weapon[count].nameP := 'morning stars';
    weapon[count].page := 'M';
    weapon[count].hand := '';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 6.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'scimitar';
    weapon[count].nameP := 'scimitars';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'great hammer';
    weapon[count].nameP := 'great hammers';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.620140;
    weapon[count].bog := 8.0;
    weapon[count].cost := 110.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bastard sword';
    weapon[count].nameP := 'bastard swords';
    weapon[count].page := 'S';
    weapon[count].hand := '';
    weapon[count].mult := 0.650130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'bastard sword';
    weapon[count].nameP := 'bastard swords';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.680130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'katana';
    weapon[count].nameP := 'katanas';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.660130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'cestus';
    weapon[count].nameP := 'cestus';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.670070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'battle axe';
    weapon[count].nameP := 'battle axes';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.700150;
    weapon[count].bog := 10.0;
    weapon[count].cost := 130.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    count := count +1;
    weapon[count].name := 'claymore';
    weapon[count].nameP := 'claymore';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.720160;
    weapon[count].bog := 7.0;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;

   total_so_far := count;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   total_so_far := 0;
   InitWeapons;
   ListWeapons;
   found := 0;
end;

procedure TForm1.ListWeapons;
var
   count, dn, dm, body: integer;
   s, ds: string;
   avg, dnf, dmf: double;
begin
   ListBox1.Clear;
   for count := 1 to total_so_far do
   begin
    s := '';
    s := s +weapon[count].name
           +weapon[count].hand
           +StringOfChar(' ', NameWidth-Length(weapon[count].name+weapon[count].hand));

   body := weapon[count].body;
   avg := body * weapon[count].mult;

   dnf := avg / 3.5;
   dn := round(dnf);

   dmf := (avg *2 -(dn *6) - dn)/2;
   dm := round(dmf);

   ds := '';
   if dn >0 then
    ds := ds +StringOfChar(' ', 3-Length(IntToStr(dn)))
           +IntToStr(dn)
   else
    ds := ds +StringOfChar(' ', 3);

   if dm = 0 then
    ds := ds +StringOfChar(' ', 2)
   else
      if dm < 0 then
         ds := ds +StringOfChar(' ', 2-Length(IntToStr(dm)))
                 +IntToStr(dm)
      else
         ds := ds +StringOfChar(' ', 2-Length('+'+IntToStr(dm)))
                 +'+'+IntToStr(dm);
    s := s +StringOfChar(' ', 6- Length(ds)) + ds;
    s := s + StringOfChar(' ', 4-Length(IntToStr(weapon[count].body)))
           +IntToStr(weapon[count].body);
    s := s + StringOfChar(' ', 6-Length(FloatToStr(weapon[count].cost)))
           +FloatToStr(weapon[count].cost);
    s := s + StringOfChar(' ', 8-Length(Format('%f ',[weapon[count].bog])))
           +Format('%f ',[weapon[count].bog]);

      ListBox1.Items.Add(s);
   end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   TrackBar1.Left := 2;
   TrackBar1.Width := Panel1.Width -4;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   Label1.Caption := 'Strength: '
                   + StringOfChar(' ', 3-Length(IntToStr(TrackBar1.position)))
                   + IntToStr(TrackBar1.position);
   if found > 0 then
      ListChosenWeapon(found);
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  ListWeapon(ListBox1.ItemAtPos(APoint, True) +1);
end;

procedure TForm1.ListWeapon(count: integer);
var
   t, test, compare: shortstring;
   count2: integer;
begin
   t := ListBox1.Items.Strings[count-1];
   test := '';
   for count2 := 1 to NameWidth do
       test := test + t[count2];
   found := 0;

      for count2 := 1 to total_so_far do
      begin
         compare := weapon[count2].name
           +weapon[count2].hand
           +StringOfChar(' ', NameWidth-Length(weapon[count2].name+weapon[count2].hand));
         if test = compare then found := count2;
      end;

  if found > 0 then
  begin
   TrackBar1.Position := weapon[found].body;
   TrackBar1Change(self);
  end;

end;

procedure TForm1.ListChosenWeapon(this_one: integer);
var
   count, dn, dm, body: integer;
   s, ds: string;
   avg, dnf, dmf: double;
begin
   count := this_one;
   RichEdit1.Lines.Clear;
    s := '';
    s := s +weapon[count].name
           +weapon[count].hand
           +StringOfChar(' ', NameWidth-Length(weapon[count].name+weapon[count].hand));

      RichEdit1.Lines.Add(s);

   body := TrackBar1.Position;
   avg := body * weapon[count].mult;

   dnf := avg / 3.5;
   dn := round(dnf);

   dmf := (avg *2 -(dn *6) - dn)/2;
   dm := round(dmf);

   ds := '';
   if dn >0 then
    ds := ds +StringOfChar(' ', 3-Length(IntToStr(dn)))
           +IntToStr(dn)
   else
    ds := ds +StringOfChar(' ', 3);

   if dm = 0 then
    ds := ds +StringOfChar(' ', 2)
   else
      if dm < 0 then
         ds := ds +StringOfChar(' ', 2-Length(IntToStr(dm)))
                 +IntToStr(dm)
      else
         ds := ds +StringOfChar(' ', 2-Length(IntToStr(dm)))
                 +'+'+IntToStr(dm);
    s := ds;
      RichEdit1.Lines.Add(s);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if Button1.Caption = 'Alphabetical' then
   begin
      ListBox1.Sorted := False;
      Button1.Caption := 'Book format';
      ListWeapons;
   end else begin
      ListBox1.Sorted := True;
      Button1.Caption := 'Alphabetical';
   end;
end;

end.
