unit CDRWp;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    Panel1: TPanel;
    Label1: TLabel;
    ComboBox1: TComboBox;
    Label2: TLabel;
    ComboBox2: TComboBox;
    Label3: TLabel;
    ComboBox3: TComboBox;
    Label4: TLabel;
    ComboBox4: TComboBox;
    Label5: TLabel;
    ComboBox5: TComboBox;
    Label6: TLabel;
    ComboBox6: TComboBox;
    RichEdit1: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure ComboBox1KeyPress(Sender: TObject; var Key: Char);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure ComboBox2KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox3KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox4KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox5KeyPress(Sender: TObject; var Key: Char);
    procedure ComboBox6KeyPress(Sender: TObject; var Key: Char);
  private
    app_path: string;
    { Private declarations }
  public
    procedure InitComboBoxes;
    procedure SaveComboBoxes;
    procedure ListDiceLanguage;
    procedure ListDiceLanguage2;
    { Public declarations }
  end;
const
  maxLength =    24;
  d20       = ' D20';
  d12       = ' D12';
  d10       = ' D10';
  d08       = ' D 8';
  d06       = ' D 6';
  d04       = ' D 4';
  spacer    =    24;

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   app_path := ExtractFilePath(Application.ExeName);
   InitcomboBoxes;
   ListDiceLanguage;
end;

procedure TForm1.InitComboBoxes;
var
   fn: string;
begin
   ComboBox1.Clear;
   fn := app_path +'D20.txt';
   ComboBox1.Items.LoadFromFile(fn);
   ComboBox1.SelText := ComboBox1.Items[0];

   ComboBox2.Clear;
   fn := app_path +'D12.txt';
   ComboBox2.Items.LoadFromFile(fn);
   ComboBox2.SelText := ComboBox2.Items[0];

   ComboBox3.Clear;
   fn := app_path +'D08.txt';
   ComboBox3.Items.LoadFromFile(fn);
   ComboBox3.SelText := ComboBox3.Items[0];

   ComboBox4.Clear;
   fn := app_path +'D10.txt';
   ComboBox4.Items.LoadFromFile(fn);
   ComboBox4.SelText := ComboBox4.Items[0];

   ComboBox5.Clear;
   fn := app_path +'D06.txt';
   ComboBox5.Items.LoadFromFile(fn);
   ComboBox5.SelText := ComboBox5.Items[0];

   ComboBox6.Clear;
   fn := app_path +'D04.txt';
   ComboBox6.Items.LoadFromFile(fn);
   ComboBox6.SelText := ComboBox6.Items[0];
end;

procedure TForm1.SaveComboBoxes;
var
   fn: string;
begin
   fn := app_path +'D20.txt';
   ComboBox1.Items.SaveToFile(fn);

   fn := app_path +'D12.txt';
   ComboBox2.Items.SaveToFile(fn);

   fn := app_path +'D08.txt';
   ComboBox3.Items.SaveToFile(fn);

   fn := app_path +'D10.txt';
   ComboBox4.Items.SaveToFile(fn);

   fn := app_path +'D06.txt';
   ComboBox5.Items.SaveToFile(fn);

   fn := app_path +'D04.txt';
   ComboBox6.Items.SaveToFile(fn);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
   SaveComboBoxes;
end;

procedure TForm1.ComboBox1KeyPress(Sender: TObject; var Key: Char);
begin
   case Key of
   #13: begin
          ComboBox1.SelStart := 0;
          ComboBox1.SelLength := MaxLength;
          ComboBox1.Items.Add(ComboBox1.SelText);
          ListDiceLanguage;
        end;
   end;
end;

procedure TForm1.ComboBox2KeyPress(Sender: TObject; var Key: Char);
begin
   case Key of
   #13: begin
          ComboBox2.SelStart := 0;
          ComboBox2.SelLength := MaxLength;
          ComboBox2.Items.Add(ComboBox2.SelText);
          ListDiceLanguage;
        end;
   end;
end;

procedure TForm1.ComboBox3KeyPress(Sender: TObject; var Key: Char);
begin
   case Key of
   #13: begin
          ComboBox3.SelStart := 0;
          ComboBox3.SelLength := MaxLength;
          ComboBox3.Items.Add(ComboBox3.SelText);
          ListDiceLanguage;
        end;
   end;
end;

procedure TForm1.ComboBox4KeyPress(Sender: TObject; var Key: Char);
begin
   case Key of
   #13: begin
          ComboBox4.SelStart := 0;
          ComboBox4.SelLength := MaxLength;
          ComboBox4.Items.Add(ComboBox4.SelText);
          ListDiceLanguage;
        end;
   end;
end;

procedure TForm1.ComboBox5KeyPress(Sender: TObject; var Key: Char);
begin
   case Key of
   #13: begin
          ComboBox5.SelStart := 0;
          ComboBox5.SelLength := MaxLength;
          ComboBox5.Items.Add(ComboBox5.SelText);
          ListDiceLanguage;
        end;
   end;
end;

procedure TForm1.ComboBox6KeyPress(Sender: TObject; var Key: Char);
begin
   case Key of
   #13: begin
          ComboBox6.SelStart := 0;
          ComboBox6.SelLength := MaxLength;
          ComboBox6.Items.Add(ComboBox6.SelText);
          ListDiceLanguage;
        end;
   end;
end;

procedure TForm1.ListDiceLanguage;
var
   s: array [1..124] of shortString;
   count: integer;
begin
   RichEdit1.Lines.Clear;
   for count := 1 to 24 do
       s[count] := '';
   count := 0;

   inc(count);
   s[count] := d20;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text;

   inc(count);
   s[count] := d20+d12;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text;

   inc(count);
   s[count] := d20+d12+d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text
                   +' ' +ComboBox3.Text;

   inc(count);
   s[count] := d20+d12+d08+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d20+d12+d08+d06+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d20+d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox3.Text;

   inc(count);
   s[count] := d20+d08+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d20+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d20+d06+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d20+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d12;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text;

   inc(count);
   s[count] := d12+d10;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text
                   +' ' +ComboBox4.Text;

   inc(count);
   s[count] := d12+d10+D08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text
                   +' ' +ComboBox4.Text
                   +' ' +ComboBox3.Text;

//   inc(count);
//   s[count] := d12+d10+D04;
//   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
//   s[count] := S[count] +ComboBox2.Text
//                   +' ' +ComboBox4.Text
//                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d12+D08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text
                   +' ' +ComboBox3.Text;

//   inc(count);
//   s[count] := d12+d04;
//   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
//   s[count] := S[count] +ComboBox2.Text
//                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d10;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text;

   inc(count);
   s[count] := d10+d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox3.Text;

   inc(count);
   s[count] := d10+d08+D06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d10+D06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d10+d06+D04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d10+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox3.Text;

   inc(count);
   s[count] := d08+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox5.Text;

   inc(count);
   s[count] := d06+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox6.Text;

   for count := 1 to count do
       RichEdit1.Lines.Add(s[count]);
end;

procedure TForm1.ListDiceLanguage2;
var
   s: array [1..124] of shortString;
   count: integer;
begin
   RichEdit1.Lines.Clear;
   for count := 1 to 24 do
       s[count] := '';
   count := 0;

   inc(count);
   s[count] := d20;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text;

   inc(count);
   s[count] := d20+d12;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text;

   inc(count);
   s[count] := d20+d12+d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text
                   +' ' +ComboBox3.Text;

   inc(count);
   s[count] := d20+d12+d08+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d20+d12+d08+d06+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox2.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d20+d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox3.Text;

   inc(count);
   s[count] := d20+d08+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d20+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d20+d06+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d20+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox1.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d12;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text;

   inc(count);
   s[count] := d12+d10;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text
                   +' ' +ComboBox4.Text;

   inc(count);
   s[count] := d12+d10+D08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text
                   +' ' +ComboBox4.Text
                   +' ' +ComboBox3.Text;

//   inc(count);
//   s[count] := d12+d10+D04;
//   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
//   s[count] := S[count] +ComboBox2.Text
//                   +' ' +ComboBox4.Text
//                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d12+D08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox2.Text
                   +' ' +ComboBox3.Text;

//   inc(count);
//   s[count] := d12+d04;
//   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
//   s[count] := S[count] +ComboBox2.Text
//                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d10;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text;

   inc(count);
   s[count] := d10+d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox3.Text;

   inc(count);
   s[count] := d10+d08+D06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d10+D06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d10+d06+D04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d10+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox4.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d08;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox3.Text;

   inc(count);
   s[count] := d08+d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox3.Text
                   +' ' +ComboBox5.Text;

   inc(count);
   s[count] := d06;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox5.Text;

   inc(count);
   s[count] := d06+d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox5.Text
                   +' ' +ComboBox6.Text;

   inc(count);
   s[count] := d04;
   s[count] := S[count] +StringOfChar(' ', Spacer- Length(s[count]));
   s[count] := S[count] +ComboBox6.Text;

   for count := 1 to count do
       RichEdit1.Lines.Add(s[count]);
end;

end.
