unit armoryP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, ExtCtrls;

type
  TForm1 = class(TForm)
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    Panel2: TPanel;
    RichEdit1: TRichEdit;
    TrackBar1: TTrackBar;
    EditName: TEdit;
    LabelName: TLabel;
    LabelPlural: TLabel;
    EditPlural: TEdit;
    LabelMult: TLabel;
    EditMult: TEdit;
    LabelBog: TLabel;
    EditBog: TEdit;
    TrackBar2: TTrackBar;
    LabelBody: TLabel;
    EditBody: TEdit;
    LabelAcc: TLabel;
    EditAcc: TEdit;
    LabelAvg: TLabel;
    EditAvg: TEdit;
    LabelCost: TLabel;
    EditCost: TEdit;
    LabelDice: TLabel;
    EditDice: TEdit;
    EditD_mod: TEdit;
    Labeld_mod: TLabel;
    LabelTime: TLabel;
    EditTime: TEdit;
    CheckBox1: TCheckBox;
    Panel1: TPanel;
    Button4: TButton;
    Button3: TButton;
    Button2: TButton;
    LabelHands: TLabel;
    LabelPage: TLabel;
    EditPage: TEdit;
    EditHands: TEdit;
    Memo1: TMemo;
    Button1: TButton;
    procedure FormCreate(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure CheckBox1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure Button3Click(Sender: TObject);
    procedure Button4Click(Sender: TObject);
    procedure FormCloseQuery(Sender: TObject; var CanClose: Boolean);
    procedure EditMultChange(Sender: TObject);
  private
    procedure initWeapons;
    procedure PrepSave;
    procedure ScanLoad;
    function Save: Boolean;
    function SaveChanges: Boolean;
    { Private declarations }
  public
     total_so_far, armorer_value: integer;
     Modified: Boolean;
     filePath, fileName: string;
    { Public declarations }
  end;

type
  TWeaper = record
    mult: double;
    name: shortstring;
    nameP: shortstring;
    page: char;
    hand: char;
    body: Uint;
    oldBody: Uint;
    avg: double;
    dice: Uint;
    d_mod: integer;
    acc: Uint;
    bog: double;
    cost: double;
  end;
const
  max_weapon_set = 585;
var
  Form1: TForm1;
  weapon: array [1..max_weapon_set] of TWeaper;

implementation

{$R *.DFM}

procedure TForm1.PrepSave;
const
   gap = 32;
var
   count: integer;
   s: string;
begin
     Memo1.Lines.Clear;
     s := IntToStr(total_so_far);
     s := s +StringOfChar(' ',80-length(s));
     Memo1.Lines.Add(s);
     for count := 1 to total_so_far do
     begin
        s := Format('%2.6f ',[weapon[count].mult]);
        s := s +Format('%s ',[weapon[count].name]);
        s := s +Format('%s ',[weapon[count].nameP]);
        s := s +weapon[count].page +' ';
        s := s +weapon[count].hand +' ';
        s := s +Format('%d ',[weapon[count].body]);
        s := s +Format('%f ',[weapon[count].avg]);
        s := s +Format('%d ',[weapon[count].dice]);
        s := s +Format('%d ',[weapon[count].d_mod]);
        s := s +Format('%d ',[weapon[count].acc]);
        s := s +Format('%f ',[weapon[count].bog]);
        s := s +Format('%f ',[weapon[count].cost]);
        s := s +StringOfChar(' ',80-length(s));
        Memo1.Lines.Add(s);
     end;
end;

procedure TForm1.ScanLoad;
const
   gap = 82;
var
   count, s1, s2: integer;
   s: string;
begin
   s1 := 0;
   s2 := 0;
   Memo1.SelStart := s1;
   Memo1.SelLength := 1;
   while Memo1.SelText <> ' ' do
   begin
      inc(s2);
      Memo1.SelStart := s2;
      Memo1.SelLength := 1;
   end;
   Memo1.SelStart := s1;
   Memo1.SelLength := s2;
   s := Memo1.SelText;
   total_so_far := StrToInt(s);
     for count := 1 to total_so_far do
     begin
        s1 := gap * count;
        s2 := s1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        if Memo1.SelText <> ' ' then
        begin
           while Memo1.SelText <> ' ' do
           begin
              inc(s2);
              Memo1.SelStart := s2;
              Memo1.SelLength := 1;
           end;
        end else begin
           inc(s1);
           s2 := s1;
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
           while Memo1.SelText <> ' ' do
           begin
              inc(s2);
              Memo1.SelStart := s2;
              Memo1.SelLength := 1;
           end;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].mult := StrToFloat(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].name := s;

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].nameP := s;

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].page := s[1];

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].hand := s[1];

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].body := StrToInt(s);
        weapon[count].OldBody := StrToInt(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].avg := StrToFloat(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].dice := StrToInt(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].d_mod := StrToInt(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].acc := StrToInt(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].bog := StrToFloat(s);

        s1 := s2+1;
        Memo1.SelStart := s1;
        Memo1.SelLength := 1;
        while Memo1.SelText <> ' ' do
        begin
           inc(s2);
           Memo1.SelStart := s2;
           Memo1.SelLength := 1;
        end;
        Memo1.SelStart := s1;
        Memo1.SelLength := s2-s1;
        s := Memo1.SelText;
        weapon[count].cost := StrToFloat(s);
     end;

   memo1.SelStart := 0;
   memo1.SelLength := 0;
end;

function Tform1.Save: Boolean;
begin
  Result := False;
     SaveDialog1.InitialDir := filePath;
     SaveDialog1.FileName := fileName;
  if SaveDialog1.Execute then
  begin
     prepSave;
     Memo1.Lines.SaveToFile(SaveDialog1.FileName);
     result := True;
  end;
end;

function TForm1.SaveChanges: Boolean;
begin
   case MessageDlg(
        'The '''+ fileName +''' weapon file has changed.' +
        #13#13 +'Do you want to save the changes?',
        mtConfirmation,mbYesNoCancel,0) of
     idYes:
       Result := Save;
     idNo:
       Result := True;
     else
        Result := False;
     end;
end;

procedure TForm1.InitWeapons;
var
   count, body: integer;
   f, i: double;
begin
    count := 1;
    weapon[count].name := 'quarrel';
    weapon[count].nameP := 'quarrels';
    weapon[count].page := 'R';
    weapon[count].hand := '1';
    weapon[count].mult := 0.080024;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'quarrel';
    weapon[count].nameP := 'quarrels';
    weapon[count].page := 'R';
    weapon[count].hand := '1';
    weapon[count].mult := 0.080028;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'quarrel';
    weapon[count].nameP := 'quarrels';
    weapon[count].page := 'R';
    weapon[count].hand := '1';
    weapon[count].mult := 0.080040;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'arrow';
    weapon[count].nameP := 'arrows';
    weapon[count].page := 'B';
    weapon[count].hand := '1';
    weapon[count].mult := 0.090007;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (4 -f);

    count := count +1;
    weapon[count].name := 'arrow';
    weapon[count].nameP := 'arrows';
    weapon[count].page := 'B';
    weapon[count].hand := '1';
    weapon[count].mult := 0.090009;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (4 -f);

    count := count +1;
    weapon[count].name := 'arrow';
    weapon[count].nameP := 'arrows';
    weapon[count].page := 'B';
    weapon[count].hand := '1';
    weapon[count].mult := 0.090011;
    weapon[count].bog := 0.015;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (4 -f);

    count := count +1;
    weapon[count].name := 'tetsubishi';
    weapon[count].nameP := 'tetsubishi';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.120070;
    weapon[count].bog := 0.07;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'blowgun';
    weapon[count].nameP := 'glowguns';
    weapon[count].page := 'B';
    weapon[count].hand := '#';
    weapon[count].mult := 0.140070;
    weapon[count].bog := 0.05;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (9 -f);

    count := count +1;
    weapon[count].name := 'shurikens';
    weapon[count].nameP := 'shuriken';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.140070;
    weapon[count].bog := 0.05;
    weapon[count].cost := 3.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (64 -f);

    count := count +1;
    weapon[count].name := 'discus';
    weapon[count].nameP := 'discus';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.140110;
    weapon[count].bog := 0.05;
    weapon[count].cost := 3.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (64 -f);

    count := count +1;
    weapon[count].name := 'chock';
    weapon[count].nameP := 'chocks';
    weapon[count].page := 'R';
    weapon[count].hand := '#';
    weapon[count].mult := 0.140240;
    weapon[count].bog := 4.0;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (18 -f);

    count := count +1;
    weapon[count].name := 'tails';
    weapon[count].nameP := 'tail';
    weapon[count].page := 'F';
    weapon[count].hand := '1';
    weapon[count].mult := 0.180080;
    weapon[count].bog := 0.4;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'amentum';
    weapon[count].nameP := 'amentums';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.200070;
    weapon[count].bog := 0.2;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'atl';
    weapon[count].nameP := 'atls';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.200070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'sling';
    weapon[count].nameP := 'slings';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.210060;
    weapon[count].bog := 0.3;
    weapon[count].cost := 2.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'knife';
    weapon[count].nameP := 'knives';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.230070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'chain';
    weapon[count].nameP := 'chains';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.230100;
    weapon[count].bog := 2.0;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (13 -f);

    count := count +1;
    weapon[count].name := 'bola';
    weapon[count].nameP := 'bolas';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.240090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (13 -f);

    count := count +1;
    weapon[count].name := 'lasso';
    weapon[count].nameP := 'lassos';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.240110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (13 -f);

    count := count +1;
    weapon[count].name := 'fist';
    weapon[count].nameP := 'fists';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.240090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 0.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (1000 -f);

    count := count +1;
    weapon[count].name := 'knife';
    weapon[count].nameP := 'knives';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.250070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'boomerang';
    weapon[count].nameP := 'boomerangs';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.240090;
    weapon[count].bog := 1.5;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (21 -f);

    count := count +1;
    weapon[count].name := 'crossbow';
    weapon[count].nameP := 'crossbows';
    weapon[count].page := 'R';
    weapon[count].hand := '#';
//    weapon[count].mult := 0.250240;
    weapon[count].mult := 0.250120;
    weapon[count].bog := 3.0;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (18 -f);

    count := count +1;
    weapon[count].name := 'arbalest';
    weapon[count].nameP := 'arbalests';
    weapon[count].page := 'R';
    weapon[count].hand := '#';
//    weapon[count].mult := 0.250280;
    weapon[count].mult := 0.250140;
    weapon[count].bog := 5.0;
    weapon[count].cost := 80.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (18 -f);

    count := count +1;
    weapon[count].name := 'scorpion';
    weapon[count].nameP := 'scorpions';
    weapon[count].page := 'R';
    weapon[count].hand := '#';
    weapon[count].mult := 0.250160;
    weapon[count].mult := 0.250160;
    weapon[count].bog := 10.0;
    weapon[count].cost := 160.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (18 -f);

    count := count +1;
    weapon[count].name := 'bottle';
    weapon[count].nameP := 'bottles';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.260070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'mug';
    weapon[count].nameP := 'mugs';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.260070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 1.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'stiletto';
    weapon[count].nameP := 'stilettos';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.260070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'dagger';
    weapon[count].nameP := 'daggers';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'dirk';
    weapon[count].nameP := 'dirks';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'gauche';
    weapon[count].nameP := 'gauches';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'breaker';
    weapon[count].nameP := 'breakers';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270070;
    weapon[count].bog := 0.1;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'javelin';
    weapon[count].nameP := 'javelins';
    weapon[count].page := 'P';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270090;
    weapon[count].bog := 1.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'blade';
    weapon[count].nameP := 'blades';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'chair';
    weapon[count].nameP := 'chairs';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.290120;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (25 -f);

    count := count +1;
    weapon[count].name := 'tanto';
    weapon[count].nameP := 'tantos';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.290090;
    weapon[count].bog := 0.2;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'baton';
    weapon[count].nameP := 'batons';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.300090;
    weapon[count].bog := 1.0;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'sap';
    weapon[count].nameP := 'saps';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.300080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'staff';
    weapon[count].nameP := 'staves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.300090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (19 -f);

    count := count +1;
    weapon[count].name := 'net';
    weapon[count].nameP := 'nets';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.300100;
    weapon[count].bog := 1.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'bullwhip';
    weapon[count].nameP := 'bullwhips';
    weapon[count].page := 'F';
    weapon[count].hand := '1';
    weapon[count].mult := 0.310090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'kama';
    weapon[count].nameP := 'kamas';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.310100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'lance';
    weapon[count].nameP := 'lances';
    weapon[count].page := 'P';
    weapon[count].hand := '1';
    weapon[count].mult := 0.270090;
    weapon[count].bog := 2.0;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'spear';
    weapon[count].nameP := 'spears';
    weapon[count].page := 'P';
    weapon[count].hand := '1';
    weapon[count].mult := 0.310110;
    weapon[count].bog := 3.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'blade';
    weapon[count].nameP := 'blades';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.320100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 4.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'blade';
    weapon[count].nameP := 'blades';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.320110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 4.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'rock';
    weapon[count].nameP := 'rocks';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 0.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'cudgel';
    weapon[count].nameP := 'cudgels';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.5;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'club';
    weapon[count].nameP := 'clubs';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330080;
    weapon[count].bog := 1.5;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'crowbar';
    weapon[count].nameP := 'crowbars';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330080;
    weapon[count].bog := 2.0;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'kiseru';
    weapon[count].nameP := 'kiser';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'escrima';
    weapon[count].nameP := 'escrim';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'sword';
    weapon[count].nameP := 'swords';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'tessun';
    weapon[count].nameP := 'tessu';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330070;
    weapon[count].bog := 1.5;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'stool';
    weapon[count].nameP := 'stools';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'tonfa';
    weapon[count].nameP := 'tonfas';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.330090;
    weapon[count].bog := 1.5;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'chair';
    weapon[count].nameP := 'chairs';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.340120;
    weapon[count].bog := 0.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (25 -f);

    count := count +1;
    weapon[count].name := 'hunting';
    weapon[count].nameP := 'hunting';
    weapon[count].page := 'B';
    weapon[count].hand := '1';
    weapon[count].mult := 0.350070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (14 -f);

    count := count +1;
    weapon[count].name := 'ashiko';
    weapon[count].nameP := 'ashik';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.350110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (12 -f);

    count := count +1;
    weapon[count].name := 'trident';
    weapon[count].nameP := 'tridents';
    weapon[count].page := 'P';
    weapon[count].hand := '1';
    weapon[count].mult := 0.350100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'arbalest';
    weapon[count].nameP := 'arbalests';
    weapon[count].page := 'R';
    weapon[count].hand := '1';
    weapon[count].mult := 0.350140;
    weapon[count].bog := 0.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (18 -f);

    count := count +1;
    weapon[count].name := 'spear';
    weapon[count].nameP := 'spear';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.360110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'pike';
    weapon[count].nameP := 'pikes';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.360120;
    weapon[count].bog := 0.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'staff';
    weapon[count].nameP := 'staves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.370070;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (19 -f);

    count := count +1;
    weapon[count].name := 'bo';
    weapon[count].nameP := 'bos';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.370080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'shinobi';
    weapon[count].nameP := 'shinob';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.370110;
    weapon[count].bog := 0.5;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (11 -f);

    count := count +1;
    weapon[count].name := 'club';
    weapon[count].nameP := 'clubs';
    weapon[count].page := 'T';
    weapon[count].hand := '#';
    weapon[count].mult := 0.380080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 10.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'nunchucka';
    weapon[count].nameP := 'nunchucks';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 35.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'epee';
    weapon[count].nameP := 'epee';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'hatchet';
    weapon[count].nameP := 'hatchets';
    weapon[count].page := 'M';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 1.0;
    weapon[count].cost := 15.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'horse';
    weapon[count].nameP := 'horse';
    weapon[count].page := 'B';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 2.0;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (14 -f);

    count := count +1;
    weapon[count].name := 'rapier';
    weapon[count].nameP := 'rapiers';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 0.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'staff';
    weapon[count].nameP := 'staffs';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 1.8;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (19 -f);

    count := count +1;
    weapon[count].name := 'stool';
    weapon[count].nameP := 'stools';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.380090;
    weapon[count].bog := 4.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (14 -f);

    count := count +1;
    weapon[count].name := 'hammer';
    weapon[count].nameP := 'hammers';
    weapon[count].page := 'M';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380100;
    weapon[count].bog := 2.0;
    weapon[count].cost := 25.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'bench';
    weapon[count].nameP := 'benches';
    weapon[count].page := 'I';
    weapon[count].hand := '1';
    weapon[count].mult := 0.380110;
    weapon[count].bog := 8.0;
    weapon[count].cost := 25.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (14 -f);

    count := count +1;
    weapon[count].name := 'table';
    weapon[count].nameP := 'tables';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.390120;
    weapon[count].bog := 20.0;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (25 -f);

    count := count +1;
    weapon[count].name := 'sai';
    weapon[count].nameP := 'sai';
    weapon[count].page := 'O';
    weapon[count].hand := '1';
    weapon[count].mult := 0.400080;
    weapon[count].bog := 0.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'naginata';
    weapon[count].nameP := 'naginatas';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.400100;
    weapon[count].bog := 4.0;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'scythe';
    weapon[count].nameP := 'scythes';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.400110;
    weapon[count].bog := 4.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'sectional';
    weapon[count].nameP := 'staves';
    weapon[count].page := 'F';
    weapon[count].hand := '1';
    weapon[count].mult := 0.420100;
    weapon[count].bog := 3.5;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'hammer';
    weapon[count].nameP := 'hammers';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.420140;
    weapon[count].bog := 8.0;
    weapon[count].cost := 110.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'foil';
    weapon[count].nameP := 'foils';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.450100;
    weapon[count].bog := 0.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'lance';
    weapon[count].nameP := 'lances';
    weapon[count].page := 'P';
    weapon[count].hand := '1';
    weapon[count].mult := 0.450110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'glave';
    weapon[count].nameP := 'glaves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.450120;
    weapon[count].bog := 6.0;
    weapon[count].cost := 65.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'longbow';
    weapon[count].nameP := 'longbows';
    weapon[count].page := 'B';
    weapon[count].hand := '#';
    weapon[count].mult := 0.460110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (14 -f);

    count := count +1;
    weapon[count].name := 'quarterstaff';
    weapon[count].nameP := 'quarterstaves';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.460110;
    weapon[count].bog := 1.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (19 -f);

    count := count +1;
    weapon[count].name := 'axe';
    weapon[count].nameP := 'axes';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.460110;
    weapon[count].bog := 2.5;
    weapon[count].cost := 30.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'bisen';
    weapon[count].nameP := 'bisen';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.500120;
    weapon[count].bog := 7.0;
    weapon[count].cost := 80.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'axe';
    weapon[count].nameP := 'axes';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.500150;
    weapon[count].bog := 10.0;
    weapon[count].cost := 130.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'cutlass';
    weapon[count].nameP := 'cutlass';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.530100;
    weapon[count].bog := 1.5;
    weapon[count].cost := 50.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'halberd';
    weapon[count].nameP := 'halberds';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.530130;
    weapon[count].bog := 8.0;
    weapon[count].cost := 70.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (15 -f);

    count := count +1;
    weapon[count].name := 'mace';
    weapon[count].nameP := 'maces';
    weapon[count].page := 'M';
    weapon[count].hand := '1';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 3.0;
    weapon[count].cost := 40.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'sabre';
    weapon[count].nameP := 'sabres';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'sword';
    weapon[count].nameP := 'sword';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'wakazashi';
    weapon[count].nameP := 'wakazashis';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.540110;
    weapon[count].bog := 2.0;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'pick';
    weapon[count].nameP := 'picks';
    weapon[count].page := 'P';
    weapon[count].hand := '#';
    weapon[count].mult := 0.540130;
    weapon[count].bog := 10.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'pick';
    weapon[count].nameP := 'picks';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.560120;
    weapon[count].bog := 4.0;
    weapon[count].cost := 60.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'boomerang';
    weapon[count].nameP := 'boomerangs';
    weapon[count].page := 'T';
    weapon[count].hand := '1';
    weapon[count].mult := 0.420120;//0.560120;
    weapon[count].bog := 1.5;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (13 -f);

    count := count +1;
    weapon[count].name := 'flail';
    weapon[count].nameP := 'flails';
    weapon[count].page := 'F';
    weapon[count].hand := '1';
    weapon[count].mult := 0.580120;
    weapon[count].bog := 4.0;
    weapon[count].cost := 70.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'broadsword';
    weapon[count].nameP := 'broadswrods';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.600120;
    weapon[count].bog := 2.5;
    weapon[count].cost := 80.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'ninja';
    weapon[count].nameP := 'ninjato';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.600120;
    weapon[count].bog := 2.5;
    weapon[count].cost := 180.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'sword';
    weapon[count].nameP := 'sword';
    weapon[count].page := 'S';
    weapon[count].hand := '3';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'katana';
    weapon[count].nameP := 'katanas';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'maul';
    weapon[count].nameP := 'mauls';
    weapon[count].page := 'O';
    weapon[count].hand := '#';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 6.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'star';
    weapon[count].nameP := 'stars';
    weapon[count].page := 'M';
    weapon[count].hand := '1';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 6.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'scimitar';
    weapon[count].nameP := 'scimitars';
    weapon[count].page := 'S';
    weapon[count].hand := '1';
    weapon[count].mult := 0.610130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'hammer';
    weapon[count].nameP := 'hammers';
    weapon[count].page := 'M';
    weapon[count].hand := '1';
    weapon[count].mult := 0.620130;
    weapon[count].bog := 6.0;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'hammer';
    weapon[count].nameP := 'hammers';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.620140;
    weapon[count].bog := 8.0;
    weapon[count].cost := 110.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'sword';
    weapon[count].nameP := 'swords';
    weapon[count].page := 'S';
    weapon[count].hand := '3';
    weapon[count].mult := 0.660130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 100.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'katana';
    weapon[count].nameP := 'katanas';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.660130;
    weapon[count].bog := 3.5;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

    count := count +1;
    weapon[count].name := 'cestus';
    weapon[count].nameP := 'cestus';
    weapon[count].page := 'I';
    weapon[count].hand := '#';
    weapon[count].mult := 0.670070;
    weapon[count].bog := 1.0;
    weapon[count].cost := 20.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (8 -f);

    count := count +1;
    weapon[count].name := 'axe';
    weapon[count].nameP := 'axes';
    weapon[count].page := 'M';
    weapon[count].hand := '#';
    weapon[count].mult := 0.700150;
    weapon[count].bog := 10.0;
    weapon[count].cost := 130.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (16 -f);

    count := count +1;
    weapon[count].name := 'claymore';
    weapon[count].nameP := 'claymore';
    weapon[count].page := 'S';
    weapon[count].hand := '#';
    weapon[count].mult := 0.720160;
    weapon[count].bog := 7.0;
    weapon[count].cost := 150.0;
    f := weapon[count].mult * 1000;
    i := round(f);
    f := (weapon[count].mult * 1000000) -(i *1000);
    f := f /10;
    body := round(f);
    weapon[count].body := body;
    weapon[count].oldBody := body;
    weapon[count].bog := f / (17 -f);

   total_so_far := count;
   TrackBar1.Max := Total_so_far;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   total_so_far := 0;
   InitWeapons;
   TrackBar1.Position := 2;
   TrackBar2.Position := 0;
   armorer_value := 150;
   modified := False;
   Filepath := ExtractFilePath(Application.ExeName);
   FileName := 'armory.txt';
   TrackBar1.Position := 2;
   TrackBar1.Invalidate;
   TrackBar1.Position := 3;
   TrackBar1.Invalidate;   //
end;

procedure TForm1.Button1Click(Sender: TObject);
var
   s: string;
begin
   if TrackBar1.Position <> Total_so_far then
   begin
      TrackBar1.position := Total_so_far;
   end else begin
      richEdit1.Lines.Clear;
      inc(Total_so_far);
      TrackBar1.Max := Total_so_far;
      TrackBar1.Position := Total_so_far;
      weapon[Total_so_far].Name := EditName.Text;
      if total_so_far < max_weapon_set then
      begin
            s := format('name: %s',[weapon[TrackBar1.position].name]);
            s := s + stringOfChar(' ',32-Length(s));
            s := s + weapon[TrackBar1.position].Page;
            s := s + stringOfChar(' ',36-Length(s));
            s := s + format(' %13f',[weapon[TrackBar1.position].Mult]);
            s := s + stringOfChar(' ',63-Length(s));
            richedit1.lines.add(s);
      end;
   end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
   i, body, dn, dm, acc, cost, time: integer;
   mult, bog, f, avg, dnf, dmf, accf, costf, timef: double;
   page, hands: char;
   name, plural, s: string;
begin
   name := weapon[TrackBar1.position].Name;
   Editname.Text := name;

   plural := weapon[TrackBar1.position].nameP;
   Editplural.Text := plural;

   mult := weapon[TrackBar1.position].Mult;
   EditMult.Text := FloatToStr(mult);

   page := weapon[TrackBar1.position].Page;
   Editpage.Text := page;

   hands := weapon[TrackBar1.position].hand;
   Edithands.Text := hands;

   bog := weapon[TrackBar1.position].bog;
   Editbog.Text := FloatToStr(bog);

   f := mult * 1000;
   i := round(f);
   f := (mult * 1000000) -(i *1000);
   f := f /10;
   body := round(f);

   EditBody.Text := IntToStr(body);
   weapon[TrackBar1.position].body := body;
   TrackBar2.Position := body- weapon[TrackBar1.position].OldBody;

   avg := body * mult;
   EditAvg.Text := FloatToStr(avg);
   weapon[TrackBar1.position].avg := avg;

   dnf := avg / 3.5;
   dn := round(dnf);

   dmf := (avg *2 -(dn *6) - dn)/2;
   dm := round(dmf);

   EditDice.Text := IntToStr(dn);
   EditD_mod.Text := IntToStr(dm);
   weapon[TrackBar1.position].dice := dn;
   weapon[TrackBar1.position].d_mod := dm;

   accf := body / avg -1;
   acc := round(accf);
   EditAcc.Text := IntToStr(acc);
   weapon[TrackBar1.position].acc := acc;

   costf := weapon[TrackBar1.position].cost;
   cost := round(costf);
   editCost.Text := IntToStr(cost);

   timef := cost / armorer_value;
   timef := timef * 60; {hours in a work week}
   time := 0;
   while timef > 0 do
   begin
      inc(time);
      timef := timef - 10;
   end;
   if time = 1 then
   begin
      timef := cost /armorer_value *60;
      timef := 10 / timef;
      time := round(timef);
      if time = 0 then time := 1;
      EditTime.text := format(' %2d a day',[time]);
   end else begin
      EditTime.text := IntToStr(Time)+' man days';
   end;

   richEdit1.Lines.Clear;
            s := format('name: %s',[weapon[TrackBar1.position].name]);
            s := s + stringOfChar(' ',32-Length(s));
            s := s + weapon[TrackBar1.position].Page;
            s := s + stringOfChar(' ',36-Length(s));
            s := s + format(' %9f',[weapon[TrackBar1.position].Mult]);
            s := s + stringOfChar(' ',53-Length(s));
            richedit1.lines.add(s);
            s := format('Dx %2d',[(24-weapon[TrackBar1.position].Body)]);
            case dm of
            -6.. -1: s := s +format('  damage %d%d',[dn,dm]);
            0: s := s +format('  damage %d  ',[dn]);
            1..100000: s := s +format('  damage %d+%d',[dn,dm]);
            end;
            s := s + stringOfChar(' ',53-Length(s));
            richedit1.lines.add(s);
            s := format('cost $%9f',[weapon[TrackBar1.position].cost]);
            s := s + stringOfChar(' ',53-Length(s));
            richedit1.lines.add(s);

end;

procedure TForm1.TrackBar2Change(Sender: TObject);
var
   i, body, dn, dm, acc, cost, time: integer;
   mult, bog, f, avg, dnf, dmf, accf, costf, timef: double;
   page, hands: char;
   name, plural, s: string;
begin
   modified := True;
   name := weapon[TrackBar1.position].Name;
   Editname.Text := name;

   plural := weapon[TrackBar1.position].nameP;
   Editplural.Text := plural;

   mult := weapon[TrackBar1.position].Mult;
   EditMult.Text := FloatToStr(mult);

   page := weapon[TrackBar1.position].Page;
   Editpage.Text := page;

   hands := weapon[TrackBar1.position].hand;
   Edithands.Text := hands;

   bog := weapon[TrackBar1.position].bog;
   Editbog.Text := FloatToStr(bog);

   f := mult * 1000;
   i := round(f);
   f := (mult * 1000000) -(i *1000);
   f := f /10;
   body := round(f);
   if (TrackBar2.Position <> (body-weapon[trackBar1.position].OldBody)) then
   begin
      body := trackbar2.position +weapon[trackBar1.position].OldBody;
      weapon[trackBar1.Position].body := body;
      f := body * 10;
      f := f / 1000;
      f := i + f;
      f := f / 1000;
      weapon[trackBar1.Position].mult := f;
   end;
   EditBody.Text := IntToStr(body);
   avg := body * mult;
   EditAvg.Text := FloatToStr(avg);

   dnf := avg / 3.5;
   dn := round(dnf);

   dmf := (avg *2 -(dn *6) - dn)/2;
   dm := round(dmf);

   EditDice.Text := IntToStr(dn);
   EditD_mod.Text := IntToStr(dm);

   accf := body / avg -1;
   acc := round(accf);
   EditAcc.Text := IntToStr(acc);

   cost := round(weapon[TrackBar1.position].cost);
   timef := cost * weapon[TrackBar1.position].oldBody;
   costf := timef / body;
   cost := round(costf);
   editCost.Text := IntToStr(cost);

   timef := cost / armorer_value;
   timef := timef * 60; {hours in a work week}
   time := 0;
   while timef > 0 do
   begin
      inc(time);
      timef := timef - 10;
   end;
   if time = 1 then
   begin
      timef := cost /armorer_value *60;
      timef := 10 / timef;
      time := round(timef);
      if time = 0 then time := 1;
      EditTime.text := format(' %2d a day',[time]);
   end else begin
      EditTime.text := IntToStr(Time)+' man days';
   end;


   weapon[TrackBar1.position].bog := body / (17 - body);
   richEdit1.Lines.Clear;
            s := format('name: %s',[weapon[TrackBar1.position].name]);
            s := s + stringOfChar(' ',32-Length(s));
            s := s + weapon[TrackBar1.position].Page;
            s := s + stringOfChar(' ',36-Length(s));
            s := s + format(' %9f',[weapon[TrackBar1.position].Mult]);
            s := s + stringOfChar(' ',53-Length(s));
            richedit1.lines.add(s);
            s := format('Dx %2d',[(24-weapon[TrackBar1.position].Body)]);
            case dm of
            -6.. -1: s := s +format('  damage %d%d',[dn,dm]);
            0: s := s +format('  damage %d  ',[dn]);
            1..100000: s := s +format('  damage %d+%d',[dn,dm]);
            end;
            s := s + stringOfChar(' ',53-Length(s));
            richedit1.lines.add(s);
            s := format('cost $%9f',[weapon[TrackBar1.position].cost]);
            s := s + stringOfChar(' ',53-Length(s));
            richedit1.lines.add(s);
            LabelBog.Caption := format('%9f',[weapon[TrackBar1.position].bog]);
end;

procedure TForm1.CheckBox1Click(Sender: TObject);
var
  cost, time, match: integer;
  costf, timef: double;
begin
 if not CheckBox1.Checked then
 begin
    CheckBox1.Checked := True;
   match := 0;
   if checkbox1.caption = 'Master Armorer' then match := 1;
   if checkbox1.caption = 'Armorer' then match := 3;
   if checkbox1.caption = 'Customer' then match := 2;
      case match of
      1: begin
            armorer_value := 70;
           CheckBox1.Caption := 'Customer';
           TrackBar1.Height := 30;
           TrackBar1.Left := 360;
           TrackBar1.top := 92;
           TrackBar1.Width := 168;
           TrackBar2.Height := 30;
           TrackBar2.Left := 360;
           TrackBar2.top := 200;
           TrackBar2.Width := 105;
           RichEdit1.Height := 89;
           RichEdit1.Left := 368;
           RichEdit1.top := 1;
           RichEdit1.Width := 168;
           Panel2.Height := 305;
           Panel2.Left := -368;
           Panel2.top := 8;
           Panel2.Width := 537;
           Form1.Height := 348;
           Form1.Left := 1;
           Form1.top := 1;
           Form1.Width := 185;
         end;
      2: begin
           armorer_value := 150;
           CheckBox1.Caption := 'Armorer';
           EditBody.Height := 21;
           EditBody.Left := 226;
           EditBody.top := 200;
           EditBody.Width := 25;
           LabelBody.Height := 16;
           LabelBody.Left := 186;
           LabelBody.top := 200;
           LabelBody.Width := 32;
           TrackBar1.Height := 30;
           TrackBar1.Left := 184;
           TrackBar1.top := 92;
           TrackBar1.Width := 345;
           TrackBar2.Height := 30;
           TrackBar2.Left := 248;
           TrackBar2.top := 200;
           TrackBar2.Width := 217;
           RichEdit1.Height := 89;
           RichEdit1.Left := 184;
           RichEdit1.top := 1;
           RichEdit1.Width := 352;
           Panel2.Height := 305;
           Panel2.Left := -184;
           Panel2.top := 8;
           Panel2.Width := 537;
           Form1.Height := 348;
           Form1.Left := 1;
           Form1.top := 1;
           Form1.Width := 369;
         end;
      3: begin
           armorer_value := 200;
           CheckBox1.Caption := 'Master Armorer';
           EditBody.Height := 21;
           EditBody.Left := 48;
           EditBody.top := 200;
           EditBody.Width := 25;
           LabelBody.Height := 16;
           LabelBody.Left := 13;
           LabelBody.top := 200;
           LabelBody.Width := 32;
           TrackBar1.Height := 30;
           TrackBar1.Left := 8;
           TrackBar1.top := 92;
           TrackBar1.Width := 521;
           TrackBar2.Height := 30;
           TrackBar2.Left := 80;
           TrackBar2.top := 200;
           TrackBar2.Width := 385;
           RichEdit1.Height := 89;
           RichEdit1.Left := 1;
           RichEdit1.top := 1;
           RichEdit1.Width := 535;
           Panel2.Height := 305;
           Panel2.Left := 8;
           Panel2.top := 8;
           Panel2.Width := 537;
           Form1.Height := 348;
           Form1.Left := 1;
           Form1.top := 1;
           Form1.Width := 561;
           end;
      end;

   costf := weapon[TrackBar1.position].cost;
   cost := round(costf);
   editCost.Text := IntToStr(cost);

   timef := cost / armorer_value;
   timef := timef * 60; {hours in a work week}
   time := 0;
   while timef > 0 do
   begin
      inc(time);
      timef := timef - 10;
   end;
   if time = 1 then
   begin
      timef := cost /armorer_value *60;
      timef := 10 / timef;
      time := round(timef);
      if time = 0 then time := 1;
      EditTime.text := format(' %2d a day',[time]);
   end else begin
      EditTime.text := IntToStr(Time)+' man days';
   end;

   end;
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   OpenDialog1.InitialDir := filePath;
   OpenDialog1.FileName := FileName;
   if OpenDialog1.Execute then
   begin
      FileName := OpenDialog1.FileName;
      filePath := extractFilePath(OpenDialog1.FileName);
      Memo1.Lines.Clear;
      Memo1.Lines.LoadFromFile(FileName);
      fileName := extractFileName(OpenDialog1.FileName);
      ScanLoad;
      modified := False;
   end;
end;

procedure TForm1.Button3Click(Sender: TObject);
begin
   save;
end;

procedure TForm1.Button4Click(Sender: TObject);
begin
   close;
end;

procedure TForm1.FormCloseQuery(Sender: TObject; var CanClose: Boolean);
begin
   CanClose := not Modified or SaveChanges;
end;

procedure TForm1.EditMultChange(Sender: TObject);
begin
   Weapon[TrackBar1.Position].mult := StrToFloat(EditMult.Text);
end;

end.
