unit builderP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Buttons, StdCtrls, ExtCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    StatusBar1: TStatusBar;
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Memo1: TMemo;
    procedure Timer1Timer(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Label1DblClick(Sender: TObject);
    procedure Label2DblClick(Sender: TObject);
    procedure Label3DblClick(Sender: TObject);
    procedure Label1MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label2MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label2MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3MouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label3MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Label2MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure Label3MouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
  private
    cx, cy, dragLabel, last_mouse_x, last_mouse_y: integer;

    t: TRect;
    procedure Redraw;
    { Private declarations }
  public
    { Public declarations }
  end;

const
   sprites = 3;
var
  Form1: TForm1;
  hex: array [1..(3*sprites)] of integer;
  arc1: array [1..8] of integer;

implementation

{$R *.DFM}

procedure TForm1.Redraw;
var
   r: integer;
begin
   r := 70;
   arc1[1] := Label3.Left-r;
   arc1[2] := Label3.Top-r;
   arc1[3] := Label3.Left+r;
   arc1[4] := Label3.Top+r;
   arc1[5] := Label3.Left-r;
   arc1[6] := Label3.Top;
   arc1[7] := Label3.Left-r;
   arc1[8] := Label3.Top;

end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
   Redraw;
   FormPaint(self);
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   Form1.Canvas.Brush.Color := clSilver;
   Form1.Canvas.FillRect(t);
   Form1.Canvas.Pen.Color := clBlue;
   Form1.Canvas.Arc(arc1[1],arc1[2],arc1[3],arc1[4],arc1[5],arc1[6],arc1[7],arc1[8]);
   Label1.Invalidate;
   Label2.Invalidate;
   Label3.Invalidate;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   hex[1] := round(cx * 1.0);
   hex[2] := round(cy * 0.5);
   hex[3] := round(cx * 1.0);
   hex[4] := round(cy * 1.0);
   hex[5] := round(cx * 1.5);
   hex[6] := round(cy * 1.0);
   dragLabel := 0;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
  cx := Form1.ClientWidth div 2;
  cy := Form1.ClientHeight div 2;
   t.Left := 0;
   t.Top := 0;
   t.Right := Form1.clientWidth;
   t.Bottom := Form1.ClientHeight;
end;

procedure TForm1.Label1DblClick(Sender: TObject);
var
   match: integer;
begin
   match := 0;
   if Label1.Caption = 'clockwise approach' then
      match := 1;
   if Label1.Caption = 'counter clockwise approach' then
      match := 2;

   case match of
      1: Label1.Caption := 'counter clockwise approach';
      2: Label1.Caption := 'clockwise approach';
   end;
end;

procedure TForm1.Label2DblClick(Sender: TObject);
var
   match: integer;
begin
   match := 0;
   if Label2.Caption = 'murder hole' then
      match := 1;
   if Label2.Caption = 'gate house' then
      match := 2;

   case match of
      1: Label2.Caption := 'gate house';
      2: Label2.Caption := 'murder hole';
   end;
end;

procedure TForm1.Label3DblClick(Sender: TObject);
var
   match: integer;
begin
   match := 0;
   if Label3.Caption = 'raised' then
      match := 1;
   if Label3.Caption = 'recesed' then
      match := 2;

   case match of
      1: Label3.Caption := 'recesed';
      2: Label3.Caption := 'raised';
   end;
end;

procedure TForm1.Label1MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   dragLabel := 1;
   last_mouse_x := x;
   last_mouse_y := y;
end;

procedure TForm1.Label1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   dragLabel := 0;
end;

procedure TForm1.Label2MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   dragLabel := 2;
   last_mouse_x := x;
   last_mouse_y := y;
end;

procedure TForm1.Label2MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   dragLabel := 0;
end;

procedure TForm1.Label3MouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   dragLabel := 3;
   last_mouse_x := x;
   last_mouse_y := y;
end;

procedure TForm1.Label3MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   dragLabel := 0;
end;

procedure TForm1.Label1MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if dragLabel = 1 then
   begin
      Label1.Left := Label1.Left+ x -last_mouse_x;
      Label1.Top := Label1.Top +y -last_mouse_y;
   end;
end;

procedure TForm1.Label2MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if dragLabel = 2 then
   begin
      Label2.Left := Label2.Left+ x -last_mouse_x;
      Label2.Top := Label2.Top +y -last_mouse_y;
   end;
end;

procedure TForm1.Label3MouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
begin
   if dragLabel = 3 then
   begin
      Label3.Left := Label3.Left+ x -last_mouse_x;
      Label3.Top := Label3.Top +y -last_mouse_y;
   end;
end;

end.
