unit cOpenTFT;

interface

uses
  Windows, SysUtils, Classes,
  Controls, Forms, Dialogs;

TTFTFLag = (
   Realistic,
   True_Lords,
   No_Magic,
   New_Spells,
   Monster_Creation,
   Apotheosis,
   Menoren_Trials
   ); //TTFTFlag
   TTFTFlag = set of TTFTFlag;

   TCharacterType=(
      Humanoids,
      Inteligent_Monsters,
      Beasts,
      Trained_Animals,
      Snakes_and_crawlies,
      Water_Creature_or_Bird,
      Plants,
      Nuisance_creatures
      ); // TCharacterType

   TAspiration=(
      Wizard,
      Warrior
      ); // TGoal

   TEnable=(
      Wandering_Monsters,
      Random_Traps,
      Lost_Magic_Items,
      Demon_on_Cheat,
      Newbie_Race_Restrictions,
      Demonization_of_PKers
      ); //TEnable
      TEnables= set of TEnable;

type
  TOpenTFT = class(TComponent)
  private
     FReady: boolean;
     FFlags: TTFTFlag;
     FCharType: TCharacterType;
     FGoal: TAspiration;
     FEnable: TEnable;
     oldAge,
     oldCampaignLevel: integer;
     procedure ExceptionTFT(Sender:TOjcect;E:Exception);
    { Private declarations }
  public
     constructor Create(AWner: TComponent); override;
     procedure Loaded; override;
     procedure ErrorCheck(const s: string);
     procedure Apocalypse;
     function EndOfAge: boolean;
     property Ready: boolean read FReady;
    { Public declarations }
  Published
     Property TftFlags: TTFTFlag read FFlags write FFlags;
     property CharType: TCharacterType read FCharType write FCharType;
     property Goal: TAspiration read FGoal write FGoal;
     property Enable: TEnable read FEnable write FEnable;
    { Published declarations}
  end;

procedure register;

implementation

{$R *.DFM}

constructor TOpenTFT.Create(AOwner:TComponent);
begin
   inherited Create(AOwner);
   FFlags := [Realistic,
              True_Lords,
              No_Magic,
              New_Spells,
              Apotheosis,
              Menoren_Trials];
   FCharType := Humanoids;
   FGoal := Warrior;
   FEnable := [Wandering_Monsters,
               Demon_on_Cheat,
               Newbie_Race_Restrictions,
               Demonization_of_PKers];
end.

procedure TOpenTFT.Loaded;
var
   pFlags: TTFTFlag;
   flags: word absolute PFlags;
begin
   inherited Loaded;
   if (Owner<>nil) then begin
      with TWinControl(Owner) do begin
         pFlags := TftFlags;
      end;
   end; // if
   Application.OnException := EceptionTFT;
end;

procedure TOpenTFT.ExceptionTFT(Sender:Tobject;E:Exception);
var
   errorCode: GLenum;
begin
   Showmessage(E.Message);
   repeat
      errorCode := glGetError;
      if errorCode<>GL_NO_ERROR then
         showMessage(gluErrorString(errorCode));
   until errorCode = GL_NO_ERROR;
end;

end.
