unit family_o;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics,
   Controls, Forms, Dialogs,
  StdCtrls, ComCtrls, Menus, ExtCtrls, Buttons;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    Timer1: TTimer;
    Button_Generate: TButton;
    RichEdit2: TRichEdit;
    BitBtn_first: TBitBtn;
    BitBtn_previous: TBitBtn;
    BitBtn_next: TBitBtn;
    BitBtn_last: TBitBtn;
    TrackBar1: TTrackBar;
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    SaveDialog1: TSaveDialog;
    procedure FormCreate(Sender: TObject);
    procedure RichEdit1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Timer1Timer(Sender: TObject);
    procedure Button_GenerateClick(Sender: TObject);
    procedure BitBtn_firstClick(Sender: TObject);
    procedure BitBtn_previousClick(Sender: TObject);
    procedure BitBtn_nextClick(Sender: TObject);
    procedure BitBtn_lastClick(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Save1Click(Sender: TObject);
    procedure SaveAs1Click(Sender: TObject);
    procedure Exit1Click(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;
 Names_matrix = record
   Spell_1: array [1..8] of string;
   Spell_2: array [1..10] of string;
   Spell_3: array [1..14] of string;
   Spell_4: array [1..12] of string;
   Spell_5: array [1..14] of string;
   Spell_6: array [1..12] of string;
   Chaos_normal: array [1..10] of string;
   Chaos_magical: array [1..16] of string;
   Neutral_normal: array [1..11] of string;
   Neutral_magical: array [1..13] of string;
   Law_normal: array [1..7] of string;
   Law_magical: array [1..10] of string;
   Holy_1: array [1..6] of string;
   Holy_2: array [1..6] of string;
   Holy_3: array [1..6] of string;
   Holy_4: array [1..6] of string;
   Holy_5: array [1..6] of string;
   Table_A: array [1..18] of String;
   TAble_B: array [1..15] of String;
   Law_Intrests: array [1..22] of string;
   Chaos_Intrests: array [1..22] of string;
   Effects: array [1..12] of string;
   Comm: array [1..4] of string;
   end;
 Special_matrix = record
   Name: string;
   Cursed: ShortInt;
   Saving_throw: ShortInt;
   Hit_die: ShortInt;
   To_be_Hit: ShortInt;
   Invisible_stalker: ShortInt;
   Teleportation: ShortInt;
   end;
 Alignment_matrix = record
   Name: String;
   Roster: string;
   Index: array [1..8] of integer;
   Powers_List: string;
   Table_A_Index: array [1..18] of integer;
   Table_B_Index: array [1..15] of integer;
   Combat_list: String;
   Chaos_normal_Index: array [1..10] of integer;
   Chaos_magical_Index: array [1..16] of integer;
   Neutral_normal_Index: array [1..11] of integer;
   Neutral_magical_Index: array [1..13] of integer;
   Law_normal_Index: array [1..7] of integer;
   Law_magical_Index: array [1..10] of integer;
   end;
 Origin_matrix = record
   Name: String;
   Index: array [1..8] of integer;
   Spell_list: String;
   Spell_1_Index: array [1..8] of integer;
   Spell_2_Index: array [1..10] of integer;
   Spell_3_Index: array [1..14] of integer;
   Spell_4_Index: array [1..12] of integer;
   Spell_5_Index: array [1..14] of integer;
   Spell_cost: integer;
   Holy_List: string;
   Holy_1_Index: array [1..6] of integer;
   Holy_2_Index: array [1..6] of integer;
   Holy_3_Index: array [1..6] of integer;
   Holy_4_Index: array [1..6] of integer;
   Holy_5_Index: array [1..6] of integer;
   end;
 Inteligence_matrix = record
   Name: String;
   Index: array [1..12] of integer;
   List: string;
   Effects_Index: array [1..12] of integer;
   Comm_Index: array [1..4] of integer;
   end;
 Ego_matrix = record
   Name: String;
   Index: array [1..22] of integer;
   Law_Intrests_Index: array [1..22] of integer;
   Chaos_Intrests_Index: array [1..22] of integer;
   end;

 Appearance_matrix = record
   Value: integer;
   Magic_cost: integer;
   end;

 Sword_matrix = record
   Alignment: Alignment_matrix;
   Origin: Origin_matrix;
   Inteligence: Inteligence_matrix;
   Ego: Ego_matrix;
   Special: Special_matrix;
   Appearance: Appearance_matrix;
   end;

 current_display = record
   byNumber: integer;
   byName: string;
   end;

const
  MaxFamSIZE = 1001;
var
  Form1: TForm1;
  Questing_sword: Boolean;
  rolls_on_magic_table, rolls_on_combat_table, rolls_on_special_table: Integer;
  CountI: integer;
  Count, background, TOTAL, GrandTotal: Integer;
  d4, d6, d8, d10, d12, d20: integer;
  Family: array [1..MaxFamSIZE] of Sword_matrix;
  Current: current_display;
  Names: Names_matrix;

implementation

{$R *.DFM}

function Roman(N: integer): String;
begin
   Result := '';
   case N of
      1: Result := 'I';
      2: Result := 'II';
      3: Result := 'III';
      4: Result := 'IV';
      5: Result := 'V';
      6: Result := 'VI';
      7: Result := 'VII';
      8: Result := 'VIII';
      9: Result := 'IX';
      10: Result := 'X';
      11: Result := 'XI';
      12: Result := 'XII';
      13: Result := 'XIII';
      14: Result := 'XIV';
      15: Result := 'XV';
      16: Result := 'XVI';
      17: Result := 'XVII';
      18: Result := 'XVIII';
      19: Result := 'XIX';
      20: Result := 'XX';
   end;
end;

function Plural(N: integer): String;
begin
  if N > 1 then
     Result :='s'
  else
     Result := ''
end;

function Whole(N: integer): String;
begin
   Result := '';
   case N of
      1: Result := 'one';
      2: Result := 'two';
      3: Result := 'three';
      4: Result := 'four';
      5: Result := 'five';
      6: Result := 'six';
      7: Result := 'seven';
      8: Result := 'eight';
      9: Result := 'nine';
      10: Result := 'ten';
      11: Result := 'eleven';
      12: Result := 'twelve';
      13: Result := 'thirteen';
      14: Result := 'fourteen';
      15: Result := 'fifteen';
      16: Result := 'sixteen';
      17: Result := 'seventeen';
      18: Result := 'eighteen';
      19: Result := 'nineteen';
      20: Result := 'twenty';
   end;
end;

function init(shou: integer): boolean;
var
   count: integer;
begin
      Current.byNumber := 1;
      Current.byName := 'a';
      Family[shou].Alignment.Name := '';
      Family[shou].Alignment.Roster := '';
      Family[shou].Alignment.Powers_List := '';
      for count := 1 to 18 do
         Family[shou].Alignment.Table_A_Index[count] := 0;
      for count := 1 to 15 do
         Family[shou].Alignment.Table_B_Index[count] := 0;
      Family[shou].Origin.Name := '';
      for count := 1 to 8 do
         Family[shou].Origin.Index[count] := 0;
      Family[shou].Origin.Spell_list := '';
      for count := 1 to 8 do
         Family[shou].Origin.Spell_1_Index[count] := 0;
      for count := 1 to 10 do
         Family[shou].Origin.Spell_2_Index[count] := 0;
      for count := 1 to 14 do
         Family[shou].Origin.Spell_3_Index[count] := 0;
      for count := 1 to 12 do
         Family[shou].Origin.Spell_4_Index[count] := 0;
      for count := 1 to 14 do
         Family[shou].Origin.Spell_5_Index[count] := 0;
      for count := 1 to 10 do
         Family[shou].Alignment.Chaos_normal_Index[count] := 0;
      for count := 1 to 16 do
         Family[shou].Alignment.Chaos_magical_Index[count] := 0;
      for count := 1 to 11 do
         Family[shou].Alignment.Neutral_normal_Index[count] := 0;
      for count := 1 to 13 do
         Family[shou].Alignment.Neutral_magical_Index[count] := 0;
      for count := 1 to 7 do
         Family[shou].Alignment.Law_normal_Index[count] := 0;
      for count := 1 to 10 do
         Family[shou].Alignment.Law_magical_Index[count] := 0;
      Family[shou].Origin.Holy_list := '';
      for count := 1 to 6 do
         Family[shou].Origin.Holy_1_Index[count] := 0;
      for count := 1 to 6 do
         Family[shou].Origin.Holy_2_Index[count] := 0;
      for count := 1 to 6 do
         Family[shou].Origin.Holy_3_Index[count] := 0;
      for count := 1 to 6 do
         Family[shou].Origin.Holy_4_Index[count] := 0;
      for count := 1 to 6 do
         Family[shou].Origin.Holy_5_Index[count] := 0;
      Family[shou].Inteligence.Name := '';
      for count := 1 to 12 do
         Family[shou].Inteligence.Index[count] := 0;
      Family[shou].Inteligence.List := '';
      for count := 1 to 12 do
         Family[shou].Inteligence.Effects_Index[count] := 0;
      for count := 1 to 4 do
         Family[shou].Inteligence.Comm_Index[count] := 0;
      Family[shou].Ego.Name := '';
      for count := 1 to 22 do
         Family[shou].Ego.Index[count] := 0;
      for count := 1 to 22 do
         Family[shou].Ego.Law_Intrests_Index[count] := 0;
      for count := 1 to 22 do
         Family[shou].Ego.Chaos_Intrests_Index[count] := 0;
      Family[shou].Special.Name := '';
      Family[shou].Special.Cursed := 0;
      Family[shou].Special.Saving_throw := 0;
      Family[shou].Special.Hit_die := 0;
      Family[shou].Special.To_be_Hit := 0;
      Family[shou].Special.Invisible_stalker := 0;
      Family[shou].Special.Teleportation := 0;
      Family[shou].Appearance.Value := 0;
      Family[shou].Appearance.Magic_cost := 0;
   Result := True;
end;

procedure family_print(N: integer);
var
   delay: integer;
begin
   with Form1.RichEdit2 do
   begin
      Clear;
      Lines.Add('SWORD #'+IntToStr(N));
      SelLength := 0;
      SelAttributes.Style := [fsBold];
   end;
   with Form1.RichEdit1 do
   begin
   SelAttributes.Color := clBlack;
   SelAttributes.Style := [];
   Lines.Add('ALIGNMENT: '+
             ' ' +
             Family[N].Alignment.Roster);
   SelStart :=
      SelStart - Length('ALIGNMENT:   '+
             ' ' +
             Family[N].Alignment.Roster);
   SelLength := 10;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('ORIGIN: ' +
             ' ' +
             Family[N].Origin.Name);
   SelStart :=
      SelStart - Length('ORIGIN:   ' +
             ' ' +
             Family[N].Origin.Name);
   SelLength := 7;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
 //  begin
//  end;
   Lines.Add('IQ: ' +
             Family[N].Inteligence.Name +
             ' and ' +
             Family[N].Inteligence.List);
   SelStart :=
      SelStart - Length('IQ: ' +
             Family[N].Inteligence.Name +
             ' and   ' +
             Family[N].Inteligence.List);
   SelLength := 3;
   SelAttributes.Color := clGreen;
   SelAttributes.Style := [fsBold];
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('EGO: '+
             Family[N].EGO.Name);
   SelStart :=
      SelStart - Length('EGO:   '+
             Family[N].EGO.Name);
   SelLength := 4;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('MAGIC:  '+
             Family[N].Origin.Spell_list);
   SelStart :=
      SelStart -Length('MAGIC:    '+
               Family[N].Origin.Spell_list);
   SelLength := 6;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('HOLY: '+
             Family[N].Origin.Holy_list);
   SelStart :=
     SelStart -Length('HOLY    '+
                       Family[N].Origin.Holy_list);
   SelLength := 5;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('COMBAT: '+
             Family[N].Alignment.Combat_List);
   SelStart :=
      SelStart -Length('COMBAT:   '+
                       Family[N].Alignment.Combat_List);
   SelLength := 7;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('SPECIAL: '+
             Family[N].Special.Name +
             Family[N].Alignment.Powers_List);
   SelStart :=
      SelStart - Length('SPECIAL:   '+
             Family[N].Special.Name +
             Family[N].Alignment.Powers_List);
   SelLength := 8;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 7 do
//   begin
   SelAttributes.Color := clGreen;
//   end;
   Lines.Add('APPEARANCE: ' +
             IntToStr(Family[N].Appearance.Value));
   SelStart :=
      SelStart - Length('  APPEARANCE: ' +
             IntToStr(Family[N].Appearance.Value));
   SelLength := 11;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
//   for delay := 1 to 1000 do
//   begin
//   end;
   Lines.Add('SPELL COST: ' +
             IntToStr(Family[N].Origin.Spell_Cost) +
             ' gold to recharge');
   SelStart :=
      SelStart - Length('  SPELL COST: ' +
             IntToStr(Family[N].Origin.Spell_Cost) +
             ' gold to recharge');
   SelLength := 10;
   SelAttributes.Style := [fsBold];
   SelAttributes.Color := clGreen;
   SelLength := 0;
   end;
end;

function dice(count: Integer): Integer;
begin
     Result := Random(count)+1;
end;

procedure specialNOTE;
var
   d100: integer;
begin
   d100 := ((dice(10)-1) * 10) + (dice(10)-1);
   background := 1;
   IF (d100 >= 3) AND (d100 <= 8) THEN
      background := 2;
   IF (d100 >= 9) AND (d100 <= 10) THEN
      background := 3;
end;

procedure alignment;
begin
   case dice(8) of
     1: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'L';
     2: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'L';
     3: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'L';
     4: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'L';
     5: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'N';
     6: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'N';
     7: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'C';
     8: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + 'C';
   end;
end;


procedure origin;
begin
   case dice(8) of
     1: Family[TOTAL].Origin.Index[1]
              := Family[TOTAL].Origin.Index[1]+1;
     2: Family[TOTAL].Origin.Index[2]
              := Family[TOTAL].Origin.Index[2]+1;
     3: Family[TOTAL].Origin.Index[3]
              := Family[TOTAL].Origin.Index[3]+1;
     4: Family[TOTAL].Origin.Index[4]
              := Family[TOTAL].Origin.Index[4]+1;
     5: Family[TOTAL].Origin.Index[5]
              := Family[TOTAL].Origin.Index[5]+1;
     6: Family[TOTAL].Origin.Index[6]
              := Family[TOTAL].Origin.Index[6]+1;
     7: Family[TOTAL].Origin.Index[7]
              := Family[TOTAL].Origin.Index[7]+1;
     8: Family[TOTAL].Origin.Index[8]
              := Family[TOTAL].Origin.Index[8]+1;
   end;
end;

procedure Origin_name_build;
var
   count: integer;
   H,F,M: Boolean;
begin
   H := False;
   F := False;
   M := False;
   if Family[TOTAL].Origin.Index[1] > 0 then
      H := True;
   for count := 2 to 6 do
   begin
      if Family[TOTAL].Origin.Index[count] > 0 then
         F := True;
   end;
   for count := 7 to 8 do
   begin
      if Family[TOTAL].Origin.Index[count] > 0 then
         M := True;
   end;
   if H = True then
      Family[TOTAL].Origin.Name := 'Holy ';
   if F = True then
      Family[TOTAL].Origin.Name := Family[TOTAL].Origin.Name + 'Fighter ';
   if M = True then
      Family[TOTAL].Origin.Name := Family[TOTAL].Origin.Name + 'Magician';
   for count := Length(Family[TOTAL].Origin.Name) to  21 do
      Family[TOTAL].Origin.Name := Family[TOTAL].Origin.Name + ' ';
end;

procedure IQ;
begin
   case dice(12) of
     1: Family[TOTAL].Inteligence.Index[1]
              := Family[TOTAL].Inteligence.Index[1]+1;
     2: Family[TOTAL].Inteligence.Index[2]
              := Family[TOTAL].Inteligence.Index[2]+1;
     3: Family[TOTAL].Inteligence.Index[3]
              := Family[TOTAL].Inteligence.Index[3]+1;
     4: Family[TOTAL].Inteligence.Index[4]
              := Family[TOTAL].Inteligence.Index[4]+1;
     5: Family[TOTAL].Inteligence.Index[5]
              := Family[TOTAL].Inteligence.Index[5]+1;
     6: Family[TOTAL].Inteligence.Index[6]
              := Family[TOTAL].Inteligence.Index[6]+1;
     7: Family[TOTAL].Inteligence.Index[7]
              := Family[TOTAL].Inteligence.Index[7]+1;
     8: Family[TOTAL].Inteligence.Index[8]
              := Family[TOTAL].Inteligence.Index[8]+1;
     9: Family[TOTAL].Inteligence.Index[9]
              := Family[TOTAL].Inteligence.Index[9]+1;
     10: Family[TOTAL].Inteligence.Index[10]
              := Family[TOTAL].Inteligence.Index[10]+1;
     11: Family[TOTAL].Inteligence.Index[11]
              := Family[TOTAL].Inteligence.Index[11]+1;
     12: Family[TOTAL].Inteligence.Index[12]
              := Family[TOTAL].Inteligence.Index[12]+1;
   end;
end;

procedure IQ_name_build;
var
   count: integer;
begin
   for count := 1 to 12 do
   begin
      if Family[TOTAL].Inteligence.Index[count] > 0 then
         Family[TOTAL].Inteligence.Name := IntToStr(count);
   end;
   if StrToInt(Family[TOTAL].Inteligence.Name) < 10 then
      Family[TOTAL].Inteligence.Name :=
         ' ' + Family[TOTAL].Inteligence.Name;
end;

procedure EGO;
begin
   case dice(12) of
     1: Family[TOTAL].EGO.Index[1]
              := Family[TOTAL].EGO.Index[1]+1;
     2: Family[TOTAL].EGO.Index[2]
              := Family[TOTAL].EGO.Index[2]+1;
     3: Family[TOTAL].EGO.Index[3]
              := Family[TOTAL].EGO.Index[3]+1;
     4: Family[TOTAL].EGO.Index[4]
              := Family[TOTAL].EGO.Index[4]+1;
     5: Family[TOTAL].EGO.Index[5]
              := Family[TOTAL].EGO.Index[5]+1;
     6: Family[TOTAL].EGO.Index[6]
              := Family[TOTAL].EGO.Index[6]+1;
     7: Family[TOTAL].EGO.Index[7]
              := Family[TOTAL].EGO.Index[7]+1;
     8: Family[TOTAL].EGO.Index[8]
              := Family[TOTAL].EGO.Index[8]+1;
     9: Family[TOTAL].EGO.Index[9]
              := Family[TOTAL].EGO.Index[9]+1;
     10: Family[TOTAL].EGO.Index[10]
              := Family[TOTAL].EGO.Index[10]+1;
     11: Family[TOTAL].EGO.Index[11]
              := Family[TOTAL].EGO.Index[11]+1;
     12: Family[TOTAL].EGO.Index[12]
              := Family[TOTAL].EGO.Index[12]+1;
   end;
end;

procedure EGO_name_build;
var
   count: integer;
begin
   for count := 1 to 22 do
   begin
      if Family[TOTAL].EGO.Index[count] > 0 then
         Family[TOTAL].EGO.Name := IntToStr(count);
   end;
   if StrToInt(Family[TOTAL].EGO.Name) < 10 then
      Family[TOTAL].EGO.Name := ' ' + Family[TOTAL].EGO.Name;
end;

procedure Magic_Table;
var
   max_level, spells_per_1, spells_per_2, spells_per_3,
   spells_per_4, spells_per_5, d100: integer;
begin
   while Rolls_on_magic_table > 0 do
   begin
      max_level := 0;
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..30: max_level := 1;
         31..55: max_level := 2;
         56..76: max_level := 3;
         77..90: max_level := 4;
         91..100: max_level := 5;
      end;
      spells_per_5 := 0;
      spells_per_4 := 0;
      spells_per_3 := 0;
      spells_per_2 := 0;
      if max_level > 4 then
         spells_per_5 := dice(4);
      if max_level > 3 then
         spells_per_4 := dice(6);
      if max_level > 2 then
         spells_per_3 := dice(8);
      if max_level > 1 then
         spells_per_2 := dice(10);
      spells_per_1 := dice(12);
      while spells_per_1 > 0 do
      begin
         Inc(Family[TOTAL].Origin.Spell_1_Index[dice(8)]);
         dec(spells_per_1);
      end;
      while spells_per_2 > 0 do
      begin
         Inc(Family[TOTAL].Origin.Spell_2_Index[dice(10)]);
         dec(spells_per_2);
      end;
      while spells_per_3 > 0 do
      begin
         Inc(Family[TOTAL].Origin.Spell_3_Index[dice(12)]);
         dec(spells_per_3);
      end;
      while spells_per_4 > 0 do
      begin
         Inc(Family[TOTAL].Origin.Spell_4_Index[dice(12)]);
         dec(spells_per_4);
      end;
      while spells_per_5 > 0 do
      begin
         Inc(Family[TOTAL].Origin.Spell_5_Index[dice(12)]);
         dec(spells_per_5);
      end;
      Rolls_on_magic_table := Rolls_on_magic_table -1;
   end;
end;

procedure magic;
var
   d100: integer;
begin
   d100 := ((dice(10)-1) * 10) + (dice(10)-1);
   if (Family[TOTAL].Origin.Index[7] > 1) or
      (Family[TOTAL].Origin.Index[8] > 1) then
      d100 := d100 + (dice(10)-1);

   case d100 of
     1..12: ; // none
     13: Family[TOTAL].Special.Cursed :=
               Family[TOTAL].Special.Cursed +1;
     14..65: ; // none
     66..76: Rolls_on_magic_table := 1;
     77: begin
         Family[TOTAL].Special.Saving_throw :=
            Family[TOTAL].Special.Saving_throw + (dice(10)-1);
         Rolls_on_magic_table := 1;
         end;
     78..86: Rolls_on_magic_table := 1;
     87..97: Rolls_on_magic_table := 2;
     98..103: Rolls_on_magic_table := 3;
     104..109: Rolls_on_magic_table := 4;
   end;
   Magic_table;
end;

procedure Magic_name_build;
var
   count, shou: integer;
begin
   shou := TOTAL;
   for count := 1 to 8 do
   begin
      if Family[shou].Origin.Spell_1_Index[count] > 0 then
         Family[shou].Origin.Spell_list := Family[shou].Origin.Spell_list +
         ', '+Names.Spell_1[count] +
         ' '+ Roman(Family[shou].Origin.Spell_1_Index[count]);
         Inc(Family[shou].Origin.Spell_cost,( Family[shou].Origin.Spell_1_Index[count]*1000) );
   end;
   for count := 1 to 10 do
   begin
      if Family[shou].Origin.Spell_2_Index[count] > 0 then
         Family[shou].Origin.Spell_list := Family[shou].Origin.Spell_list +
         ', '+Names.Spell_2[count] +
         ' '+ Roman(Family[shou].Origin.Spell_2_Index[count]);
         Inc(Family[shou].Origin.Spell_cost,( Family[shou].Origin.Spell_2_Index[count]*2000) );
   end;
   for count := 1 to 14 do
   begin
      if Family[shou].Origin.Spell_3_Index[count] > 0 then
         Family[shou].Origin.Spell_list := Family[shou].Origin.Spell_list +
         ', '+Names.Spell_3[count] +
         ' '+ Roman(Family[shou].Origin.Spell_3_Index[count]);
         Inc(Family[shou].Origin.Spell_cost,( Family[shou].Origin.Spell_3_Index[count]*3000) );
   end;
   for count := 1 to 12 do
   begin
      if Family[shou].Origin.Spell_4_Index[count] > 0 then
         Family[shou].Origin.Spell_list := Family[shou].Origin.Spell_list +
         ', '+Names.Spell_4[count] +
         ' '+ Roman(Family[shou].Origin.Spell_4_Index[count]);
         Inc(Family[shou].Origin.Spell_cost,( Family[shou].Origin.Spell_4_Index[count]*4000) );
   end;
   for count := 1 to 14 do
   begin
      if Family[shou].Origin.Spell_5_Index[count] > 0 then
         Family[shou].Origin.Spell_list := Family[shou].Origin.Spell_list +
         ', '+Names.Spell_5[count] +
         ' '+ Roman(Family[shou].Origin.Spell_5_Index[count]);
         Inc(Family[shou].Origin.Spell_cost,( Family[shou].Origin.Spell_5_Index[count]*5000) );
   end;
end;

procedure Holy_Table;
var
   level, d6, Rolls_left: integer;
begin
   Rolls_left := 1;
   while Rolls_left > 0 do
   begin
      level := dice(6);
      d6 := dice(6);
      case level of
         1: inc(Family[TOTAL].Origin.Holy_1_Index[d6]);
         2: begin
               if d6 > 4 then
               begin
                  Rolls_left := Rolls_left +2;
               end
               else
               begin
                  inc(Family[TOTAL].Origin.Holy_2_Index[d6]);
               end;
            end;
         3: begin
               if d6 > 4 then
               begin
                  Rolls_left := Rolls_left +2;
               end
               else
               begin
                  inc(Family[TOTAL].Origin.Holy_3_Index[d6]);
               end;
            end;
         4: inc(Family[TOTAL].Origin.Holy_4_Index[d6]);
         5: begin
               inc(Family[TOTAL].Origin.Holy_5_Index[d6]);
               if d6 = 4 then
                  Questing_sword := True;
            end;
         6: Rolls_left := Rolls_left +2;
      end;
      Rolls_left := Rolls_left -1;
   end;
end;

procedure Holy;
begin
     if Family[TOTAL].Origin.Index[1] > 0 then
        Holy_table;
end;

procedure Holy_name_build;
var
   count, shou: integer;
begin
   shou := TOTAL;
   for count := 1 to 6 do
   begin
      if Family[shou].Origin.Holy_1_Index[count] > 0 then
         Family[shou].Origin.Holy_list := Family[shou].Origin.Holy_list +
         ', x'+
         IntToStr(Family[shou].Origin.Holy_1_Index[count]) +
         ' '+Names.Holy_1[count] +
         ' ';
   end;
   for count := 1 to 6 do
   begin
      if Family[shou].Origin.Holy_2_Index[count] > 0 then
         Family[shou].Origin.Holy_list := Family[shou].Origin.Holy_list +
         ', x'+
         IntToStr(Family[shou].Origin.Holy_2_Index[count]) +
         ' '+Names.Holy_2[count] +
         ' ';
   end;
   for count := 1 to 6 do
   begin
      if Family[shou].Origin.Holy_3_Index[count] > 0 then
         Family[shou].Origin.Holy_list := Family[shou].Origin.Holy_list +
         ', x'+
         IntToStr(Family[shou].Origin.Holy_3_Index[count]) +
         ' '+Names.Holy_3[count] +
         ' ';
   end;
   for count := 1 to 6 do
   begin
      if Family[shou].Origin.Holy_4_Index[count] > 0 then
         Family[shou].Origin.Holy_list := Family[shou].Origin.Holy_list +
         ', x'+
         IntToStr(Family[shou].Origin.Holy_4_Index[count]) +
         ' '+Names.Holy_4[count] +
         ' ';
   end;
   for count := 1 to 6 do
   begin
      if Family[shou].Origin.Holy_5_Index[count] > 0 then
         Family[shou].Origin.Holy_list := Family[shou].Origin.Holy_list +
         ', x'+
         IntToStr(Family[shou].Origin.Holy_5_Index[count]) +
         ' '+Names.Holy_5[count] +
         ' ';
   end;
end;

procedure intell_and_comm;
var
   IQ, d6, count, rolls, twoD10: integer;
begin
   IQ := 0;
   for count := 1 to 12 do
      if Family[TOTAL].Inteligence.Index[count] > 0 then
         IQ := count;

   rolls := 0;

   for count := 1 to IQ do
      inc(rolls);
   d6 := 0;
   for count := 1 to rolls do
      inc(d6,dice(6));
   rolls := d6 div 4;
   while rolls > 0 do
   begin
      twoD10 := dice(10) + dice(10);
      case twoD10 of
        2: inc(Family[TOTAL].Inteligence.Effects_Index[1]);
        3: inc(Family[TOTAL].Inteligence.Effects_Index[2]);
        4: inc(Family[TOTAL].Inteligence.Effects_Index[3]);
        5: inc(Family[TOTAL].Inteligence.Effects_Index[4]);
        6..7: inc(Family[TOTAL].Inteligence.Effects_Index[5]);
        8..9: inc(Family[TOTAL].Inteligence.Effects_Index[6]);
        10: inc(Family[TOTAL].Inteligence.Effects_Index[7]);
        11..13: inc(Family[TOTAL].Inteligence.Effects_Index[8]);
        14..16: inc(Family[TOTAL].Inteligence.Effects_Index[9]);
        17..18: inc(Family[TOTAL].Inteligence.Effects_Index[10]);
        19: inc(Family[TOTAL].Inteligence.Effects_Index[11]);
        20: inc(Family[TOTAL].Inteligence.Effects_Index[12]);
      end;
      dec(rolls);
   end;
end;

procedure intell_and_comm_name_build;
var
   count: integer;
begin
   for count := 1 to 12 do
   begin
      if Family[TOTAL].Inteligence.Effects_Index[count] > 0 then
      begin
         Family[TOTAL].Inteligence.List :=
            Family[TOTAL].Inteligence.List +
            ', '+
            Names.Effects[count]+
            '('+
            IntToStr(Family[TOTAL].Inteligence.Effects_Index[count]) +
            ')';
      end;
   end;
end;

procedure appearance;
var
   d6, threeD6: integer;
begin
   d6 := dice(6);
   threeD6 := 0;
   case d6 of
      1..2: threeD6 := dice(6);
      3..4: threeD6 := dice(6) + dice(6);
      5..6: threeD6 := dice(6) + dice(6) + dice(6);
   end;
   Family[TOTAL].Appearance.Value :=
      Family[TOTAL].Appearance.Value + (threeD6 * 100);
end;

procedure communicate;
var
   IQ, count: integer;
begin
   IQ := 0;
   for count := 1 to 12 do
      if Family[TOTAL].Inteligence.Index[count] > 0 then
         IQ := count;
   case IQ of
      1..3: inc(Family[TOTAL].Inteligence.Comm_Index[1]);
      4..7: inc(Family[TOTAL].Inteligence.Comm_Index[2]);
      8..10: inc(Family[TOTAL].Inteligence.Comm_Index[3]);
      11..12: inc(Family[TOTAL].Inteligence.Comm_Index[4]);
   end;
end;

procedure communicate_name_build;
var
   count: integer;
begin
   for count := 1 to 4 do
   begin
      if Family[TOTAL].Inteligence.Comm_Index[count] > 0 then
         Family[TOTAL].Inteligence.List := Names.Comm[count];

   end;
end;

procedure List_A;
var
   d100, Rolls_left: integer;
begin
   Rolls_left := 1;
   While Rolls_left > 0 do
   begin
   d100 := ((dice(10)-1) * 10) + (dice(10)-1);
   case d100 of
      1..5: begin
               if dice(6) < 3 then
                 inc(Family[TOTAL].Alignment.Table_A_Index[1])
               else
                 inc(Family[TOTAL].Alignment.Table_A_Index[2])
             end;
      6..10: begin
               if dice(6) < 3 then
                 inc(Family[TOTAL].Alignment.Table_A_Index[3])
               else
                 inc(Family[TOTAL].Alignment.Table_A_Index[4])
             end;
      11..15: begin
               if dice(6) < 3 then
                 inc(Family[TOTAL].Alignment.Table_A_Index[5])
               else
                 inc(Family[TOTAL].Alignment.Table_A_Index[6])
             end;
      16..20: begin
               if dice(6) < 3 then
                 inc(Family[TOTAL].Alignment.Table_A_Index[7])
               else
                 inc(Family[TOTAL].Alignment.Table_A_Index[8])
             end;
      21..25: inc(Family[TOTAL].Alignment.Table_A_Index[9]);
      26..30: inc(Family[TOTAL].Alignment.Table_A_Index[10]);
      31..40: inc(Family[TOTAL].Alignment.Table_A_Index[11]);
      41..50: inc(Family[TOTAL].Alignment.Table_A_Index[12]);
      51..60: inc(Family[TOTAL].Alignment.Table_A_Index[13]);
      61..70: inc(Family[TOTAL].Alignment.Table_A_Index[14]);
      71..80: inc(Family[TOTAL].Alignment.Table_A_Index[15]);
      81..85: inc(Family[TOTAL].Alignment.Table_A_Index[16], dice(12));
      86..95: inc(Rolls_Left,2);
      96..100: inc(Rolls_Left,3);
   end;
      dec(Rolls_Left);
   end;
end;

procedure List_B;
var
   d100, Rolls_left: integer;
begin
   Rolls_left := 1;
   While Rolls_left > 0 do
   begin
   d100 := ((dice(10)-1) * 10) + (dice(10)-1);
   case d100 of
      1..10: inc(Family[TOTAL].Alignment.Table_B_Index[1]);
      11..18: inc(Family[TOTAL].Alignment.Table_B_Index[2]);
      19..25: inc(Family[TOTAL].Alignment.Table_B_Index[3]);
      26..30: inc(Family[TOTAL].Alignment.Table_B_Index[4],dice(10));
      31..38: inc(Family[TOTAL].Alignment.Table_B_Index[5]);
      39..42: inc(Family[TOTAL].Alignment.Table_B_Index[6]);
      43..45: inc(Family[TOTAL].Alignment.Table_B_Index[7]);
      46..50: inc(Family[TOTAL].Alignment.Table_B_Index[8]);
      51..56: inc(Family[TOTAL].Alignment.Table_B_Index[9]);
      57..60: inc(Family[TOTAL].Alignment.Table_B_Index[10]);
      61..75: inc(Family[TOTAL].Alignment.Table_B_Index[15]); // blank ???
      76..80: inc(Family[TOTAL].Alignment.Table_B_Index[11]);
      81..88: inc(Family[TOTAL].Alignment.Table_B_Index[12],dice(10));
      89..94: inc(Family[TOTAL].Alignment.Table_B_Index[13],dice(4));
      95..100: inc(Rolls_Left,2);
   end;
      dec(Rolls_Left);
   end;
end;

procedure adj_EGO;
var
   count, count2, modifyer: integer;
begin
    modifyer := 0;
      for count2 := 1 to 8 do
      begin
         if Family[TOTAL].Origin.Spell_1_Index[count2] > 0 then
            modifyer := 1;
      end;
      for count2 := 1 to 10 do
      begin
         if Family[TOTAL].Origin.Spell_2_Index[count2] > 0 then
            modifyer := 2;
      end;
      for count2 := 1 to 14 do
      begin
         if Family[TOTAL].Origin.Spell_3_Index[count2] > 0 then
            modifyer := 3;
      end;
      for count2 := 1 to 12 do
      begin
         if Family[TOTAL].Origin.Spell_4_Index[count2] > 0 then
            modifyer := 4;
      end;
      for count2 := 1 to 14 do
      begin
         if Family[TOTAL].Origin.Spell_5_Index[count2] > 0 then
            modifyer := 5;
      end;
   count2 := 0;
   for count := 1 to 22 do
   begin
      if Family[TOTAL].EGO.Index[count] > 0 then
         count2 := count;
   end;
   modifyer := modifyer + count2;
   count := 0;
   for count2 := 1 to 10 do
   begin
      count := count
              +Family[TOTAL].Alignment.Chaos_normal_Index[count2];
   end;
   for count2 := 1 to 16 do
   begin
      count := count
              +Family[TOTAL].Alignment.Chaos_magical_Index[count2];
   end;
   for count2 := 1 to 11 do
   begin
      count := count
              +Family[TOTAL].Alignment.Neutral_normal_Index[count2];
   end;
   for count2 := 1 to 13 do
   begin
      count := count
              +Family[TOTAL].Alignment.Neutral_magical_Index[count2];
   end;
   for count2 := 1 to 7 do
   begin
      count := count
              +Family[TOTAL].Alignment.Law_normal_Index[count2];
   end;
   for count2 := 1 to 10 do
   begin
      count := count
              +Family[TOTAL].Alignment.Law_magical_Index[count2];
   end;
   count := (count+1) div 3;
   count := count + modifyer;
   if count > 22 then
      count := 22;
   inc(Family[TOTAL].EGO.Index[count]);
end;

procedure powers;
var
   d10, count: integer;
begin
   count := Length(Family[TOTAL].Alignment.Roster);
   while count > 0 do
   begin
      case Family[TOTAL].Alignment.Roster[count] of
         'L': begin
                 d10 := dice(10);
                 case d10 of
                    1..4: List_A;
                    5..10: List_B;
                 end;
              dec(count);
              end;

         'N': begin
                 d10 := dice(10);
                 case d10 of
                    1..5: List_A;
                    6..10: List_B;
                 end;
              dec(count);
              end;

         'C': begin
                 d10 := dice(10);
                 case d10 of
                    1..7: List_A;
                    8..10: List_B;
                 end;
              dec(count);
              end;
      end;
   end;
end;

procedure Powers_name_build;
var
   count: integer;
begin
   for count := 1 to 18 do
   begin
      if Family[TOTAL].Alignment.Table_A_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Powers_List :=
                Family[TOTAL].Alignment.Powers_List  +
                ', ' +
                Names.Table_A[count] +
                '(' +
                IntToStr(Family[TOTAL].Alignment.Table_A_Index[count]) +
                ')';
      end;
   end;

   for count := 1 to 15 do
   begin
      if Family[TOTAL].Alignment.Table_B_Index[count] > 0 then
      begin
         if count = 4 then
         begin
         Family[TOTAL].Alignment.Powers_List :=
                Family[TOTAL].Alignment.Powers_List +
                ', ' +
                Names.Table_B[count] +
                IntToStr(Family[TOTAL].Alignment.Table_B_Index[count]) +
                ' turns';
         end
         else
         begin
         Family[TOTAL].Alignment.Powers_List :=
                Family[TOTAL].Alignment.Powers_List +
                ', ' +
                Names.Table_B[count] +
                '(' +
                IntToStr(Family[TOTAL].Alignment.Table_B_Index[count]) +
                ')';
         end;
      end;
   end;
end;

procedure Combat_vs_Law_normal;
var
   d100: integer;
begin
   rolls_on_combat_table := 1;
   while rolls_on_combat_table > 0 do
   begin
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..35: inc(Family[TOTAL].Alignment.Law_normal_Index[1]);
         36..40: inc(Family[TOTAL].Alignment.Law_normal_Index[2]);
         45..55: inc(Family[TOTAL].Alignment.Law_normal_Index[3]);
         56..70: inc(Family[TOTAL].Alignment.Law_normal_Index[4]);
         71..85: inc(Family[TOTAL].Alignment.Law_normal_Index[5]);
         86..90: inc(Family[TOTAL].Alignment.Law_normal_Index[1]);
         96..100: inc(rolls_on_combat_table,2);
      end;
   dec(rolls_on_combat_table);
   end;
end;

procedure Combat_vs_Law_magical;
var
   d100: integer;
begin
   rolls_on_combat_table := 1;
   while rolls_on_combat_table > 0 do
   begin
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..10: inc(Family[TOTAL].Alignment.Law_magical_Index[1]);
         11..15: inc(Family[TOTAL].Alignment.Law_magical_Index[2]);
         16..25: inc(Family[TOTAL].Alignment.Law_magical_Index[3]);
         26..35: inc(Family[TOTAL].Alignment.Law_magical_Index[4]);
         36..45: inc(Family[TOTAL].Alignment.Law_magical_Index[5]);
         46..60: inc(Family[TOTAL].Alignment.Law_magical_Index[6]);
         61..75: inc(Family[TOTAL].Alignment.Law_magical_Index[7]);
         76..85: inc(Family[TOTAL].Alignment.Law_magical_Index[8]);
         86..95: inc(rolls_on_combat_table);
         96..100: inc(rolls_on_combat_table,2);
      end;
   dec(rolls_on_combat_table);
   end;
end;

procedure Combat_vs_Neutral_normal;
var
   d100: integer;
begin
   rolls_on_combat_table := 1;
   while rolls_on_combat_table > 0 do
   begin
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..20: inc(Family[TOTAL].Alignment.Neutral_normal_Index[1]);
         21..30: inc(Family[TOTAL].Alignment.Neutral_normal_Index[2]);
         31..40: inc(Family[TOTAL].Alignment.Neutral_normal_Index[3]);
         41..50: inc(Family[TOTAL].Alignment.Neutral_normal_Index[4]);
         51..60: inc(Family[TOTAL].Alignment.Neutral_normal_Index[5]);
         61..65: inc(Family[TOTAL].Alignment.Neutral_normal_Index[6]);
         66..70: inc(Family[TOTAL].Alignment.Neutral_normal_Index[7]);
         71..75: inc(Family[TOTAL].Alignment.Neutral_normal_Index[8]);
         76..85: inc(Family[TOTAL].Alignment.Neutral_normal_Index[1]);
         86..95: inc(rolls_on_combat_table,2);
         96..100: inc(rolls_on_combat_table,3);
      end;
   dec(rolls_on_combat_table);
   end;
end;

procedure Combat_vs_Neutral_magical;
var
   d100: integer;
begin
   rolls_on_combat_table := 1;
   while rolls_on_combat_table > 0 do
   begin
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..5: inc(Family[TOTAL].Alignment.Neutral_magical_Index[1]);
         6..10: inc(Family[TOTAL].Alignment.Neutral_magical_Index[2]);
         11..15: inc(Family[TOTAL].Alignment.Neutral_magical_Index[3]);
         16..30: inc(Family[TOTAL].Alignment.Neutral_magical_Index[4]);
         31..40: inc(Family[TOTAL].Alignment.Neutral_magical_Index[5]);
         41..55: inc(Family[TOTAL].Alignment.Neutral_magical_Index[6]);
         56..65: inc(Family[TOTAL].Alignment.Neutral_magical_Index[7]);
         66..70: inc(Family[TOTAL].Alignment.Neutral_magical_Index[8]);
         71..75: inc(Family[TOTAL].Alignment.Neutral_magical_Index[9]);
         76..80: inc(Family[TOTAL].Alignment.Neutral_magical_Index[10]);
         81..85: inc(Family[TOTAL].Alignment.Neutral_magical_Index[11]);
         86..90: inc(Family[TOTAL].Alignment.Neutral_magical_Index[12]);
         91..100: inc(rolls_on_combat_table,2);
      end;
   dec(rolls_on_combat_table);
   end;
end;

procedure Combat_vs_Chaos_normal;
var
   d100: integer;
begin
   rolls_on_combat_table := 1;
   while rolls_on_combat_table > 0 do
   begin
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..20: inc(Family[TOTAL].Alignment.Chaos_normal_Index[1]);
         21..30: inc(Family[TOTAL].Alignment.Chaos_normal_Index[2]);
         31..35: inc(Family[TOTAL].Alignment.Chaos_normal_Index[3]);
         36..50: inc(Family[TOTAL].Alignment.Chaos_normal_Index[4]);
         51..60: inc(Family[TOTAL].Alignment.Chaos_normal_Index[5]);
         61..65: inc(Family[TOTAL].Alignment.Chaos_normal_Index[6]);
         66..75: inc(Family[TOTAL].Alignment.Chaos_normal_Index[7]);
         76..85: inc(Family[TOTAL].Alignment.Chaos_normal_Index[8]);
         86..95: inc(rolls_on_combat_table,2);
         96..100: inc(rolls_on_combat_table,3);
      end;
   dec(rolls_on_combat_table);
   end;
end;

procedure Combat_vs_Chaos_magical;
var
   d100: integer;
begin
   rolls_on_combat_table := 1;
   while rolls_on_combat_table > 0 do
   begin
      d100 := ((dice(10)-1) * 10) + (dice(10)-1);
      case d100 of
         1..5: inc(Family[TOTAL].Alignment.Chaos_magical_Index[1]);
         6..15: inc(Family[TOTAL].Alignment.Chaos_magical_Index[2]);
         16..25: inc(Family[TOTAL].Alignment.Chaos_magical_Index[3]);
         26..30: inc(Family[TOTAL].Alignment.Chaos_magical_Index[4]);
         31..35: inc(Family[TOTAL].Alignment.Chaos_magical_Index[5]);
         36..40: inc(Family[TOTAL].Alignment.Chaos_magical_Index[6]);
         41..45: inc(Family[TOTAL].Alignment.Chaos_magical_Index[7]);
         46..50: inc(Family[TOTAL].Alignment.Chaos_magical_Index[8]);
         51..55: inc(Family[TOTAL].Alignment.Chaos_magical_Index[9]);
         56..60: inc(Family[TOTAL].Alignment.Chaos_magical_Index[10]);
         61..65: inc(Family[TOTAL].Alignment.Chaos_magical_Index[11]);
         66..70: inc(Family[TOTAL].Alignment.Chaos_magical_Index[12]);
         71..80: inc(Family[TOTAL].Alignment.Chaos_magical_Index[13]);
         81..90: inc(Family[TOTAL].Alignment.Chaos_magical_Index[14]);
         91..95: inc(rolls_on_combat_table,2);
         96..100: inc(rolls_on_combat_table,3);
      end;
   dec(rolls_on_combat_table);
   end;
end;

procedure Combat;
var
   d100, count, count2, d6: integer;
begin
   count := Length(Family[TOTAL].Alignment.Roster);
   while count > 0 do
   begin
     d100 := ((dice(10)-1) * 10) + (dice(10)-1);
     if (Family[TOTAL].Origin.Index[2] > 1) or
        (Family[TOTAL].Origin.Index[3] > 1) or
        (Family[TOTAL].Origin.Index[4] > 1) or
        (Family[TOTAL].Origin.Index[5] > 1) or
        (Family[TOTAL].Origin.Index[6] > 1) then
        d100 := d100 + (dice(10)-1);
     count2 := 0;
     case d100 of
        1..12: ; // none
        13: begin
            inc(Family[TOTAL].Special.Invisible_stalker);
            end;
        14..65: ; // none
        66..76: inc(count2);
        77: begin
            inc(Family[TOTAL].Special.Teleportation);
            inc(count2);
            end;
        78..86: inc(count2);
        87..97: inc(count2,2);
        98..103: inc(count2,3);
        104..109: inc(count2,4);
     end;
     while count2 > 0 do
     begin
        if Family[TOTAL].Alignment.Roster[count] = 'L' then
        begin
        d6 := dice(6);
        case d6 of
           1..4: begin
                   Combat_vs_Neutral_normal;
                   Combat_vs_Chaos_normal;
                 end;
           5..6: begin
                   Combat_vs_Neutral_magical;
                   Combat_vs_Chaos_magical;
                 end;
        end;
        dec(count2);
        end;
        if Family[TOTAL].Alignment.Roster[count] = 'N' then
        begin
        d6 := dice(6);
        case d6 of
           1..3: begin
                   Combat_vs_Law_normal;
                   Combat_vs_Chaos_normal;
                 end;
           4..6: begin
                   Combat_vs_Law_magical;
                   Combat_vs_Chaos_magical;
                 end;
        end;
        dec(count2);
        end;
        if Family[TOTAL].Alignment.Roster[count] = 'C' then
        begin
        d6 := dice(6);
        case d6 of
           1..2: begin
                   Combat_vs_Neutral_normal;
                   Combat_vs_Law_normal;
                 end;
           3..6: begin
                   Combat_vs_Neutral_magical;
                   Combat_vs_Law_magical;
                 end;
        end;
        dec(count2);
        end;
     end;
     dec(count);
   end;
end;

procedure Combat_name_build;
var
   count: integer;
begin
   Family[TOTAL].Alignment.Combat_list := '+1 all';

   for count := 1 to 10 do
   begin
      if Family[TOTAL].Alignment.Chaos_normal_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Combat_list :=
         Family[TOTAL].Alignment.Combat_list +
         ', +' +
         IntToStr(Family[TOTAL].Alignment.Chaos_normal_Index[count]) +
         ' ' +
         Names.Chaos_normal[count] ;
      end;
   end;

   for count := 1 to 16 do
   begin
      if Family[TOTAL].Alignment.Chaos_magical_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Combat_list :=
         Family[TOTAL].Alignment.Combat_list +
         ', +' +
         IntToStr(Family[TOTAL].Alignment.Chaos_magical_Index[count]) +
         ' ' +
         Names.Chaos_magical[count] ;
      end;
   end;


   for count := 1 to 11 do
   begin
      if Family[TOTAL].Alignment.Neutral_normal_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Combat_list :=
         Family[TOTAL].Alignment.Combat_list +
         ', +' +
         IntToStr(Family[TOTAL].Alignment.Neutral_normal_Index[count]) +
         ' ' +
         Names.Neutral_normal[count] ;
      end;
   end;

   for count := 1 to 13 do
   begin
      if Family[TOTAL].Alignment.Neutral_magical_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Combat_list :=
         Family[TOTAL].Alignment.Combat_list +
         ', +' +
         IntToStr(Family[TOTAL].Alignment.Neutral_magical_Index[count]) +
         ' ' +
         Names.Neutral_magical[count] ;
      end;
   end;


   for count := 1 to 7 do
   begin
      if Family[TOTAL].Alignment.Law_normal_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Combat_list :=
         Family[TOTAL].Alignment.Combat_list +
         ', +' +
         IntToStr(Family[TOTAL].Alignment.Law_normal_Index[count]) +
         ' ' +
         Names.Law_normal[count] ;
      end;
   end;

   for count := 1 to 10 do
   begin
      if Family[TOTAL].Alignment.Law_magical_Index[count] > 0 then
      begin
         Family[TOTAL].Alignment.Combat_list :=
         Family[TOTAL].Alignment.Combat_list +
         ', +' +
         IntToStr(Family[TOTAL].Alignment.Law_magical_Index[count]) +
         ' ' +
         Names.Law_magical[count] ;
      end;
   end;

end;

procedure Special_name_build;
begin
   if Family[TOTAL].Special.Cursed > 0 then
      Family[TOTAL].Special.Name := ', Cursed';
   if Family[TOTAL].Special.Saving_throw > 0 then
   begin
      if Length(Family[TOTAL].Special.Name) > 0 then
         Family[TOTAL].Special.Name := Family[TOTAL].Special.Name + ', ';
      Family[TOTAL].Special.Name :=
             Family[TOTAL].Special.Name + ', +' +
             IntToStr(Family[TOTAL].Special.Saving_throw) +
             ' Saving throw';
   end;
   if Family[TOTAL].Special.Hit_die > 0 then
   begin
      if Length(Family[TOTAL].Special.Name) > 0 then
         Family[TOTAL].Special.Name := Family[TOTAL].Special.Name + ', ';
      Family[TOTAL].Special.Name :=
             Family[TOTAL].Special.Name + ', +' +
             IntToStr(Family[TOTAL].Special.Hit_die) +
             ' Hit die';
   end;

   if Family[TOTAL].Special.To_be_Hit > 0 then
   begin
      if Length(Family[TOTAL].Special.Name) > 0 then
         Family[TOTAL].Special.Name := Family[TOTAL].Special.Name + ', ';
      Family[TOTAL].Special.Name :=
             Family[TOTAL].Special.Name + ', -' +
             IntToStr(Family[TOTAL].Special.To_be_Hit) +
             ' To be hit';
   end;

   if Family[TOTAL].Special.Invisible_stalker > 0 then
   begin
      if Length(Family[TOTAL].Special.Name) > 0 then
         Family[TOTAL].Special.Name := Family[TOTAL].Special.Name + ', ';
      Family[TOTAL].Special.Name :=
             Family[TOTAL].Special.Name +
             ', Invisible stalker';
   end;

   if Family[TOTAL].Special.Teleportation > 0 then
   begin
      if Length(Family[TOTAL].Special.Name) > 0 then
         Family[TOTAL].Special.Name := Family[TOTAL].Special.Name + ', ';
      Family[TOTAL].Special.Name :=
             Family[TOTAL].Special.Name +
             ' Teleport away from battle';
   end;
end;

procedure Alignment_name_build;
begin
   case length(Family[TOTAL].Alignment.Roster) of
     1: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + '      ';
     2: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + '     ';
     3: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + '    ';
     4: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + '   ';
     5: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + '  ';
     6: Family[TOTAL].Alignment.Roster :=
           Family[TOTAL].Alignment.Roster + ' ';
   end;
end;

function generate_swords(Count: integer): Boolean;
begin
     specialNOTE;
     while background > 0 do
     begin
        alignment;
        origin;
        IQ;
        EGO;
        magic;
        holy;
        intell_and_comm;
        appearance;
        background := background - 1;
     end;
     Powers;
     Powers_name_build;
     communicate;
     Communicate_name_build;
     intell_and_comm_name_build;
     Combat;
     Combat_name_build;
     Origin_name_build;
     Alignment_name_build;
     IQ_name_build;
     adj_EGO;
     EGO_name_build;
     Special_name_build;
     Magic_name_build;
     Holy_name_build;
     TOTAL := TOTAL + 1;
     Result := True;
end;

procedure TForm1.FormCreate(Sender: TObject);
var
   count: integer;
begin
//     RichEdit1.Lines.LoadFromFile('The ways of matrix.rtf');
     RichEdit1.Font.Name := 'Courier New';
     RichEdit1.Font.Size := 10;
     RichEdit2.Font.Name := 'Courier New';
     RichEdit2.Lines.LoadFromFile('Spells Level 1.txt');
     for count := 1 to 8 do
     begin
        Names.Spell_1[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Spells Level 2.txt');
     for count := 1 to 10 do
     begin
        Names.Spell_2[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Spells Level 3.txt');
     for count := 1 to 14 do
     begin
        Names.Spell_3[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Spells Level 4.txt');
     for count := 1 to 12 do
     begin
        Names.Spell_4[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Spells Level 5.txt');
     for count := 1 to 14 do
     begin
        Names.Spell_5[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Spells Level 6.txt');
     for count := 1 to 12 do
     begin
        Names.Spell_6[count] := RichEdit2.Lines.Strings[count-1];
     end;

     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Holy Level 1.txt');
     for count := 1 to 6 do
     begin
        Names.Holy_1[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Holy Level 2.txt');
     for count := 1 to 6 do
     begin
        Names.Holy_2[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Holy Level 3.txt');
     for count := 1 to 6 do
     begin
        Names.Holy_3[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Holy Level 4.txt');
     for count := 1 to 6 do
     begin
        Names.Holy_4[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Holy Level 5.txt');
     for count := 1 to 6 do
     begin
        Names.Holy_5[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Table A.txt');
     for count := 1 to 18 do
     begin
        Names.Table_A[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Table B.txt');
     for count := 1 to 15 do
     begin
        Names.Table_B[count] := RichEdit2.Lines.Strings[count-1];
     end;
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Chaos normal.txt');
     for count := 1 to 10 do
         Names.Chaos_normal[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Chaos magical.txt');
     for count := 1 to 16 do
         Names.Chaos_magical [count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Neutral normal.txt');
     for count := 1 to 11 do
         Names.Neutral_normal[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Neutral magical.txt');
     for count := 1 to 13 do
         Names.Neutral_magical[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Law normal.txt');
     for count := 1 to 7 do
         Names.Law_normal[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Law magical.txt');
     for count := 1 to 10 do
         Names.Law_magical[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Effects.txt');
     for count := 1 to 12 do
         Names.Effects[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Comm.txt');
     for count := 1 to 4 do
         Names.Comm[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Chaos Intrests.txt');
     for count := 1 to 22 do
         Names.Chaos_Intrests[count] := RichEdit2.Lines.Strings[count-1];
     RichEdit2.Lines.Clear;
     RichEdit2.Lines.LoadFromFile('Law Intrests.txt');
     for count := 1 to 22 do
         Names.Law_Intrests[count] := RichEdit2.Lines.Strings[count-1];
end;

procedure TForm1.RichEdit1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
     if Button =  mbRight then
     begin    
        if RichEdit1.SelLength > 0 then
        begin
           RichEdit1.SelAttributes.Color := clRed;
        end;
     end;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
//     if Current.ByNumber > 0 then
//     begin
//        Form1.RichEdit1.clear;
//        family_print(Current.ByNumber);
//   form1.Canvas.a
//     form1.Caption := RichEdit1.Font.Name +' '+
//                    inttostr(richEdit1.SelAttributes.Size );
//     form1.Caption := inttostr( RichEdit1.SelStart);
//     form1.Caption := RichEdit1.Lines.Strings[3];
end;

procedure TForm1.Button_GenerateClick(Sender: TObject);
var
   fount: integer;
begin
     Randomize;
     Questing_Sword := False;
     Count := 0;
     TOTAL := 1;
     Form1.RichEdit1.Lines.Clear;
     fount := 1;
     while (fount <= MaxFamSIZE) and
           (Questing_sword = False) do
     begin
         Form1.Caption := IntToStr(TOTAL);
         init(fount);
         Generate_Swords(fount);
         inc(fount);
     end;
     Form1.RichEdit1.clear;
     family_print(fount-1);
     MessageDlg('A Questing sword has been found',
                mtInformation,[mbOk],0);
     dec(fount);
     Current.ByNumber := fount;
     Form1.TrackBar1.Max := fount;
     Form1.TrackBar1.Position := fount;
end;

procedure TForm1.BitBtn_firstClick(Sender: TObject);
begin
   Current.ByNumber := 1;
   Form1.TrackBar1.Position := Current.ByNumber;
   Form1.RichEdit1.clear;
   Family_print(Current.ByNumber);
end;

procedure TForm1.BitBtn_previousClick(Sender: TObject);
begin
   if Current.byNumber > 1 then
      dec(Current.byNumber);
   begin
      Form1.TrackBar1.Position := Current.ByNumber;
      Form1.RichEdit1.clear;
      Family_print(Current.ByNumber);
   end;
end;

procedure TForm1.BitBtn_nextClick(Sender: TObject);
begin
   if (Current.byNumber < StrToInt(Form1.Caption)) then
      inc(Current.byNumber);
   begin
      Form1.TrackBar1.Position := Current.ByNumber;
      Form1.RichEdit1.clear;
      Family_print(Current.ByNumber);
   end;
end;

procedure TForm1.BitBtn_lastClick(Sender: TObject);
begin
   Current.ByNumber := StrToInt(Form1.Caption);
   Form1.TrackBar1.Position := Current.ByNumber;
   Form1.RichEdit1.clear;
   Family_print(Current.ByNumber);
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   if TrackBar1.Position <> Current.ByNumber then
   begin
     Current.ByNumber := TrackBar1.Position;
     Form1.RichEdit1.clear;
     Family_print(Current.ByNumber);
   end;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   RichEdit1.Top := 42;
   RichEdit1.Left := 0;
   RichEdit1.Width := Form1.Width;
   RichEdit1.Height := Form1.Height-42;
end;

procedure TForm1.Save1Click(Sender: TObject);
var
   x: integer;
begin
   with Form1.RichEdit1 do
   begin
      clear;
   end;
   Form1.RichEdit1.clear;
   for x := TrackBar1.Min to TrackBar1.Max do
   begin
       Form1.RichEdit1.Lines.Add('Sword #'+IntToStr(x));
       Family_print(x);
       Form1.RichEdit1.Lines.Add('-------------------------------------');
   end;
   Form1.RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
   Form1.RichEdit1.clear;
   family_print(TrackBar1.Position);

end;

procedure TForm1.SaveAs1Click(Sender: TObject);
var
   x: integer;
begin
   with Form1.RichEdit1 do
   begin
      clear;
   end;
   Form1.RichEdit1.clear;
   for x := TrackBar1.Max to TrackBar1.Min do
   begin
       Form1.RichEdit1.Lines.Add('Sword #'+IntToStr(x));
       Family_print(x);
       Form1.RichEdit1.Lines.Add('-------------------------------------');
   end;
   If SaveDialog1.Execute then
   begin
       Form1.RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
   end;
   Form1.RichEdit1.clear;
   family_print(TrackBar1.Position);

end;


procedure TForm1.Exit1Click(Sender: TObject);
begin
   Application.Terminate;
end;

end.
