unit fract_p;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Button1: TButton;
    Label1: TLabel;
    TrackBar1: TTrackBar;
    scale: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure Button1Click(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure scaleChange(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;
  H: array [0..512] of integer;
  H_old: array [0..512] of integer;
  cx, cy: integer;
  divisor, off_x: integer;

implementation

{$R *.DFM}
function deviation(N: integer): integer;
var
   temp: integer;
begin
   temp := random(N)+1;
   Result := temp;
end;
procedure TForm1.FormCreate(Sender: TObject);
var
   count: integer;
begin
   Randomize;
   for count := 0 to 512 do
   begin
      H[count] := 0;
      H_old[count] := 0;
   end;
   divisor := 0;
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   cx := Form1.ClientWidth div 2;
   cy := Form1.ClientHeight div 2;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
var
   count, n: integer;
begin
      form1.Canvas.Pen.Color := clBtnFace;
      Form1.Canvas.MoveTo((0-off_x), cy);
      for count := 0 to 512 do
      begin
         n := (count*form1.scale.position)-off_x;
         Form1.Canvas.LineTo(n, cy - H_old[count]);
         Form1.Canvas.Polygon([Point(n-1,cy-H_old[count]-1),
                               Point(n+1,cy-H_old[count]-1),
                               Point(n+1,cy-H_old[count]+1),
                               Point(n-1,cy-H_old[count]+1)]);
      end;
      Form1.Canvas.MoveTo(0-off_x, cy);
      for count := 0 to 512 do
      begin
         form1.Canvas.Pen.Color := clBlack;
         n := (count*form1.scale.position)-off_x;
         Form1.Canvas.LineTo(n, cy - H[count]);
         form1.Canvas.Pen.Color := clOlive;
         Form1.Canvas.Polygon([Point(n-1,cy-H[count]-1),
                               Point(n+1,cy-H[count]-1),
                               Point(n+1,cy-H[count]+1),
                               Point(n-1,cy-H[count]+1)]);
      end;
      form1.Canvas.Pen.Color := clred;
      Form1.Canvas.MoveTo(cx+2, 0);
      Form1.Canvas.LineTo(cx+2, cy+cy);

end;

procedure TForm1.Button1Click(Sender: TObject);
var
   length, leng, dev, devi, roll, count, pos: integer;
   rate: real;
begin
   Form1.Caption := 'Deviate: ';
   for count := 0 to 512 do
       H_old[count] := H[count];

   rate := 0.90;
   Length := 512;
   Leng := length;
   Dev := 64;
   devi := 0;
   Form1.Label1.caption := 'Rolls  ';
   roll := 0;
   for count := 0 to 8 do
   begin
      leng := leng div 2;
      pos := leng;
      while pos < length do
      begin
         devi := ((H[pos - leng] + H[pos + leng]) div 2);
         roll := deviation(dev);
         H[pos] :=  devi - roll;
         Pos := Pos +(leng * 2);
      end;
      Form1.Label1.caption := Form1.Label1.Caption +',   '+IntToStr(roll);
      form1.Caption := Form1.Caption +','+IntToStr(dev)+
          '('+IntToStr(devi)+')';
      dev := round(dev * rate);
   end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   off_x := TrackBar1.position;
   Form1.Invalidate;
end;

procedure TForm1.scaleChange(Sender: TObject);
begin
   Form1.Invalidate;
   Form1.TrackBar1.Max := 512 * Form1.Scale.Position;
   Form1.TrackBar1.Frequency := Form1.TrackBar1.Max div 100;
end;

end.
