unit matrix_9p;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Math, StdCtrls;

type
  TForm1 = class(TForm)
    Timer1: TTimer;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    procedure FormResize(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

var
   cx,cy,ty,rx,ry, z, D: integer;
   sprite_z: integer;
   cycle : longint;
   Mhex: array [1..6,1..3] of integer;

   scale, incriment: real;
   Radian_x, Radian_y, Radian_z : real;

procedure TForm1.FormResize(Sender: TObject);
begin
     cx := Form1.ClientWidth div 2;
     cy := Form1.ClientHeight div 2;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
     D := 10;
     sprite_z := 10;
     Scale := 0.5;
     Radian_x := 0;
     Radian_y := 0;
     Radian_z := 0;
     z := 1;
     incriment := 0.01745329252;
     ty := 128;
     rx := 112;
     ry := 64;
     cycle := 0;
end;

procedure TForm1.FormPaint(Sender: TObject);
var
   x,t,y, count: integer;
   vx,vy,vz: integer;
begin
     x := rx;
     t := ty;
     y := ry;
     Mhex[1,1] := 0;
     Mhex[1,2] := t;
     Mhex[1,3] := z;

     Mhex[2,1] := x;
     Mhex[2,2] := y;
     Mhex[2,3] := z;

     Mhex[3,1] := x;
     Mhex[3,2] := -y;
     Mhex[3,3] := z;

     Mhex[4,1] := 0;
     Mhex[4,2] := -t;
     Mhex[4,3] := z;

     Mhex[5,1] := -x;
     Mhex[5,2] := -y;
     Mhex[5,3] := z;

     Mhex[6,1] := -x;
     Mhex[6,2] := y;
     Mhex[6,3] := z;

    Label10.Caption := '1x  '+IntToStr(Mhex[1,1]);
    Label11.Caption := '1y  '+IntToStr(Mhex[1,2]);
    Label12.Caption := '2x  '+IntToStr(Mhex[2,1]);
    Label13.Caption := '2y  '+IntToStr(Mhex[2,2]);
    Label14.Caption := '3x  '+IntToStr(Mhex[3,1]);
    Label15.Caption := '3y  '+IntToStr(Mhex[3,2]);

     For count := 1 to 6 do
     begin
         // z
         vx := Mhex[count,1];
         vy := Mhex[count,2];
         vz := Mhex[count,3];
         Mhex[count,1] := round((vx *    Cos(Radian_z) ) +
                                (vy *   -Sin(Radian_z) ));
         Mhex[count,2] := round((vx *    Sin(Radian_z) ) +
                                (vy *    Cos(Radian_z) ));
         Mhex[count,3] := vz;
     end;

     For count := 1 to 6 do
     begin
         // y
         vx := Mhex[count,1];
         vy := Mhex[count,2];
         vz := Mhex[count,3];
         Mhex[count,1] := round((vx *      Cos(Radian_y)) +
                                (vz *      Sin(Radian_y)));
         Mhex[count,2] := vy;
         Mhex[count,3] := round((vx *      -Sin(Radian_y))  +
                                (vz *      Cos(Radian_y)))  ;
     end;

     For count := 1 to 6 do
     begin
         // x
         vx := Mhex[count,1];
         vy := Mhex[count,2];
         vz := Mhex[count,3];
         Mhex[count,1] := vx;
         Mhex[count,2] := round((vy *      Cos(Radian_x))  +
                                (vz *   (-Sin(Radian_x)))) ;
         Mhex[count,3] := round((vy *      Sin(Radian_x))  +
                                (vz *      Cos(Radian_x)))  ;
     end;

     for count := 1 to 6 do
     begin
          Mhex[count,1] := round(Mhex[count,1] * D/ sprite_z*scale);
          Mhex[count,2] := round(Mhex[count,2] * D/ sprite_z*scale);
     end;

     Form1.Canvas.MoveTo(Mhex[1,1]+cx  ,cy-Mhex[1,2]);
     Form1.Canvas.LineTo(Mhex[2,1]+cx  ,cy-Mhex[2,2]);
     Form1.Canvas.LineTo(Mhex[3,1]+cx  ,cy-Mhex[3,2]);
     Form1.Canvas.LineTo(Mhex[4,1]+cx  ,cy-Mhex[4,2]);
     Form1.Canvas.LineTo(Mhex[5,1]+cx  ,cy-Mhex[5,2]);
     Form1.Canvas.LineTo(Mhex[6,1]+cx  ,cy-Mhex[6,2]);
//     Form1.Canvas.LineTo(Mhex[1,1]+cx  ,cy-Mhex[1,2]);

    Label1.Caption := 'Scale     '+FloatToStr(Scale);
    Label2.Caption := 'Timer     '+IntToStr(Cycle);
    Label3.Caption := 'top y     '+IntToStr(Mhex[1,2]);
    Label4.Caption := 'right y   '+IntToStr(Mhex[2,2]);
    Label5.Caption := 'Radian_x  '+FloatToStr(Radian_x);
    Label6.Caption := 'Radian_y  '+FloatToStr(Radian_y);
    Label7.Caption := 'Radian_z  '+FloatToStr(Radian_z);
    Label8.Caption := 'cos z  '+FloatToStr(cos(Radian_z));
    Label9.Caption := 'sin z  '+FloatToStr(Sin(Radian_z));
end;

procedure TForm1.Timer1Timer(Sender: TObject);
begin
     Cycle := Cycle +1;
//     Scale := Scale * 0.99;
     Radian_x := Radian_x + incriment;
     if Radian_x > 6.28318530718 then
         Radian_x := Radian_z - 6.28318530718;
//     Radian_y := Radian_y + incriment;
     if Radian_y > 6.28318530718 then
         Radian_y := Radian_z - 6.28318530718;
     Radian_z := Radian_z + incriment;
     if Radian_z > 6.28318530718 then
         Radian_z := Radian_z - 6.28318530718;
     Form1.Invalidate;
end;


end.

