unit testGlP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Transfrm, cOpenGL, Material, openGL, Light, testPick2P, ComCtrls;

type
  TForm1 = class(TForm)
    OpenGL1: TOpenGL;
    TRansform1: TTRansform;
    Material1: TMaterial;
    Material2: TMaterial;
    TRansform2: TTRansform;
    TRansform3: TTRansform;
    Material3: TMaterial;
    Light1: TLight;
    TRansform4: TTRansform;
    Material4: TMaterial;
    Light2: TLight;
    TrackBar1: TTrackBar;
    TrackBar2: TTrackBar;
    TrackBar3: TTrackBar;
    TrackBar4: TTrackBar;
    TrackBar5: TTrackBar;
    procedure TRansform1Paint(Sender: TObject);
    procedure TRansform2Paint(Sender: TObject);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TRansform3Paint(Sender: TObject);
    procedure TRansform4Paint(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TrackBar1Change(Sender: TObject);
    procedure TrackBar2Change(Sender: TObject);
    procedure TrackBar3Change(Sender: TObject);
    procedure TrackBar4Change(Sender: TObject);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure TrackBar5Change(Sender: TObject);
  private
     StartX,
     StartY: integer;
     startShift: TShiftState;
     selTrans: TTransform;
     trnX, trnY: GLfloat;
     PickBuffer: array[1..64] of GLuint;
     procedure Cube;
     procedure Selection(px,py:GLdouble);
     procedure SelectionDone;
     procedure Selection2(px,py:GLdouble);
     function SelectionDone2: GLint;
    { Private declarations }
  public
    { Public declarations }
  end;

  Phit =^THit;
  THit = packed record
     ncount,
     dnear,
     dfar: GLuint;
     names: array[1..32] of GLuint;
  end; {THit}

var
  Form1: TForm1;

implementation

{$R *.DFM}

procedure TForm1.TRansform1Paint(Sender: TObject);
begin
   Material1.Apply;
   glLoadName(1);
   Cube;
end;

procedure TForm1.TRansform2Paint(Sender: TObject);
begin
   Material2.Apply;
   glLoadName(2);
   glPushMatrix;
      glTranslatef(0.5,0.0,0.0);
      glScalef(0.3,0.3,0.3);
      glPushName(4);
      Cube;
      glPopName;
   glPopMatrix;
   Cube;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);
   Transform4.Apply;
   Transform3.Apply;
   Transform1.Apply;
   Transform2.Apply;
//   glFlush;
   OpenGl1.Swap;
   OpenGL1.ErrorCheck('FormPaint');
   Form1.Caption := 'Ambient '
                   +FloatToStr(0.2 + ((TrackBar3.position-10)/10));
   Form1.Caption := Form1.Caption+ ',  Diffuse '
                   +FloatToStr(0.5 + ((TrackBar4.position-10)/10));
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   if OpenGL1.Smaller then
      FormPaint(Sender);
end;

procedure TForm1.Cube;
begin
   glNormal3f(0.0,0.0,1.0);
   glBegin(GL_POLYGON);  {near face}
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(+0.4,-0.4,+0.4);
      glVertex3f(+0.4,+0.4,+0.4);
      glVertex3f(-0.4,+0.4,+0.4);
   glEnd;

   glNormal3f(1.0,0.0,0.0);
   glBegin(GL_POLYGON);  {right face}
      glVertex3f(+0.4,-0.4,+0.4);
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(+0.4,+0.4,-0.4);
      glVertex3f(+0.4,+0.4,+0.4);
   glEnd;

   glNormal3f(-1.0,0.0,0.0);
   glBegin(GL_POLYGON);  {left face}
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(-0.4,+0.4,+0.4);
      glVertex3f(-0.4,+0.4,-0.4);
   glEnd;

   glNormal3f(0.0,0.0,-1.0);
   glBegin(GL_POLYGON);  {back face}
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(-0.4,+0.4,-0.4);
      glVertex3f(+0.4,+0.4,-0.4);
   glEnd;

   glNormal3f(0.0,-1.0,0.0);
   glBegin(GL_POLYGON);  {bottom face}
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(+0.4,-0.4,+0.4);
   glEnd;

   glNormal3f(0.0,1.0,0.0);
   glBegin(GL_POLYGON);  {top face}
      glVertex3f(-0.4,+0.4,+0.4);
      glVertex3f(+0.4,+0.4,+0.4);
      glVertex3f(+0.4,+0.4,-0.4);
      glVertex3f(-0.4,+0.4,-0.4);
   glEnd;

end;

procedure TForm1.TRansform3Paint(Sender: TObject);
begin
   Light1.Apply;
   Material3.Apply;
   glLoadName(3);
   Cube;
end;

procedure TForm1.TRansform4Paint(Sender: TObject);
begin
   Light2.Apply;
end;

procedure TForm1.Selection(px,py:GLdouble);
type
   TViewPort= packed record
      left,bottom,width,height: GLint;
   end;
var
   viewport: TViewPort;
begin
   glRenderMode(GL_SELECT);
   glInitNames;
   glPushName(0);
   glMatrixMode(GL_PROJECTION);
   glPushMatrix;
   glLoadIdentity;
   glGetIntegerv(GL_VIEWPORT,@viewport);
   py := viewport.height-py;
   gluPickMatrix(px,py,2.0,2.0,@viewport);
   with OpenGL1 do
      glFrustum(prxLeft,prxRight,prxBottom,prxTop,prxNear,prxFar);
end;

procedure TForm1.SelectionDone;
const
   countElement=1;
   nearElement=1;
   farElement=1;
var
   place,
   nm,
   hit,
   hits: GLint;
   aHit: PHit;
   nameList: string;
begin
   glMatrixMode(GL_PROJECTION);
   glPopMatrix;
   hits := glRenderMode(GL_RENDER);
   place := 1;
   with Form2,ListBox1,Items do
   begin
      clear;
      add(Format('Hits = %d', [hits]));
      for hit := 1 to hits do
      begin
         ahit := @PickBuffer[place];
         with ahit^ do
         begin
            place := place+countElement+nearElement+FarElement+ncount;
            add(Format('  hit#%d  count=%d  near=%d  far=%d',
               [hit,ncount,dnear,dfar]));
            nameList := '    names:';
            for nm := 1 to ncount do
                nameList := nameList+' '+IntToStr(names[nm]);
            add(nameList);
         end; {with aHit^}
      end; {for}
   end; {with form2,listBox1,Items}
   Form2.Show;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   glSelectBuffer(128,@PickBuffer);
   StartX := -1;
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
{   Selection(x,y);
   FormPaint(nil);
   SelectionDone;           }
   StartX := -1;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
var
   n: GLFloat;
begin
   n := (TrackBar1.Position-10) /10;
   Light2.AmbientRed := 0.3 + n;
   Light2.AmbientGreen := 0.3 + n;
   Light2.AmbientBlue := 0.3 + n;

   n := (TrackBar2.Position-10) /10;
   Light2.DiffuseRed := 0.2 + n;
   Light2.DiffuseGreen := 0.2 + n;
   Light2.DiffuseBlue := 0.2 + n;

   FormPaint(self);
end;

procedure TForm1.TrackBar2Change(Sender: TObject);
var
   n: GLFloat;
begin
   n := (TrackBar1.Position-10) /10;
   Light2.AmbientRed := 0.3 + n;
   Light2.AmbientGreen := 0.3 + n;
   Light2.AmbientBlue := 0.3 + n;

   n := (TrackBar2.Position-10) /10;
   Light2.DiffuseRed := 0.2 + n;
   Light2.DiffuseGreen := 0.2 + n;
   Light2.DiffuseBlue := 0.2 + n;
   FormPaint(self);
end;

procedure TForm1.TrackBar3Change(Sender: TObject);
var
   n: GLFloat;
begin
   n := (TrackBar3.Position-10) /10;
   Material1.AmbRed := 0.2 + n;
   Material1.AmbGreen := 0.2 + n;
   Material1.AmbBlue := 0.2 + n;

   n := (TrackBar4.Position-10) /10;
   Material1.DifRed := 0.8 + n;
   Material1.DifGreen := 0.3 + n;
   Material1.DifBlue := 0.5 + n;

   FormPaint(Self);
end;

procedure TForm1.TrackBar4Change(Sender: TObject);
var
   n: GLFloat;
begin
   n := (TrackBar3.Position-10) /10;
   Material1.AmbRed := 0.2 + n;
   Material1.AmbGreen := 0.2 + n;
   Material1.AmbBlue := 0.2 + n;

   n := (TrackBar4.Position-10) /10;
   Material1.DifRed := 0.8 + n;
   Material1.DifGreen := 0.3 + n;
   Material1.DifBlue := 0.5 + n;

   FormPaint(Self);
end;

procedure TForm1.Selection2(px,py:GLdouble);
type
   TViewPort = packed record
      left,bottom,width,height: GLint;
   end;
var
   viewport: TViewPort;
begin
   glRenderMode(GL_SELECT);
   glInitNames;
   glPushName(0);
   glMatrixMode(GL_PROJECTION);
   glPushMatrix;
   glLoadIdentity;
   glGetIntegerv(GL_VIEWPORT,@viewport);
   py := viewport.Height -py;
   gluPickMatrix(px, py, 2.0, 2.0, @viewport);
end;

function  TForm1.SelectionDone2: GLint;
begin
   glMatrixMode(GL_PROJECTION);
   glPopMatrix;
   result := glRenderMode(GL_RENDER);
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
   countElement = 1;
   nearElement =1;
   farElement =1;
var
   selno,
   place: integer;
   hit,
   hits: GLint;
   ahit: PHit;
   mx,
   nearer,
   nearest: double;
begin
   startX := -1;
   if Button <> mbLeft then
      exit;
   Selection2(x,y);
   with OpenGL1 do
      glFrustum(prxLeft,prxRight,prxBottom,PrxTop,prxNear,prxFar);
   formPaint(nil);
   hits := SelectionDone2;
   if (hits<1) or (Button<>mbLeft) then
      exit;

   StartX := X;
   startY := Y;
   startShift := Shift;
   place := 1;
   nearest := 9e33;
   mx := maxint;

   for hit := 1 to hits do
   begin
      ahit := @PickBuffer[place];
      with ahit^ do
      begin
         nearer := dnear;
         if nearer< 0 then
         begin
            nearer := mx+nearer;
            nearer := mx+nearer;
         end;
         if nearer < nearest then
         begin
            nearest := nearer;
            selno := names[1];
         end;
         place := place+countElement+nearElement+farElement+ncount;
      end; {with}
   end; {for}

   case Selno of
     1: selTrans := Transform1;
     2: selTrans := Transform2;
     3: selTrans := Transform3;
   end;
   with SelTrans do
   begin
      trnX := TranX;
      trnY := Trany;
   end;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   deltaX,
   deltaY: integer;
   ratio,
   changeX,
   changeY: GLFloat;
begin
   if StartX <0 then
      exit;
   deltaX := x-startX;
   deltaY := startY-Y;

   with selTrans,OpenGL1 do
   begin
      ratio := -tranZ/prxNear;
      changeX := deltaX*(prxRight-prxLeft)/ClientWidth;
      changeY := deltaY*(prxTop-prxBottom)/ClientHeight;
      tranX := trnX+changeX *ratio;
      tranY := trnY +changeY * ratio;
   end;
   FormPaint(nil);

end;

procedure TForm1.TrackBar5Change(Sender: TObject);
begin
   Light1.Cutoff := TrackBar5.Position;
   FormPaint(Self);
end;

end.

