unit variabP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Menus, StdCtrls, ComCtrls;

type
  TForm1 = class(TForm)
    MainMenu1: TMainMenu;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    N3: TMenuItem;
    Close1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    RichEdit1: TRichEdit;
    procedure FormCreate(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure Init(sender: TObject);
  private
    { Private declarations }
  public
    procedure LetsAct;
    function pole_weapon_charge: boolean;       //  pole_weapon_in_or_vs_charge,
    function remaining_figures_to_act_first: integer;  //  remaining_figure_to_act
    function lost_this_turn: boolean;		//  loose_this_turn
    function lost_next_turn: boolean;           //  loose_next_turn
    function set_vs_charge_already: boolean;	//  set_vs_charge
    function step_one_hex_only: boolean;	//  step_one
    function charging: boolean;			//  charge
    function berserking: boolean;               //
    function turns_aiming_for_an_opening: boolean;
    function weapon_arm1_is_broken: boolean;    //  arm, tenticle, or jaw for a bite
    function hands_used_in_primary_attack_how_many: integer;
    procedure ShotPrimary;
    function weapon_arm2_is_broken: boolean;    //  weapon_arm2_broken
    function hands_used_in_secondary_attack: integer;    //  hands_used_in_secondary_attack
    procedure ShotSecondary;
    function weapon_arm3_is_broken: boolean;    //  weapon_arm3_broken
    function hands_used_in_Tertiary_attack: integer;    //  hands_used_in_tertiary_attack
    procedure ShotTertiary;
  end;

var
  Form1: TForm1;
//////////////
//////////////
//////////////
//////////////
//////////////

//    spell cast of detect life  =  detect life - detect insect -detect disease

//////////////
//////////////
//////////////
//////////////
//////////////
//////////////
type
   upperCaseDMG = 'A'..'Z';

   type_of_typesDMG = 1..32;
      Type_of_typesDMGstrings = array [1..32] of char;
      type_of_spellDMG = 1..4;
      Type_spellDMGstrings = array [1..4] of char;
      type_of_payDMG = 1..12;
      Type_payDMGstrings = array [1..12] of char;
      type_of_enchantDMG = 1..8;
      Type_enchantDMGstrings = array [1..8] of char;

   IntendedDMG = (antagonistic, hostile, unconcerned, indiferent, friendly, nice);
      IntendedDMGstrings = array [-4..11] of shortstring; //(antagonistic, hostile, unconcerned, indiferent, friendly, nice);

   stanceDMG = ( crawling, kneeling, prone, supine, crouch, stand);
      StanceDMGstrings = array [-4..11] of shortstring;   //  crawling, kneeling, prone, supine, crouch, stand

   reactions_to_injuriesDMG = (DX_2_next_turn_only, knocked_down_lose_next_turn,
                               DX_4_next_turn_only, enemy_falls_unconsious,
                               foe_drops_weapon,    use_of_limb_is_lost, DX_minus_3 );
      react_injuryDMGstrings = array [1..7] of shortstring;
             //  c = st / 3.33         f = c * 1.6       (c=st/1.6 *1.6    f=c*1.6)

             //  a = st / 7.5          d = a * 2.5       (a=st/2.5 *2.5    d=a*2.5)
             //  b = st / 5.0          e = b * 2.0       (b=st/2.2 *2.2    e=b*2.2)


{
'+','$','3','4','5','6','7','8','a','A','b','B','c','C','d','e','E','f','g','h','L','M','n','r','R','s','S','T','U','V','W'
   TALENT CATEGORIES                                  .
        +    $+	additional profits from selling items made
        $    pay after subsistance for class
        3    IQ x 3
        4    IQ x 4
        5    15 x entertainment talents
             15 x languages
        6    IQ x 6
        7    IQ x 7
        8    8 x entertainment spells
        a	2 or more strengths, take twice as many wizards for each added increment
        A    aid spell
        b	2 or more strengths, add one wizrd for each additional point or hex of effect.
        B    combat spell
        c	two versions, twice the wizards for second version
        C	creation spell
        d	10 week spell. +10% to value of underlying item.
        e	18 week spell. +20% to value of underlying item.
        E    entertainment
                charisma
		sex appeal
		acrobatics
		mimic
		ventriloquist
        f	25 week spell. +30% to value of underlying item.
        g	40 week spell. +50% to value of underlying item.
        h	70 week spell. +100% to value of underlying item.
        L    language
		literacy
	 	languages (all, big list, skipped here)
        m       magic item
        M	missile spell
        n    none	subsitance is provided, no pay
   p potion
        r    +20$ if bard
        R    +40$ if master bard
        s    entertainment spell
        S	special spell
        T	thrown spell
        U    10 x weapon and UC skills
        V    five years as a seargent
        W    weapon
}

type
TCombatCardDMG = record
   fighting,
   arguing,	       //
   ST, st_adj,
   DX, dx_adj,
	   dx_standing_in_turn_sequence,	//
   IQ, iq_adj,
	   picked_option,
	   renew_spell_cost,
	   countdown_turns_left,
   MA, ma_adj,				//	adj_ma covers speed move, rope, or stop, flight spell = ma +2, leather ma -2
	   noise_per_hex_moved,		//
	   ambush_surprise,			//
	   loose_move,
	   ma_avert,				//	required hex distance left to cover
	   ma_engaged,			//	movement ends when this is triggered
	   ma_left,
	   number_of_figures_to_move,
	   number_of_figures_eliminated,
	   number_of_figures_controled_summoned,
	   number_of_figures_left_to_move,
	   movement_of_multihex_figures,
	   shifting,
	   moving_onto_other_figures,
		attempting_hth,
		in_hth,
	   move_through_friends_not_engaged,
	   flight: extended;
	   stance: StanceDMG;		//	crawling, kneeling, prone, supine, crouch, stand
	   stance_s: StanceDMGstrings;	//	crawling, kneeling, prone, supine, crouch, stand
	   actions_during_movement_jumping_scooping,
	   hidden_movement,
	   reveal_movement,
	   invent_new_move,
	   full_move,			//	all loose_this_turn.
		flee,
		pursue,			//	long distance running melee
		jump_over_kneeling,
		jump_over_prone,
		jump_over_pit,
		climbing_slope,
		climbing_face,
		climbing_spikes,
		climbing_n_spiking,
		climbing_rope,
		climbing_rope_ladder,
		scoop_up_weapon,
		grab_up_weapon,
		taking_prisoner,
	   broken_ground,
	   darkness,
	   water_footing_depth,		//	ankles, knees, waist, shoulders
	   traps,
	   aireal_combat,
	   mounted_combat,

           burial_mound_control,
           artifact_combat,
           merchant_combat,
           siege_combat,
           space_combat,

           campaign_edges_of_time_gods_teeth_audio_combat,

           stores_of_ammo,
           stores_of_ammo_extra,
           building_rules,
           ship_combat,
           campaign_d20_multiplyer,
           subject_number,
           campaign_age,
           media_number,
           serial_number,
           immunities_detected,
           in_disguise_real_name,
           reitreiver_pet,
           subdued_already,
           fire_explosion_in_doors_tunnels,
           implosion_pull,
           detect_lair,                 //      to find specific monsters
           oom,                         //      out of mana, wont even consider spells
           afk,                         //      all for Ok, auto-follow leaders instructions
           pre_arranged_duel_with_seconds,
           pre_arranged_duel_as_second,
           pentigram,
           spectral_prison,
           rune_weapon,
           a_seat_at_the_high_table,    //      fear, courtly graces, diplomacy, charisma, bard, new followers, preist, theologian
           concentrate_fire_file,
           concentrate_fire_rank,
           vampiric_drain,
           vigilanti_operation,
           realm_wide_change,
           national_character_of_invasion,
           planetary_bombardment,
   picked_action,
	   pole_weapon_in_or_vs_charge,          // true false flag
	   remaining_figure_to_act,
	   dx_standing_next_player,
	   reactions_to_injury: extended;
           react_injury_s : react_injuryDMGstrings;
{   reactions_to_injuriesDMG = (DX_2_next_turn_only, knocked_down_lose_next_turn,
                               DX_4_next_turn_only, enemy_falls_unconsious,
                               foe_drops_weapon,    use_of_limb_is_lost,    DX_minus_3 );  }
	   loose_this_turn,			//	already attempted hth, knocked down, triped, unconcious
	   loose_next_turn,
	   set_vs_charge,			//	double damage pole, dx+2
	   step_one,				//
	   charge,				//	double damage pole
   berserk,
	   turns_aim_opening,		//
           weapon_arm1_broken,               //      arm, tenticle, or jaw for a bite
           hands_used_in_primary_attack,
           weapon_arm2_broken,               //      arm, tenticle, or jaw for a bite
           primary_shot,
              ready_str,
              ready_weapon,
              ready_D,
              ready_d_mod,
              weapon_broken,
		dx_bonus,			//	target's concealment, facing, mounted combat,
		   talent_lacking,		//	DX-4, half damage, or club damage which ever is more.
			attack,
			   clubs,
			   sheild_rush,
			   whip,
			   bola,
			   lasso,
			   sha_ken,
			   net,
			   dagger_marksman,
			   petard,
			   slaughtering_helpless,
				coup_de_gras,
			   sweeping_blow,	//	2h weapon required, DX-4 on all 3 attacks
			   subdue,
			   trampling,
			throw,
			   molotov,
			   gas_bomb,
			   grenade,
			jab,
			   polearm,
			attempt_hth,
			dodge,
			defend,
			shoot,
			   long_range_missile_fire,
			drop_kneel,
			drop_kneel_n_shoot,
			drop_prone,
			last_shot,
			disengage,
			cast_a_spell,
				charge_str_battery,
			disbelieve,
			pick_up_dropped_weapon,
			stand_up,
			stand_from_kneeling_move_half,	//	if ma_left = ma_adj
			stand_from_kneel_ready_move_2,	//	if ma_left = ma_adj
			drop,
			sheath,
			sling,
			exchange_with_adjacent,
			ready,					//	3d vs. DX if prone
			ready_move_2,				//	if ma_left = ma_adj
		   automatic_hit,
		   crippling_hit,
                   done_rolled_to_hit,
		   damage_d,
		   damage_d_mod,
		   damage_d_mult,
		   done_damage_rolled,
		   damage_stopped_by_target,
		   poison,
		   poison_damage_done,
		   done_damage_taken_by_figure,
		   noise_from_fighting,
                   exp_to_award,
		   exp_awarded,
		   exp_number_of_kills_to_award,
                   exp_number_of_kills_awarded,
           hands_used_in_secondary_attack,
           weapon_arm3_broken,               //      arm, tenticle, or jaw for a bite
	   second_shot,
              secondary_str,
              secondary_weapon,
              secondary_D,
              secondary_d_mod,
              weapon_broken2,
		dx_bonus2,			//	target's concealment, facing, mounted combat,
		   talent_lacking2,		//	DX-4, half damage, or club damage which ever is more.
		                                //	second shot is not possible
		  	attack2,
		   	throw2,
		   	jab2,
		   	drop_kneel2,
		  	drop_prone2,
		     automatic_hit2,
		     crippling_hit2,
		     damage_d2,
		     damage_d_mod2,
		     damage_d_mult2,
		     done_damage_rolled2,
		     damage_stopped_by_target2,
		     poison2,
		     poison_damage_done2,
		     done_damage_taken_by_figure2,
		     noise_from_fighting2,
                     exp_to_award2,
		     exp_awarded2,
    		     exp_number_of_kills_to_award2,
                     exp_number_of_kills_awarded2,
              hands_used_in_hth_attack,
                                                //      arm, tenticle, or jaw for a bite
                                                //      arm, tenticle, or jaw for a bite
                                                //      arm, tenticle, or jaw for a bite
              HTH_shot,
                 hth_str,
                 hth_weapon,
                 hth_d,
                 hth_d_mod,
                 // if (in_hth),
		dx_bonus3,			//	target's concealment, facing, mounted combat,
		   talent_lacking3,		//	DX-4, half damage, or club damage which ever is more.
		   automatic_hit3,
		   crippling_hit3,
			attack3,		//	bare hand damage
			throw3,			//	uc IV needed ???
			jab3,			//	using cestus or dagger
			pin_a_foe3,		//	uc I needed
			disengage_from_hth3,
			cast_spell3,		//	dx-6,
			draw_a_dagger3,         //
		   damage_d3,
		   damage_d_mod3,               //
		   damage_d_mult3,
		   damage_done3,                //
		   damage_stopped_by_target3,
		   poison3,                     //
		   poison_damage_done3,
		   damage_taken_by_figure3,     //
		   exp_awarded3,
		   exp_number_of_kills3,        //
   armor_str,
   armor,
   armor_points,
   shield_str,
   sheild,
   sheild_points,
   sheild_D,
   sheild_d_mod,
   spell_str,
   spell_defence,
   spell_points,
   wounds,
   fatigue,
   aimed_shots,
   noise_total,				//	noise_per_hex_moved + noise_from_fighting
   conciousness,			//	awake, asleep, dx_minus_3, unconcious, frozen, little_death, controled, possesed, dead)
   forced_retreats: extended;
   end;


type
TResearchDMG = record
   name,
   Cost_to_learn,
   Cost_Research_Per_Week,		//
   required_IQ,
   required_ST,
   required_DX,
   Total_Cost_of_Research,		//
   Turn_Research_Started,		//
   Turn_Research_Start_Over,		// 
   Turn_Research_Start_Over_Last,	//
   Turn_till_completion,		//
   Turns_Started_Over,			//
   Turns_Left,
   Turn_Invented,			//
   Turn_Cast,				//
   Turns_maintained,			//
   Turn_Registered_Guild,		//
   Turn_witnessed_by_character,		//
   Turns_to_write_scroll: extended;	// 1 day per IQ
   type_spell: Type_of_spellDMG;        // ('S','T', 'C', 'M');
   type_spell_s: Type_spellDMGstrings;  // ('S','T', 'C', 'M');
   type_types: type_of_typesDMG;
   type_types_s: type_of_typesDMGstrings;
   Turns_to_write_book: extended;	//
   week_cost_of_common_ingredients,
   week_ingredients_required,
   weeks_to_make: extended;
   end;

type
TPersonalitiesDMG = record
   bravery,
   honesty,
   friendliness,
   appearance,
   mood: extended;

   end;


type
TKind_CharacterDMG = record

   hero,
   wizard: extended;

   end;

type
TAncilary_damageDMG = record

   ancilary_adjacent_hex_damage,	//	blast trap does d-1 to each adjacent hex
   ancilary_affect_all_in_hex,		//	or just the target, (fire, blast trap, pit)
   ancilary_catch_fire,			// 	fire hex, molotov, fireball, blast trap,
   ancilary_damage_cleansing,
   ancilary_damage_disease,
   ancilary_damage_explosion,
   ancilary_damage_fire,
   ancilary_damage_fist,
   ancilary_damage_lighting,
   ancilary_damage_water,
   ancilary_disenchant,			//
   ancilary_drowning,
   ancilary_kills_all_in_hex,		//	cleasing (unless figure named by wizard to not be killed)
   ancilary_lock_knock,
   ancilary_mining_damage,			//
   ancilary_suspended_list,			//	breath, thought, heartbeat, (little death) ][ see, hear, disbelieve, spell without moving, ][ actions, body flexibility, (freeze)
   ancilary_reveal_conceal: Extended;	// 	reveals 1 conceal spell, adds 1d to "notice"

   end;


type
TExcact_PropertiesDMG = record		// turns to cast
   ancilary_damage: TAncilary_damageDMG;
   bad_and_nice_effects,			//	DX+, IQ- (body guard), Geas run screaming (alarm), Turn hair bright blue
   certain_thing,				//	combo of races and command words, or equipemnt, magic, options, etcetera...
						//	only geas once ever, by a particular wizard.
						//	may only have one geas on you at a time
						//	if wizard cast geas on already geased
						//	 (should-a-used analyze magic)
						//	then they can never geas that figure
   command_to_list,				//	to do or not to do a certain thing.
   cost_day_St_fatigue,			//
   cost_if_spell_fails,
   cost_if_target_saves,
   cost_if_cast_on_self,			//	1 for little death
   cost_if_cast_on_other,			//	4 for willing
   cost_if_cast_on_unwill_or_unconcious,	//	10
   cost_of_item_underneath,			//	gem, statue, painting, glove, etcetera.
   cost_per_1hex,				//
   cost_per_3hex,				//
   cost_per_4hex,				//
   cost_per_7hex,				//
   cost_per_adjacent_minus_1_plus_1,
   cost_per_d_damage,			//	the 1 in a fireballs 1-1
   cost_per_dice,				//
   cost_per_MH,
   cost_per_Mhex,				//
   cost_per_hex_radius,			//
   cost_per_Mhex_radius,			//
   cost_str_o_20,
   cost_str_o_29,				//	4 for trip, 6 if elemental
   cost_to_cast,				//
   cost_to_maintain,				//
   cost_to_maintain_per_hex,
   cost_to_renew,				//
   cost_to_stack,
   crossbow_cock_turns,
   d_mod, 					//	the -1 in a fireballs 1-1
   d_mod_plus_or_minus,			//	charm spells
   destroy_ancilary_item,			//	on detonation of blast trap
   destroy_ancilary_creation,
   destroy_elemental_all_in_5_mh,		//	any equipment on character killed by lightning
   destroy_gate,
   duration_minimum,				//	if variable number of turns, like freeze 2-12
   duration,					//	12 turns for a word of command/illusion/immage/wall/fire
   duration_to_renew,			//
   enchant_greater,				//
   enchant_lesser,				//	staff, exploding gem, ward, pentigram, lesser magic item, lesser spell
   dark_extinguish_natural_light,		//	darkness: doesn't work on sunlight
   fire_one_turn_only,
   fire_put_out,
   go_into_a_trance_to_cast,		//	trance, astral projection, possession
   hexes_maximum,				//	up to 7 connected for cleansing
   immune_to_this_spell_list,		//	revival to write scroll
   kg_per_wizard,				//	50 per flight spell
   kg_max_to_cast_on,			//	blast trap, no more than 10 kg
   learn_answer_yes_no_from_gm,
   learn_exact_enchant_on_1_item,
   learn_location_other_end_of_gate,
   must_end_turn_N_hexes_farther_away,
   must_touch_target,			//	staff counts as touching
   must_touch_with_item_trap,		//	prepaired item as "trap" to trigger possesion
   name,
   no_skill_required,			//	club
   range,					//	0= special, 1= thrown, 2=contact, 3=molotov, 4=creation, 6=missile, 7 bow
   range_hearing,				//	if in language, or all if wizard's toung
   range_whisper,				//	only 1 person
   range_seeing,				//	if literate and if in language, or all if wizard's toung
   reversable,				//	lock/knock, create/destroy, reveal/conceal
   turns_to_cast,                       //  5 second combat turns
   gate_change_rule_temp_or_perm,		//	control gate
   gate_condition_set,			//	rule set by caster of a blast trap, expunge, limiting, or gate
   gate_rules_set,				//	rules set by caster of gate
   gate_set_start_location,
   gate_set_end_destination,
   gate_intant_transport_between_points,
   see_elswhere,
   see_gate,
   see_in_dark,				//	dark vision, mage sight
   see_invisible,				//	mage sight
   see_far,					//	far vision
   see_future,				//	crystal ball
   see_past,					//	crystal ball
   single_less_20,				//	sleep, rope
   single_less_30,				//	freeze
   single_less_50_great_19,			//	MH freeze, MH sleep,
   single_great_19,				//	acts as single rope, double rope if less 20
   spell_drops_instantly,			//	caster dies/unconcious, victim dies, exorsism, possesor lets go
   spell_drops_end_of_turn,			//	summoning spells
   st_lost_per_day_under_spell: extended;	//	1 for little death
   turns_to_cast,				//	
   turns_astral,
   variable_fit,				//	magic item changing size to fit, like the one ring
   variable_forms,				//	like wizards wrath being either of the other 3 missile spells
   variable_shapes,				//	create wall, illusion, glamour, shapeshifting (only gets HTH table of new form)
   variable_clothes,				//	inviso, glamour, not shapeshifting
   victim_dies_d_to_caster,			//	possesion does 2d to caster when the victim croaks
   wishes_to_grant: extended;

   end;

type
TAbilityDMG = record
   Enabled: boolean;
   Name,
   prereq_or,
   prereq1,
   prereq2,
   prereq3,
   Free,
   Free2,
   Free3: string;
   cost,
   IQ,
   Race,
   Free_N,
   Free2_N,
   Free3_N,
   BookLength,
   BookCost,
   ScrollCost: extended;
   SpellType: char;
   JobType: char;
   Book_Kg,
   BookWeeks: extended;
   
   end;

type
TSavingRollDMG = record
	accidental_disbelieve,		// 	if iq 5 or less then roll 1d, 2d if a heard or pack, -1d if monster (auto if aniaml alone)
	aging,
	attack_telekinesis_using_weapon,
	d3vDX,
	d3vDX_or_crawl,
	d3vDX_stand_still,
	d3vIQ,
	d4vDX,
	d4vIQ,
	d4vIQscholar_or_good_friend,
	d5vIQeach_turn12turn,
	dark_attack_into,
	dark_attack_out_of,
	detect_echo,
	detect_hostile_intent,		//	detects hostile or worse specific to the character, or general to anything else
	detect_light,
	detect_pheremones,              //      km range			
	detect_tempurature_k,		//	snakes detect change 0.002 Centigrade
	detect_touch_great_illusion_flash_of_light,
	detect_vibration,			//	ants can sence insects moving though 5cm earth.
	disbeleive_at_minus_4_on_dice,
	healing,
	healing_water_elem_4d,
	higher_ST_than_caster,
	know_who_tried_to_posses,
	ma2_if_st_30_plus,
	minus_to_DX,
	no_roll_to_miss_just_save,
	not_closest_being,
	notice,				//	variable d vs iq
	save_each_turn,			//	word of command
	save_into,				//	#d vs = str of lightning, 5 scroll, 7 book or explosive gem, 9 gem, 10 wood or rope, 12 ring or metal
	save_lightning_scroll,		//	5 vs. d = st of the lightning spell, -1d if on player
	save_lightning_book_or_gem_explode,//	7 vs. d = st of the lightning spell, -1d if on player
	save_lightning_gem,			//	9 vs. d = st of the lightning spell, -1d if on player
	save_lightning_wood_or_rope,	//	10 vs. d = st of the lightning spell, -1d if on player
	save_lightning_ring_or_metal,	//	12 vs. d = st of the lightning spell, -1d if on player
	save_minus_to_be_hit,		//	blur -4, inviso -8
	save_most_or_all_of_body_present,	//	revival spell, zombie spell (head particularly)
	save_once_only,			//	control person, each pit pushed against
	save_out_of,			//	#d
	save_pit,			//	3d
	save_through,			//	#d
	save_vs_catch_fire,		//	3d vs. DX
	save_vs_drunk,			//	4d vs. ST
	save_vs_dunking,		//	3d vs. DX
	save_vs_friend,
	save_vs_scholar,
	save_vs_attrib_string,		//	like IQ, ST, or DX
	saving_throw_string_list,	//
	stand_still_2_turn,
	supress_curse_for_removal,
	work: extended;
	end;

type
TimmunitiesDMG = record
	already_been_geas_by_caster,
	animals_or_dragons,
	attack_any,
	attack_physical,
	headless_burned_or_dismemebered,
	headless_just_a_ghost,
	headless_just_the_hand,
	headless_or_no_torso,
	headless_turned_to_dust,
	caster_using_UC_talent,
	casting_wizard,
	control_person,			//	6th person under caster's control, 3rd if IQ > 2, 2nd if IQ > 7
	crystal_ball_found_site,	//	conceal, petigram, astral figure
	depends_on_rule,
	enchant_item_or_revival_spell,
	enchantment,
	fatigue_less_3,			//   any spell, as even 1 point @ 2 will render unconcious.
					   //	run this test on every spell cast relative to the cost of it's casting.
					   //	use predictive vectoring to determine if it can be completed
					   //	or is an attempt at unconciousness
	fatigue_less_6,                 //   target of a drain str
	flesh_iron,			//	one to the other, iron to stone
	flesh_stone,			//	and stone to iron
	image_or_illusion_vanish,	//	from control person or control animal
	figure_not_touched_by_wiz,
	figure_blocks_hex,
	fire_ball,			//	subtracts 1d per point of immunity
	fire_proof,
	lightning,			//	subtracts 1d per point of immunity
	magic_fist,			//	subtracts 1d per point of immunity
	magic_item,
	non_animals_or_not_real,
	non_humans_or_humanoids,
	non_thrown_spells,
	overide_immunity_for_hamer_touch,	//	the only immunity vs. immunity.  Unless there is an immunity to hamertouch specific enchantment.
	poisons_immune_to_cleanse,
        petigrams_astral_bodies,
	rope,
	rule_of_5,
	rules_on_a_gate,
	sight_magi,
	sight_blind,
	slippery_floor,
	spell_shield,				//	lol at remove thrown spells, and disolve enchantment
	spell_sheild_enchantment,		//	lol at disolve enchantment
	spell_sheild_spell,			//	lol at remove thrown spells
	spell_already_cast,
	st_20_plus,
	st_21_plus_if_not_alone_in_mh,
	st_30_plus,
	st_51_plus,
	sticky_floor,
	summonded_beings,
	talking,
	weapon_break,				//	break or shatter weapon, target weapon must be in the hands of a foe
	weapon_drop,
	weapons_contact,
	wizards_wrath: extended;		//	subtracts 1d per point of immunity

	end;


type
TKinship_PatternsDMG = record
	family,
	  // gender and generation
		Father,
		Mother,
		son,
		daughter,
		brother,
		sister,
	  // blood and marriage
		Father_in_law,
		Mother_in_law,
		grandfather,
		grandmother,
		grandson,
		granddaughter,
	  // descriptive and classifatory
		uncle,
		aunt,
		nephew,
		neice,
		cousin,
	  // customs and obligations, as sub attributes of each category or label
		passive,
		reactive,
		active,
	filial_piety,
	genealogy,
	heredity,
	kinship_and_descent,
	taxonomy,
	consanguinity: extended;
	
	end;

type
TBiologicalDMG = record
	behaviour,
	evolution,
	population_genetics: extended;

	end;

type
TCulturalDMG = record
	social_networks,
	social_behavior,
	law,
	punishment,
	politics,
	cheater_detection_mechanisms,
	ideology,
	religion,
	beliefs,
	patterns_in_production_and_consumption,
	exchange,
	socialization,
	economics,
	aggression,
	psychiatry,
        life_span_of_family_line,
	literature,
	gender,
	eating_habits,
	semiotics: extended;

	end;

type
TLinguisticDMG = record
	variation_in_language_across_years_and_space,
	the_social_uses_of_language,
	the_relationship_between_language_and_culture: extended;

	end;

type
TArchaeologyDMG = record
	material_remains_of_human_societies,
	material_culture,
	physical_objects_created_or_used,
	a_living_or_past_group,
	mediums_of_understanding_its_cultural_values: extended;

	end;

type
TAnthropologyDMG = record
	biological,
	cultural,
	linguistic: extended;

	end;

type
TIdentityDMG = record
	kill_list,
	magic_handling,	// hindu fear of D&D sorcery
	invented: extended;

	end;

type
TAbilitiesDMG = record
	Ability:          TAbilityDMG;
	Anthropology:     TAnthropologyDMG;
	archaeology:      TArchaeologyDMG;
	cultural:         TCulturalDMG;
	Exact_Property:   TExcact_PropertiesDMG;
	identity:         TIdentityDMG;
	immunity:         TImmunitiesDMG;
	linguisitc:       TLinguisticDMG;
	kinship_patterns: TKinship_PatternsDMG;
	Researching:      TResearchDMG;
	saving_roll:      TSavingRollDMG;
        Stats :           TCombatCardDMG;

	activates_only_on_command,	//	flaming weapon enchantments

	age,
	age_half_life,
	age_natural,
	attack_diameter: double;
	audible_to_wearer_only,
	blood,                          //      liters of
	brains,                         //      mass in kg relative to body weight
	breath,		        	//	air, water_fresh, water_salt, light, none (for undead)
		breath_exhale,		//	nitrogen, co2, clorine, nothing, etcetera...
	carats,
	chromo_number,	                //      chromosome number
	class_character,		//	warrior, wizard, riding animal, beasts, insects & other crawlies, nuisance
	contest_of_wills,		//	only a charm will help
	cost,
                copper,
		silver,
		gold,
		mithril,
		fatigue,
		maintain,
	damage,
		amputation,
		bite,
		bite_cumulative,
		blood_suck,		//	suck 1/2 ST a turn, drop after 3 ST.  4 ST = 1 leiter.
		blood_drink,
		break_weapon,
		cleansing,
		clumbsiness,
		command_control_possesion_persuasion_avert,
		confusion,
		corrosion,
		crush,
		curse,
		d,
		d_mod,
		death_drain,
		death_little,
		lost_enchantment,	//	three graphical modes of un-enchanting, motion blure disolve
		destroy_enchantment,	//	blackened, explode inward
		destroy_gate,		//
		disolve_enchantment,	//	colorfull, evaporates
		drowning,
		earth,
		electrical,
		expunge,
		falling,		//	1d per 5m, steep slope = 1d per 10m
		fire,
		freeze,
		frighten,
		hth,
		kick,
		literal_interpretation,
		metal,
		mental_combat,
		missile_spell,
		open_tunnel,
		organic,
		poison,
		range,
		reaction_rolls_minus_2,
		reaction_roll_on_being_freed,
	        reaction_roll_horror_type,   // ghosts (humanoids), gold jealousy (dwarves & dragons), insects (elf), fire (beasts animals)
	        reaction_roll_horror_dice,   // 3d vs. IQ for ghost.  2d if prepaired for ghost.
	        reaction_roll_horror_mod,    // -4 reaction for gold jealousy.
		regular,
		remove_cursed_item,
		remove_thrown_spells,	     //	remove thrown only takes off +1 a turn from weapon armor enchantment
		rend_apart,
		rock,
		root_rope_stop_sleep_freeze_slow,
		rust,
		sex_appeal,
		shatter_weapon,
		shock_sheild,			// 1d to wizards' and adjacent hexes, to all except wizard.
		speed_flight_feather,
		smother,
		swallow_whole,
		sticky_slippery,
		sting,
		stomp,
		throw,
		thrown_spell,
		trance,
		water,
		weakness,
		wind,
		wood,
	Dx,
	electro_sensing_receptors,		 // (threshold 0.005 uV/cm)
	enc,
		ready,
		secondary,
		belt,
		hidden,
		worn,
		pack,	
		Enc_mn_pack,
	elusiveness,				// dx-3 to hit a snake
	ep,					// experience points
	face,
		ear_count,				// snakes have zero
		ear_drum,				// 
		ear_drum_location,			// outside behind the eye for a frog
		ear_echo_range,			//	detect_echo, grants sound vision, like acute hearing, and detect insect 5.5m
		eye_count,				// 2 for human, 12 for scorpion.
		eye_diameter_cm,
		eye_distinguish_2_points_sep_by, 	//100 microns for a human
		eye_flicker_fusion_rate_a_second, 	// 300 for a fly
		eye_lenses,				// each eye of a fly has 3,000, a man only 1.
		eye_lids,				// snakes have zero
		eye_light_wavelength_min,		// 300nm for a bee
		eye_light_wavelength_max,		// 640nm for a bee
		eye_light_wavelength_mean,		//	detect_light
		eye_pupil_shape,			// round, rectangular
		olf_membrane_sq_cm,			// olfactory 14 in a cat
		olfactory_range_km,			//detect pheremones up to
	feet,					// biped, quadraped, octoped, centiped
           ankles,                      // depth of water that touches
	   foot_oder,			// strength of pheremones
	   toenails,			// hooves, claws, nails
	food,				//herbavore, carnivore, omnivore, necrovore, geovore
	fly_speed,
	gal_bladder,
	gills,
	hair,                       //  kg of
	hand,			    //  fingered, suckers, roots, vines, fore_paw, wings
	heal_wounds,                //  34560 per point, liters per point, 4d per turn,
	heal_fatigue,               //  180 per point,
	heal_fuel,		    //	turns_of_rest, blood drinking, fire, running water, strong wind, deep virgin earth, a point of fatigue
	heal_severed,		    //  regeneration rate, 0.5 per turn for vampire
	heart: Extended;
		intent: IntendedDMG;  // antagonistic, hostile, unconcerned, indiferent, friendly, nice
                intent_s: IntendedDMGstrings;
	hex,
	hex_width,
	hex_width_ma_per,
	hex_width_st_per,
	hex_length,
	hex_length_ma_per,
	hex_length_st_per,
	hex_height,
	hex_height_ma_per,
	hex_height_st_per,
	hexes,
	hex_suptle,             //  dx minus to hit me.  -3 for a snake, -3 for cat.
	hex_to_nucleus_ratio,   //  one shot weak spot, dice required to hit me.  7 for a goo, 5d for UC V, 3d for humanoid.
	hits_stopped,
		head,
		back,
		leg,
		arm,
		front_or_belly,
	hz_low,		        //lowest audible frequency
	hz_high,        	//highest audible frequency
	instinct,		//maternal (berserk to protect young), parochial (collects food for young)
	Iq,
	kg,
	leaves,
	life,
        limb,
                 ankle,         // depth of water to touch
                 knee,          // depth of water to touch
                 waist,         // depth of water to touch
                 shouder,       // depth of water to touch
                 crown,         // depth of water to touch
                 wrist,         // depth of water to touch
	liver,
	Ma,
	Ma_climb,
	ma_climb_speed,		//	divide MA by 240 if vertical surface, by 600 if spiking, by 30 if spiked already,
	Ma_fly,
	Ma_swim,
	max_Dx,
	max_Iq,
	max_St,
	metabolism,		//silicate (immune to poisons), low, high
	min_Dx,
	min_Iq,
	min_St,
	neck,			//range in hexes
		name_given,
			name_nic,
			name_full,
			name_middle,
			name_last,
			name_family,
			name_guild,
			name_secret,
			name_heir,
			name_alias,
			name_alias_2,
		named: array [1..255] of string;
		named_pets: array [1..255] of string;
		named_servants: array [1..255] of string;
		named_stowaways: array [1..255] of string;
		named_spells: array [1..255] of string;
		named_disquise: array [1..255] of string;
		named_tactic: array [1..255] of string;
		named_strategy: array [1..255] of string;
		named_communication: array [1..255] of string;
                named_beings_met: array [1..255] of string;
                named_beings_met_reaction_to: array [1..255] of string;
                named_beings_met_reaction_from: array [1..255] of string;
                named_beings_met_geas_already: array [1..255] of string;
	note,
	notes,
	page,
	page_up_to,
	pay,
	pho_per_square_mm,		//	1 million in the eye of a buzzard
	pho_percentage_that_are_rods,	//	photoreceptors
	poisonous,
	prereq,				// non talents // other conditions
		air_pressure_and_sound,
		ambushes_animals_herbs,
		animals_and_crops,
		animals_normal,
		arquebus_or_blunderbus,
		attract_converts_get_donations,
		cart_wagon_chariot_and_large_animal,
		chest_physicker_1_if_vet,
		chest_vet_i_if_phy,
		converse_with_figure,
		court_manners_and_protocol,
		dx_12,
		dx_13,
		Dx_14,
		dx_15,
		dx_16,
		except_animal_zombie_demon_nasties,
		eyes,
		guage_what_enemy_will_do,
		guild_theives,
		hands,
		hex_1_to_3_riding_animal,
		iq_6_to_10,
		lab_chemistry,
		lab_alchemy,
		lab_wizards,
		leader_of_party,
		leather_and_MA_4,
		lungs_and_mouth,
		maps_scrolls_magic_books,
		member_of_opposite_sex,
		member_of_same_sex,
		race_one_or_one_species,
		rough_rock_or_rope_spikes_hammer,
		see_something_of_worth,
		ship_medium_to_large,
		ship_small_boat,
		st_14,
		st_16,
		track_within_last_day,
		turns_about_720,
		voice_box,
		water_deep_enough,
		weapons_talent_for_in_each_hand,
		wrist_for_whip,
		years_as_a_seargent,
	prerequisite,				// talents only
		alertness,
		armorer,
		armorer_goldsmith,
		bard,
		bow,
		charisma,
		detect_traps,
		horsemanship,
		Knife,
		language_known,
		literacy,
		mechanitian,
		naturalist,
		monster_follower_I,
		physiquer,
		preist,
		recognize_value,
		remove_traps,
		seamanship,
		silent_movement,
		swimming,
		sword,
		tactics,
		theif,
		theives_argot,
		unarmed_combat_I,
		unarmed_combat_II,
		unarmed_combat_III,
		unarmed_combat_IV,
		weapons_pole,
		weapons_thrown,
		weapons_thrown_or_pole,
	race,
		state_disease,		// plague, werwolf, vampire
		state_gem,
		state_ghost,
		state_item,		//	packed, worn, ready, thrown, left lying around
		state_life,		//	mortal, undead, unmortal, unsatable, immortal, imsatable(lost soul), imdead, (un= magical creature, hence vampire decendant of apopos.  im=ghost, spirit, other zero str figure))
		state_skeleton_natural,	//	male/female, age, genus/species, marrow/undead
		state_skeleton_current,	//	male/female, age, genus/species, marrow/undead
		state_statue,
		state_trance,		//	spellcasting, trance, unconscious, summon demon, summon lesser demon, astral projection, mental combat,
	ref,
	risk,
	risk_failure,
	serial,
        shoulder,                               // depth of water to reach
	skin,
		armor,
		bark,
		body_heat,			//	to be detected by beasts
		body_humidity,		//	to be detected by beasts
		body_odor,			//	to be detected by beasts
		carapace,
		chitin,
		shell,
		shield,
		scales,
		hide,
		fur,
	St,
		St_Ma_mn_2,
		St_Ma_mn_4,
		St_Ma_mn_6,
		St_Ma_max,
	starting_item,
	stat_current_total,
	stat_extra,
	stat_start_total,
	stat_total,
	strength_compression,		//compression perpendicular to grain fiber in kg per sq cm.  Divide by 40 for damage to chop through dry wood.
	swim_speed,
	tail,
	taste_buds,				//100,000 in a catfish
	taste_bud_locations,			//toung, jaws, legs, antennae, suckers, entire body (earth worm)

	TYPE_category,
		Armour,
                   armour_dx_minus,
                   armour_enc,
                   armour_ma_minus,
		{	encumberance formula
				round_up( (kg/st)^2*(-1) )

					7 - 10 = -3 / 2 = 	-1.5
					8 - 10 = -2 / 2 =	-1
					15 - 10 = 5 / 2 =	2.5
					20 - 10 = 10 / 2 =	5
					25 - 10 = 15 / 2 =	7.5
			Armor DX minus formula
				(kg -St)/2, n	*-1 with a zero maximum.

					 8  /-8  = -1
					14  /-7  = -2
					18  /-6  = -3
					20  /-5  = -5
					24  /-4  = -6		}
		Carpet,
		Equipment,
		Fauna,
		  //   original categories
		          pets,
		          servants,
		          accidental_stowaways,
		  //   invent new creatures
			   // mandatory new creature of a slime to get access to the new categories
		  //   new categories
		          Humanoid_race,
		              // build cities
		              // build societies
		              // rule known lands
		              // are wizards or heros
		          intelligent_monsters,
		              // want to keep all the treasure
		              // want to give all the orders
		              // can not trust them behind you
		              // do not make good players
		              // would never travel with humanoids
		              // can be threatened, bribed, or negotiated with
		              // even as a monster follower, they still have independant actions
		          Portents,		// (new category); portenta
		              // use silver slime rising out of the well to litteraly say the mercury is rising
		          magical_creatures,
		              // creatures that can outlast their creators
		          riding_animals,
		              { going price (ST x 10) +(DX x DX) +(MA x3) = n
		                    IQ 5     n x 1
		                    IQ 6     n x 3
		                    IQ 7     n x 10
		                    +$100 per month of training by Animal Handler.
		                    6 months to train a riding animal
		                    1 year to train a flying mount	}
		          beasts,
		              // normal_animals,
		              // may be tamed and trained
		              // vary ST and DX slightly
		          trained_animals,
		              // pets
		              // below IQ 5 is untrainable
		              // IQ 5, warn of strangers, guard belonging, attack on command
		              // IQ 6, open doors and boxes, tracking persons by smell, perfomance tricks, stop fighting on command
		              // IQ 7, can learn any capability, bought under FINDING MAGIC ITEMS FOR SALE
		              // non animal handler
		              //      train 1 in spare time
		              //      creature must be at least 6 months old
		              //      6 months to train to IQ 5
		              //      draft animals and trained mounts
		              //           always follow giddyup-whoa commands if non panic situation.
		              // Animal handler
		              //      train 1 in spare time
		              //      train 6 at once if full time job
		              //      creature must be at least 6 months old
		              //      6 months to train to IQ 5
		              //      6 months to train from 5 to IQ 6
		              //      1 year to train from 6 to IQ 7
		              // obey commands
		              //      4d vs. owner IQ + animal IQ
		              //      5d vs. if owner is not an animal handler
		              // feed
		              //      dog $10 a week
		              //      horse $20 a week
		              //      big cat or bear $50 a week
		              // if you are not the owner
		              //      5d vs. IQ even to ride
		              //      4d vs. IQ if horseman or animal handler
		              //      3d vs. IQ if expert horseman
		              //      +2d to ride strange warhorse
		              //      +1d to ride mammoth, pegasus, or gryphon
		              //      failure means animal will fight you
			giant_insects_and_other_crawlies,
			water_creatures,
			//	only encountered in or near water.
			//	oceans
			//	lakes
			//	ponds
			//	underwater straems
			nuisance_creatures,
			//	weak: st of only 1 or 2
			//	clumbsy: dx of only 1 or 2
		Flora,
			//mostly just sit there and grow
		Gem,
		Jewelry,
		JOB,
			returned_late,
			asking_for_a_raise,
			taking_vacation,
			date_started,
			date_started_old,
			date_quit,
			date_quit_old,
			time_quit,
			time_quit_old,
			risk_string,
			risk_string_old,
			risk_min,
			risk_min_old,
			risk_max,
			risk_max_old,
			pay_rate,
			pay_rate_old,
			time_at_pay_rate,
			time_at_pay_rate_old,
			seargeant_with_5_years,
			seargeant_with_5_years_old,
		Guild_Membership,
		Language,
		Magic_Item,
			weapon_armor_enchantment,
			     //damage bonus or hit's stopped, or DX mods possible.
			     //forceback bonus from +1 hex (2 total) ---to---- +5 hex (6 total).
			     //Kg enchantment from divided by +1(2 total) --- to--- divided by +5 (6 total).
		Potion,
		price_base,		//	slave base value, or item cost
		price_going,
		price_training,	//	added to base cost to get going price
		Scroll,
		Spell,
		Spell_book,
		Talent,
		Weapon,
		{	Archaic_Weapons
				enc //=  ST required / ((Q - ST required)/m)
			 		//m = 1, m = 0.5 if mithril
				SWORD			 Q 17
				AXE, HAMMERS, & MACES	 Q 16
				BOW			 Q 14
				CROSSBOW		 Q 18
				POLEARM			 Q 15
			Magic Weapons
			Peculiar Weapons
				Quarterstaff		 Q 19
				Net			 Q 22
				Whip			 Q 24
				Lasso			 Q 23
				Boomerang		 Q 21
				Nunchucks		 Q 12
				Quarterstaff		 Q 18
				Bola			 Q 13
				Molotov			 Q 12
				Gas bomb		 Q 10
				Sha-ken			 Q 64
				Blowgun			 Q 9
			Finely Made Weapons
				j		dmg +1 (cost * 10)
				k		dmg +2 (cost * 20)
				l		dx +1 (cost * 10)
				m		dx +1, dmg +1 (cost * 100)
				n		dx +1, dmg +2 (cost * 200)	}
	venom,
	vision,	                //    20/5 = far vision or a hawk
        waist_diameter,         //    in cm
	web,
	week_cost_of_common_ingredients,
	week_ingredients_required,
	weeks_to_make,
	weight,
	weight_of_armor,
	weight_of_iron,		// 0.05 kg on a wizard gives DX-4, includes arrow heads and sha-ken.
	whiskers,		//the smaller the natural number the better they are at detection.
	whiskers_age,		//since last shave
	wings,
	wish_granting,	//
	wt: extended;

	end;

implementation
var
        able: TAbilitiesDMG;
        target: TabilitiesDMG;

{$R *.DFM}

procedure TForm1.FormCreate(Sender: TObject);
begin
   Init(Self);
end;

procedure TForm1.New1Click(Sender: TObject);
var
   i: integer;
   n: extended;
   s: shortstring;
begin

   case
   able.stats.stance of// .type_spell_s_s_s of
    kneeling:  able.stats.ma_adj := 2;
   end;

   able.Researching.Type_Types := 2;
   case
   able.Researching.Type_Types of
    2: begin
       able.pay := 20; //$    pay after subsistance for class
       Form1.Caption := Form1.Caption +'  '+ floatToStr(able.pay);
       end;
   end;
   Form1.RichEdit1.Clear;
   with RichEdit1 do
   begin
      s := 'ST:   knockdown    DX-2';
      lines.Add(s);
      for i := 1 to 100 do
      begin
//         n := able.stats.ST;
         n := i ;
         n := round(n);
//         s := format(' %g             %n        %n', [n, (n/1.6), (n/(1.6*1.6))]);
         s := format(' %g             %n        %n', [n, (n/2.23), (n/(2.23*2.23))]);
         lines.Add(s);

      end;
   end;

end;

procedure Tform1.init(sender: TObject);
begin
   able.Researching.Type_types_s[ 1] := '+'; //
   able.Researching.Type_types_s[ 2] := '$'; //
   able.Researching.Type_types_s[ 3] := '3'; //
   able.Researching.Type_types_s[ 4] := '4'; //
   able.Researching.Type_types_s[ 5] := '5'; //
   able.Researching.Type_types_s[ 6] := '6'; //
   able.Researching.Type_types_s[ 7] := '7'; //
   able.Researching.Type_types_s[ 8] := '8'; //
   able.Researching.Type_types_s[ 9] := 'a'; //
   able.Researching.Type_types_s[10] := 'A'; //
   able.Researching.Type_types_s[11] := 'b'; //
   able.Researching.Type_types_s[12] := 'B'; //
   able.Researching.Type_types_s[13] := 'c'; //
   able.Researching.Type_types_s[14] := 'C'; //
   able.Researching.Type_types_s[15] := 'd'; //
   able.Researching.Type_types_s[16] := 'e'; //
   able.Researching.Type_types_s[17] := 'E'; //
   able.Researching.Type_types_s[18] := 'f'; //
   able.Researching.Type_types_s[19] := 'g'; //
   able.Researching.Type_types_s[20] := 'h'; //
   able.Researching.Type_types_s[21] := 'L'; //
   able.Researching.Type_types_s[22] := 'm'; //
   able.Researching.Type_types_s[23] := 'M'; //
   able.Researching.Type_types_s[24] := 'n'; //
   able.Researching.Type_types_s[25] := 'r'; //
   able.Researching.Type_types_s[26] := 'R'; //
   able.Researching.Type_types_s[27] := 's'; //
   able.Researching.Type_types_s[28] := 'S'; //
   able.Researching.Type_types_s[29] := 'T'; //
   able.Researching.Type_types_s[30] := 'U'; //
   able.Researching.Type_types_s[31] := 'V'; //
   able.Researching.Type_types_s[32] := 'W'; //

   able.intent_s[-4] := 'adventure';
   able.intent_s[-3] := 'dungeon';
   able.intent_s[-2] := 'quest';
   able.intent_s[-1] := 'campaign';
   able.intent_s[ 0] := 'mission';
   able.intent_s[ 1] := 'antagonistic';
   able.intent_s[ 2] := 'hostile';
   able.intent_s[ 3] := 'unconcerned';
   able.intent_s[ 4] := 'indiferent';
   able.intent_s[ 5] := 'friendly';
   able.intent_s[ 6] := 'warm';
   able.intent_s[ 7] := 'glowing';
   able.intent_s[ 8] := 'enamored';
   able.intent_s[ 9] := 'entranced';
   able.intent_s[10] := 'charmed';
   able.intent_s[11] := 'persuaded';
//
   able.stats.stance_s[-4] := 'fall';
   able.stats.stance_s[-3] := 'slip';
   able.stats.stance_s[-2] := 'stuck';
   able.stats.stance_s[-1] := 'hang';
   able.stats.stance_s[ 0] := 'supine';
   able.stats.stance_s[ 1] := 'prone';
   able.stats.stance_s[ 2] := 'kneel';
   able.stats.stance_s[ 3] := 'duck';
   able.stats.stance_s[ 4] := 'crawl';
   able.stats.stance_s[ 5] := 'crouch';
   able.stats.stance_s[ 6] := 'stand';
   able.stats.stance_s[ 7] := 'climb';
   able.stats.stance_s[ 8] := 'jump';
   able.stats.stance_s[ 9] := 'ride';
   able.stats.stance_s[10] := 'fly';
   able.stats.stance_s[11] := 'levitate';
//
   Form1.Caption := (able.intent_s[4]) +' '+ able.stats.stance_s[1];

   able.stats.react_injury_s[1] := 'DX_2_next_turn_only';
   able.stats.react_injury_s[2] := 'knocked_down_lose_next_turn';
   able.stats.react_injury_s[3] := 'DX_4_next_turn_only';
   able.stats.react_injury_s[4] := 'enemy_falls_unconsious';
   able.stats.react_injury_s[5] := 'foe_drops_weapon';
   able.stats.react_injury_s[6] := 'use_of_limb_is_lost';
   able.stats.react_injury_s[6] := 'DX_minus_3';
end;

    function tform1.pole_weapon_charge: boolean;       //  pole_weapon_in_or_vs_charge,
    begin
       //
       result := False;
    end;

    function tform1.remaining_figures_to_act_first: integer;  //  remaining_figure_to_act
    begin
       //
       result := 0;
    end;

    function tform1.lost_this_turn: boolean;		//  loose_this_turn
    begin
       //
       if able.stats.loose_this_turn > 0 then
       begin
          able.stats.loose_this_turn := able.stats.loose_this_turn -1;
          result := True;
       end else begin
          result := False;
          if able.stats.loose_this_turn < 0 then
             result := True;     // this turn must be already complete
       end;
    end;

    function tform1.lost_next_turn: boolean;           //  loose_next_turn
    begin
       //
       result := False;
       if able.Stats.loose_next_turn > 0 then
       begin
          Able.Stats.loose_this_turn := 1;
          able.stats.loose_next_turn := able.stats.loose_next_turn -1;
          result := True;
       end;
    end;

    function tform1.set_vs_charge_already: boolean;	//  set_vs_charge
    begin
       //
       result := False;
       if able.stats.set_vs_charge > 0 then
          result := True;
    end;

    function tform1.step_one_hex_only: boolean;	//  step_one
    begin
       //
       result := False;
       if (able.stats.step_one > -1) and
          (able.stats.step_one <= 1) then
          result := True;
    end;

    function tform1.charging: boolean;			//  charge
    begin
       //
       result := False;
       if able.stats.charge > 0 then
          result := True;
    end;

    function tform1.berserking: boolean;               //
    begin
       //
       result := False;
       if able.stats.berserk > 0 then
          result := True;
    end;

    function tform1.turns_aiming_for_an_opening: boolean;     //
    begin
       //
       result := False;
       if able.stats.turns_aim_opening > 0 then
          result := True;
    end;

    function tform1.weapon_arm1_is_broken: boolean;    //  arm, tenticle, or jaw for a bite
    begin
       //
       Result := False;
       if able.stats.weapon_arm1_broken > 0 then
          result := True;
    end;

    function tform1.hands_used_in_primary_attack_how_many: integer;
    begin
       //
       Result := 0;
       if able.stats.hands_used_in_primary_attack > 0 then
          result := round(able.stats.hands_used_in_primary_attack);
    end;

    function tform1.weapon_arm2_is_broken: boolean;    //  arm, tenticle, or jaw for a bite
    begin
       //
       Result := False;
       if able.stats.weapon_arm2_broken > 0 then
          Result := True;
    end;

    procedure tform1.ShotPrimary;
    begin
       //

    end;

    function tform1.weapon_arm3_is_broken: boolean;       //  weapon_arm3_broken
    begin
       //
       Result := False;
       if able.stats.weapon_arm3_broken > 0 then
          Result := true;
    end;

    function tform1.hands_used_in_secondary_attack: integer;    //  hands_used_in_secondary_attack
    begin
       //
       result := 0;
       if able.stats.hands_used_in_secondary_attack > 0 then
          result := round(able.stats.hands_used_in_secondary_attack);
    end;

    procedure tform1.ShotSecondary;
    begin
       //

    end;

    function tform1.hands_used_in_Tertiary_attack: integer;    //  hands_used_in_secondary_attack
    begin
       //
       Result := 0;
       if able.stats.hands_used_in_hth_attack > 0 then
          Result := round(able.stats.hands_used_in_hth_attack);
    end;

    procedure tform1.ShotTertiary;
    begin
       //

    end;


procedure TForm1.LetsAct;
var
  sn: integer;
begin
     //   TCombatCardDMG = record
  with able.Stats do
  begin
   if fighting > 0 then
      noise_per_hex_moved := noise_per_hex_moved +35
   else
      if arguing > 0 then
      noise_per_hex_moved := noise_per_hex_moved +15;

   // sort turn sequence before you get to act, so you know when to act
   if dx_adj < target.stats.dx_adj then
      dx_standing_in_turn_sequence := 1;
{  ST, st_adj,
   DX, dx_adj,
	   dx_standing_in_turn_sequence,	//
   IQ, iq_adj,
	   picked_option,
	   renew_spell_cost,
	   countdown_turns_left,
   MA, ma_adj,				//	adj_ma covers speed move, rope, or stop, flight spell = ma +2, leather ma -2
	   noise_per_hex_moved,		//
	   ambush_surprise,			//
	   loose_move,
	   ma_avert,				//	required hex distance left to cover
	   ma_engaged,			//	movement ends when this is triggered
	   ma_left,
	   number_of_figures_to_move,
	   number_of_figures_eliminated,
	   number_of_figures_controled_summoned,
	   number_of_figures_left_to_move,
	   movement_of_multihex_figures,
	   shifting,
	   moving_onto_other_figures,
		attempting_hth,
		in_hth,
	   move_through_friends_not_engaged,
	   flight: extended;
	   stance: StanceDMG;		//	crawling, kneeling, prone, supine, crouch, stand
	   stance_s: StanceDMGstrings;	//	crawling, kneeling, prone, supine, crouch, stand
	   actions_during_movement_jumping_scooping,  }
   if hidden_movement > 0 then
   begin
      //  record moves but do not display
   end;
   if reveal_movement > 0 then
   begin
      // moving adjacent to a figure while invisible
   end;
   if invent_new_move > 0 then
   begin
      //  record demo
   end;
   if full_move > 0 then
   begin
      // all loose_this_turn
           if flee > 0 then
           begin
              //
           end;
           if pursue > 0 then
           begin
              //  long distance running melee
           end;
           if jump_over_kneeling > 0 then
           begin
              //
           end;
           if jump_over_prone > 0 then
           begin
              //
           end;
           if jump_over_pit > 0 then
           begin
              //
           end;
           if climbing_slope > 0 then
           begin
              //
           end;
           if climbing_face > 0 then
           begin
              //
           end;
           if climbing_spikes > 0 then
           begin
              //
           end;
           if climbing_n_spiking > 0 then
           begin
              //
           end;
           if climbing_rope > 0 then
           begin
              //
           end;
           if climbing_rope_ladder > 0 then
           begin
              //
           end;
           if scoop_up_weapon > 0 then
           begin
              // subtract 3 MA
              // ready targeted weapon
           end;
           if grab_up_weapon > 0 then
           begin
              //  3d vs. DX and
              //  ready targeted weapon
           end;
           if taking_prisoner > 0 then
           begin
              // convert damage to subdual
              // possibly make saving throw
           end;
   end;
   if broken_ground > 0 then
   begin
      //  3d vs DX or fall down loosing the turn
   end;
   if darkness > 0 then
   begin
      //  check for dark vision or mage sight
      //  check for acute hearing or echo vision
      //  apply dx mods
      //  adjust range modifier incriments for possible...
      //  one eye blind, nearsighted, or flat blind
   end;
   if water_footing_depth > 0 then
   begin
      //  ankles, knees, waist, shoulder
   end;
   if traps > 0 then
   begin
      //  call a round of saving throw checks?
      //  save vs attribute on n dice?
      //  modify n dice for detect traps ability and/or alertness
   end;
   if aireal_combat > 0 then
   begin
      //  DX-6 for all actions on or by the figure
      //  can only be engaged if figure wants to be
   end;
   if mounted_combat > 0 then
   begin
      //  DX+2 for height advantage
      //  harder to engage (considered 2 hex figure)
      //  can use horse to move onto other figures and/or trample
      //  use horses str for a charge attack with sword, axe/mace, just like pole from foot
      //  being unhorsed is a fall, having the horse fall is worse (much worse)
   end;

   if burial_mound_control > 0 then
   begin
      //  dragons changed to barrow wights in fellowship of the ring
      //  magic points protecting a site
      //  site will spawn ghost(s) or worse to protect itself
      //  if player cleans entire area and takes over operations...
      //  they get control of the mound(s)
   end;
   if artifact_combat > 0 then
   begin
      //  automatic, full auto, auto burst
      //  power supply, fuel, connection
      //  break, off switch, shut down sequence
      //  familiarity, handling maneuvers, known mistakes
   end;
   if merchant_combat > 0 then
   begin
      //  market capture
   end;
   if siege_combat > 0 then
   begin
      //  structural damage
   end;
   if space_combat > 0 then
   begin
      //  check for freefall conditions when using weapons or performing actions
   end;

   if campaign_edges_of_time_gods_teeth_audio_combat > 0 then
   begin
      //  only audio weapons work, the noise effect is the only thing that travels
   end;

   if stores_of_ammo < 1 then
   begin
      if stores_of_ammo_extra > 0 then
      begin
         // initiate autoload of more ammo?
      end;
   end;
   if building_rules > 0 then
   begin
      //  accidental injury or death
   end;
   if ship_combat > 0 then
   begin
      // DX -4 if not seamanship
   end;
   if campaign_d20_multiplyer <> 1 then
   begin
      //  damage := damage x campaign_d20_multiplyer;
   end;
   sn := round( trunc(subject_number / 1000000));
   case sn of
      1: begin
            // legends, lore, myths, player gossip, tales, and other juice
         end;
      2: begin
            //  player characters: character generation, warrior, wizard, worshipper
         end;
      3: begin
            //  communications: war drums, horns & trumpets, signal flags,
            //  signal fires, battle lanterns, message runners, carrier pidgeons,
            //  smoke signals, cryptography

            //  opperations and readiness: troop posture, deployment, and awareness

            //  logistics: game mechanics, combat, compound dice resolution (cdr),
            //  forms of conflict, scale, sequence of events,
            //  interaction of comm ops with readiness

            //  campaign: precedents, plots, general administration, management,
            //  games, referee, game master, keeper, patron, opponent, killer,
            //  monty hall, nit pick, skeptic, sophist, theorist, compiance,
            //  fractional role playing, vectors,
            //  ENCOUNTERS, SCENARIO, ADVENTURE, QUEST
         end;
      4: begin
            //  medical and dentistry: injuries (types and side effects),
            //  pod grown bodies and organs, HEALTH, healing, DEATH,
            //  regeneration (progressing from star fish, to cells, to tissue,
            //  to blood, to bone, to nerves, to organs, to limbs, to hair),
            //  cloning, spawning, stasis and/or cryogenic suspension,
            //  brain taping or memory transferance, synthesis of life forms,
            //  splicing life forms
         end;
      5: begin
            //  treasury management: broker, trade, finance, coinage, barter,
            //  precious minerals, land holdings, vaults, etcetera.
         end;
      6: begin
            //  Things: war material, ship design & material (as 'mobile' places)
            //  general material like gear & equipment
         end;
      7: begin
            //  places: mapping, keying, how places can be viewed as physical
            //  representations of game rules
         end;
      8: begin
            //  game master characters (GMC's): wearing all the hats,
            //  shoes of iron & feet of clay -- the imicibility of it all,
            //  clothing you players in henchmen
         end;
      9: begin
            //  aeronautical and astronautical material: navigation, stellar maps
         end;
      10: begin
            //  guard missions: coast guarding, boarder guard, body guard, etc,
            //  the problems of not being able to be everywhere at once and who
            //  can be trusted with complications added by teritorial behaviour
            //  and loyalty
         end;
   end;
   sn := round( trunc(campaign_age / 1000000));
   case sn of
      1: begin
            // creation
         end;
      2: begin
            //   god kings (stone age warrior preists, native americans)
         end;
      3: begin
            //   ancients (bronze age eurasia, through the fall of roman empire)
         end;
      4: begin
            //   holy avengers (the dark, middle, and mideval ages)
         end;
      5: begin
            //   renaissance colony (the awakening, the colonial era, rebelions)
         end;
      6: begin
            //   against the drug lords (current with this writting)
         end;
      7: begin
            //   building a new civilization (the fall of the solar system)
         end;
      8: begin
            //   the machine (artificial, sythentic, genetic inteligence programing)
         end;
      9: begin
            //   epic (super heros vs. super cultures)
         end;
      10: begin
            //   age of ages (time travel, time of legends, edges of time, & the end)
         end;
   end;
   sn := round( trunc(media_number / 1000000));
   case sn of
      1: begin
            // paper work and record keeping?
            //   print (black and white, two color, full color)
         end;
      2: begin
            //   photograph
         end;
      3: begin
            //   radio
         end;
      4: begin
            //   film
         end;
      5: begin
            //   television
         end;
      6: begin
            //   3 in one disk, 5 in one floppy disc, laser disc (including audio)
         end;
      7: begin
            //   personal computer, lap top computers, light tables
         end;
      8: begin
            //   main frame
         end;
      9: begin
            //   network
         end;
      10: begin
            //   satelite
         end;
   end;
   sn := round( trunc(serial_number / 1000000));
   case sn of
      1: begin
            // paper work and record keeping?
            //   print (black and white, two color, full color)
         end;
      2: begin
            //   photograph
         end;
      3: begin
            //   radio
         end;
      4: begin
            //   film
         end;
      5: begin
            //   television
         end;
      6: begin
            //   3 in one disk, 5 in one floppy disc, laser disc (including audio)
         end;
      7: begin
            //   personal computer, lap top computers, light tables
         end;
      8: begin
            //   main frame
         end;
      9: begin
            //   network
         end;
      10: begin
            //   satelite
         end;
   end;

   if immunities_detected > 0 then
   begin
      // run the immunities case list, generate exceptions
      // the next 16, only, can exonorate exceptions
      // an exonorate exception send to the opponent a "fail to disbeleive"
   end;
   if in_disguise_real_name > 0 then
   begin
      //  this can reveal hidden racial abilities
   end;
   if reitreiver_pet > 0 then
   begin
      //  explains multiple actions, and dx item exchanges
      //  pet will deliver to character items
      //  may be time to remind pet of where i am
   end;
   if subdued_already > 0 then
   begin
      // errr ummmm can't be subdued again, move this to immunities?
   end;
   if fire_explosion_in_doors_tunnels > 0 then
   begin
      // damage from certain types of effects are multiplied when in an enclosed space
      // petard, fireball, molotov, grenade, retort of gunpowder, command word
   end;
   if implosion_pull > 0 then
   begin
      // from open tunnel, universal solvent, or lightining de-enchant
   end;

   if detect_lair > 0 then
   begin
      //      to find specific monsters, alertness, architect, tracking, naturalist,
   end;
   if oom > 0 then
   begin
      //      out of mana, wont even consider spells
   end;
   if afk > 0 then
   begin
     //      All For Ok, auto-follow leaders instructions
   end;
   if pre_arranged_duel_with_seconds > 0 then
   begin
   end;
   if pre_arranged_duel_as_second > 0 then
   begin
   end;

   if pentigram > 0 then
      begin
      end;
   if spectral_prison > 0 then
      begin
      end;
   if rune_weapon > 0 then
      begin
      end;
   if a_seat_at_the_high_table > 0 then  //      fear, courtly graces, diplomacy, charisma, bard, new followers, preist, theologian, geas, avert, surrender, obey
      begin
      end;
   if concentrate_fire_file > 0 then
      begin
      end;
   if concentrate_fire_rank > 0 then
      begin
      end;

   if planetary_bombardment > 0 then
   begin
      // apply damage to planet surface
   end else begin
           if vampiric_drain > 0 then
           begin
              // restore your own strength while draining thiers
           end else begin
              if vigilanti_operation > 0 then
              begin
                 // apply damage to faith in law
              end else begin
                 if realm_wide_change > 0 then
                 begin
                    // apply damage to realm states
                 end else begin
                    if national_character_of_invasion > 0 then
                    begin
                       // apply damage to target nation
                    end;
                 end;
              end;
           end;
   end;

   end; // with
end;

end.
