unit Plan87P;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  Light, Material, Transfrm, cOpenGL, OpenGL, MMsystem, ExtCtrls,
  math, ComCtrls;

type
  TForm1 = class(TForm)
    OpenGL1: TOpenGL;
    TRansformLight: TTRansform;
    TRansformFloor: TTRansform;
    TRansformWall: TTRansform;
    MaterialLight: TMaterial;
    MaterialFloor: TMaterial;
    MaterialWall: TMaterial;
    Light1: TLight;
    TRansformPole: TTRansform;
    MaterialPole: TMaterial;
    MaterialOpen: TMaterial;
    TRansformGlobe: TTRansform;
    MaterialGlobe: TMaterial;
    TRansformLand: TTRansform;
    MaterialLand: TMaterial;
    TRansformDust: TTRansform;
    MaterialDust: TMaterial;
    Timer1: TTimer;
    TRansformCanvas: TTRansform;
    MaterialCanvas: TMaterial;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    TRansformBall: TTRansform;
    MaterialBall: TMaterial;
    Light2: TLight;
    TrackBar1: TTrackBar;
    procedure FormCreate(Sender: TObject);
    procedure FormKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormKeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure FormPaint(Sender: TObject);
    procedure FormResize(Sender: TObject);
    procedure TRansformLightPaint(Sender: TObject);
    procedure TRansformFloorPaint(Sender: TObject);
    procedure TRansformWallPaint(Sender: TObject);
    procedure TRansformPolePaint(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure TRansformGlobePaint(Sender: TObject);
    procedure TRansformLandPaint(Sender: TObject);
    procedure TransformDustPaint(Sender: TObject);
    procedure TransformCanvasPaint(Sender: TObject);
    procedure Timer1Timer(Sender: TObject);
    procedure FormMouseMove(Sender: TObject; Shift: TShiftState; X,
      Y: Integer);
    procedure FormMouseDown(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure FormMouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure TRansformBallPaint(Sender: TObject);
    procedure TrackBar1Change(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
  private
        theta,
     ang, angl, ang2, ang3, rspeed, speed, tran, rot, alt, wx, wy, wz,
     Vu_ang, Vl_ang, cercent,
     scale_dust,
     trnX, trnY, trnZ,
     scalum, Pscale: Double;
     frames, elapsed, start, TimeDif2, elapsed2, start2, Rider,
     pass, small, last_small, f1, f2,
     cur, so_far, trio,
     selected_dust, startX, startY,
     count_spread, opus_maximus: integer;
     MY_UP, MY_DOWN, MY_LEFT, MY_RIGHT,
     MY_LEFT2, MY_RIGHT2, MY_E, MY_D, MY_B, MY_T, MY_G, MY_TREB, MY_Y,
     dustinator, triangulator: Boolean;
     startShift: TShiftState;
     procedure InitDust;
     procedure DrawDust;
     procedure VectorDust;
     procedure SphereDust;
     procedure SpreadDust;
     procedure CollectDust;
     procedure BuildTerrain;
     procedure DrawTerrain;
     procedure BuildWall;
     procedure Cube;
     procedure Cube2;
     procedure CylinderBase;
     procedure Cylinder;
     procedure Opening;
     procedure Idle(Sender: TObject; var Done: boolean);
     procedure Adjust;
     procedure Selection(px,py:GLdouble);
     function SelectionDone: GLint;
     procedure DrawPlanets;
     procedure DrawPlanet(count: integer);
     procedure TimeCodeBegin;
     procedure TimeCodeEnd;
     procedure DrawTriangles;
     procedure DrawBallTriangles;
     procedure NormalizeTreb;
     procedure AverageDist;
     procedure CopyDusty;
     procedure AssignTriang;
     procedure Gravity;
     procedure Grav(count, count2: integer);
     procedure InitSolarSystem;
     procedure InitTexMap;
     procedure FirstTriangle;
     procedure NextTriangle(count: integer);
     procedure NextAdjacentTriangle(count: integer);
    { Private declarations }
  public
     procedure LoadOrb;
     procedure SaveOrb;
     procedure LoadPlanets;
     procedure SavePlanets;
     procedure SaveTriangles;
     procedure LoadTriangles;
     procedure InitializeOrb;
    { Public declarations }
  end;

var
  Form1: TForm1;

implementation

{$R *.DFM}

const
   Level = 0;
   Border = 0;
   ColorComps =3;
   MAX_DUST2 = 1447;//1461;
   MAX_DUST = 1461;
   RADI = 1.0;
//   au = 149598000.0;
     au = 149598000000.0;
// GRAVITY_CONSTANT = 0.00000000006672;
//   GRAVITY_CONSTANT = 0.00000000003336;
   GRAVITY_CONSTANT = 0.00000006672;
   VECTOR_PLAY = 1;//10.3;
   PLANET_MASS_SCALAR = 24;//24;
   PSCALE_START = 5000;
   RIDER_START = 5;
   MAX_PLANET = 144;

type
   TRGB = packed record
      r,g,b: byte;
   end;

   TWrap = array[0..0] of TRGB;

   TPoint = packed record
     x,y,z: GLfloat;
   end;

   PHit=^THit;
   THit=packed record
      ncount, dnear, dfar: GLuint;
      names: array[1..256] of GLuint;
   end;

   TPlanet = packed record
      ref_planet: integer;
      radius, mass, au, axis, day: GLfloat;
      vec, place: TPoint;
   end;

   TPoint2D = packed record
      x,y,
      angle, ang_abso: GLfloat;
   end;

   TCoord = packed record
      a,b,c: TPoint2D;
   end;

   TAdj3 = packed record
      a12, a23, a31: integer;
   end;

   TTerrainRow=array[1..66] of TPoint;
   TTerrain = array[-32..32] of TTerrainRow;
   TDust = packed array[1..MAX_DUST,0..1] of TPoint;
   TDusty = packed array[1..MAX_DUST] of TPoint;
   TTri = packed array[1.. (MAX_DUST * 6)] of TPoint;
   TTriang = packed array[1.. (MAX_DUST * 6)] of integer;
   TSolar = packed array [0..MAX_PLANET] of TPlanet;
   TTTC = packed array [1..(MAX_DUST *6)] of TCoord;
var
   pi180: double = pi/180;
   circleX, circleY : array [0..35] of glFloat;
   wall: array[1..28] of TPoint;
   sBulk, tBulk,
   sBrick, tBrick,
   sWorld, tWorld, sGrass, tGrass: GLsizei;
   globe, world, bulk, brick, grass: pointer;
   ter: TTerrain;
   Dust: TDust;
   Dusty: TDusty;
//   dlTerrain: GLuint;
   PickBuffer: array[1..512] of GLuint;
   Tri: TTri;
   Triang: TTriang;
   Treb: array [1..(MAX_DUST *2)] of TPoint;
   TreAd: array [1..(MAX_DUST *2)] of TAdj3;
   BallVect: TPoint;
   Sol: TSolar;
   TTC: TTTC;
   lastSpot: TPoint;

function ReadBitmap(const FilePath: string; var sWidth,tHeight:GLsizei): pointer;
const
   szh = SizeOf(TBitmapFileHeader);
   szi = SizeOf(TBitmapInfoHeader);
var
   bmpfile: file;
   bfh: TBitmapFileHeader;
   bmi: TBitmapInfoHeader;
   t: byte;
   x1, size: integer;
begin
   assignFile(bmpfile, FilePath);
   reset(bmpfile,1);
   size := FileSize(bmpfile)-szh-szi;
   blockread(bmpfile, bfh, szh);
   if Bfh.BfType<>$4D42 then
      raise EInvalidGraphic.Create('invalid bitmap');
   blockread(bmpfile,bmi,szi);
   with bmi do
   begin
      sWidth := biWidth;
      tHeight := biHeight;
   end;
   getmem(result,size);
   blockRead(bmpfile,result^,size);
   for x1 := 0 to sWidth * tHeight -1 do
   with TWrap(result^)[x1] do
   begin
      t := r;
      r := b;
      b := t;
   end;
end;

procedure TForm1.Selection(px,py:GLdouble);
type
   TViewPort=packed record
      left,bottom, width, height: GLint;
   end;
var
   viewport: TViewPort;
begin
   glRenderMode(GL_SELECT);
   glInitNames;
   glPushName(0);
   glMatrixMode(GL_PROJECTION);
   glPushMatrix;
   glLoadIdentity;
   glGetIntegerv(GL_VIEWPORT,@viewport);
   py := viewport.height-py;
   gluPickMatrix(px,py,2.0,2.0, @Viewport);
end;

function TForm1.SelectionDone:GLint;
begin
   glMatrixMode(GL_PROJECTION);
   glPopMatrix;
   result := glRenderMode(GL_RENDER);
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   glPixelStorei(GL_UNPACK_ALIGNMENT,1);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_S,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_WRAP_T,GL_REPEAT);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MAG_FILTER,GL_NEAREST);
   glTexParameteri(GL_TEXTURE_2D,GL_TEXTURE_MIN_FILTER,GL_NEAREST);
   glTexEnvf(GL_TEXTURE_ENV,GL_TEXTURE_ENV_MODE,GL_MODULATE);//GL_DECAL);
   bulk := readBitmap('Fig13-06.bmp',sBulk,tBulk);
   Brick := readBitmap('Fig13-10.bmp',sBrick,tBrick);
  // World := readBitmap('AreaMap.bmp',sWorld,tWorld);

//   World := readBitmap('Fig13-21.bmp',sWorld,tWorld);
   World := readBitmap('earth2.bmp',sWorld,tWorld);

  // World := readBitmap('Fig13-16.bmp',sWorld,tWorld);
   Grass := readBitmap('Fig13-19.bmp',sGrass,tGrass);
{
   glEnable(GL_LINE_SMOOTH);
   glEnable(GL_BLEND);
   glBlendFunc(GL_SRC_ALPHA,GL_ONE_MINUS_SRC_ALPHA);
   glEnable(GL_NORMALIZE);
 }
   Application.OnIdle := Idle;
   cylinderBase;
   buildWall;
   buildTerrain;
   InitDust;
   SphereDust;
   globe := gluNewQuadric;
   gluQuadricDrawStyle(globe,GLU_FILL);
   gluQuadricTexture(globe,byteBool(GL_TRUE));
   start := TimeGetTime;
   speed := 0.1;
   rspeed := 7.0;
   scalum := 1;
   wz := -8.0 * scalum;
   wx := -1.35 * scalum;
   wy := -1.5 * scalum;
   tran := 0.0 * scalum;
   Pscale := 3 / au * PSCALE_START;
   Rider := RIDER_START;
//   Pscale := 1;

   MY_UP := False;
   MY_DOWN := False;
   MY_LEFT := False;
   MY_RIGHT := False;
   MY_LEFT2 := False;
   MY_RIGHT2 := False;
   MY_B := False;
   MY_D := False;
   MY_E := False;
   MY_G := False;
   MY_T := False;

   pass := 0;
   last_small := 0;
   small := 0;
   f1 := 1;
   f2 := 2;
   cercent := 1.2;

   glSelectBuffer(128,@PickBuffer);
   cur := 0;
   so_far := 0;
   trio := 0;

   InitializeOrb;
   MY_TREB := False;
   scale_dust := 1.0;

   selected_dust := 0;
   startX := -1;
   dustinator := False;
   triangulator := False;
   MY_Y := True;
   count_spread := 0;

   BallVect.x := 0.00;
   BallVect.y := -0.01;
   BallVect.z := 0.01;

   opus_maximus := 1;
end;

procedure TForm1.NormalizeTreb;
var
   count, count2: integer;
   x1,x2,x3,
   y1,y2,y3,
   z1,z2,z3: GLFloat;
begin
   //
   MY_TREB := not MY_TREB;
   if MY_TREB then
   begin
   count := 0;
   count2 := 0;
   while count < so_far do
   begin
      inc(count);
      x1 := Tri[count].x;
      y1 := Tri[count].y;
      z1 := Tri[count].z;
      inc(count);
      x2 := Tri[count].x;
      y2 := Tri[count].y;
      z2 := Tri[count].z;
      inc(count);
      x3 := Tri[count].x;
      y3 := Tri[count].y;
      z3 := Tri[count].z;
      inc(count2);   
      Treb[count2].x := ((x1 +x2 +x3)/3);
      Treb[count2].y := ((y1 +y2 +y3)/3);
      Treb[count2].z := ((z1 +z2 +z3)/3);
   end;
   end;
end;

procedure TForm1.FormKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
//   messageDlg(IntToStr(ord(key)),mtWarning,[mbOk],0);
   case Key of
      VK_UP: MY_UP := TRUE;
      VK_DOWN: MY_DOWN := TRUE;
      VK_LEFT: MY_LEFT := TRUE;
      VK_RIGHT: MY_RIGHT := TRUE;
      VK_ESCAPE: Close;
      ord('A'): begin
            CopyDusty;
            end;
      ord('B'): begin
            MY_B := not MY_B;
            end;
      ord('C'): begin
            inc(opus_maximus);
            end;
      ord('D'): begin
            MY_D := True;
            end;
      ord('E'): begin
             MY_E := True;
             end;
      ord('F'): begin
             MY_RIGHT2 := TRUE; end;
      ord('G'): begin
             MY_G := not MY_G;
             end;
      ord('I'): begin
            LoadTriangles;
            end;
      ord('J'): begin
            count_spread := count_spread +10;
            end;
      ord('K'): begin
            SaveTriangles;
            end;
      ord('L'): begin
            SaveOrb;
            end;
      ord('M'): begin
            AverageDist;
            end;
      ord('N'): begin
            NormalizeTreb;
            end;
      ord('O'): begin
            LoadOrb;
            end;
      ord('P'): begin
           // Scalum := scalum * 1.2;
               Pscale := Pscale * 1.2;
            end;
      ord('Q'): begin
           // Scalum := Scalum * 0.8;
               Pscale := Pscale * 0.8;
            end;
      ord('R'): Begin
         if ssShift in Shift then
            rspeed := rspeed +0.01
         else begin
            if rspeed > 0.01 then
               rspeed := rspeed -0.01;
            end;
         end;
      ord('S'): begin
             MY_LEFT2 := TRUE; end;
      ord('T'): begin
             MY_T := not MY_T;
             end;
      ord('X'): begin
         if ssShift in Shift then
            speed := speed +0.001
         else begin
            if speed > 0.001 then
               speed := speed -0.001;
            end;
         end;
      ord('Y'): begin
            MY_Y := not MY_Y;
            end;
      ord('Z'): begin
            AssignTriang;
            end;
      219: wz := wz -100;
      221: wz := wz +100;
      ord('0'): Rider := 0; //cercent  := 1.02;
      ord('1'): Rider := 1; //cercent  := 1.05;
      ord('2'): Rider := 2; //cercent  := 1.10;
      ord('3'): Rider := 3; //cercent  := 1.12;
      ord('4'): Rider := 4; //cercent  := 1.14;
      ord('5'): Rider := 5; //cercent  := 1.16;
      ord('6'): Rider := 6; //cercent  := 1.18;
      ord('7'): Rider := 7; //cercent  := 1.2;
      ord('8'): Rider := 8; //cercent  := 1.25;
      ord('9'): Rider := 9; //cercent  := 1.30;
   end; {case}
end;

procedure TForm1.FormKeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   case Key of
      VK_UP: begin
             MY_UP := False;
             tran := 0.0;
             end;
      VK_DOWN: begin
             MY_DOWN := False;
             tran := 0.0;
             end;
      VK_LEFT: begin
             MY_LEFT := False;
             rot := 0.0;
             end;
      VK_RIGHT: begin
             MY_RIGHT := False;
             rot := 0.0;
             end;
      ord('S'): begin
             MY_LEFT2 := False;
             rot := 0.0;
             end;
      ord('F'): begin
             MY_RIGHT2 := False;
             rot := 0.0;
             end;
      ord('B'): begin
               //MY_B := False;
             end;
      ord('D'): begin
             MY_D := False;
             alt := 0.0;
             end;
      ord('E'): begin
             MY_E := False;
             alt := 0.0;
             end;
   end;
end;

procedure TForm1.FormPaint(Sender: TObject);
begin
   glClear(GL_COLOR_BUFFER_BIT or GL_DEPTH_BUFFER_BIT);

   glMatrixMode(GL_MODELVIEW);
   glLoadIdentity;

//   MaterialOpen.Apply;
//   Opening;

//   glScalef(0.1,0.1,0.1);
   glScalef(scalum,scalum, scalum);
   glRotatef(angl,0.0,1.0,0.0);
//   glTranslatef(wx,wy,wz);
   glTranslatef(-Sol[Rider].Place.x * PScale,-Sol[Rider].Place.y * PScale,wz);

//   Light2.Apply;
   TransformLight.Apply;
//   TransformWall.Apply;
//   TransformPole.Apply;
//   TransformGlobe.Apply;
//   TransformFloor.Apply;
                        //   TransformDust.Apply;
   TransformBall.Apply;
//   TransformLand.Apply;
   DrawPlanets;

   OpenGL1.Swap;
   OpenGL1.ErrorCheck('formpaint');
end;

procedure TForm1.DrawPlanets;
var
   count: integer;
begin
   for count := 0 to 7 do
   begin
      DrawPlanet(count);
   end;
 {  TransFormDust.TranX := 0;
   TransFormDust.TranY := 0;
   TransFormDust.TranZ := 0;
   TransformDust.ScaleX := 1.0;
   TransformDust.ScaleY := 1.0;
   TransformDust.ScaleZ := 1.0;
   TransformDust.Apply;
   }
end;

procedure TForm1.DrawPlanet(count: integer);
begin
   TransFormDust.TranX := Sol[count].Place.x * Pscale;
   TransFormDust.TranY := Sol[count].Place.y * Pscale;
   TransFormDust.TranZ := Sol[count].Place.z * Pscale;
   TransformDust.ScaleX := Sol[count].radius * Pscale;
   TransformDust.ScaleY := Sol[count].radius * Pscale;
   TransformDust.ScaleZ := Sol[count].radius * Pscale;
   TransformDust.Apply;

   glPointSize(7.0);
   glBegin(GL_POINTS);
      with TransFormDust do
      begin
         glNormal3f(Tranx,Trany,Tranz);
         glVertex3f(Tranx,Trany,Tranz);
      end;
   glEnd;

end;

procedure TForm1.TimeCodeBegin;
begin
   start2 := TimeGetTime;
end;

procedure TForm1.TimeCodeEnd;
begin
   elapsed2 := TimeGetTime;
   timedif2 := (elapsed2 - start2);
   Form1.Caption := Format('timedif: %6d',[timedif2]);
end;

procedure TForm1.DrawTriangles;
var
   count, count2: integer;
begin
   //
   count2 := 0;

   if so_far > 2 then
   begin
     glBegin(GL_TRIANGLES);

    if triangulator then
    begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         end;
      end;



    end else begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);
            if count2 = 1 then
            begin
            end;

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         end;
      end;
    end; //if Triangulator
   glEnd;
   end;
end;


procedure TForm1.DrawBallTriangles;
var
   count, count2: integer;
begin
   //
   count2 := 0;

   if so_far > 2 then

    if triangulator then
    begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);




//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

      glEnd;
         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);



//        glTexCoord2f(0.0,0.0);
            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(10.0,5.0);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

         inc(count2);
//        glTexCoord2f(5.0,10.0);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Dust[Triang[count2],0].x * scalum,
                       Dust[Triang[count2],0].y * scalum,
                       Dust[Triang[count2],0].z * scalum);
            glVertex3f(Dust[Triang[count2],0].x,Dust[Triang[count2],0].y,Dust[Triang[count2],0].z);

      glEnd;
         end;
      end;



    end else begin

      if MY_TREB then
      begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);



            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Treb[count].x * scalum,
                       Treb[count].y * scalum,
                       Treb[count].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

      glEnd;
         end;
      end else begin
         for count := 1 to (so_far div 3) do
         begin
         inc(count2);

   glBegin(GL_TRIANGLES);


            glTexCoord2f(TTC[count].a.x,TTC[count].a.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);
            if count2 = 1 then
            begin
            end;

         inc(count2);
            glTexCoord2f(TTC[count].b.x,TTC[count].b.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

         inc(count2);
            glTexCoord2f(TTC[count].c.x,TTC[count].c.y);
            glNormal3f(Tri[count2].x * scalum,
                       Tri[count2].y * scalum,
                       Tri[count2].z * scalum);
            glVertex3f(tri[count2].x,tri[count2].y,tri[count2].z);

      glEnd;
         end;
      end;

    end; //if Triangulator
end;

procedure TForm1.FormResize(Sender: TObject);
begin
   if OpenGL1.Smaller then
      FormPaint(Sender);

end;

procedure TForm1.TRansformLightPaint(Sender: TObject);
begin
   Light1.Apply;
   MaterialLight.Apply;
   Cube;

end;

procedure TForm1.TRansformFloorPaint(Sender: TObject);
begin
   MaterialFloor.Apply;
   glNormal3f(0.0,1.0,0.0);
   glBegin(GL_POLYGON);
      glVertex3f(-29.0,0.0,-29.0);
      glVertex3f(-29.0,0.0,+29.0);
      glVertex3f(+29.0,0.0,+29.0);
      glVertex3f(+29.0,0.0,-29.0);
   glEnd;

end;

procedure TForm1.TRansformWallPaint(Sender: TObject);
var
   ix: integer;
   s: GLfloat;
   t: array[false..true] of GLfloat;
   tt: boolean;
begin
   glEnable(GL_TEXTURE_2D);
   glTexImage2D(GL_TEXTURE_2D,Level,ColorComps,sBrick,tBrick,Border,
                GL_RGB,GL_UNSIGNED_BYTE,Brick);

   MaterialWall.Apply;

   s := 0.0;
   t[false] := 0.0;
   t[true] := 4.0;
   tt := false;

   glBegin(GL_TRIANGLE_STRIP);
     for ix := 1 to 14 do
     with wall[ix] do
     begin
        glNormal3f(0.0,0.0,1.0);
        glTexCoord2f(s,t[tt]);
        glVertex3f(x,y,z);
        if tt then
           s := s+2.0;
        tt := not tt;
     end;
     for ix := 15 to 28 do
     with wall[ix] do
     begin
        glNormal3f(0.0,0.0,-1.0);
        glTexCoord2f(s,t[tt]);
        glVertex3f(x,y,z);
        if tt then
           s := s+2.0;
        tt := not tt;
     end;

     for ix := 1 to 2 do
     with wall[ix] do
     begin
        glNormal3f(0.0,-1.0,0.0);
        glTexCoord2f(s,t[tt]);
        glVertex3f(x,y,z);
        if tt then
           s := s+2.0;
        tt := not tt;
     end;
  glEnd;
  glDisable(GL_TEXTURE_2D);

//   Cube;
end;

procedure TForm1.InitDust;
const
   frac = 10000;
var
   count: integer;
begin
   Randomize;
   for count := 1 to MAX_DUST do
   begin
      with Dust[count,0] do
      begin
         x := (Random(12000)-6000)/frac;
         y := (Random(12000)-6000)/frac;
         z := (Random(12000)-6000)/frac;
      end;
      with Dust[count,1] do
      begin
         x := 0;//(Random(12000)-6000)/frac /1000;
         y := 0;//(Random(12000)-6000)/frac /1000;
         z := 0;//(Random(12000)-6000)/frac /1000;
      end;
   end;
end;

procedure TForm1.DrawDust;
var
   count: integer;
begin
   glEnable(GL_TEXTURE_2D);

   glTexImage2D( GL_TEXTURE_2D, Level, ColorComps,sBulk,tBulk,Border,
                GL_RGB,GL_UNSIGNED_BYTE,bulk);

   glPointSize(7.0);
   for count := 1 to MAX_DUST do
   begin
      glLoadName(count);
      glPushMatrix;
      with Dust[count,0] do
         glTranslatef(x,y,z);
      glScalef(0.05,0.05,0.05);
      cube2;
      glPopMatrix;

{      glBegin(GL_POINTS);
      with Dust[count,0] do
      begin
         glNormal3f(x,y,z);
         glVertex3f(x,y,z);
      end;
      glEnd; }
   end;
   glDisable(GL_TEXTURE_2D);

   glBegin(GL_LINES);
      with Dust[f1,0] do
      begin
         glNormal3f(-x,-y,-z);
         glVertex3f(0.0,0.0,0.0);
         glVertex3f(x,y,z);
      end;
   glEnd;
   glBegin(GL_LINES);
      with Dust[f2,0] do
      begin
         glNormal3f(-x,-y,-z);
         glVertex3f(0.0,0.0,0.0);
         glVertex3f(x,y,z);
      end;
   glEnd;
end;

function SubtractVector(v1,v2: TPoint): TPoint;
begin
   with Result do
   begin
      x := v1.x - v2.x;
      y := v1.y - v2.y;
      z := v1.z - v2.z;
   end;
end;

function Normalize(N: TPoint):TPoint;
var
   d, m: GLFloat;
begin
   d := sqrt(N.x*N.x + N.y*N.y + N.z*N.z);
   m := RADI / d;
   Result.x := N.x * m;
   Result.y := N.y * m;
   Result.z := N.z * m;
end;

function DistanceSqr(N1, N2: TPoint): GLFloat;
var
   xd,yd,zd: GLFloat;
begin
   xd := N2.x-N1.x;
   yd := N2.y-N1.y;
   zd := N2.z-N1.z;
   Result := (xd*xd + yd*yd + zd*zd);
end;

function Distance(N1, N2: TPoint): GLFloat;
var
   xd,yd,zd: GLFloat;
begin
   xd := N2.x-N1.x;
   yd := N2.y-N1.y;
   zd := N2.z-N1.z;
   Result := sqrt(xd*xd + yd*yd + zd*zd);
end;

function Closest(p: TPoint): integer;
var
   count: integer;
   d, m: GLfloat;
begin
   m := 1000.0;
   result := 0;
      for count := 1 to MAX_DUST do
      begin
            d := Distance(p, Dust[count,0]);

            if d < m then
            begin
               m := d;
               result := count;
            end;

      end;
end;

function ClosestDot(p: TPoint): integer;
var
   count: integer;
   d, m: GLfloat;
   dp: TPoint;
begin
   m := 1000.0;
   result := 0;
      for count := 1 to MAX_DUST do
      begin
         with Form1.TransformDust do
         begin
           dp.x := Dust[count,0].x +TranX;
           dp.y := Dust[count,0].y +TranY;
           dp.z := Dust[count,0].z +TranZ;
         end;
            d := Distance(p, dp);

            if d < m then
            begin
               m := d;
               result := count;
            end;

      end;
end;

procedure TForm1.AverageDist;
var
   count, count2, count3: integer;
   d: GLfloat;
begin
   d := 0.0;
   count2 := 1;
   count3 := 0;
   for count := 1 to (so_far div 3) do
   begin
      d := d +Distance(Tri[count2   ],Tri[count2 +1]);
      inc(count3);
      d := d +Distance(Tri[count2 +1],Tri[count2 +2]);
      inc(count3);
      d := d +Distance(Tri[count2 +2],Tri[count2  ]);
      inc(count3);
      count2 := count2 +3;
   end;
   d := d / count3;
//   Form1.Caption := FloatToStr(d);
end;

procedure TForm1.CopyDusty;
var
   count: integer;
begin
   for count := 1 to MAX_DUST do
   begin
      Dusty[count].x := Dust[count,0].x;
      Dusty[count].y := Dust[count,0].y;
      Dusty[count].z := Dust[count,0].z;
   end;
   Dustinator := not Dustinator;
end;

procedure TForm1.AssignTriang;
var
   count, count2: integer;
begin
   if not dustinator then
      exit;

   for count := 1 to so_far do
   begin
      for count2 := 1 to MAX_DUST do
      begin
         with dusty[count2] do
         begin
            if (Tri[count].x = x) and
               (Tri[count].y = y) and
               (Tri[count].z = z)
               then Triang[count] := count2;
         end;
      end;
   end;
   triangulator := not triangulator;
end;

procedure TForm1.SphereDust;
var
   count : integer;
begin
   for count := 1 to MAX_DUST do
         Dust[count,0] := Normalize(Dust[count,0]);
end;

procedure TForm1.SpreadDust;
var
   count, count2, s1, s2: integer;
   x1,y1,z1, x2,y2,z2,
   xd,yd,zd, d, m,
   percent: GLFloat;
begin
   m := 2.0;
   s1 := 0;
   s2 := 0;

   for count := 1 to MAX_DUST do
   begin
      for count2 := 1 to MAX_DUST do
      begin
         if count <> count2 then
         begin
            d := Distance(Dust[count,0], Dust[count2,0]);

            if d < m then
            begin
               m := d;
               s1 := count;
               s2 := count2;
            end;

         end;
      end;
   end;

   if (m < 1.0) and
      (s1 <> 0) and
      (s2 <> 0) and
      (s1 <> s2) then
   begin
      inc(pass);
      f1 := s1;
      f2 := s2;
            x1 := Dust[s1,0].x;
            y1 := Dust[s1,0].y;
            z1 := Dust[s1,0].z;

            x2 := Dust[s2,0].x;
            y2 := Dust[s2,0].y;
            z2 := Dust[s2,0].z;

      // move point 2 away by 20%
      percent := 1.2;
//      if (m > 0.09) then
//         percent :=  0.1220 / m;
//      if (m < 0.01) then
//         percent := 10.0;

      xd := x2 - x1;
      yd := y2 - y1;
      zd := z2 - z1;

      dust[s2,0].x := (xd * percent) + x1;
      dust[s2,0].y := (yd * percent) + y1;
      dust[s2,0].z := (zd * percent) + z1;

      // move point 1 away by 20%
      xd := x1 - x2;
      yd := y1 - y2;
      zd := z1 - z2;

      dust[s1,0].x := (xd * percent) + x2;
      dust[s1,0].y := (yd * percent) + y2;
      dust[s1,0].z := (zd * percent) + z2;

      // normalize distances for 2 points
      Dust[s1,0] := Normalize(Dust[s1,0]);
      Dust[s2,0] := Normalize(Dust[s2,0]);
   end;

   // info calc for caption text output
{   d := Distance(Dust[s1,0], Dust[s2,0]);

   form1.Caption := Format(
                    'small: %6d  pass: %6d  %6d %6d   %0.7f',
                          [small,     pass,    s1, s2,    d]);
}
{    'small: '+IntToStr(small)
                   +' pass: '+IntToStr(pass)
                   +'   ' +IntToStr(s1)
                   +',  ' +IntToStr(s2)
                   +'   ' +FloatToStr(d);}
end;

procedure TForm1.CollectDust;
const
   OPTIM = 0.1220;
var
   count, count2,
   s1,s2,s3,s4: Integer;
   d, m,m3,m4, dx,dy,dz, reduce: GLFloat;
begin
   last_small := Small;
   s1 := 0;
   s2 := 0;
   s3 := 0;
   s4 := 0;
   m3 := 0.0;
   m4 := 0.0;

   for count := 1 to MAX_DUST do
   begin
      m := 1.2;

      for count2 := 1 to MAX_DUST do
      begin
         d := Distance(Dust[count,0], Dust[count2,0]);

         if count <> count2 then
            if d < m then
            begin
               s4 := s3;
               m4 := m3;
               s3 := s2;
               m3 := m;

               m := d;
               s1 := count;
               s2 := count2;
            end;
      end;

      if m > OPTIM then
      begin
         inc(Small);
         dx := Dust[s1,0].x - Dust[s2,0].x;
         dy := Dust[s1,0].y - Dust[s2,0].y;
         dz := Dust[s1,0].z - Dust[s2,0].z;
         reduce := OPTIM / m;

         Dust[s2,0].x := (dx * reduce) +Dust[s2,0].x;
         Dust[s2,0].y := (dy * reduce) +Dust[s2,0].y;
         Dust[s2,0].z := (dz * reduce) +Dust[s2,0].z;

         Dust[s2,0] := Normalize(Dust[s2,0]);
      end;

      if (m3 > OPTIM) and
         (s3 <> 0)  then
      begin
         dx := Dust[s1,0].x - Dust[s3,0].x;
         dy := Dust[s1,0].y - Dust[s3,0].y;
         dz := Dust[s1,0].z - Dust[s3,0].z;
         reduce := OPTIM / m3;

         Dust[s3,0].x := (dx * reduce) +Dust[s3,0].x;
         Dust[s3,0].y := (dy * reduce) +Dust[s3,0].y;
         Dust[s3,0].z := (dz * reduce) +Dust[s3,0].z;

         Dust[s3,0] := Normalize(Dust[s3,0]);
      end;

      if (m4 > OPTIM) and
         (s4 <> 0) then
      begin
         dx := Dust[s1,0].x - Dust[s4,0].x;
         dy := Dust[s1,0].y - Dust[s4,0].y;
         dz := Dust[s1,0].z - Dust[s4,0].z;
         reduce := OPTIM / m4;

         Dust[s4,0].x := (dx * reduce) +Dust[s4,0].x;
         Dust[s4,0].y := (dy * reduce) +Dust[s4,0].y;
         Dust[s4,0].z := (dz * reduce) +Dust[s4,0].z;

         Dust[s4,0] := Normalize(Dust[s4,0]);
      end;
   end;

end;

procedure TForm1.VectorDust;
const
   deFRACT = 100;
var
   count, count2: integer;
   x1,y1,z1, x2,y2,z2,
   xd,yd,zd, d: GLFloat;
begin
   for count := 1 to MAX_DUST do
   begin
      for count2 := 1 to MAX_DUST do
      begin
            x1 := Dust[count,0].x *deFRACT;
            y1 := Dust[count,0].y *deFRACT;
            z1 := Dust[count,0].z *deFRACT;

            x2 := Dust[count2,0].x *deFRACT;
            y2 := Dust[count2,0].y *deFRACT;
            z2 := Dust[count2,0].z *deFRACT;

         xd := x2-x1;
         yd := y2-y1;
         zd := z2-z1;
         d := xd*xd + yd*yd + zd*zd;
//         if d < 100 then d := 1;
         if d <> 0 then
            d := 1/d;
         with Dust[count2,1] do
         begin
            x := x -(xd * d);
            Dust[count2,0].x := Dust[count2,0].x + x;
            y := y -(yd * d);
            Dust[count2,0].y := Dust[count2,0].y + y;
            z := z -(zd * d);
            Dust[count2,0].z := Dust[count2,0].z + z;
         end;
      end;
         if count = 100 then
{            form1.Caption := FloatToStr(dust[count-1,1].x)
             +'   '+FloatToStr(dust[count-1,1].y)
             +'   '+FloatToStr(dust[count-1,1].z)
             ;           }
   end;
end;

procedure TForm1.BuildTerrain;
var
   row, ix: integer;
   q: GLfloat;
begin
   Randomize;
   for row := -32 to 32 do
   begin
      q := -17.0;
      for ix := 1 to 66 do
      with ter[row,ix] do
      begin
         y := -1.5+0.001 * Random(500);
         if odd(ix) then
         begin
            q := q+1.0;
            x := q+0.1-0.001 * Random(201);
            z := 0.001 * Random(450)+row;
         end else begin
            x := q;
            z := 1.0 - 0.001 *Random(450)+row;
         end;
      end;
   end;

   for row := -32 to 31 do
      for ix := 1 to 33 do
         ter[row+1,2*ix-1] := ter[row,2*ix];
end;

procedure TForm1.DrawTerrain;
var
   ix, row, extra, start, finish: integer;
   s: GLfloat;
   t: array[false..true] of GLfloat;
   tt: boolean;
begin
   extra := round(abs(10.0*cos(theta)));
   start := round(-wz);
   finish := start;
   start := start-10-extra;
   if start <-32 then start := -32;
   finish := finish+10+extra;
   if finish > 32 then finish := 32;

   glTexImage2D(GL_TEXTURE_2D,Level,ColorComps,sGrass,tGrass,Border,
            GL_RGB,GL_UNSIGNED_BYTE,Grass);
   glEnable(GL_TEXTURE_2D);
   for row := start to finish do
   begin
      s := 0.0;
      t[false] := 0.0;
      t[true] := 2.0;
      tt := false;
      glBegin(GL_TRIANGLE_STRIP);
      for ix := 1 to 66 do
      with ter[row,ix] do
      begin
         glNormal3f(0.0,1.0,0.0);
         glTexCoord2f(s,t[tt]);
         glVertex3f(x,y,z);
         if tt then
            s := s+1.0;
         tt := not tt;
      end;
      glEnd;
   end;
   glDisable(GL_TEXTURE_2D);
end;

procedure TForm1.BuildWall;
var
   q: GLfloat;
   ix: integer;
begin
   q := -2.0;
   for ix := 1 to 14 do
   with wall[ix] do
   if odd(ix) then
   begin
      q := q+1.0;
      x := q;
      y := +1.0;
   end else begin
      x := q;
      y := -1.0;
   end;

   q := q+1.0;
   for ix := 15 to 28 do
   with wall[ix] do
   if odd(ix) then
   begin
      q := q-1.0;
      x := q;
      y := 1.0;
      z := -0.5;
   end else begin
      x := q;
      y := -1.0;
      z := -0.5;
   end;
end;

procedure TForm1.Cube;
begin
   glNormal3f(0.0,0.0,1.0);
   glBegin(GL_POLYGON);  {near face}
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(+0.4,-0.4,+0.4);
      glVertex3f(+0.4,+0.4,+0.4);
      glVertex3f(-0.4,+0.4,+0.4);
   glEnd;

   glNormal3f(1.0,0.0,0.0);
   glBegin(GL_POLYGON);  {right face}
      glVertex3f(+0.4,-0.4,+0.4);
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(+0.4,+0.4,-0.4);
      glVertex3f(+0.4,+0.4,+0.4);
   glEnd;

   glNormal3f(-1.0,0.0,0.0);
   glBegin(GL_POLYGON);  {left face}
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(-0.4,+0.4,+0.4);
      glVertex3f(-0.4,+0.4,-0.4);
   glEnd;

   glNormal3f(0.0,0.0,-1.0);
   glBegin(GL_POLYGON);  {back face}
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(-0.4,+0.4,-0.4);
      glVertex3f(+0.4,+0.4,-0.4);
   glEnd;

   glNormal3f(0.0,-1.0,0.0);
   glBegin(GL_POLYGON);  {bottom face}
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(+0.4,-0.4,+0.4);
   glEnd;

   glNormal3f(0.0,1.0,0.0);
   glBegin(GL_POLYGON);  {top face}
      glVertex3f(-0.4,+0.4,+0.4);
      glVertex3f(+0.4,+0.4,+0.4);
      glVertex3f(+0.4,+0.4,-0.4);
      glVertex3f(-0.4,+0.4,-0.4);
   glEnd;
end;

procedure TForm1.Cube2;
begin
   glNormal3f(0.0,0.0,1.0);
   glBegin(GL_POLYGON);  {near face}
      glTexCoord2f(-1,-1);
      glColor3f(1.0,0.0,0.0);
      glVertex3f(-0.4,-0.4,+0.4);
      glTexCoord2f( 1,-1);
      glColor3f(0.0,1.0,0.0);
      glVertex3f(+0.4,-0.4,+0.4);
      glTexCoord2f( 1, 1);
      glColor3f(0.0,0.5,0.5);
      glVertex3f(+0.4,+0.4,+0.4);
      glTexCoord2f(-1, 1);
      glColor3f(0.0,0.0,1.0);
      glVertex3f(-0.4,+0.4,+0.4);
   glEnd;

   glNormal3f(1.0,0.0,0.0);
   glBegin(GL_POLYGON);  {right face}
      glVertex3f(+0.4,-0.4,+0.4);
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(+0.4,+0.4,-0.4);
      glVertex3f(+0.4,+0.4,+0.4);
   glEnd;

   glNormal3f(-1.0,0.0,0.0);
   glBegin(GL_POLYGON);  {left face}
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(-0.4,+0.4,+0.4);
      glVertex3f(-0.4,+0.4,-0.4);
   glEnd;

   glNormal3f(0.0,0.0,-1.0);
   glBegin(GL_POLYGON);  {back face}
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(-0.4,+0.4,-0.4);
      glVertex3f(+0.4,+0.4,-0.4);
   glEnd;

   glNormal3f(0.0,-1.0,0.0);
   glBegin(GL_POLYGON);  {bottom face}
      glVertex3f(-0.4,-0.4,+0.4);
      glVertex3f(-0.4,-0.4,-0.4);
      glVertex3f(+0.4,-0.4,-0.4);
      glVertex3f(+0.4,-0.4,+0.4);
   glEnd;

   glNormal3f(0.0,1.0,0.0);
   glBegin(GL_POLYGON);  {top face}
      glVertex3f(-0.4,+0.4,+0.4);
      glVertex3f(+0.4,+0.4,+0.4);
      glVertex3f(+0.4,+0.4,-0.4);
      glVertex3f(-0.4,+0.4,-0.4);
   glEnd;
end;

procedure TForm1.CylinderBase;
var
   around: integer;
   pi18: double;
begin
   pi18 := pi/18.0;
   for around := 0 to 35 do
   begin
      circleX[around] := 0.4 * sin(around*pi18);
      circleY[around] := 0.4 * cos(around*pi18);
   end;
end;

procedure TForm1.Cylinder;
var
   around: integer;
begin
   glBegin(GL_TRIANGLE_STRIP);
     for around := 0 to 35 do
     begin
        glNormal3f(circleX[around],circleY[around],0.0);
        glVertex3f(circleX[around],circleY[around],0.0);
        glVertex3f(circleX[around],circleY[around],1.0);
     end;
     glNormal3f(circleX[0],circleY[0],0.0);
     glVertex3f(circleX[0],circleY[0],0.0);
     glVertex3f(circleX[0],circleY[0],1.0);
   glEnd;
end;

procedure TForm1.Idle(Sender: TObject; var Done: boolean);
begin
//
end;


procedure TForm1.Adjust;
var
{   viewerx,
   viewerz,
   minX,
   deltax,
   deltaz,
   distance, }
   savex,
   savey,
   savez: GLfloat;
{   ix,
   start,
   finish,
   strip : integer;}

function restore: boolean;
   begin
      result := true;
      wx := savex;
      wy := saveY;
      wz := savez;
   end;
begin
   if MY_T then begin
      scale_dust := scale_dust * 1.05;
      TransformDust.ScaleX := scale_dust;
      TransformDust.ScaleY := scale_dust;
      TransformDust.ScaleZ := scale_dust;
   end;
   if MY_G then begin
      scale_dust := scale_dust * 0.95;
      TransformDust.ScaleX := scale_dust;
      TransformDust.ScaleY := scale_dust;
      TransformDust.ScaleZ := scale_dust;
   end;
   if MY_UP then
   begin
//      Scalum := Scalum * 0.8;
//      speed := speed * 0.7;
      tran := +speed;
   end;
   if MY_DOWN then
   begin
//      Scalum := Scalum * 1.2;
//      speed := speed * 1.3;
      tran := -speed;
   end;
   if MY_LEFT then rot := -rspeed;
   if MY_LEFT2 then
   begin
      ang2 := ang2 + rspeed;
      if ang2 > 360.0 then ang2 := ang2 -360.0;
   end;
   if MY_RIGHT then rot := +rspeed;
   if MY_RIGHT2 then
   begin
      ang2 := ang2 - rspeed;
      if ang2 <   0.0 then ang2 := ang2 +360.0;
   end;
   if MY_E then
   begin
      ang3 := ang3 + rspeed;
      if ang3 > 360.0 then ang3 := ang3 -360.0;
      //alt := alt -speed;
   end;
   if MY_D then
   begin
      ang3 := ang3 - rspeed;
      if ang3 <   0.0 then ang3 := ang3 +360.0;
      //alt := alt +speed;
   end;

   angl := angl+rot;
   if angl > 360.0 then angl := angl -360.0;
   if angl <   0.0 then angl := angl +360.0;

   theta := angl *pi180;
   savex := wx;
   wx := wx -tran *sin(theta);
   savez := wz;
   wz := wz +tran *cos(theta);

{   strip := round(-wz);
   start := round(-wx)+34;
   finish := start+6;
   dec(start,5);
   minx := 99999.9;
   savey := wy;

   if (finish<1) or (start> 66) or (strip<-32) or (strip>32) then
      wy := 0
   else
   for ix := start to finish do
   with ter[strip,ix] do
   begin
      deltaX := abs(x-wx);
      if deltaX<minx then
      begin
         minx := deltaX;
         wy := -1.45-y;
      end;
   end;                }
   wy := wy +alt;

{   viewerx := -wx;
   viewerz := -wz;

   with TransformPole do
   begin
      deltax := tranX-viewerx;
      deltaz := tranZ-viewerz;
      distance := sqrt(deltax*deltax+deltaz*deltaz);
      if (distance< 2.115) and restore then
         exit;
   end;

   with TransformWall do
   begin
      ix := 0;
      repeat
         inc(ix,2);
         with wall[ix] do
         begin
            deltax := x-viewerx;
            deltaz := Tranz+z-viewerz;
         end;
         distance := sqrt(deltax*deltax+deltaz*deltaz);
         if (distance<2.42) and restore then
            exit;
      until ix=28;
   end;

   with TransformGlobe do
   begin
      deltax := TranX -viewerx;
      deltaz := Tranz -viewerz;
      distance := sqrt(deltax*deltax+deltaz*deltaz);
      if (distance <4.14) and restore then
         exit;
   end;
}
{   with TransformWall do
   begin
      deltax := TranX-viewerx;
      deltaz := TranZ-viewerz;
      distance := sqrt(deltax*deltax+deltaz*deltaz);
      if (distance < 2.67) then
      begin
         if (distance<2.42) and restore then
            exit;
         deltax := TranX+0.4-viewerx;
         deltaz := tranz+0.4-viewerz;
         distance := sqrt(deltax*deltax+deltaz*deltaz);
         if (distance<2.42) and restore then
            exit;

         deltax := TranX+0.4-viewerx;
         deltaz := tranz-0.4-viewerz;
         distance := sqrt(deltax*deltax+deltaz*deltaz);
         if (distance<2.42) and restore then
            exit;

         deltax := TranX-0.4-viewerx;
         deltaz := tranz+0.4-viewerz;
         distance := sqrt(deltax*deltax+deltaz*deltaz);
         if (distance<2.42) and restore then
            exit;

         deltax := TranX-0.4-viewerx;
         deltaz := tranz-0.4-viewerz;
         distance := sqrt(deltax*deltax+deltaz*deltaz);
         if (distance<2.42) and restore then
            exit;
      end;
   end;}

end;

procedure TForm1.TRansformPolePaint(Sender: TObject);
begin
   MaterialPole.Apply;
   Cylinder;
end;

procedure TForm1.Opening;
begin
   glEnable(GL_TEXTURE_2D);

   glTexImage2D( GL_TEXTURE_2D, Level, ColorComps,sBulk,tBulk,Border,
                GL_RGB,GL_UNSIGNED_BYTE,bulk);

   glBegin(GL_POLYGON);
      glTexCoord2f( 0.0, 0.0);  glVertex3f(-1.0, 1.0,-2.0);
      glTexCoord2f( 0.0, 7.0);  glVertex3f(-1.0,-1.0,-2.0);
      glTexCoord2f( 1.0, 7.0);  glVertex3f(-0.7,-1.0,-2.0);
      glTexCoord2f( 1.0, 0.0);  glVertex3f(-0.7, 1.0,-2.0);
   glEnd;

   glBegin(GL_POLYGON);
      glTexCoord2f( 0.0, 0.0);  glVertex3f(-0.7, 1.0,-2.0);
      glTexCoord2f( 0.0, 1.0);  glVertex3f(-0.7, 0.7,-2.0);
      glTexCoord2f( 1.0, 1.0);  glVertex3f(-0.4, 0.7,-2.0);
      glTexCoord2f( 1.0, 0.0);  glVertex3f(-0.4, 1.0,-2.0);
   glEnd;

   glBegin(GL_POLYGON);
      glTexCoord2f( 0.0, 0.0);  glVertex3f( 0.7, 1.0,-2.0);
      glTexCoord2f( 0.0, 7.0);  glVertex3f( 0.7,-1.0,-2.0);
      glTexCoord2f( 1.0, 7.0);  glVertex3f( 1.0,-1.0,-2.0);
      glTexCoord2f( 1.0, 0.0);  glVertex3f( 1.0, 1.0,-2.0);
   glEnd;

   glBegin(GL_POLYGON);
      glTexCoord2f( 0.0, 0.0);  glVertex3f( 0.4, 1.0,-2.0);
      glTexCoord2f( 0.0, 1.0);  glVertex3f( 0.4, 0.7,-2.0);
      glTexCoord2f( 1.0, 1.0);  glVertex3f( 0.7, 0.7,-2.0);
      glTexCoord2f( 1.0, 0.0);  glVertex3f( 0.7, 1.0,-2.0);
   glEnd;

   glBegin(GL_POLYGON);
      glTexCoord2f( 0.4, 1.0);  glVertex3f(-1.0, 1.0,-2.0);
      glTexCoord2f( 0.4, 0.7);  glVertex3f(-1.0, 1.0,-2.0);
      glTexCoord2f( 0.7, 0.7);  glVertex3f(-1.0, 1.0,-2.0);
      glTexCoord2f( 0.7, 1.0);  glVertex3f(-1.0, 1.0,-2.0);
   glEnd;

   glDisable(GL_TEXTURE_2D);
end;

procedure TForm1.FormDestroy(Sender: TObject);
begin
    FreeMem(bulk);
    FreeMem(Brick);
    FreeMem(world);
    freeMem(grass);
    gluDeleteQuadric(globe);
end;

procedure TForm1.TRansformGlobePaint(Sender: TObject);
begin
   glPushMatrix;
      glRotatef(ang,0.0,0.0,1.0);

      glEnable(GL_TEXTURE_2D);
      glTexImage2D(GL_TEXTURE_2D,Level,ColorComps,sworld,tWorld,Border,
                   GL_RGB,GL_UNSIGNED_BYTE, world);
      MaterialGlobe.Apply;
      gluSphere(globe, 2.0,18,12);
      glDisable(GL_TEXTURE_2D);

   glPopMatrix;
end;

procedure TForm1.TRansformLandPaint(Sender: TObject);
begin
   MaterialLand.Apply;
   DrawTerrain;
end;

procedure TForm1.TransformCanvasPaint(Sender: TObject);
begin
   MaterialCanvas.Apply;
   Cube;
end;

procedure TForm1.TransformDustPaint(Sender: TObject);
begin
   glpushMatrix;
//   glScalef(scalum,scalum, scalum);
      glRotatef(ang2, 0.0,1.0,0.0);
      glRotatef(ang3, 1.0,0.0,0.0);

   glRotatef(Vu_ang,1.0,0.0,0.0);
   glRotatef(Vl_ang,0.0,1.0,0.0);

   if (so_far > 2) and
      (MY_Y)
      then begin
            glTexImage2D( GL_TEXTURE_2D, Level, ColorComps,sBulk,tBulk,Border,
                 GL_RGB,GL_UNSIGNED_BYTE,bulk);

{            glTexImage2D(GL_TEXTURE_2D,Level,ColorComps,sGrass,tGrass,Border,
                 GL_RGB,GL_UNSIGNED_BYTE,Grass);

            glTexImage2D(GL_TEXTURE_2D,Level,ColorComps,sBrick,tBrick,Border,
                 GL_RGB,GL_UNSIGNED_BYTE,Brick);

            glTexImage2D(GL_TEXTURE_2D,Level,ColorComps,sworld,tWorld,Border,
                 GL_RGB,GL_UNSIGNED_BYTE, world);

            glTexImage2D( GL_TEXTURE_2D, Level, ColorComps,sBulk,tBulk,Border,
                 GL_RGB,GL_UNSIGNED_BYTE,bulk);
}
   glEnable(GL_TEXTURE_2D);
   MaterialDust.Apply;
          DrawTriangles;
   glDisable(GL_TEXTURE_2D);
      end;
//      else    TransFormCanvas.Apply;

   if MY_B then
      DrawDust;
      // marker box
      glPushMatrix;
      with Dust[Triang[9],0] do
         glTranslatef(x,y,z);
      glScalef(0.05,0.05,0.05);
      cube2;
      glPopMatrix;

   glpopMatrix;
end;

procedure TForm1.Timer1Timer(Sender: TObject);
const
   rollover = 10;
   mspersec = 1000.0;
   half = 1/30000.0;
   fullrot = 360.0;
var
   deltaAngle,
   averageTime,
   timedif: GLfloat;
   count, count2: integer;
begin
   Adjust;
   inc(frames);
   elapsed := TimeGetTime;
   timedif := (elapsed - start);
   averageTime := timedif/frames;
   deltaAngle := fullrot*averageTime*half;
   ang := ang+deltaAngle;
   if ang>= 360.0 then
      ang := ang-360.0;

   if frames >= rollover then
   begin
//      Form1.Caption := Format('fps =%0.1f   Speed =%0.2f   Rot =%0.2f',
//               [rollover*mspersec/(elapsed-start)
//                , speed, rot]);
      start := elapsed;
      frames := 0;
   end;

//   VectorDust;
//   SpreadDust;
   if count_spread > 0 then
   begin
     SpreadDust;
     dec(count_spread);
   end;
   if last_small <> small then
      CollectDust;
//   if pass = 1000 then last_small := -1;
//   if pass > 1000 then
   TimeCodeBegin;
   gravity;
   for count := 0 to 7 do
      for count2 := 0 to 7 do
      begin
         if count <> count2 then
            grav(count, count2);
      end;
   FormPaint(Self);
   TimeCodeEnd;
  { form1.Caption := Format(
                    'scalum: %6f  tran: %6f  wx: %6f  wz: %6f  theta: %6f',
                          [scalum,     tran,      wx,      wz,      theta]);
   }
end;

procedure TForm1.SaveOrb;
var
   SaveStream: TFileStream;
   n: Double;
   count: integer;
   s: string;
begin
   s := ExtractFileDir(Application.ExeName);
   SaveDialog1.InitialDir := s;
   SaveDialog1.FileName := 'aorb1.orb';
   If SaveDialog1.Execute then
   begin
      try
         SaveStream := TFileStream.Create(SaveDialog1.FileName, fmOpenWrite or fmCreate);
         for count := 1 to MAX_DUST do
         begin
            n := Dust[count,0].x;
            SaveStream.Write(N, sizeof(double));
            n := Dust[count,0].y;
            SaveStream.Write(N, sizeof(double));
            n := Dust[count,0].z;
            SaveStream.Write(N, sizeof(double));
         end;
      finally
         SaveStream.Free;
      end;
   end;
end;

procedure TForm1.LoadOrb;
var
   LoadStream: TFileStream;
   n: Double;
   count: integer;
begin
   OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   OpenDialog1.FileName := 'aorb1.orb';
   If OpenDialog1.Execute then
   begin
    try
      LoadStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
      for count := 1 to MAX_DUST do
      begin
         LoadStream.Read(N, sizeof(double));
         Dust[count,0].x := n;
         LoadStream.Read(N, sizeof(double));
         Dust[count,0].y := n;
         LoadStream.Read(N, sizeof(double));
         Dust[count,0].z := n;
      end;
    finally
      LoadStream.Free;
    end;
   end;
end;

procedure TForm1.SavePlanets;
var
   SaveStream: TFileStream;
   i, count: integer;
   f: GLfloat;
   p: TPoint;
   s: string;
begin
   s := ExtractFileDir(Application.ExeName);
   SaveDialog1.InitialDir := s;
   SaveDialog1.FileName := 'apla1.pla';
      try
         SaveStream := TFileStream.Create(SaveDialog1.FileName, fmOpenWrite or fmCreate);
         for count := 1 to MAX_PLANET do
         begin
            i := Sol[count].Ref_planet;
            SaveStream.Write(i, sizeof(integer));
            f := Sol[count].radius;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].mass;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].au;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].axis;
            SaveStream.Write(f, sizeof(GLfloat));
            f := Sol[count].day;
            SaveStream.Write(f, sizeof(GLfloat));
            p := Sol[count].vec;
            SaveStream.Write(p, sizeof(TPoint));
            p := Sol[count].place;
            SaveStream.Write(p, sizeof(TPoint));
         end;
      finally
         SaveStream.Free;
      end;
end;

procedure TForm1.LoadPlanets;
var
   LoadStream: TFileStream;
   i, count: integer;
   f: GLfloat;
   p: TPoint;
begin
   OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   OpenDialog1.FileName := 'apla1.pla';
   if FileExists(openDialog1.Filename) then
        try
         LoadStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
         for count := 1 to MAX_PLANET do
         begin
            LoadStream.Read(i, sizeof(integer));
            Sol[count].Ref_planet := i;
            LoadStream.Read(f, sizeof(GLfloat));
            Sol[count].radius := f;
            LoadStream.Read(f, sizeof(GLfloat));
            Sol[count].mass := f;
            LoadStream.Read(f, sizeof(GLfloat));
            Sol[count].au := f;
            LoadStream.Read(f, sizeof(GLfloat));
            Sol[count].axis := f;
            LoadStream.Read(f, sizeof(GLfloat));
            Sol[count].day := f;
            LoadStream.Read(p, sizeof(TPoint));
            Sol[count].vec := p;
            LoadStream.Read(p, sizeof(TPoint));
            Sol[count].place := p;
         end;
       finally
         LoadStream.Free;
       end
   else
      InitSolarSystem;
end;

procedure TForm1.SaveTriangles;
var
   SaveStream: TFileStream;
   n: Double;
   count: integer;
   s: string;
begin
   s := ExtractFileDir(Application.ExeName);
   SaveDialog1.InitialDir := s;
   SaveDialog1.FileName := 'atri1.tri';
   If SaveDialog1.Execute then
   begin
      try
         SaveStream := TFileStream.Create(SaveDialog1.FileName, fmOpenWrite or fmCreate);
         count := so_far;
         SaveStream.Write(count, sizeof(integer));
         for count := 1 to so_far do
         begin
            n := tri[count].x;
            SaveStream.Write(N, sizeof(double));
            n := tri[count].y;
            SaveStream.Write(N, sizeof(double));
            n := tri[count].z;
            SaveStream.Write(N, sizeof(double));
         end;
      finally
         SaveStream.Free;
      end;
   end;
end;

procedure TForm1.LoadTriangles;
var
   LoadStream: TFileStream;
   n: Double;
   count: integer;
begin
   OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   OpenDialog1.FileName := 'atri1.tri';
   If OpenDialog1.Execute then
   begin
    try
      LoadStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
      LoadStream.Read(count, sizeof(integer));
      so_far := count;
      for count := 1 to so_far do
      begin
         LoadStream.Read(N, sizeof(double));
         tri[count].x := n;
         LoadStream.Read(N, sizeof(double));
         tri[count].y := n;
         LoadStream.Read(N, sizeof(double));
         tri[count].z := n;
      end;
    finally
      LoadStream.Free;
    end;
   end;
{   form1.Caption := Format(
                    'selno: %6d  so_far: %6d',
                          [2, so_far]);}
end;

procedure TForm1.InitializeOrb;
var
   LoadStream: TFileStream;
   n: Double;
   count: integer;
begin
   OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   OpenDialog1.FileName := 'aorb1.orb';
    try
      LoadStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
      for count := 1 to MAX_DUST do
      begin
         LoadStream.Read(N, sizeof(double));
         Dust[count,0].x := n;
         LoadStream.Read(N, sizeof(double));
         Dust[count,0].y := n;
         LoadStream.Read(N, sizeof(double));
         Dust[count,0].z := n;
      end;
    finally
      LoadStream.Free;
    end;

   OpenDialog1.InitialDir := ExtractFileDir(Application.ExeName);
   OpenDialog1.FileName := 'atri1.tri';
    try
      LoadStream := TFileStream.Create(OpenDialog1.FileName, fmOpenRead);
      LoadStream.Read(count, sizeof(integer));
      so_far := count;
      for count := 1 to so_far do
      begin
         LoadStream.Read(N, sizeof(double));
         tri[count].x := n;
         LoadStream.Read(N, sizeof(double));
         tri[count].y := n;
         LoadStream.Read(N, sizeof(double));
         tri[count].z := n;
      end;
    finally
      LoadStream.Free;
    end;

    CopyDusty;
    NormalizeTreb;
    AssignTriang;
    InitTexMap;
    loadPlanets;
end;

procedure TForm1.FormMouseMove(Sender: TObject; Shift: TShiftState; X,
  Y: Integer);
var
   center_x, center_y,
   deltaX, deltaY: integer;
   pi18: double;
   ratio, changeX, changeY: GLfloat;
begin
   if ssShift in Shift then
   begin
      pi18 := pi/18.0;
      center_x := Form1.ClientWidth div 2;
      center_y := Form1.ClientHeight div 2;

      Vu_ang := (y -center_y) *-Pi18;
      Vl_ang := (center_x -x) *Pi18;
   end else begin
      if startX<0 then
         exit;

      deltaX := x-startX;
      deltaY := starty-y;
      with dust[selected_dust,0],OpenGL1 do
      begin
         ratio := -z/prxNear;
         changeX := deltaX*(prxRight-prxLeft)/ClientWidth;
         changeY := deltaY*(prxTop-prxBottom)/ClientHeight;
         x := trnX+changeX*ratio;
         y := trnY+changeY*ratio;
         //dippy
      end;
      dust[selected_dust,0] := Normalize(dust[selected_dust,0]);
   end;
end;

procedure TForm1.FormMouseDown(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
const
   countElement=1;
   nearElement=1;
   farElement=1;
var
   selno, place: integer;
   hit, hits: GLint;
   ahit: PHit;
   mx, nearer, nearest: double;
begin
   Selection(x,y);
   with OpenGL1 do
      glFrustum(prxLeft,prxRight,prxBottom,prxTop,prxNear,prxFar);
   FormPaint(nil);
   hits := SelectionDone;
   if (hits<1) then
      exit;
   place := 1;
   nearest := 9e33;
   mx := maxint;

   selno := 0;
   for hit := 1 to hits do
   begin
      ahit := @PickBuffer[place];
      with ahit^ do
      begin
         nearer := dnear;
         if nearer<0 then
         begin
            nearer := mx+nearer;
            nearer := mx+nearer;
         end;
         if nearer<nearest then
         begin
            nearest := nearer;
            selno := names[1];
         end;
         place := place+countElement+nearElement+farElement+ncount;
      end;
   end;

   if (selno > 0) and
      (selno < MAX_DUST+1) then
   begin
      selected_dust := selNo;
      StartX := X;
      StartY := Y;
      startShift := Shift;
      with dust[selno,0] do
      begin
         trnX := x;
         trnY := y;
         trnZ := z;
      end;

{      if Button = mbLeft then
      begin
         inc(so_far);
         with dust[selno,0] do
         begin
            tri[so_far].x := x;
            tri[so_far].y := y;
            tri[so_far].z := z;
         end;
      end else begin
         dec(so_far);
         if so_far < 0 then so_far := 0;
      end;}
   end;
{   form1.Caption := Format(
                    'selno: %6d  so_far: %6d',
                          [selno, so_far]);}
end;

procedure TForm1.FormMouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
begin
   StartX := -1;
end;

procedure TForm1.TRansformBallPaint(Sender: TObject);
begin
   MaterialDust.Apply;
   glpushMatrix;
      glRotatef(ang2, 0.0,1.0,0.0);
      glRotatef(ang3, 1.0,0.0,0.0);

//   glRotatef(Vu_ang,1.0,0.0,0.0);
//   glRotatef(Vl_ang,0.0,1.0,0.0);

   if so_far > 2
      then DrawTriangles;

   glpopMatrix;
end;

procedure TForm1.InitSolarSystem;
var
   count : integer;
begin
   // sol
   Sol[0].Ref_planet := 0;
   Sol[0].radius   := 695000.0;
   Sol[0].mass     := 1989000.0 * power(10, PLANET_MASS_SCALAR);
   Sol[0].au       := 0.0;
   Sol[0].axis     := 0.0;
   Sol[0].day      := 0.0;
   Sol[0].vec.x    := 0.0;
   Sol[0].vec.y    := 0.0;
   Sol[0].vec.z    := 0.0;
   Sol[0].place.x  := Sol[Sol[0].Ref_planet].Place.x +Sol[0].Au;
   Sol[0].place.y  := Sol[Sol[0].Ref_planet].Place.y;
   Sol[0].place.z  := Sol[Sol[0].Ref_planet].Place.z;

   // mercury
   Sol[1].Ref_planet := 0;
   Sol[1].radius := 2440.0;
   Sol[1].mass := 0.330 * power(10, PLANET_MASS_SCALAR);
   Sol[1].au := 0.38 * au;
   Sol[1].axis := 0.0;
   Sol[1].day := 0.0;
   Sol[1].vec.x    := 0.0;
   Sol[1].vec.y    := 47.87 *VECTOR_PLAY;
   Sol[1].vec.z    := 0.0;
   Sol[1].place.x  := Sol[Sol[1].Ref_planet].Place.x +Sol[1].Au;
   Sol[1].place.y  := Sol[Sol[1].Ref_planet].Place.y;
   Sol[1].place.z  := Sol[Sol[1].Ref_planet].Place.z;

   // venus
   Sol[2].Ref_planet := 0;
   Sol[2].radius := 6051.8;
   Sol[2].mass := 4.869 * power(10, PLANET_MASS_SCALAR);
   Sol[2].au := 0.72 * au;
   Sol[2].axis := 0.0;
   Sol[2].day := 0.0;
   Sol[2].vec.x    := 0.0;
   Sol[2].vec.y    := 35.02 *VECTOR_PLAY;
   Sol[2].vec.z    := 0.0;
   Sol[2].place.x  := Sol[Sol[2].Ref_planet].Place.x +Sol[2].Au;
   Sol[2].place.y  := Sol[Sol[2].Ref_planet].Place.y;
   Sol[2].place.z  := Sol[Sol[2].Ref_planet].Place.z;

   // terra
   Sol[3].Ref_planet := 0;
   Sol[3].radius := 6371.0;
   Sol[3].mass := 5.9736 * power(10, PLANET_MASS_SCALAR);
   Sol[3].au := 1 * au;
   Sol[3].axis := 0.0;
   Sol[3].day := 0.0;
   Sol[3].vec.x    := 0.0;
   Sol[3].vec.y    := 29.78 *VECTOR_PLAY;
   Sol[3].vec.z    := 0.0;
   Sol[3].place.x  := Sol[Sol[3].Ref_planet].Place.x +Sol[3].Au;
   Sol[3].place.y  := Sol[Sol[3].Ref_planet].Place.y;
   Sol[3].place.z  := Sol[Sol[3].Ref_planet].Place.z;

   // luna
   Sol[4].Ref_planet := 3;
   Sol[4].radius := 1738.0;
   Sol[4].mass := 0.0735 * power(10, PLANET_MASS_SCALAR);
   Sol[4].au := 0.002569553 * au;
   Sol[4].axis := 0.0;
   Sol[4].day := 0.0;
   Sol[4].vec.x    := 0.0;
   Sol[4].vec.y    := (1.023 *VECTOR_PLAY) +Sol[Sol[4].Ref_planet].vec.y;
   Sol[4].vec.z    := 0.0;
   Sol[4].place.x  := Sol[Sol[4].Ref_planet].Place.x
                     +Sol[4].Au
                     +Sol[Sol[4].Ref_planet].radius;
   Sol[4].place.y  := Sol[Sol[4].Ref_planet].Place.y;
   Sol[4].place.z  := Sol[Sol[4].Ref_planet].Place.z;

   // mars
   Sol[5].Ref_planet := 0;
   Sol[5].radius := 3397.0;
   Sol[5].mass := 0.64219 * power(10, PLANET_MASS_SCALAR);
   Sol[5].au := 1.52 * au;
   Sol[5].axis := 0.0;
   Sol[5].day := 0.0;
   Sol[5].vec.x    := 0.0;
   Sol[5].vec.y    := (24.13 *VECTOR_PLAY);
   Sol[5].vec.z    := 0.0;
   Sol[5].place.x  := Sol[Sol[5].Ref_planet].Place.x +Sol[5].Au;
   Sol[5].place.y  := Sol[Sol[5].Ref_planet].Place.y;
   Sol[5].place.z  := Sol[Sol[5].Ref_planet].Place.z;

   // phobos
   Sol[6].Ref_planet := 5;
   Sol[6].radius := 11.1;
   Sol[6].mass := 0.0000000108 * power(10, PLANET_MASS_SCALAR);
   Sol[6].au := 0.000062688 * au;
   Sol[6].axis := 0.0;
   Sol[6].day := 0.0;
   Sol[6].vec.x    := 0.0;
   Sol[6].vec.y    := (2.14 *VECTOR_PLAY) +Sol[Sol[6].Ref_planet].vec.y;
   Sol[6].vec.z    := 0.0;
   Sol[6].place.x  := Sol[Sol[6].Ref_planet].Place.x
                     +Sol[Sol[6].Ref_planet].radius
                     +Sol[6].Au;
   Sol[6].place.y  := Sol[Sol[6].Ref_planet].Place.y;
   Sol[6].place.z  := Sol[Sol[6].Ref_planet].Place.z;

   // deimos
   Sol[7].Ref_planet := 5;
   Sol[7].radius := 6.3;
   Sol[7].mass := 0.0000000018 * power(10, PLANET_MASS_SCALAR);
   Sol[7].au := 0.00015681 * au;
   Sol[7].axis := 0.0;
   Sol[7].day := 0.0;
   Sol[7].vec.x    := 0.0;
   Sol[7].vec.y    := (1.36 *VECTOR_PLAY) +Sol[Sol[7].Ref_planet].vec.y;
   Sol[7].vec.z    := 0.0;
   Sol[7].place.x  := Sol[Sol[7].Ref_planet].Place.x
                     +Sol[Sol[7].Ref_planet].radius
                     +Sol[7].Au;
   Sol[7].place.y  := Sol[Sol[7].Ref_planet].Place.y;
   Sol[7].place.z  := Sol[Sol[7].Ref_planet].Place.z;

   for count := 8 to MAX_PLANET do begin
        //
        Sol[count].Ref_planet := 5;
        Sol[count].radius := 6.3;
        Sol[count].mass := 0.0000000018 * power(10, PLANET_MASS_SCALAR);
        Sol[count].au := 0.00015681 * au;
        Sol[count].axis := 0.0;
        Sol[count].day := 0.0;
        Sol[count].vec.x    := 0.0;
        Sol[count].vec.y    := (1.36 *VECTOR_PLAY) +Sol[Sol[count].Ref_planet].vec.y;
        Sol[count].vec.z    := 0.0;
        Sol[count].place.x  := Sol[Sol[count].Ref_planet].Place.x
                     +Sol[Sol[count].Ref_planet].radius
                     +Sol[count].Au;
        Sol[count].place.y  := Sol[Sol[count].Ref_planet].Place.y;
        Sol[count].place.z  := Sol[Sol[count].Ref_planet].Place.z;
   end;

end;

procedure TForm1.InitTexMap;
var
   count: integer;
begin
   FirstTriangle;
   for count := 2 to (so_far div 3) do
      NextTriangle(count);
   for count := 1 to (so_far div 3) do
      NextAdjacentTriangle(count);
end;

function GetVector(p1, p2: TPoint): TPoint;
begin
   with Result do
   begin
      x := p2.x - p1.x;
      y := p2.y - p1.y;
      z := p2.z - p1.z;
   end;
end;

function Dot(v1, v2: Tpoint): GLfloat;
begin
   //
   v1 := normalize(v1);
   v2 := normalize(v2);
      Result :=
              +(v1.x * v2.x)
              +(v1.y * v2.y)
              +(v1.z * v2.z);
end;

procedure TForm1.FirstTriangle;
var
   pt1, pt2, pt3, v12, v13: TPoint;
   d12, scale_it, ang_1, ang_t, dista: GLFloat;
begin
   pt1.x := Dust[Triang[1],0].x;
   pt1.y := Dust[Triang[1],0].y;
   pt1.z := Dust[Triang[1],0].z;
   pt2.x := Dust[Triang[2],0].x;
   pt2.y := Dust[Triang[2],0].y;
   pt2.z := Dust[Triang[2],0].z;
   pt3.x := Dust[Triang[3],0].x;
   pt3.y := Dust[Triang[3],0].y;
   pt3.z := Dust[Triang[3],0].z;

   TTC[1].c.x := 0;
   TTC[1].c.y := 0;

   d12 := distance(pt1,pt2);
   v12 := GetVector(pt1, pt2);
   v13 := GetVector(pt1, pt3);
   scale_it := dot(v12, v13);
   ang_1 := arcCos(scale_it);
   TTC[1].b.x := cos(ang_1) * D12 * 10;
   TTC[1].b.y := sin(ang_1) * D12 * 10;

   TTC[1].a.x := 0;
   TTC[1].a.y := Distance(pt1, pt3)* 10;

   TTC[1].a.angle := ang_1;

   v12 := GetVector(pt2, pt1);
   v13 := GetVector(pt2, pt3);
   scale_it := dot(v12, v13);
   ang_1 := arcCos(scale_it);
   TTC[1].b.angle := ang_1;

   v12 := GetVector(pt3, pt1);
   v13 := GetVector(pt3, pt2);
   scale_it := dot(v12, v13);
   ang_1 := arcCos(scale_it);
   TTC[1].c.angle := ang_1;

                  // now assign 2d coords
                  // from center of triangle

                  v12 := GetVector( pt1, Treb[1]);
                  v13 := GetVector( pt2, Treb[1]);
                  scale_it := dot(v12, v13);
                  ang_1 := arcCos(scale_it) / 2;
                  dista := distance(pt1, Treb[1]);

                  TTC[1].a.x := (cos(-ang_1) * dista * 10);
                  TTC[1].a.y := (sin(-ang_1) * dista * 10);

                  TTC[1].b.x := (cos(ang_1) * dista * 10);
                  TTC[1].b.y := (sin(ang_1) * dista * 10);

                  v12 := GetVector( pt1, Treb[1]);
                  v13 := GetVector( pt3, Treb[1]);
                  scale_it := dot(v12, v13);
                  ang_t := ang_1 +arcCos(scale_it);
                  dista := distance(pt3, Treb[1]);

                  TTC[1].c.x := (cos(ang_t) * dista * 10);
                  TTC[1].c.y := (sin(ang_t) * dista * 10);

end;

procedure TForm1.NextTriangle(count: integer);
var
   last_pt1, last_pt2, last_pt3,
   pt1, pt2, pt3,
   vn1, vn2: TPoint;
   count_last, count_dis,
   last_1, last_2, last_3,
   dis_1, dis_2, dis_3: integer;
   last_ang_a, last_ang_b, last_ang_c,
   dista, scale_it, ang_1, ang_t,
   px, py, dx, dy: GLfloat;
begin
// init primary players
   count_last := (count-2) * 3;
   if count > 1 then
   begin
      last_ang_a  := TTC[count-1].a.angle;
      last_ang_b  := TTC[count-1].b.angle;
      last_ang_c  := TTC[count-1].c.angle;
   end else begin
      last_ang_a  :=  60 * pi180;
      last_ang_b  := 60 * pi180;
      last_ang_c  := 60 * pi180;
   end;
   if count_last < 1 then count_last := 1;

   last_1 := Triang[count_last +1];
   last_2 := Triang[count_last +2];
   last_3 := Triang[count_last +3];

//   ang_1 := (last_ang_a + last_ang_b + last_ang_c) / pi180;
   count_dis := (count-1) * 3;
   pt1.x := Dust[ Triang[count_dis+1] ,0].x;
   pt1.y := Dust[ Triang[count_dis+1] ,0].y;
   pt1.z := Dust[ Triang[count_dis+1] ,0].z;
   pt2.x := Dust[ Triang[count_dis+2] ,0].x;
   pt2.y := Dust[ Triang[count_dis+2] ,0].y;
   pt2.z := Dust[ Triang[count_dis+2] ,0].z;
   pt3.x := Dust[ Triang[count_dis+3] ,0].x;
   pt3.y := Dust[ Triang[count_dis+3] ,0].y;
   pt3.z := Dust[ Triang[count_dis+3] ,0].z;

   dis_1 := Triang[count_dis +1];
   dis_2 := Triang[count_dis +2];
   dis_3 := Triang[count_dis +3];

   // test wich adjacent set up we are
   // dealing with.  last 1,3  dis 1,2 ?

   if dis_1 = last_1 then
   begin
            if dis_2 = last_2 then
            begin
               // dis_1, last_1 :: dis_2 & last_2
               beep;
               // should not be possible

            end else begin
               if dis_2 = last_3 then
               begin
                  // dis_1, last_1 :: dis_2 & last_3

                  vn1 := GetVector(pt1, pt2);
                  vn2 := GetVector(pt1, pt3);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].a.angle := ang_1;

                  vn1 := GetVector(pt2, pt1);
                  vn2 := GetVector(pt2, pt3);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].b.angle := ang_1;

                  vn1 := GetVector(pt3, pt1);
                  vn2 := GetVector(pt3, pt2);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].c.angle := ang_1;

                  // now assign 2d coords
                  // from center of triangle

                  vn1 := GetVector( pt1, Treb[count]);
                  vn2 := GetVector( pt2, Treb[count]);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it) / 2;
                  dista := distance(pt1, Treb[count]);

                  TTC[count].a.x := (cos(-ang_1) * dista * 10);
                  TTC[count].a.y := (sin(-ang_1) * dista * 10);

                  TTC[count].b.x := (cos(ang_1) * dista * 10);
                  TTC[count].b.y := (sin(ang_1) * dista * 10);

                  vn1 := GetVector( pt1, Treb[count]);
                  vn2 := GetVector( pt3, Treb[count]);
                  scale_it := dot(vn1, vn2);
                  ang_t := ang_1 +arcCos(scale_it);
                  dista := distance(pt3, Treb[count]);

                  TTC[count].c.x := (cos(ang_t) * dista * 10);
                  TTC[count].c.y := (sin(ang_t) * dista * 10);

                  // now rotate texture to align with last triangle
                  //

                  ang_1 := last_ang_a;
                  if ang_1 > (pi * 2) then ang_1 := ang_1 - (pi * 2);
                  if ang_1 < 0 then ang_1 := ang_1 + (pi * 2);
                  TTC[count].a.angle := TTC[count].a.angle +ang_1;
                  TTC[count].b.angle := TTC[count].b.angle +ang_1;

                  px := TTC[count].a.x;
                  py := TTC[count].a.y;
                  TTC[count].a.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].a.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  px := TTC[count].b.x;
                  py := TTC[count].b.y;
                  TTC[count].b.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].b.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  px := TTC[count].c.x;
                  py := TTC[count].c.y;
                  TTC[count].c.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].c.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  // now slide it down into place
                  // against previous triangle

                  dx := TTC[count-1].a.x  -TTC[count].a.x;
                  dy := TTC[count-1].a.y  -TTC[count].a.y;

                  dx := TTC[count-1].c.x  -TTC[count].b.x;
                  dy := TTC[count-1].c.y  -TTC[count].b.y;
                  TTC[count].a.x := TTC[count].a.x +dx;
                  TTC[count].a.y := TTC[count].a.y +dy;
                  TTC[count].b.x := TTC[count].b.x +dx;
                  TTC[count].b.y := TTC[count].b.y +dy;
                  TTC[count].c.x := TTC[count].c.x +dx;
                  TTC[count].c.y := TTC[count].c.y +dy;

               end else begin
               beep;

                  // should not be possible

               end;
            end;
   end else begin
      if dis_1 = last_2 then
      begin
            if dis_2 = last_1 then
            begin
                // dis_1, last_2 :: dis_2 & last_1

                  vn1 := GetVector(pt1, pt2);
                  vn2 := GetVector(pt1, pt3);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].a.angle := ang_1;

                  vn1 := GetVector(pt2, pt1);
                  vn2 := GetVector(pt2, pt3);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].b.angle := ang_1;

                  vn1 := GetVector(pt3, pt1);
                  vn2 := GetVector(pt3, pt2);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].c.angle := ang_1;

                  // now assign 2d coords
                  // from center of triangle

                  vn1 := GetVector( pt1, Treb[count]);
                  vn2 := GetVector( pt2, Treb[count]);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it) / 2;
                  dista := distance(pt1, Treb[count]);

                  TTC[count].a.x := (cos(-ang_1) * dista * 10);
                  TTC[count].a.y := (sin(-ang_1) * dista * 10);

                  TTC[count].b.x := (cos(ang_1) * dista * 10);
                  TTC[count].b.y := (sin(ang_1) * dista * 10);

                  vn1 := GetVector( pt1, Treb[count]);
                  vn2 := GetVector( pt3, Treb[count]);
                  scale_it := dot(vn1, vn2);
                  ang_1 := ang_1 +arcCos(scale_it);
                  dista := distance(pt3, Treb[count]);

                  TTC[count].c.x := (cos(ang_1) * dista * 10);
                  TTC[count].c.y := (sin(ang_1) * dista * 10);

                  // now rotate texture to align with last triangle
                  //

                  ang_1 := 180 * pi180;
                  TTC[count].a.angle := TTC[count].a.angle +ang_1;
                  TTC[count].b.angle := TTC[count].b.angle +ang_1;

                  px := TTC[count].a.x;
                  py := TTC[count].a.y;
                  TTC[count].a.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].a.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  px := TTC[count].b.x;
                  py := TTC[count].b.y;
                  TTC[count].b.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].b.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  px := TTC[count].c.x;
                  py := TTC[count].c.y;
                  TTC[count].c.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].c.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  // now slide it down into place
                  // against previous triangle

                  dx := TTC[count-1].a.x  -TTC[count].a.x;
                  dy := TTC[count-1].a.y  -TTC[count].a.y;

                  dx := TTC[count-1].c.x  -TTC[count].b.x;
                  dy := TTC[count-1].c.y  -TTC[count].b.y;
                  TTC[count].a.x := TTC[count].a.x +dx;
                  TTC[count].a.y := TTC[count].a.y +dy;
                  TTC[count].b.x := TTC[count].b.x +dx;
                  TTC[count].b.y := TTC[count].b.y +dy;
                  TTC[count].c.x := TTC[count].c.x +dx;
                  TTC[count].c.y := TTC[count].c.y +dy;

            end else begin
               if dis_2 = last_3 then
               begin
                  // dis_1, last_2 :: dis_2 & last_3
               beep;

                  // should not be possible

               end else begin

                        beep
                        // should not be possible
               end;
            end;

      end else begin
         if dis_1 = last_3 then
         begin
            if dis_2 = last_1 then
            begin
               // dis_1, last_3 :: dis_2 & last_1

               beep;
               // should not be possible

            end else begin
               if dis_2 = last_2 then
               begin
                  // dis_1, last_3 :: dis_2 & last_2

                  vn1 := GetVector(pt1, pt2);
                  vn2 := GetVector(pt1, pt3);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].a.angle := ang_1;

                  vn1 := GetVector(pt2, pt1);
                  vn2 := GetVector(pt2, pt3);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].b.angle := ang_1;

                  vn1 := GetVector(pt3, pt1);
                  vn2 := GetVector(pt3, pt2);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it);
                  TTC[count].c.angle := ang_1;

                  // now assign 2d coords
                  // from center of triangle

                  vn1 := GetVector( pt1, Treb[count]);
                  vn2 := GetVector( pt2, Treb[count]);
                  scale_it := dot(vn1, vn2);
                  ang_1 := arcCos(scale_it) / 2;
                  dista := distance(pt1, Treb[count]);

                  TTC[count].a.x := (cos(-ang_1) * dista * 10);
                  TTC[count].a.y := (sin(-ang_1) * dista * 10);

                  TTC[count].b.x := (cos(ang_1) * dista * 10);
                  TTC[count].b.y := (sin(ang_1) * dista * 10);

                  vn1 := GetVector( pt1, Treb[count]);
                  vn2 := GetVector( pt3, Treb[count]);
                  scale_it := dot(vn1, vn2);
                  ang_1 := ang_1 +arcCos(scale_it);
                  dista := distance(pt3, Treb[count]);

                  TTC[count].c.x := (cos(ang_1) * dista * 10);
                  TTC[count].c.y := (sin(ang_1) * dista * 10);

                  // now rotate texture to align with last triangle
                  //

                  // now rotate texture to align with last triangle
                  //

                  ang_1 := last_ang_b;
                  if ang_1 > (pi * 2) then ang_1 := ang_1 - (pi * 2);
                  if ang_1 < 0 then ang_1 := ang_1 + (pi * 2);
                  TTC[count].a.angle := TTC[count].a.angle +ang_1;
                  TTC[count].b.angle := TTC[count].b.angle +ang_1;

                  px := TTC[count].a.x;
                  py := TTC[count].a.y;
                  TTC[count].a.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].a.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  px := TTC[count].b.x;
                  py := TTC[count].b.y;
                  TTC[count].b.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].b.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  px := TTC[count].c.x;
                  py := TTC[count].c.y;
                  TTC[count].c.x := (px * cos(ang_1)) + (py * -sin(ang_1 ));
                  TTC[count].c.y := (px * sin(ang_1)) + (py *  cos(ang_1 ));

                  // now slide it down into place
                  // against previous triangle

                  dx := TTC[count-1].a.x  -TTC[count].a.x;
                  dy := TTC[count-1].a.y  -TTC[count].a.y;

                  dx := TTC[count-1].c.x  -TTC[count].b.x;
                  dy := TTC[count-1].c.y  -TTC[count].b.y;
                  TTC[count].a.x := TTC[count].a.x +dx;
                  TTC[count].a.y := TTC[count].a.y +dy;
                  TTC[count].b.x := TTC[count].b.x +dx;
                  TTC[count].b.y := TTC[count].b.y +dy;
                  TTC[count].c.x := TTC[count].c.x +dx;
                  TTC[count].c.y := TTC[count].c.y +dy;

               end else begin

               beep;
                  // should not be possible

               end;
            end;
         end else begin

               beep;
               // should not be possible

         end;
      end;
   end;
end;

procedure TForm1.NextAdjacentTriangle(count: integer);
var
   count_last, count_dis, count_dat,
   t1, t2, t3, n1, n2, n3,
   count2, count3: integer;
   m1, m2, m3: boolean;
begin
   count_last := count-1;
   count_dis := (count-1) * 3;
   t1 := Triang[count_dis+1];
   t2 := Triang[count_dis+2];
   t3 := Triang[count_dis+3];

   Tread[count].a12 := count_last;

   for count2 := 1 to (so_far div 3) do
   begin
       count_dat := (count2-1) * 3;
         if count2 <> count then
         begin
            m1 := False;
            m2 := False;
            m3 := False;
            n1 := Triang[count_dat+1];
            n2 := Triang[count_dat+2];
            n3 := Triang[count_dat+3];

            if (t1 = n1) then m1 := True;
            if (t1 = n2) then m1 := True;
            if (t1 = n3) then m1 := True;

            if (t2 = n1) then m2 := True;
            if (t2 = n2) then m2 := True;
            if (t2 = n3) then m2 := True;

            if (t3 = n1) then m3 := True;
            if (t3 = n2) then m3 := True;
            if (t3 = n3) then m3 := True;

            if m2 and m3 then
               Tread[count].a23 := count2
               else if m3 and m1 then
                  Tread[count].a31 := count2
                  else if m1 and m2 then
                     Tread[count].a12 := count2;
         end;
   end;
end;

procedure TForm1.Gravity;
var
   d, scalar: GLFloat;
   p1, p2, p3: TPoint;
   dot : integer;
begin
   p1.x := TransformDust.TranX;
   p1.y := TransformDust.TranY;
   p1.z := TransformDust.TranZ;

   p2.x := TransformBall.TranX;
   p2.y := TransformBall.TranY;
   p2.z := TransformBall.TranZ;

   d := DistanceSqr(p1,p2);
//   form1.Caption := FloatToStr(d);

   if d < 1.2 then
   begin
      dot := ClosestDot(p2);

      // scalar
      scalar :=
              +(BallVect.x * Dust[dot,0].x)
              +(BallVect.y * Dust[dot,0].y)
              +(BallVect.z * Dust[dot,0].z);

      p3.x := 2 * scalar * Dust[dot,0].x;
      p3.y := 2 * scalar * Dust[dot,0].y;
      p3.z := 2 * scalar * Dust[dot,0].z;

      with BallVect do
      begin
         x := x -p3.x;
         y := y -p3.y;
         z := z -p3.z;
      end;
         ballVect.x := BallVect.X * 0.95;
         ballVect.y := BallVect.y * 0.95;
         ballVect.z := BallVect.z * 0.95;
   end;

   d := d  * 100;

   d := 1/d;

   p3.x := p1.x-p2.x;
   p3.y := p1.y-p2.y;
   p3.z := p1.z-p2.z;

   p3 := normalize(p3);

   with BallVect do
   begin
      X := X +(p3.x *d);
      Y := Y +(p3.y *d);
      Z := Z +(p3.z *d);
   end;

   with TransformBall, BallVect do
   begin
      TranX := TranX +X;
      Trany := Trany +Y;
      Tranz := Tranz +Z;
   end;

   // second check for collision
   p1.x := TransformDust.TranX;
   p1.y := TransformDust.TranY;
   p1.z := TransformDust.TranZ;

   p2.x := TransformBall.TranX;
   p2.y := TransformBall.TranY;
   p2.z := TransformBall.TranZ;

   d := DistanceSqr(p1,p2);
//   form1.Caption := FloatToStr(d);

   if d < 1.0 then
   begin
      with TransformBall do
      begin
         TranX := lastSpot.x;
         Trany := lastSpot.y;
         Tranz := lastSpot.z;
         ballVect.x := BallVect.X * 0.9;
         ballVect.y := BallVect.y * 0.9;
         ballVect.z := BallVect.z * 0.9;
      end;
   end;

   with TransformBall do
   begin
      lastSpot.x := TranX;
      lastSpot.y := TranY;
      lastSpot.z := TranZ;
   end;
end;

procedure TForm1.Grav(count, count2: integer);
var
   d, scalar: GLFloat;
   m1, m2, r1, r2: double;
   p1, p2, p3, p4, p5: TPoint;
   dot : integer;
begin
   p1.x := Sol[count].place.x;
   p1.y := Sol[count].place.Y;
   p1.z := Sol[count].place.Z;

   p2.x := Sol[count2].place.x;
   p2.y := Sol[count2].place.Y;
   p2.z := Sol[count2].place.Z;

   m1 := Sol[count].mass;
   m2 := Sol[count2].mass;

   r1 := Sol[count].radius;
   r2 := Sol[count2].radius;

   p4.x := p1.x * 1000;
   p4.y := p1.y * 1000;
   p4.z := p1.z * 1000;

   p5.x := p2.x * 1000;
   p5.y := p2.y * 1000;
   p5.z := p2.z * 1000;

   d := DistanceSqr(p4,p5);
   d := 1/d;
   d := d * m2 * GRAVITY_CONSTANT;

   p3.x := p2.x-p1.x;
   p3.y := p2.y-p1.y;
   p3.z := p2.z-p1.z;

   p3 := normalize(p3);

   with Sol[count].vec do
   begin
      X := X +(p3.x *d);
      Y := Y +(p3.y *d);
      Z := Z +(p3.z *d);
   end;

   with Sol[count].place do
   begin
      X := X +Sol[count].vec.x;
      Y := Y +Sol[count].vec.y;
      Z := Z +Sol[count].vec.z;
   end;
end;

procedure TForm1.TrackBar1Change(Sender: TObject);
begin
   TransformLight.TranZ := -500 + (Trackbar1.Position *10);
end;

procedure TForm1.FormClose(Sender: TObject; var Action: TCloseAction);
begin
    SavePlanets;
end;

end.
