unit charactP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, ComCtrls, StdCtrls, ToolWin;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    StatusBar1: TStatusBar;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Object1: TMenuItem;
    Links1: TMenuItem;
    N3: TMenuItem;
    GoTo1: TMenuItem;
    Replace1: TMenuItem;
    Find1: TMenuItem;
    N4: TMenuItem;
    PasteSpecial1: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    N5: TMenuItem;
    Repeatcommand1: TMenuItem;
    Undo1: TMenuItem;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter2: TSplitter;
    Panel3: TPanel;
    Splitter3: TSplitter;
    Panel4: TPanel;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Button1: TButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList2: TImageList;
    procedure FormCreate(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure ListBox1KeyPress(Sender: TObject; var Key: Char);
  private
     RaceCurrentTotal: integer;
     procedure InitChar;
     procedure InitRaces;
     procedure InitRaceStats;
     procedure InitRaceBodyPart;
     procedure BirthChar;
     procedure SelectParent(count: integer);
     Function GetRaceName(count: integer): shortString;
     function GetStat(number: double): shortString;
    { Private declarations }
  public
     sentence, father, mother: integer;
     procedure FirstChoice;
     procedure BlankSheet;
     procedure FullSheet;
     procedure ListRaces;
    { Public declarations }
  end;

Type
   TRaces = record
      Name, Plural, common, language, latin: shortString;
      N: integer;
      end;

   TRaceStats = packed record
      St, St_min, St_max,
      Dx, Dx_min, Dx_max,
      Iq, Iq_min, Iq_max,
      Ma, Ma_min, Ma_max,
      Cp, Cp_min, Cp_max,
      Hx, Hx_min, Hx_max,
      Ap
      :double;
   end;

   TRaceBodyParts = packed record
      {component selection}
   blood,
   head,
      ear,
      eye,
         brain,
      hair, wisker, beard,
      horn,
      mouth,
         tooth,
         tusk,
      neck,
      nose, probiscus,
   body,
      skin, hide, leather, fur, feather, chitin, shell, scales,
      nucleous,
      trunk, stalk, stem,
         backbone,
         gallbladder,
         heart,
         liver,
   limb,
      arm,
         hand,
            claw,
            claw_socket,
      fin,
      leg,
         foot,
            hoof, toenail, talon,
         root,
      tenticle,
      branch,
         twig,
            leaf,
      wing,
   tail,
         fluke,
         stinger
   : double
      end;

   TBodyParts = packed record
      Part: TRaceBodyParts;
      end;

const
  SheetCharWidth     =     77;
  MaxRaces           =    1440;
  MaxRaceStats       =    1440;
  Max                =   9999;
  WidthRaceName      =     24;
  WidthRacePlural    =     24;
  WidthRaceCommon    =     24;
  WidthRaceLanguage  =     24;
  WidthRaceSt        =      4;
  WidthRaceDx        =      4;
  WidthRaceIq        =      4;
  WidthRaceMa        =      4;
  WidthRaceEp        =      4;

var
  Form1: TForm1;
  Race: array [1..MaxRaces] of TRaces;
  Stat: array [1..MaxRaceStats] of TRaceStats;
  Body: array [1..MaxRaceStats] of TBodyParts;
  char_race: TRaces;
  char_stat: TRaceStats;
  char_body: TBodyParts;

implementation

{$R *.DFM}

procedure TForm1.InitChar;
begin
   Sentence := 0;
   Father := 0;
   Mother := 0;
   FirstChoice;

   char_race.Name := '';
   char_race.Plural  := '';
   char_race.common  := '';
   char_race.language  := '';
   char_race.latin  := '';
   char_race.N  := 0;

   char_stat.St := 0.0;
   char_stat.St_min := 0.0;
   char_stat.St_max := 0.0;
   char_stat.Dx := 0.0;
   char_stat.Dx_min := 0.0;
   char_stat.Dx_max := 0.0;
   char_stat.Iq := 0.0;
   char_stat.Iq_min := 0.0;
   char_stat.Iq_max := 0.0;
   char_stat.Ma := 0.0;
   char_stat.Ma_min := 0.0;
   char_stat.Ma_max := 0.0;
   char_stat.Cp := 0.0;
   char_stat.Cp_min := 0.0;
   char_stat.Cp_max := 0.0;
   char_stat.Hx := 0.0;
   char_stat.Hx_min := 0.0;
   char_stat.Hx_max := 0.0;
   char_stat.Ap := 0.0;
end;

procedure Tform1.InitRaces;
var
   count, stat_count: integer;
begin
   count :=1;
   stat_count :=1;
   Race[count].Name     := 'black';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'yellow';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'orange';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'red';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hairy';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'bald';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'peaceful';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'warlike';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'city-bred';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wandering';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'amazon';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'male-chauvinist';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'good';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'evil';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'practical';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mad';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nasty';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'coarse-hair';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'sharp-tooth';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'fanged';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'claw';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'tough';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'greedy';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'quarrelsome';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'good';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'harsh';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'militant';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountain';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hut';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'kingdom';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'slender';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'uncommon';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'influential';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'forest';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountain-peak';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'proud';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'aloof';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'humble';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'deep';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'underground';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dignified';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'boisterous';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'earthy';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'drinking';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gold-digger';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'bad';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'proud';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'intelligent';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'crafty';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ruthless';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'civil';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'merchant';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'big';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'stupid';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'servant';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'simple';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'brutal';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'cruel';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'bad';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'peaceful';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'rural';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'venturing';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'nimble';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hardy';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'friendly';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'quarreling';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'unruly';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'moronic';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hunter';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gatherer';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'villa';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'alley';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'quarreling';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'grassland';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'woodland';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'forester';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'civilized';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'barbarian';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wino';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'simpleton';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'titanus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'quiet';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'titanus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gardener';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'titanus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'outcast';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'titanus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'surly';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'titanus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'murderous';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'titanus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'tough';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'tribal';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountainous';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ruin-dwelling';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'jewel-collector';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'guard';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'trustworthy';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'sullen';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'suspicious';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'fearsome';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'disliked';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'shunned';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'loyal';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'reserved';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'touchy';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'duelist';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'reptilis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pond';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'mer';
   Race[count].Latin    := 'meros hominis';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'lake';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'mer';
   Race[count].Latin    := 'meros hominis';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'sea';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'mer';
   Race[count].Latin    := 'meros hominis';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'ocean';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'mer';
   Race[count].Latin    := 'meros hominis';
   Race[count].N := 1;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'white';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'grey';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'black';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'brown';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'red';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'greater';
   Race[count].Plural   := 'demons';
   Race[count].Common   := 'demon';
   Race[count].Language := 'demonic';
   Race[count].Latin    := 'daemonies';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'lesser';
   Race[count].Plural   := 'demons';
   Race[count].Common   := 'demon';
   Race[count].Language := 'demonic';
   Race[count].Latin    := 'daemonies';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'shy';
   Race[count].Plural   := 'sasquatch';
   Race[count].Common   := 'sasquatch';
   Race[count].Language := 'salishan';
   Race[count].Latin    := 'yeti';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'shy';
   Race[count].Plural   := 'yeti';
   Race[count].Common   := 'yeti';
   Race[count].Language := 'tibetan';
   Race[count].Latin    := 'yeti';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'servant';
   Race[count].Plural   := 'wyverns';
   Race[count].Common   := 'wyvern';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'vipera';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'enchantment-using';
   Race[count].Plural   := 'wyverns';
   Race[count].Common   := 'wyvern';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'vipera';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'ally';
   Race[count].Plural   := 'wraiths';
   Race[count].Common   := 'wraith';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'phasma';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wizard';
   Race[count].Plural   := 'wraiths';
   Race[count].Common   := 'wraith';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'phasma';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'single';
   Race[count].Plural   := 'trolls';
   Race[count].Common   := 'troll';
   Race[count].Language := 'troglodyte';
   Race[count].Latin    := 'troller';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'paired';
   Race[count].Plural   := 'trolls';
   Race[count].Common   := 'troll';
   Race[count].Language := 'troglodyte';
   Race[count].Latin    := 'troller';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'greedy';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'swamp';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dishonest';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'cowardly';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'man-eater';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ambush';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'sneak-attack';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'strong';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'gruntish';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'surly';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'gruntish';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'villager';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'gruntish';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dwarf-slave';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'gruntish';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'stupid';
   Race[count].Plural   := 'ogres';
   Race[count].Common   := 'ogre';
   Race[count].Language := 'gia';
   Race[count].Latin    := 'orcus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'loathesome';
   Race[count].Plural   := 'ghouls';
   Race[count].Common   := 'ghoul';
   Race[count].Language := 'ghoulish';
   Race[count].Latin    := 'orcus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'group';
   Race[count].Plural   := 'ghouls';
   Race[count].Common   := 'ghoul';
   Race[count].Language := 'ghoulish';
   Race[count].Latin    := 'orcus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'dim-tunnel';
   Race[count].Plural   := 'shadowights';
   Race[count].Common   := 'shadowight';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'orcus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'subterrain';
   Race[count].Plural   := 'shadowights';
   Race[count].Common   := 'shadowight';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'orcus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'hydra';
   Race[count].Common   := 'hydra';
   Race[count].Language := 'hydranian';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'large';
   Race[count].Plural   := 'hydra';
   Race[count].Common   := 'hydra';
   Race[count].Language := 'hydranian';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'obnoxious';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'comfort';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wealthy';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'powerful';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ever-hungry';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'earth';
   Race[count].Plural   := 'elementals';
   Race[count].Common   := 'elemental';
   Race[count].Language := 'e';
   Race[count].Latin    := 'terra';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'air';
   Race[count].Plural   := 'elementals';
   Race[count].Common   := 'elemental';
   Race[count].Language := 'e';
   Race[count].Latin    := 'vortex';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'fire';
   Race[count].Plural   := 'elementals';
   Race[count].Common   := 'elemental';
   Race[count].Language := 'e';
   Race[count].Latin    := 'pyro';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'water';
   Race[count].Plural   := 'elementals';
   Race[count].Common   := 'elemental';
   Race[count].Language := 'e';
   Race[count].Latin    := 'hydra';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'darkness';
   Race[count].Plural   := 'apep';
   Race[count].Common   := 'apep';
   Race[count].Language := 'popis';
   Race[count].Latin    := 'apopis';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nag';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'riding';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'light';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mustang';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pony';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'draft';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'clydesdale';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'percheron';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'war';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'donkey';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'mule';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'unicorn';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'pegasus';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'indricotherium';
   Race[count].Common   := 'indricotherium';
   Race[count].Language := 'indrian';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'elephants';
   Race[count].Common   := 'elephant';
   Race[count].Language := 'elephant';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := '';
   Race[count].Plural   := 'mammoths';
   Race[count].Common   := 'mammoth';
   Race[count].Language := 'mammoth';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'oxen';
   Race[count].Common   := 'ox';
   Race[count].Language := 'oxen';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := '';
   Race[count].Plural   := 'yaks';
   Race[count].Common   := 'yak';
   Race[count].Language := 'yak';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := '';
   Race[count].Plural   := 'caraboa';
   Race[count].Common   := 'carabo';
   Race[count].Language := 'carabo';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'water';
   Race[count].Plural   := 'buffalos';
   Race[count].Common   := 'buffalo';
   Race[count].Language := 'buffalo';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'camels';
   Race[count].Common   := 'camel';
   Race[count].Language := 'camel';
   Race[count].Latin    := 'mamailian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'riding';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'reptile';
   Race[count].Latin    := 'reptilian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'saurian';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'reptile';
   Race[count].Latin    := 'reptilian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'walker';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'reptile';
   Race[count].Latin    := 'reptilian';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'flightless';
   Race[count].Plural   := 'birds';
   Race[count].Common   := 'bird';
   Race[count].Language := 'avian';
   Race[count].Latin    := 'diatryma';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'enormous';
   Race[count].Plural   := 'birds';
   Race[count].Common   := 'bird';
   Race[count].Language := 'avian';
   Race[count].Latin    := 'roc';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'rare';
   Race[count].Plural   := 'gryphons';
   Race[count].Common   := 'gryphon';
   Race[count].Language := 'gryphon';
   Race[count].Latin    := 'gryphon';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'solitary';
   Race[count].Plural   := 'gryphons';
   Race[count].Common   := 'gryphon';
   Race[count].Language := 'gryphon';
   Race[count].Latin    := 'gryphon';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'partner';
   Race[count].Plural   := 'dolphins';
   Race[count].Common   := 'dolphin';
   Race[count].Language := 'dolphin';
   Race[count].Latin    := 'dolphin';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'grey';
   Race[count].Plural   := 'wolves';
   Race[count].Common   := 'wolf';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'dire';
   Race[count].Plural   := 'wolves';
   Race[count].Common   := 'wolf';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'shepherd';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'wolfhound';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'hunting';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'HPR';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'hound';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'flushing';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'pointer';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'retriever';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'cave';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'kodiak';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'grizzly';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'black';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'cinnamon';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'lion';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'tiger';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'sabertooth';
   Race[count].Plural   := 'tigers';
   Race[count].Common   := 'tiger';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'jaguar';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'pet';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'great';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'baboon';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'chimpanzee';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'monkey';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'theif';
   Race[count].Plural   := 'slinkers';
   Race[count].Common   := 'slinker';
   Race[count].Language := 'slinky';
   Race[count].Latin    := 'slinkus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pet';
   Race[count].Plural   := 'slinkers';
   Race[count].Common   := 'slinker';
   Race[count].Language := 'slinky';
   Race[count].Latin    := 'slinkus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'group';
   Race[count].Plural   := 'dragonets';
   Race[count].Common   := 'dragonet';
   Race[count].Language := 'dracus';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pet';
   Race[count].Plural   := 'dragonets';
   Race[count].Common   := 'dragonet';
   Race[count].Language := 'dracus';
   Race[count].Latin    := 'draco';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'stone';
   Race[count].Plural   := 'beetle';
   Race[count].Common   := 'beetle';
   Race[count].Language := 'silicus';
   Race[count].Latin    := 'beetlus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'spiders';
   Race[count].Common   := 'spider';
   Race[count].Language := 'spindle';
   Race[count].Latin    := 'arachnid';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'scorpions';
   Race[count].Common   := 'scorpion';
   Race[count].Language := 'scorpious';
   Race[count].Latin    := 'scorpio';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'basic';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'spyder';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'low render';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'termagant';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'phlanxe';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'gantua';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'myrmidon';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'plunge';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'worker';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'large';
   Race[count].Plural   := 'snakes';
   Race[count].Common   := 'snake';
   Race[count].Language := 'serpent';
   Race[count].Latin    := 'serpio';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'snakes';
   Race[count].Common   := 'snake';
   Race[count].Language := 'serpent';
   Race[count].Latin    := 'serpio';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'monster';
   Race[count].Plural   := 'snakes';
   Race[count].Common   := 'snake';
   Race[count].Language := 'serpent';
   Race[count].Latin    := 'serpio';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'saurian';
   Race[count].Latin    := 'saurus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'goo';
   Race[count].Common   := 'goo';
   Race[count].Language := 'slime';
   Race[count].Latin    := 'goous';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'medium';
   Race[count].Plural   := 'goo';
   Race[count].Common   := 'goo';
   Race[count].Language := 'slime';
   Race[count].Latin    := 'goous';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'large';
   Race[count].Plural   := 'goo';
   Race[count].Common   := 'goo';
   Race[count].Language := 'slime';
   Race[count].Latin    := 'goous';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'carnivorous';
   Race[count].Plural   := 'piranhas';
   Race[count].Common   := 'piranha';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nuaghty';
   Race[count].Plural   := 'minos';
   Race[count].Common   := 'mino';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'salt water';
   Race[count].Plural   := 'sharks';
   Race[count].Common   := 'shark';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'turtles';
   Race[count].Common   := 'turtle';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'monster';
   Race[count].Plural   := 'turtles';
   Race[count].Common   := 'turtle';
   Race[count].Language := 'reptilian';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'uncle teeth';
   Race[count].Common   := 'uncle teeth';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'clams';
   Race[count].Common   := 'clam';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'salt water';
   Race[count].Plural   := 'kraken';
   Race[count].Common   := 'kraken';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'fresh water';
   Race[count].Plural   := 'kraken';
   Race[count].Common   := 'kraken';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'crocodiles';
   Race[count].Common   := 'crocodile';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'bloodtree';
   Race[count].Plural   := 'roots';
   Race[count].Common   := 'roots';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'am';
   Race[count].Plural   := 'bushes';
   Race[count].Common   := 'bush';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'edible';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hallucinogenic';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'poisonous';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'poison gas';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'explosive';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'berserker';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'green';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'red';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'brown';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'silver';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'group';
   Race[count].Plural   := 'rats';
   Race[count].Common   := 'rat';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'vampire';
   Race[count].Plural   := 'bats';
   Race[count].Common   := 'bat';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'swarm';
   Race[count].Plural   := 'spiders';
   Race[count].Common   := 'spider';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'swarm';
   Race[count].Plural   := 'wasps';
   Race[count].Common   := 'wasp';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'jumping';
   Race[count].Plural   := 'scuttles';
   Race[count].Common   := 'scuttle';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'flocking';
   Race[count].Plural   := 'piranhakeets';
   Race[count].Common   := 'piranhakeet';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'wall climber';
   Race[count].Plural   := 'scorpions';
   Race[count].Common   := 'scorpion';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nuisance';
   Race[count].Plural   := 'children';
   Race[count].Common   := 'child';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].N := stat_count;

   RaceCurrentTotal := count;
   InitRaceStats;
end;

procedure Tform1.InitRaceStats;
var
   count: integer;
begin
   count := 1; {men}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := 25;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {orc}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {elf}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {dwarf}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 6;
   Stat[count].Dx_min   := 6;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {goblin}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 6;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {hobgoblin}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 6;
   Stat[count].Dx_min   := 6;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {halfling}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := 20;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 6;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {prootwaddle}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 6;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {centaur}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 2;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {giant}
   Stat[count].St       := 25;
   Stat[count].St_min   := 25;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 9;
   Stat[count].Dx_min   := 9;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 10;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 0;

   inc(count); {gargoyle}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := 10;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 3;

   inc(count); {reptile men}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {white dragon}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count);{grey dragon}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 12;
   Stat[count].Iq_min   := 12;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;

   inc(count);{black dragon}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 16;
   Stat[count].Iq_min   := 16;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 4;
   Stat[count].Hx_min   := 4;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 3;

   inc(count);{brown dragon}
   Stat[count].St       := 60;
   Stat[count].St_min   := 60;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 20;
   Stat[count].Iq_min   := 20;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 7;
   Stat[count].Hx_min   := 7;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 5;

   inc(count);{red dragon}
   Stat[count].St       := 100;
   Stat[count].St_min   := 100;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 24;
   Stat[count].Iq_min   := 24;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 14;
   Stat[count].Hx_min   := 14;
   Stat[count].Hx_max   := 14;
   Stat[count].Ap       := 6;

   inc(count); {greater demon}
   Stat[count].St       := 100;
   Stat[count].St_min   := 100;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 20;
   Stat[count].Iq_min   := 20;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := MAX;
   Stat[count].Ma_min   := MAX;
   Stat[count].Ma_max   := MAX;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 4;

   inc(count); {lesser demon}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 14;
   Stat[count].Iq_min   := 14;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := MAX;
   Stat[count].Ma_min   := MAX;
   Stat[count].Ma_max   := MAX;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 3;

   inc(count); {sasquatch}
   Stat[count].St       := 18;
   Stat[count].St_min   := 18;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {wyvern}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 12;
   Stat[count].Iq_min   := 12;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 3;
   Stat[count].Ma_min   := 3;
   Stat[count].Ma_max   := 3;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 2;

   inc(count); {wraith}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := 25;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 1;
   Stat[count].Ma_min   := 1;
   Stat[count].Ma_max   := 1;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {troll}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 11;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {octopus}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 15;
   Stat[count].Dx_min   := 15;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {neanderthal}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {ogres}
   Stat[count].St       := 42;
   Stat[count].St_min   := 42;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 6;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 5;
   Stat[count].Hx_min   := 5;
   Stat[count].Hx_max   := 5;
   Stat[count].Ap       := 0;

   inc(count); {ghoul}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {shadowight}
   Stat[count].St       := 5;
   Stat[count].St_min   := 5;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 5;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {hydra}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 4;
   Stat[count].Hx_min   := 4;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 0;

   inc(count); {hydra}
   Stat[count].St       := 60;
   Stat[count].St_min   := 60;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 7;
   Stat[count].Hx_min   := 7;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 0;

   inc(count); {basilisk}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {earth elemental}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {air elemental}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {fire elemental}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {water elemental}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {apep}
   Stat[count].St       := 40;
   Stat[count].St_min   := 40;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 6;
   Stat[count].Hx_min   := 6;
   Stat[count].Hx_max   := 6;
   Stat[count].Ap       := 3;

   inc(count); {nag horse}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {riding horse}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 24;
   Stat[count].Ma_min   := 24;
   Stat[count].Ma_max   := 24;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {light horse}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 30;
   Stat[count].Ma_min   := 30;
   Stat[count].Ma_max   := 30;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {draft horse}
   Stat[count].St       := 26;
   Stat[count].St_min   := 26;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 22;
   Stat[count].Ma_min   := 22;
   Stat[count].Ma_max   := 22;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {warhorse}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 24;
   Stat[count].Ma_min   := 24;
   Stat[count].Ma_max   := 24;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {donkey}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 15;
   Stat[count].Dx_min   := 15;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 16;
   Stat[count].Ma_min   := 16;
   Stat[count].Ma_max   := 16;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {mule horse}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {unicorn horse}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 30;
   Stat[count].Ma_min   := 30;
   Stat[count].Ma_max   := 30;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {pegasus horse}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 22;
   Stat[count].Ma_min   := 22;
   Stat[count].Ma_max   := 22;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {indri mammal}
   Stat[count].St       := 40;
   Stat[count].St_min   := 40;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 8;
   Stat[count].Hx_min   := 8;
   Stat[count].Hx_max   := 10;
   Stat[count].Ap       := 2;

   inc(count); {elephant mammal}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 9;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 16;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 10;
   Stat[count].Hx_min   := 10;
   Stat[count].Hx_max   := 10;
   Stat[count].Ap       := 2;

   inc(count); {oxen mammal}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 1;

   inc(count); {camel mammal}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {lizard reptile}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;

   inc(count); {saurian reptile}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := 11;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 16;
   Stat[count].Ma_min   := 16;
   Stat[count].Ma_max   := 16;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 3;

   inc(count); {walker reptile}
   Stat[count].St       := 22;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 24;
   Stat[count].Ma_min   := 24;
   Stat[count].Ma_max   := 24;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {diatryma bird}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 22;
   Stat[count].Ma_min   := 22;
   Stat[count].Ma_max   := 22;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {roc bird}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 0;

   inc(count); {gryphon}
   Stat[count].St       := 26;
   Stat[count].St_min   := 26;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 8;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {dolphin}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 11;
   Stat[count].Iq_min   := 9;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 0;

   inc(count); {wolf}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {dire wolf}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {big dog}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {wolfhound}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {hunting dog}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {spaniel dog}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {gray hound}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {flushing dog}
   Stat[count].St       := 5;
   Stat[count].St_min   := 5;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {pointer dog}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {retriever dog}
   Stat[count].St       := 3;
   Stat[count].St_min   := 3;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {small dog}
   Stat[count].St       := 3;
   Stat[count].St_min   := 3;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {cave bears}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;

   inc(count); {kodiak bears}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {black bears}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {lion cats}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {tiger cats}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 15;
   Stat[count].Dx_min   := 15;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {sabertooth cats}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {jaguar cats}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;

   inc(count); {little cats}
   Stat[count].St       := 4;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {great ape}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {baboon ape}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {chimpanzee ape}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {monkey ape}
   Stat[count].St       := 2;
   Stat[count].St_min   := 2;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {slinker}
   Stat[count].St       := 2;
   Stat[count].St_min   := 2;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {dragonet}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 7;
   Stat[count].Ma_min   := 7;
   Stat[count].Ma_max   := 7;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {stone beetle}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 2;
   Stat[count].Iq_min   := 2;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 4;

   inc(count); {giant spider}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {giant scorpion}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {basic}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 12;
   Stat[count].Iq_min   := 12;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {spyders}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 1;

   inc(count); {low renders}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {termagants}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {phlanxes}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;

   inc(count); {gantuas}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 3;

   inc(count); {myrmidon}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {plunges}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 16;
   Stat[count].Dx_min   := 16;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 7;
   Stat[count].Ma_min   := 7;
   Stat[count].Ma_max   := 7;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {WORKERS}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {large snake}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {giant snake}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 5;
   Stat[count].Ap       := 0;

   inc(count); {monster snake}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 6;
   Stat[count].Hx_min   := 6;
   Stat[count].Hx_max   := 10;
   Stat[count].Ap       := 0;

   inc(count); {lizard}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 5;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := MAX;
   Stat[count].Ap       := 0;

   inc(count); {goo}
   Stat[count].St       := MAX;
   Stat[count].St_min   := MAX;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;

   inc(count); {goo}
   Stat[count].St       := MAX;
   Stat[count].St_min   := MAX;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 3;
   Stat[count].Ma_min   := 3;
   Stat[count].Ma_max   := 3;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 0;

   inc(count); {goo}
   Stat[count].St       := MAX;
   Stat[count].St_min   := MAX;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 2;
   Stat[count].Ma_min   := 2;
   Stat[count].Ma_max   := 2;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 5;
   Stat[count].Hx_min   := 5;
   Stat[count].Hx_max   := 14;
   Stat[count].Ap       := 0;

   inc(count); {piranha}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {naughty minnow}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {shark}
   Stat[count].St       := 28;
   Stat[count].St_min   := 28;
   Stat[count].St_max   := 28;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 14;
   Stat[count].Ap       := 0;

   inc(count); {giant snapping turtles}
   Stat[count].St       := 36;
   Stat[count].St_min   := 36;
   Stat[count].St_max   := 36;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := 12;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 6;
   Stat[count].Ap       := 4;

   inc(count); {giant snapping turtles}
   Stat[count].St       := 70;
   Stat[count].St_min   := 70;
   Stat[count].St_max   := 70;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := 12;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 7;
   Stat[count].Hx_min   := 7;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 7;

   inc(count); {uncle teeth}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := 50;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := 13;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 4;
   Stat[count].Hx_min   := 4;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 2;

   inc(count); {giant clam}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := 50;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 0;
   Stat[count].Iq_min   := 0;
   Stat[count].Iq_max   := 0;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 1;

   inc(count); {kraken}
   Stat[count].St       := 60;
   Stat[count].St_min   := 60;
   Stat[count].St_max   := 60;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 6;
   Stat[count].Hx_min   := 6;
   Stat[count].Hx_max   := 6;
   Stat[count].Ap       := 2;

   inc(count); {crocodile}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 5;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 3;

   inc(count); {bloodtree}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := 10;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 0;
   Stat[count].Iq_min   := 0;
   Stat[count].Iq_max   := 0;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {am bush}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := 10;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := 12;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {mushroom}
   Stat[count].St       := 0;
   Stat[count].St_min   := 0;
   Stat[count].St_max   := 0;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 0;
   Stat[count].Iq_min   := 0;
   Stat[count].Iq_max   := 0;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 0;
   Stat[count].Hx_min   := 0;
   Stat[count].Hx_max   := 0;
   Stat[count].Ap       := 0;

   inc(count); {green slime}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := 20;
   Stat[count].Dx       := 1;
   Stat[count].Dx_min   := 1;
   Stat[count].Dx_max   := 1;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 2;
   Stat[count].Ma_min   := 2;
   Stat[count].Ma_max   := 2;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {brown slime}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := 30;
   Stat[count].Dx       := 1;
   Stat[count].Dx_min   := 1;
   Stat[count].Dx_max   := 1;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 2;
   Stat[count].Ma_min   := 2;
   Stat[count].Ma_max   := 2;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {silver slime}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := 20;
   Stat[count].Dx       := 1;
   Stat[count].Dx_min   := 1;
   Stat[count].Dx_max   := 1;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 6;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {rats}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {scuttles}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 9;
   Stat[count].Dx_min   := 9;
   Stat[count].Dx_max   := 9;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {piranhakeets}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {rats}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := 4;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {children}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := 4;
   Stat[count].Dx       := 5;
   Stat[count].Dx_min   := 5;
   Stat[count].Dx_max   := 5;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   InitRaceBodyPart;
end;

procedure TForm1.InitRaceBodyPart;
var
   count: integer;
begin
   for count := 1 to MaxRaceStats do
   begin
      body[count].part.blood       :=      0.0;        {deci lieters}
      body[count].part.head        :=      0.0;        {whole }
      body[count].part.ear         :=      0.0;        {whole}
      body[count].part.eye         :=      0.0;        {whole}
      body[count].part.brain       :=      0.0;        {whole}
      body[count].part.hair        :=      0.0;        {number of hairs on head}
      body[count].part.wisker      :=      0.0;        {length of hairs}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.mouth       :=      0.0;        {number of}
      body[count].part.tooth       :=      0.0;        {number of}
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.neck        :=      0.0;        {number of}
      body[count].part.nose        :=      0.0;        {number of}
      body[count].part.probiscus   :=      0.0;        {protrusion to head size ratio}
      body[count].part.body        :=      0.0;        {presence of}
      body[count].part.skin        :=      0.0;        {presence of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.trunk       :=      0.0;        {centi meter circumference }
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.backbone    :=      0.0;        {number of vertebra}
      body[count].part.gallbladder :=      0.0;        {presence of & absorbancy ratio to 1}
      body[count].part.heart       :=      0.0;        {presence of}
      body[count].part.liver       :=      0.0;        {presence of & absorbancy ratio to 1}
      body[count].part.limb        :=      0.0;        {number of}
      body[count].part.arm         :=      0.0;        {number of}
      body[count].part.hand        :=      0.0;        {number of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.leg         :=      0.0;        {number of}
      body[count].part.foot        :=      0.0;        {number of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.toenail     :=      0.0;        {number of}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.root        :=      0.0;        {depth}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.tail        :=      0.0;        {length}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.stinger     :=      0.0;        {damage of poison}
   end;
   count := 0;

   inc(count);
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.brain       :=      1.0;        {whole}
      body[count].part.hair        := 144000.0;        {number of hairs on head}
      body[count].part.wisker      :=      1.0;        {length of hairs, mm}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.trunk       :=      0.0;        {centi meter circumference }
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.gallbladder :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.heart       :=      1.0;        {presence of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.toenail     :=     10.0;        {number of}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.root        :=      0.0;        {depth}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.stinger     :=      0.0;        {damage of poison}
end;

procedure TForm1.FirstChoice;
var
   s: shortString;
begin
   RichEdit1.Lines.Clear;
   s := 'Father:________________________      Class: _________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Mother:________________________      Class: _________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);

   RichEdit1.SelStart := 7;
   RichEdit1.SelLength := 0;
end;

procedure TForm1.BlankSheet;
var
   s: shortString;
begin
   RichEdit1.Lines.Clear;
   s := 'Name:____________________ Sex:___________            ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Race: ________________________       Class: _________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                Cp: ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   S := 'St:____(____)   Bare hand:_______  |Wounds:         |';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Dx:____(____)   Armor:___________  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Iq:____(____)   _________________  |Fatigue:        |';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ma:____(____)   Reputation:______  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                    --Abilities--';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Studied:_____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                   --Accessories--';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ready weapon(s)  ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Secondary weapon ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                 ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'On belt _____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Hidden (where) ______________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Worn ________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Total kg ___________  including pack ________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ma-2______ Ma-4,Dx-1_______Ma-6,Dx-2_______Max_______';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ep: ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '   Accessory                  |    Location     | kg ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Five magic items (in order)                          ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(1)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(2)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(3)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(4)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(5)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                   -- Notes --';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);

   RichEdit1.SelStart := 7;
   RichEdit1.SelLength := 0;
end;

procedure TForm1.FullSheet;
var
   s, t: shortString;
begin
   RichEdit1.Lines.Clear;
   s := 'Name:________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 t  := char_race.Name;
   s := t;
   s := s + StringOfChar(' ', WidthRaceName -Length(s));
   s := 'Race:'+s;
   s := s+' Sex:______ Class:______';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 t  := getStat(char_stat.Cp);
   s := '                Cp: '+t;
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 t  := getStat(char_stat.St);
   S := 'St:'+t+'(____)   Bare hand:_______  |Wounds:         |';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 t  := getStat(char_stat.Dx);
   s := 'Dx:'+t+'(____)   Armor:___________  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 t  := getStat(char_stat.Iq);
   s := 'Iq:'+t+'(____)   _________________  |Fatigue:        |';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 t  := getStat(char_stat.Ma);
   s := 'Ma:'+t+'(____)   Reputation:______  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
 if round(char_stat.Hx) > 1 then
 begin
 t  := getStat(char_stat.Hx);
   s := 'Hex'+t;
 end else begin
   s := '';
 end;
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '                    --Abilities--';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Studied:_____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '                   --Accessories--';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Ready weapon(s)  ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Secondary weapon ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '                 ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'On belt _____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Hidden (where) ______________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Worn ________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Total kg ___________  including pack ________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Ma-2______ Ma-4,Dx-1_______Ma-6,Dx-2_______Max_______';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Ep: ';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '   Accessory                  |    Location     | kg ';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := 'Five magic items (in order)                          ';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '(1)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '(2)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '(3)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '(4)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '(5)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '                   -- Notes --';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   RichEdit1.Lines.Add(s);

   RichEdit1.SelStart := 7;
   RichEdit1.SelLength := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   InitRaces;
   InitChar;
   ListRaces;
end;

procedure TForm1.BirthChar;
var
   count: integer;
   s: shortString;
begin
{  char_race: TRaces;
  char_stat: TRaceStats;
  char_body: TBodyParts;}
 if (father > 0) and
    (mother > 0) then
 begin
  if father = mother then
  begin
     char_race.Name     := GetRaceName(father);
     char_race.Plural   := Race[father].Plural;
     char_race.common   := Race[father].common;
     char_race.language := Race[father].language;
     char_race.latin    := Race[father].latin;
     char_race.N        := Race[father].N ;

     char_stat.St       := Stat[Race[father].N].St;
     char_stat.St_min   := Stat[Race[father].N].St_min;
     char_stat.St_max   := Stat[Race[father].N].St_max;
     char_stat.Dx       := Stat[Race[father].N].Dx;
     char_stat.Dx_min   := Stat[Race[father].N].Dx_min;
     char_stat.Dx_max   := Stat[Race[father].N].Dx_max;
     char_stat.Iq       := Stat[Race[father].N].Iq;
     char_stat.Iq_min   := Stat[Race[father].N].Iq_min;
     char_stat.Iq_max   := Stat[Race[father].N].Iq_max;
     char_stat.Ma       := Stat[Race[father].N].Ma;
     char_stat.Ma_min   := Stat[Race[father].N].Ma_min;
     char_stat.Ma_max   := Stat[Race[father].N].Ma_max;
     char_stat.Cp       := Stat[Race[father].N].Cp;
     char_stat.Cp_min   := Stat[Race[father].N].Cp_min;
     char_stat.Cp_max   := Stat[Race[father].N].Cp_max;
     char_stat.Hx       := Stat[Race[father].N].Hx;
     char_stat.Hx_min   := Stat[Race[father].N].Hx_min;
     char_stat.Hx_max   := Stat[Race[father].N].Hx_max;
     char_stat.Ap       := Stat[Race[father].N].Ap;

  end else begin
     char_race.Name     := Race[mother].common +' '+Race[father].common;
     if length(char_race.Name) > WidthRaceName then
     begin
        s := char_race.Name;
        char_race.Name := '';
        for count := 1 to 24 do
            char_race.Name := char_race.Name + s[count];
     end;
     char_race.Plural   := Race[father].Plural;
     char_race.common   := Race[father].common;
     char_race.language := Race[father].language;
     char_race.latin    := Race[father].latin +' ' +Race[mother].latin;
     char_race.N        := Race[father].N;

     char_stat.St       := (Stat[Race[father].N].St +Stat[Race[mother].N].St) /2;
     char_stat.St_min   := (Stat[Race[father].N].St_min + Stat[Race[mother].N].St_min) /2;
     char_stat.St_max   := (Stat[Race[father].N].St_max + Stat[Race[mother].N].St_max) /2;
     char_stat.Dx       := (Stat[Race[father].N].Dx + Stat[Race[mother].N].Dx) /2;
     char_stat.Dx_min   := (Stat[Race[father].N].Dx_min + Stat[Race[mother].N].Dx_min) /2;
     char_stat.Dx_max   := (Stat[Race[father].N].Dx_max + Stat[Race[mother].N].Dx_max) /2;
     char_stat.Iq       := (Stat[Race[father].N].Iq + Stat[Race[mother].N].Iq) /2;
     char_stat.Iq_min   := (Stat[Race[father].N].Iq_min + Stat[Race[mother].N].Iq_min) /2;
     char_stat.Iq_max   := (Stat[Race[father].N].Iq_max + Stat[Race[mother].N].Iq_max) /2;
     char_stat.Ma       := (Stat[Race[father].N].Ma + Stat[Race[mother].N].Ma) /2;
     char_stat.Ma_min   := (Stat[Race[father].N].Ma_min + Stat[Race[mother].N].Ma_min) /2;
     char_stat.Ma_max   := (Stat[Race[father].N].Ma_max + Stat[Race[mother].N].Ma_max) /2;
     char_stat.Cp       := (Stat[Race[father].N].Cp + Stat[Race[mother].N].Cp) /2;
     char_stat.Cp_min   := (Stat[Race[father].N].Cp_min + Stat[Race[mother].N].Cp_min) /2;
     char_stat.Cp_max   := (Stat[Race[father].N].Cp_max + Stat[Race[mother].N].Cp_max) /2;
     char_stat.Hx       := (Stat[Race[father].N].Hx + Stat[Race[mother].N].Hx) /2;
     char_stat.Hx_min   := (Stat[Race[father].N].Hx_min + Stat[Race[mother].N].Hx_min) /2;
     char_stat.Hx_max   := (Stat[Race[father].N].Hx_max + Stat[Race[mother].N].Hx_max) /2;
     char_stat.Ap       := (Stat[Race[father].N].Ap + Stat[Race[mother].N].Ap) /2;

  end;
  FullSheet;
  end else begin
     initChar;
  end;
end;

procedure TForm1.SelectParent(count: integer);
var
   t, test, compare: shortstring;
   count2, found: integer;
begin
   Form1.Caption := IntToStr(count);

   t := ListBox1.Items.Strings[count-1];
   test := '';
   for count2 := 1 to 24 do
       test := test + t[count2];
   found := 0;

   for count2 := 1 to RaceCurrentTotal do
   begin
      compare := GetRaceName(count2);

      if test = compare then found := count2;

   end;

   case sentence of
    0: begin
         Form1.Caption := GetRaceName(found);
         Father := found;
         if mother <> 0 then
         begin
            BirthChar;
            Sentence := 2;
         end else begin
            sentence := 1;
         end;
       end;
    1: begin
         Form1.Caption := GetRaceName(found);
         Mother := found;
         if Father <> 0 then
         begin
            BirthChar;
            Sentence := 2;
         end else begin
            sentence := 0;
         end;
       end;
   end; // case sentence of
end;

function TForm1.GetRaceName(count: integer): shortString;
begin
      if Race[count].Name = '' then
      result := Race[count].Common else
      result := Race[count].Name +' ' +Race[count].Common;
      result := result + StringOfChar(' ',WidthRaceName -Length(result));
end;

function TForm1.GetStat(number: double): shortString;
var
   temp: integer;
begin
   result := '';
   temp := round(number);
   if temp <> 0 then
   begin
      if temp >= max then result := '  ~ ' else
         result := IntToStr(temp);
   end;
   result := StringOfChar(' ', 4-Length(result)) +Result;
end;

procedure Tform1.ListRaces;
var
  count, total: integer;
  s, t: ShortString;
begin
   listBox1.Items.Clear;
   for count := 1 to RaceCurrentTotal do
   begin
      s := '';
      s := s + GetRaceName(count);
      if Stat[Race[count].N].St = 0 then
      t := '' else if Stat[Race[count].N].St >= MAX then
      t := '~' else
      t := IntToStr(round(Stat[Race[count].N].St));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Dx = 0 then
      t := '' else if Stat[Race[count].N].Dx >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Dx));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Iq = 0 then
      t := '' else if Stat[Race[count].N].Iq >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Iq));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Ma = 0 then
      t := '' else if Stat[Race[count].N].Ma >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Ma));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Cp = 0 then
      t := '' else if Stat[Race[count].N].Cp >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Cp));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Ap = 0 then
      t := '' else if Stat[Race[count].N].Ap >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Ap));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;


      total := Round(Stat[Race[count].N].St);
      total := total +Round(Stat[Race[count].N].Dx);
      total := total +Round(Stat[Race[count].N].Iq);
      total := total +Round(Stat[Race[count].N].Cp);
      t := IntToStr(total);
      s := s +  StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      s := s + StringOfChar(' ',SheetCharWidth - length(s));
      ListBox1.Items.Add(s);
   end;
end;

procedure TForm1.New1Click(Sender: TObject);
begin
   InitChar;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  SelectParent(ListBox1.ItemAtPos(APoint, True) +1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if Button1.Caption = 'alphabetical' then
   begin
      ListBox1.Sorted := False;
      Button1.Caption := 'book format';
      ListRaces;
   end else begin
      ListBox1.Sorted := True;
      Button1.Caption := 'alphabetical';
   end;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
   New1Click(Self);
end;

procedure TForm1.ListBox1KeyPress(Sender: TObject; var Key: Char);
begin
   case key of
    #13: selectParent(ListBox1.ItemIndex +1);
   end;
end;

end.
