unit monsterP;

interface

uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ExtCtrls, Menus, ComCtrls, StdCtrls, ToolWin, Printers, Buttons, Mask;

type
  TForm1 = class(TForm)
    RichEdit1: TRichEdit;
    MainMenu1: TMainMenu;
    StatusBar1: TStatusBar;
    File1: TMenuItem;
    Exit1: TMenuItem;
    N1: TMenuItem;
    PrintSetup1: TMenuItem;
    Print1: TMenuItem;
    N2: TMenuItem;
    SaveAs1: TMenuItem;
    Save1: TMenuItem;
    Open1: TMenuItem;
    New1: TMenuItem;
    Edit1: TMenuItem;
    Object1: TMenuItem;
    Links1: TMenuItem;
    N3: TMenuItem;
    GoTo1: TMenuItem;
    Replace1: TMenuItem;
    Find1: TMenuItem;
    N4: TMenuItem;
    PasteSpecial1: TMenuItem;
    Paste1: TMenuItem;
    Copy1: TMenuItem;
    Cut1: TMenuItem;
    N5: TMenuItem;
    Repeatcommand1: TMenuItem;
    Undo1: TMenuItem;
    Splitter1: TSplitter;
    Panel1: TPanel;
    Panel2: TPanel;
    Splitter2: TSplitter;
    Panel3: TPanel;
    Splitter3: TSplitter;
    Panel4: TPanel;
    ListBox1: TListBox;
    Label1: TLabel;
    Label2: TLabel;
    Label3: TLabel;
    Label4: TLabel;
    Label5: TLabel;
    Label6: TLabel;
    Label7: TLabel;
    Label8: TLabel;
    Button1: TButton;
    ToolBar1: TToolBar;
    ToolButton1: TToolButton;
    ImageList1: TImageList;
    ToolButton2: TToolButton;
    ToolButton3: TToolButton;
    ToolButton4: TToolButton;
    ImageList2: TImageList;
    OpenDialog1: TOpenDialog;
    SaveDialog1: TSaveDialog;
    PopupMenu1: TPopupMenu;
    Copy: TMenuItem;
    N6: TMenuItem;
    Print2: TMenuItem;
    PrintDialog1: TPrintDialog;
    PrinterSetupDialog1: TPrinterSetupDialog;
    N7: TMenuItem;
    OutputtoText1: TMenuItem;
    PageControl1: TPageControl;
    TabSheetFormat: TTabSheet;
    TabSheetRace: TTabSheet;
    Memo1: TMemo;
    BitBtn1: TBitBtn;
    Button2: TButton;
    BitBtn2: TBitBtn;
    Button3: TButton;
    TabSheetSex: TTabSheet;
    Label9: TLabel;
    Label10: TLabel;
    Label11: TLabel;
    Label12: TLabel;
    Label13: TLabel;
    Label14: TLabel;
    Label15: TLabel;
    Label16: TLabel;
    Label17: TLabel;
    TabSheetName: TTabSheet;
    TabSheetClass: TTabSheet;
    TabSheetStrength: TTabSheet;
    TabSheetDexterity: TTabSheet;
    TabSheetInteligence: TTabSheet;
    TabSheetMove: TTabSheet;
    TabSheetHand: TTabSheet;
    TabSheetArmor: TTabSheet;
    TabSheetJob: TTabSheet;
    TabSheetSilver: TTabSheet;
    TabSheetWounds: TTabSheet;
    TabSheetFatigue: TTabSheet;
    TabSheetAble: TTabSheet;
    TabSheetStudy: TTabSheet;
    TabSheetReady: TTabSheet;
    TabSheetSecond: TTabSheet;
    TabSheetBelt: TTabSheet;
    TabSheetHidden: TTabSheet;
    TabSheetWorn: TTabSheet;
    TabSheetKg: TTabSheet;
    TabSheetExperience: TTabSheet;
    TabSheetPack: TTabSheet;
    TabSheetMagic1: TTabSheet;
    TabSheetMagic2: TTabSheet;
    TabSheetMagic3: TTabSheet;
    TabSheetMagic4: TTabSheet;
    TabSheetMagic5: TTabSheet;
    TabSheetNotes: TTabSheet;
    procedure FormCreate(Sender: TObject);
    procedure New1Click(Sender: TObject);
    procedure ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
      Shift: TShiftState; X, Y: Integer);
    procedure Button1Click(Sender: TObject);
    procedure ToolButton1Click(Sender: TObject);
    procedure Button2Click(Sender: TObject);
    procedure RichEdit1KeyPress(Sender: TObject; var Key: Char);
    procedure Button3Click(Sender: TObject);
    procedure CopyClick(Sender: TObject);
    procedure PrintSetup1Click(Sender: TObject);
    procedure Print1Click(Sender: TObject);
    procedure ToolButton3Click(Sender: TObject);
    procedure Print2Click(Sender: TObject);
    procedure OutputtoText1Click(Sender: TObject);
    procedure BitBtn1Click(Sender: TObject);
    procedure BitBtn2Click(Sender: TObject);
    procedure ListBox1KeyUp(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure PageControl1Change(Sender: TObject);
    procedure ListBox1DrawItem(Control: TWinControl; Index: Integer;
      Rect: TRect; State: TOwnerDrawState);
  private
     RaceCurrentTotal, start, leng, ceta,
     TalentCurrentTotal: integer;
     Fn: string;
     function GetActivePage: integer;
     procedure InitCapture;
     procedure InitChar;
     procedure InitRaces;
     procedure InitRaceStats;
     procedure InitRaceBodyPart;
     function FindTalent(s: shortString): UINT;
     procedure InitTalents;
     procedure BirthChar;
     procedure SelectParent(count: integer);
     procedure upDateTapSheetRace;
     function SelectRace(count: integer): integer;
     Function GetRaceName(count: integer): shortString;
     Function GetRaceNameIndex(count: integer): shortString;
     function GetStat(number: double): shortString;
     function GetDamage(number: double; st: double): shortString;
    { Private declarations }
  public
     sentence, father, mother: integer;
     procedure FirstChoice;
     procedure BlankSheet;
     procedure FullSheet;
     procedure ListFormats;
     procedure ListName;
     procedure ListRaces;
     procedure ListSex;
     procedure ListClass;
     procedure ListStrength;
     procedure ListDexterity;
     procedure ListInteligence;
     procedure ListMovement;
     procedure ListHand;
     procedure ListArmor;
     procedure ListJob;
     procedure ListSilver;
     procedure ListWounds;
     procedure ListFatigue;
     procedure ListAble;
     procedure ListStudy;
     procedure ListReady;
     procedure ListSecond;
     procedure ListBelt;
     procedure ListHidden;
     procedure ListWorn;
     procedure ListKg;
     procedure ListExperience;
     procedure ListPack;
     procedure ListMagic1;
     procedure ListMagic2;
     procedure ListMagic3;
     procedure ListMagic4;
     procedure ListMagic5;
     procedure ListNotes;
    { Public declarations }
  end;
const
  MaxWounds          =     25;
  MaxTalents         =    375;
  MaxAbility         =     42;

Type
   TParents = packed record
      Name, FirstName, MiddleName, LastName, NickName, Alias,
      Race, Sex, Classi: ShortString;
      end;

   TCharacterRecord = packed record
      Name, FirstName, MiddleName, LastName, NickName, Alias,
      Race, Sex, Classi: ShortString;
      Cp_S, St_S, St_adj_S, Dx_S, Dx_adj_S, Iq_S, Iq_adj_S, Ma_S, Ma_adj_S, Hex_S, Hex_adj_S,
      Hd_S, Hd_mod_S, Ap_S, Ep_S, Job_S, Fame_low_S, Fame_high_S: ShortString;
      wounds_S, fatigue_S: array [1..MaxWounds] of ShortString;
      Able: array [1..MaxTalents] of ShortString;
      Abilities: array [1.. MaxAbility] of ShortString;
      Studied1, Studied2, Studied3: ShortString;

      Ready0, Ready1, Ready2: ShortString;
      Ready0_kg, Ready1_kg, Ready2_kg: ShortString;
      Second1, Second2: ShortString;
      Second1_kg, Second2_kg: ShortString;
      Belt1, Belt2: ShortString;
      Belt1_kg, Belt2_kg: ShortString;
      Hidden1, Hidden2: ShortString;
      Hidden1_kg, Hidden2_kg: ShortString;
      Worn1, Worn2: ShortString;
      Worn1_kg, Worn2_kg: ShortString;
      Total_kg, Total_kg_Pack, Ma_2_kg, Ma_4_kg, Ma_6_kg, Max_kg: ShortString;

      Exp1, Exp2, Exp3: Shortstring;

      Equip1:     array [1.. 32] of ShortString;
      Equip1_loc: array [1.. 32] of ShortString;
      Equip1_kg:  array [1.. 32] of ShortString;

      Magic1:     array [1.. 10] of ShortString;
      Magic1_loc: array [1.. 10] of ShortString;
      Magic1_kg:  array [1.. 10] of ShortString;

      Note1, Note2, Note3: Shortstring;
      end;

   TChars = packed record
      Name, Sex, Classi: shortString;
      end;

   TRaces = record
      Name, Plural, common, language, latin,
      pref, sufi,
      hand, skin, fame: shortString;
      N: integer;
      end;

   TRaceStats = packed record
      St, St_min, St_max,
      Dx, Dx_min, Dx_max,
      Iq, Iq_min, Iq_max,
      Ma, Ma_min, Ma_max,
      Cp, Cp_min, Cp_max,
      Hx, Hx_min, Hx_max,
      Ap,
      Hd
      :double;
   end;

   TRaceBodyParts = packed record
      {component selection}
   blood,
      aura,
      awe,
      chromosomes,
      spells,
   head,
      antenna,
         TasteBudsAntena,
      ear,
         ear_drum,
         ear_min,
         ear_max,
      eye,
         retina,
         eyeFFR,
         eye2Pmicron,
         eye_diameter,
         eye_lenses,
         eye_vision,
         eye_rods,
         eye_sound,
         eye_electro,
         eye_stalks,
         eye_lids,
         brain,
      hair,
         wisker,
              TastebudsWiskers,
         beard,
      horn,
      mouth,
         TasteBudsRoof,
         toung,
            TastebudsToung,
         tooth,
         tusk,
         fang,
      neck,
         esophagus,
         voice_box,
         gills,
      nose,
         probiscus,
         sinus,
   body,
      skin,
         TasteBudsBody,
         hide,
         leather,
         fur,
         feather,
         chitin,
         shell,
         scales,
      nucleous,
      trunk,
            stalk,
            stem,
            bone,
               backbone,
               rib,
         gallbladder,
            GallBladder_IronOxide,
         heart,
         liver,
         kidney,
         lung,
         intestin_lessor,
         intestin_greater,
         stomache,
         spleen,
   limb,
      arm,
         hand,
            claw,
            claw_socket,
      fin,
      leg,
         TasteBudsLeg,
         foot,
            hoof,
            toenail,
            talon,
         root,
      tenticle,
      branch,
         twig,
            leaf,
      wing,
   tail,
         fluke,
         stinger,
         spinner
   : double
      end;

   TBodyParts = packed record
      Part: TRaceBodyParts;
      end;

   TCaptureSpaces = packed record
      name, nameW,
      race, raceW,               sex, sexW,    classi, classiW,
      cp, CpW, cp_adj, cp_adjW,
      St, StW, St_adj, St_adjW,  Hd, HdW,      wounds1, wounds1W,
                                               wounds2, wounds2W,
      Dx, DxW, Dx_adj, Dx_adjW,  Ap, ApW,      wounds3, wounds3W,

      Iq, IqW, Iq_adj, Iq_adjW,  Job, JobW,    fatigue1, fatigue1W,
                                               fatigue2, fatigue2W,
      Ma, MaW, Ma_adj, Ma_adjW,  silver, silverW,  Fatigue3, fatigue3W,
      Hx, HxW,
      Able1, Able1W,
      Able2, Able2W,
      Able3, Able3W,
      Able4, Able4W,
      Able5, Able5W,
      Able6, Able6W,
      Able7, Able7W,
      Able8, Able8W,
      Able9, Able9W,
      Able10, Able10W,
      Able11, Able11W,
      Able12, Able12W,
      Able13, Able13W,
      Able14, Able14W,
      Able15, Able15W,
      Able16, Able16W,
      study1, study1W, study2, study2W,
      ready0, ready0W, ready0_kg, ready0W_kg,
      ready1, ready1W, ready1_kg, ready1W_kg,
      ready2, ready2W, ready2_kg, ready2W_kg,
      Second1, Second1W, Second1_kg, Second1W_kg,
      Second2, Second2W, Second2_kg, Second2W_kg,
      Belt1, Belt1W, Belt2, Belt2W,
      Hidden1, Hidden1W, Hidden2, Hidden2W,
      Worn1, Worn1W, Worn2, Worn2W,
      TotalKg, TotalKgW, Pack, PackW,
      Ma_2, Ma_2W, Ma4, Ma4_W, Ma6, Ma6_W, Max, MaxW,
      Ep1, Ep1W,
      Ep2, Ep2W,
      Ep3, Ep3W,
      Equip1A,  Equip1AW,  Eq_loc1A,  Eq_loc1AW,  Eq_kg1A,  Eq_kg1AW,
      Equip1B,  Equip1BW,  Eq_loc1B,  Eq_loc1BW,  Eq_kg1B,  Eq_kg1BW,
      Equip2A,  Equip2AW,  Eq_loc2A,  Eq_loc2AW,  Eq_kg2A,  Eq_kg2AW,
      Equip2B,  Equip2BW,  Eq_loc2B,  Eq_loc2BW,  Eq_kg2B,  Eq_kg2BW,
      Equip3A,  Equip3AW,  Eq_loc3A,  Eq_loc3AW,  Eq_kg3A,  Eq_kg3AW,
      Equip3B,  Equip3BW,  Eq_loc3B,  Eq_loc3BW,  Eq_kg3B,  Eq_kg3BW,
      Equip4A,  Equip4AW,  Eq_loc4A,  Eq_loc4AW,  Eq_kg4A,  Eq_kg4AW,
      Equip4B,  Equip4BW,  Eq_loc4B,  Eq_loc4BW,  Eq_kg4B,  Eq_kg4BW,
      Equip5A,  Equip5AW,  Eq_loc5A,  Eq_loc5AW,  Eq_kg5A,  Eq_kg5AW,
      Equip5B,  Equip5BW,  Eq_loc5B,  Eq_loc5BW,  Eq_kg5B,  Eq_kg5BW,
      Equip6A,  Equip6AW,  Eq_loc6A,  Eq_loc6AW,  Eq_kg6A,  Eq_kg6AW,
      Equip6B,  Equip6BW,  Eq_loc6B,  Eq_loc6BW,  Eq_kg6B,  Eq_kg6BW,
      Equip7A,  Equip7AW,  Eq_loc7A,  Eq_loc7AW,  Eq_kg7A,  Eq_kg7AW,
      Equip7B,  Equip7BW,  Eq_loc7B,  Eq_loc7BW,  Eq_kg7B,  Eq_kg7BW,
      Equip8A,  Equip8AW,  Eq_loc8A,  Eq_loc8AW,  Eq_kg8A,  Eq_kg8AW,
      Equip8B,  Equip8BW,  Eq_loc8B,  Eq_loc8BW,  Eq_kg8B,  Eq_kg8BW,
      Equip9A,  Equip9AW,  Eq_loc9A,  Eq_loc9AW,  Eq_kg9A,  Eq_kg9AW,
      Equip9B,  Equip9BW,  Eq_loc9B,  Eq_loc9BW,  Eq_kg9B,  Eq_kg9BW,
      Equip10A, Equip10AW, Eq_loc10A, Eq_loc10AW, Eq_kg10A, Eq_kg10AW,
      Equip10B, Equip10BW, Eq_loc10B, Eq_loc10BW, Eq_kg10B, Eq_kg10BW,
      Equip11A, Equip11AW, Eq_loc11A, Eq_loc11AW, Eq_kg11A, Eq_kg11AW,
      Equip11B, Equip11BW, Eq_loc11B, Eq_loc11BW, Eq_kg11B, Eq_kg11BW,
      Equip12A, Equip12AW, Eq_loc12A, Eq_loc12AW, Eq_kg12A, Eq_kg12AW,
      Equip12B, Equip12BW, Eq_loc12B, Eq_loc12BW, Eq_kg12B, Eq_kg12BW,
      Equip13A, Equip13AW, Eq_loc13A, Eq_loc13AW, Eq_kg13A, Eq_kg13AW,
      Equip13B, Equip13BW, Eq_loc13B, Eq_loc13BW, Eq_kg13B, Eq_kg13BW,
      Equip14A, Equip14AW, Eq_loc14A, Eq_loc14AW, Eq_kg14A, Eq_kg14AW,
      Equip14B, Equip14BW, Eq_loc14B, Eq_loc14BW, Eq_kg14B, Eq_kg14BW,
      Equip15A, Equip15AW, Eq_loc15A, Eq_loc15AW, Eq_kg15A, Eq_kg15AW,
      Equip15B, Equip15BW, Eq_loc15B, Eq_loc15BW, Eq_kg15B, Eq_kg15BW,
      Equip16A, Equip16AW, Eq_loc16A, Eq_loc16AW, Eq_kg16A, Eq_kg16AW,
      Equip16B, Equip16BW, Eq_loc16B, Eq_loc16BW, Eq_kg16B, Eq_kg16BW,
      mi1A, mi1AW, mi1_locA, mi1_locAW, mi1_kgA, mi1_kgAW,
      mi1B, mi1BW, mi1_locB, mi1_locBW, mi1_kgB, mi1_kgBW,
      mi2A, mi2AW, mi2_locA, mi2_locAW, mi2_kgA, mi2_kgAW,
      mi2B, mi2BW, mi2_locB, mi2_locBW, mi2_kgB, mi2_kgBW,
      mi3A, mi3AW, mi3_locA, mi3_locAW, mi3_kgA, mi3_kgAW,
      mi3B, mi3BW, mi3_locB, mi3_locBW, mi3_kgB, mi3_kgBW,
      mi4A, mi4AW, mi4_locA, mi4_locAW, mi4_kgA, mi4_kgAW,
      mi4B, mi4BW, mi4_locB, mi4_locBW, mi4_kgB, mi4_kgBW,
      mi5A, mi5AW, mi5_locA, mi5_locAW, mi5_kgA, mi5_kgAW,
      mi5B, mi5BW, mi5_locB, mi5_locBW, mi5_kgB, mi5_kgBW,
      note1, note1W,
      note2, note2W,
      note3, note3W
      : integer;
      end;

   TTalents = record
      Name: shortString;
      NameN,
      Pre1N, pre2N, Pre1orN, pre2orN,
      PreInc1N, PreInc2N,
      IQ,
      costToWize,
      costToHero: UINT;
      cast: char; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
      JobQual: char; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
      category: char; // 't' = thrown, 'm' = missile, 'c' = creation, 's' = special
      listed, HandRequired: boolean; // False if not, and only implied
      end;

   TList = packed record
      List: TTalents;
      end;

const
  SheetCharWidth     =     62;
  SheetCharWidth2    =    116;
  SheetRaceWidth     =     54;
  MaxRaces           =    1440;
  MaxRaceStats       =    1440;
  Max                =   9999;
  WidthRaceName      =     25;
  WidthRacePlural    =     24;
  WidthRaceCommon    =     24;
  WidthRaceLanguage  =     24;
  WidthSex           =      6;
  WidthClass         =      6;
  WidthRaceSt        =      4;
  WidthRaceDx        =      4;
  WidthRaceIq        =      4;
  WidthRaceMa        =      4;
  WidthRaceEp        =      4;
  WidthHandDamage    =      8;

var
  Form1: TForm1;
  Race: array [1..MaxRaces] of TRaces;
  Stat: array [1..MaxRaceStats] of TRaceStats;
  Body: array [1..MaxRaceStats] of TBodyParts;
  char_act: TChars;
  char_race: TRaces;
  char_stat: TRaceStats;
  char_body: TBodyParts;
  char_wounds: array [1..MaxWounds] of integer;
  char_fatigue: array [1..MaxWounds] of integer;
  char_wounds1, char_wounds2, char_fatigue1, char_fatigue2: shortString;
  C: TCaptureSpaces;
  Talent: array [1..MaxTalents] of TList;
  cha: TCharacterRecord;

implementation

{$R *.DFM}

procedure TForm1.InitCapture;
var
   LoadStream: TFileStream;
   s: string;
begin
   Fn := ExtractFilePath(Application.ExeName);
   s  := Fn +'/sheet capture.int';

  LoadStream := TFileStream.Create(s,fmOpenRead);

   try
      LoadStream.Read(c.name, sizeof(Integer));
      LoadStream.Read(c.nameW, sizeof(Integer));
      LoadStream.Read(c.race, sizeof(Integer));
      LoadStream.Read(c.raceW, sizeof(Integer));
      LoadStream.Read(c.sex, sizeof(Integer));
      LoadStream.Read(c.sexW, sizeof(Integer));
      LoadStream.Read(c.classi, sizeof(Integer));
      LoadStream.Read(c.classiW, sizeof(Integer));
      LoadStream.Read(c.cp, sizeof(Integer));
      LoadStream.Read(c.CpW, sizeof(Integer));
      LoadStream.Read(c.cp_adj, sizeof(Integer));
      LoadStream.Read(c.cp_adjW, sizeof(Integer));
      LoadStream.Read(c.St, sizeof(Integer));
      LoadStream.Read(c.StW, sizeof(Integer));
      LoadStream.Read(c.St_adj, sizeof(Integer));
      LoadStream.Read(c.St_adjW, sizeof(Integer));
      LoadStream.Read(c.Hd, sizeof(Integer));
      LoadStream.Read(c.HdW, sizeof(Integer));
      LoadStream.Read(c.wounds1, sizeof(Integer));
      LoadStream.Read(c.wounds1W, sizeof(Integer));
      LoadStream.Read(c.wounds2, sizeof(Integer));
      LoadStream.Read(c.wounds2W, sizeof(Integer));
      LoadStream.Read(c.Dx, sizeof(Integer));
      LoadStream.Read(c.DxW, sizeof(Integer));
      LoadStream.Read(c.Dx_adj, sizeof(Integer));
      LoadStream.Read(c.Dx_adjW, sizeof(Integer));
      LoadStream.Read(c.Ap, sizeof(Integer));
      LoadStream.Read(c.ApW, sizeof(Integer));
      LoadStream.Read(c.wounds3, sizeof(Integer));
      LoadStream.Read(c.wounds3W, sizeof(Integer));
      LoadStream.Read(c.Iq, sizeof(Integer));
      LoadStream.Read(c.IqW, sizeof(Integer));
      LoadStream.Read(c.Iq_adj, sizeof(Integer));
      LoadStream.Read(c.Iq_adjW, sizeof(Integer));
      LoadStream.Read(c.Job, sizeof(Integer));
      LoadStream.Read(c.JobW, sizeof(Integer));
      LoadStream.Read(c.fatigue1, sizeof(Integer));
      LoadStream.Read(c.fatigue1W, sizeof(Integer));
      LoadStream.Read(c.fatigue2, sizeof(Integer));
      LoadStream.Read(c.fatigue2W, sizeof(Integer));
      LoadStream.Read(c.Ma, sizeof(Integer));
      LoadStream.Read(c.MaW, sizeof(Integer));
      LoadStream.Read(c.Ma_adj, sizeof(Integer));
      LoadStream.Read(c.Ma_adjW, sizeof(Integer));
      LoadStream.Read(c.silver, sizeof(Integer));
      LoadStream.Read(c.silverW, sizeof(Integer));
      LoadStream.Read(c.Fatigue3, sizeof(Integer));
      LoadStream.Read(c.fatigue3W, sizeof(Integer));
      LoadStream.Read(c.Hx, sizeof(Integer));
      LoadStream.Read(c.HxW, sizeof(Integer));
      LoadStream.Read(c.Able1, sizeof(Integer));
      LoadStream.Read(c.Able1W, sizeof(Integer));
      LoadStream.Read(c.Able2, sizeof(Integer));
      LoadStream.Read(c.Able2W, sizeof(Integer));
      LoadStream.Read(c.Able3, sizeof(Integer));
      LoadStream.Read(c.Able3W, sizeof(Integer));
      LoadStream.Read(c.Able4, sizeof(Integer));
      LoadStream.Read(c.Able4W, sizeof(Integer));
      LoadStream.Read(c.Able5, sizeof(Integer));
      LoadStream.Read(c.Able5W, sizeof(Integer));
      LoadStream.Read(c.Able6, sizeof(Integer));
      LoadStream.Read(c.Able6W, sizeof(Integer));
      LoadStream.Read(c.Able7, sizeof(Integer));
      LoadStream.Read(c.Able7W, sizeof(Integer));
      LoadStream.Read(c.Able8, sizeof(Integer));
      LoadStream.Read(c.Able8W, sizeof(Integer));
      LoadStream.Read(c.Able9, sizeof(Integer));
      LoadStream.Read(c.Able9W, sizeof(Integer));
      LoadStream.Read(c.Able10, sizeof(Integer));
      LoadStream.Read(c.Able10W, sizeof(Integer));
      LoadStream.Read(c.Able11, sizeof(Integer));
      LoadStream.Read(c.Able11W, sizeof(Integer));
      LoadStream.Read(c.Able12, sizeof(Integer));
      LoadStream.Read(c.Able12W, sizeof(Integer));
      LoadStream.Read(c.Able13, sizeof(Integer));
      LoadStream.Read(c.Able13W, sizeof(Integer));
      LoadStream.Read(c.Able14, sizeof(Integer));
      LoadStream.Read(c.Able14W, sizeof(Integer));
      LoadStream.Read(c.Able15, sizeof(Integer));
      LoadStream.Read(c.Able15W, sizeof(Integer));
      LoadStream.Read(c.Able16, sizeof(Integer));
      LoadStream.Read(c.Able16W, sizeof(Integer));
      LoadStream.Read(c.study1, sizeof(Integer));
      LoadStream.Read(c.study1W, sizeof(Integer));
      LoadStream.Read(c.study2, sizeof(Integer));
      LoadStream.Read(c.study2W, sizeof(Integer));
      LoadStream.Read(c.ready0, sizeof(Integer));
      LoadStream.Read(c.ready0W, sizeof(Integer));
      LoadStream.Read(c.ready0_kg, sizeof(Integer));
      LoadStream.Read(c.ready0W_kg, sizeof(Integer));
      LoadStream.Read(c.ready1, sizeof(Integer));
      LoadStream.Read(c.ready1W, sizeof(Integer));
      LoadStream.Read(c.ready1_kg, sizeof(Integer));
      LoadStream.Read(c.ready1W_kg, sizeof(Integer));
      LoadStream.Read(c.ready2, sizeof(Integer));
      LoadStream.Read(c.ready2W, sizeof(Integer));
      LoadStream.Read(c.ready2_kg, sizeof(Integer));
      LoadStream.Read(c.ready2W_kg, sizeof(Integer));
      LoadStream.Read(c.Second1, sizeof(Integer));
      LoadStream.Read(c.Second1W, sizeof(Integer));
      LoadStream.Read(c.Second1_kg, sizeof(Integer));
      LoadStream.Read(c.Second1W_kg, sizeof(Integer));
      LoadStream.Read(c.Second2, sizeof(Integer));
      LoadStream.Read(c.Second2W, sizeof(Integer));
      LoadStream.Read(c.Second2_kg, sizeof(Integer));
      LoadStream.Read(c.Second2W_kg, sizeof(Integer));
      LoadStream.Read(c.Belt1, sizeof(Integer));
      LoadStream.Read(c.Belt1W, sizeof(Integer));
      LoadStream.Read(c.Belt2, sizeof(Integer));
      LoadStream.Read(c.Belt2W, sizeof(Integer));
      LoadStream.Read(c.Hidden1, sizeof(Integer));
      LoadStream.Read(c.Hidden1W, sizeof(Integer));
      LoadStream.Read(c.Hidden2, sizeof(Integer));
      LoadStream.Read(c.Hidden2W, sizeof(Integer));
      LoadStream.Read(c.Worn1, sizeof(Integer));
      LoadStream.Read(c.Worn1W, sizeof(Integer));
      LoadStream.Read(c.Worn2, sizeof(Integer));
      LoadStream.Read(c.Worn2W, sizeof(Integer));
      LoadStream.Read(c.TotalKg, sizeof(Integer));
      LoadStream.Read(c.TotalKgW, sizeof(Integer));
      LoadStream.Read(c.Pack, sizeof(Integer));
      LoadStream.Read(c.PackW, sizeof(Integer));
      LoadStream.Read(c.Ma_2, sizeof(Integer));
      LoadStream.Read(c.Ma_2W, sizeof(Integer));
      LoadStream.Read(c.Ma4, sizeof(Integer));
      LoadStream.Read(c.Ma4_W, sizeof(Integer));
      LoadStream.Read(c.Ma6, sizeof(Integer));
      LoadStream.Read(c.Ma6_W, sizeof(Integer));
      LoadStream.Read(c.Max, sizeof(Integer));
      LoadStream.Read(c.MaxW, sizeof(Integer));
      LoadStream.Read(c.Ep1, sizeof(Integer));
      LoadStream.Read(c.Ep1W, sizeof(Integer));
      LoadStream.Read(c.Ep2, sizeof(Integer));
      LoadStream.Read(c.Ep2W, sizeof(Integer));
      LoadStream.Read(c.Ep3, sizeof(Integer));
      LoadStream.Read(c.Ep3W, sizeof(Integer));

      LoadStream.Read(c.Equip1A, sizeof(Integer));
      LoadStream.Read(c.Equip1AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc1A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc1AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg1A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg1AW, sizeof(Integer));
      LoadStream.Read(c.Equip1B, sizeof(Integer));
      LoadStream.Read(c.Equip1BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc1B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc1BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg1B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg1BW, sizeof(Integer));

      LoadStream.Read(c.Equip2A, sizeof(Integer));
      LoadStream.Read(c.Equip2AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc2A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc2AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg2A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg2AW, sizeof(Integer));
      LoadStream.Read(c.Equip2B, sizeof(Integer));
      LoadStream.Read(c.Equip2BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc2B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc2BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg2B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg2BW, sizeof(Integer));

      LoadStream.Read(c.Equip3A, sizeof(Integer));
      LoadStream.Read(c.Equip3AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc3A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc3AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg3A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg3AW, sizeof(Integer));
      LoadStream.Read(c.Equip3B, sizeof(Integer));
      LoadStream.Read(c.Equip3BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc3B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc3BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg3B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg3BW, sizeof(Integer));

      LoadStream.Read(c.Equip4A, sizeof(Integer));
      LoadStream.Read(c.Equip4AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc4A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc4AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg4A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg4AW, sizeof(Integer));
      LoadStream.Read(c.Equip4B, sizeof(Integer));
      LoadStream.Read(c.Equip4BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc4B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc4BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg4B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg4BW, sizeof(Integer));

      LoadStream.Read(c.Equip5A, sizeof(Integer));
      LoadStream.Read(c.Equip5AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc5A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc5AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg5A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg5AW, sizeof(Integer));
      LoadStream.Read(c.Equip5B, sizeof(Integer));
      LoadStream.Read(c.Equip5BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc5B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc5BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg5B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg5BW, sizeof(Integer));

      LoadStream.Read(c.Equip6A, sizeof(Integer));
      LoadStream.Read(c.Equip6AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc6A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc6AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg6A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg6AW, sizeof(Integer));
      LoadStream.Read(c.Equip6B, sizeof(Integer));
      LoadStream.Read(c.Equip6BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc6B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc6BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg6B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg6BW, sizeof(Integer));

      LoadStream.Read(c.Equip7A, sizeof(Integer));
      LoadStream.Read(c.Equip7AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc7A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc7AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg7A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg7AW, sizeof(Integer));
      LoadStream.Read(c.Equip7B, sizeof(Integer));
      LoadStream.Read(c.Equip7BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc7B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc7BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg7B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg7BW, sizeof(Integer));

      LoadStream.Read(c.Equip8A, sizeof(Integer));
      LoadStream.Read(c.Equip8AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc8A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc8AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg8A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg8AW, sizeof(Integer));
      LoadStream.Read(c.Equip8B, sizeof(Integer));
      LoadStream.Read(c.Equip8BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc8B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc8BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg8B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg8BW, sizeof(Integer));

      LoadStream.Read(c.Equip9A, sizeof(Integer));
      LoadStream.Read(c.Equip9AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc9A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc9AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg9A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg9AW, sizeof(Integer));
      LoadStream.Read(c.Equip9B, sizeof(Integer));
      LoadStream.Read(c.Equip9BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc9B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc9BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg9B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg9BW, sizeof(Integer));

      LoadStream.Read(c.Equip10A, sizeof(Integer));
      LoadStream.Read(c.Equip10AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc10A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc10AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg10A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg10AW, sizeof(Integer));
      LoadStream.Read(c.Equip10B, sizeof(Integer));
      LoadStream.Read(c.Equip10BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc10B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc10BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg10B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg10BW, sizeof(Integer));

      LoadStream.Read(c.Equip11A, sizeof(Integer));
      LoadStream.Read(c.Equip11AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc11A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc11AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg11A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg11AW, sizeof(Integer));
      LoadStream.Read(c.Equip11B, sizeof(Integer));
      LoadStream.Read(c.Equip11BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc11B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc11BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg11B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg11BW, sizeof(Integer));

      LoadStream.Read(c.Equip12A, sizeof(Integer));
      LoadStream.Read(c.Equip12AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc12A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc12AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg12A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg12AW, sizeof(Integer));
      LoadStream.Read(c.Equip12B, sizeof(Integer));
      LoadStream.Read(c.Equip12BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc12B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc12BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg12B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg12BW, sizeof(Integer));

      LoadStream.Read(c.Equip13A, sizeof(Integer));
      LoadStream.Read(c.Equip13AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc13A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc13AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg13A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg13AW, sizeof(Integer));
      LoadStream.Read(c.Equip13B, sizeof(Integer));
      LoadStream.Read(c.Equip13BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc13B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc13BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg13B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg13BW, sizeof(Integer));

      LoadStream.Read(c.Equip14A, sizeof(Integer));
      LoadStream.Read(c.Equip14AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc14A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc14AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg14A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg14AW, sizeof(Integer));
      LoadStream.Read(c.Equip14B, sizeof(Integer));
      LoadStream.Read(c.Equip14BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc14B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc14BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg14B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg14BW, sizeof(Integer));

      LoadStream.Read(c.Equip15A, sizeof(Integer));
      LoadStream.Read(c.Equip15AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc15A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc15AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg15A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg15AW, sizeof(Integer));
      LoadStream.Read(c.Equip15B, sizeof(Integer));
      LoadStream.Read(c.Equip15BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc15B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc15BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg15B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg15BW, sizeof(Integer));

      LoadStream.Read(c.Equip16A, sizeof(Integer));
      LoadStream.Read(c.Equip16AW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc16A, sizeof(Integer));
      LoadStream.Read(c.Eq_loc16AW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg16A, sizeof(Integer));
      LoadStream.Read(c.Eq_kg16AW, sizeof(Integer));
      LoadStream.Read(c.Equip16B, sizeof(Integer));
      LoadStream.Read(c.Equip16BW, sizeof(Integer));
      LoadStream.Read(c.Eq_loc16B, sizeof(Integer));
      LoadStream.Read(c.Eq_loc16BW, sizeof(Integer));
      LoadStream.Read(c.Eq_kg16B, sizeof(Integer));
      LoadStream.Read(c.Eq_kg16BW, sizeof(Integer));


      LoadStream.Read(c.mi1A, sizeof(Integer));
      LoadStream.Read(c.mi1AW, sizeof(Integer));
      LoadStream.Read(c.mi1_locA, sizeof(Integer));
      LoadStream.Read(c.mi1_locAW, sizeof(Integer));
      LoadStream.Read(c.mi1_kgA, sizeof(Integer));
      LoadStream.Read(c.mi1_kgAW, sizeof(Integer));
      LoadStream.Read(c.mi1B, sizeof(Integer));
      LoadStream.Read(c.mi1BW, sizeof(Integer));
      LoadStream.Read(c.mi1_locB, sizeof(Integer));
      LoadStream.Read(c.mi1_locBW, sizeof(Integer));
      LoadStream.Read(c.mi1_kgB, sizeof(Integer));
      LoadStream.Read(c.mi1_kgBW, sizeof(Integer));

      LoadStream.Read(c.mi2A, sizeof(Integer));
      LoadStream.Read(c.mi2AW, sizeof(Integer));
      LoadStream.Read(c.mi2_locA, sizeof(Integer));
      LoadStream.Read(c.mi2_locAW, sizeof(Integer));
      LoadStream.Read(c.mi2_kgA, sizeof(Integer));
      LoadStream.Read(c.mi2_kgAW, sizeof(Integer));
      LoadStream.Read(c.mi2B, sizeof(Integer));
      LoadStream.Read(c.mi2BW, sizeof(Integer));
      LoadStream.Read(c.mi2_locB, sizeof(Integer));
      LoadStream.Read(c.mi2_locBW, sizeof(Integer));
      LoadStream.Read(c.mi2_kgB, sizeof(Integer));
      LoadStream.Read(c.mi2_kgBW, sizeof(Integer));

      LoadStream.Read(c.mi3A, sizeof(Integer));
      LoadStream.Read(c.mi3AW, sizeof(Integer));
      LoadStream.Read(c.mi3_locA, sizeof(Integer));
      LoadStream.Read(c.mi3_locAW, sizeof(Integer));
      LoadStream.Read(c.mi3_kgA, sizeof(Integer));
      LoadStream.Read(c.mi3_kgAW, sizeof(Integer));
      LoadStream.Read(c.mi3B, sizeof(Integer));
      LoadStream.Read(c.mi3BW, sizeof(Integer));
      LoadStream.Read(c.mi3_locB, sizeof(Integer));
      LoadStream.Read(c.mi3_locBW, sizeof(Integer));
      LoadStream.Read(c.mi3_kgB, sizeof(Integer));
      LoadStream.Read(c.mi3_kgBW, sizeof(Integer));

      LoadStream.Read(c.mi4A, sizeof(Integer));
      LoadStream.Read(c.mi4AW, sizeof(Integer));
      LoadStream.Read(c.mi4_locA, sizeof(Integer));
      LoadStream.Read(c.mi4_locAW, sizeof(Integer));
      LoadStream.Read(c.mi4_kgA, sizeof(Integer));
      LoadStream.Read(c.mi4_kgAW, sizeof(Integer));
      LoadStream.Read(c.mi4B, sizeof(Integer));
      LoadStream.Read(c.mi4BW, sizeof(Integer));
      LoadStream.Read(c.mi4_locB, sizeof(Integer));
      LoadStream.Read(c.mi4_locBW, sizeof(Integer));
      LoadStream.Read(c.mi4_kgB, sizeof(Integer));
      LoadStream.Read(c.mi4_kgBW, sizeof(Integer));

      LoadStream.Read(c.mi5A, sizeof(Integer));
      LoadStream.Read(c.mi5AW, sizeof(Integer));
      LoadStream.Read(c.mi5_locA, sizeof(Integer));
      LoadStream.Read(c.mi5_locAW, sizeof(Integer));
      LoadStream.Read(c.mi5_kgA, sizeof(Integer));
      LoadStream.Read(c.mi5_kgAW, sizeof(Integer));
      LoadStream.Read(c.mi5B, sizeof(Integer));
      LoadStream.Read(c.mi5BW, sizeof(Integer));
      LoadStream.Read(c.mi5_locB, sizeof(Integer));
      LoadStream.Read(c.mi5_locBW, sizeof(Integer));
      LoadStream.Read(c.mi5_kgB, sizeof(Integer));
      LoadStream.Read(c.mi5_kgBW, sizeof(Integer));

      LoadStream.Read(c.note1, sizeof(Integer));
      LoadStream.Read(c.note1W, sizeof(Integer));
      LoadStream.Read(c.note2, sizeof(Integer));
      LoadStream.Read(c.note2W, sizeof(Integer));
      LoadStream.Read(c.note3, sizeof(Integer));
      LoadStream.Read(c.note3W, sizeof(Integer));
   finally
      LoadStream.Free;
   end;
end;

procedure TForm1.InitChar;
var
   count: integer;
begin
   for count := 1 to MaxWounds do
   begin
      char_wounds[count] := 0;
      char_fatigue[count] := 0;
   end;
  char_wounds1 := '';
  char_wounds2 := '';
  char_fatigue1 := '';
  char_fatigue2 := '';
   start := 0;
   leng := 0;
   ceta := 0;
   Memo1.Lines.Clear;

   Sentence := 0;
   Father := 0;
   Mother := 0;
   FirstChoice;

   char_act.name := '';
   char_act.sex := '';
   char_act.classi := '';

   char_race.Name := '';
   char_race.Plural  := '';
   char_race.common  := '';
   char_race.language  := '';
   char_race.latin  := '';
   char_race.hand  := '';
   char_race.skin  := '';
   char_race.fame  := '';
   char_race.N  := 0;

   char_stat.St := 0.0;
   char_stat.St_min := 0.0;
   char_stat.St_max := 0.0;
   char_stat.Dx := 0.0;
   char_stat.Dx_min := 0.0;
   char_stat.Dx_max := 0.0;
   char_stat.Iq := 0.0;
   char_stat.Iq_min := 0.0;
   char_stat.Iq_max := 0.0;
   char_stat.Ma := 0.0;
   char_stat.Ma_min := 0.0;
   char_stat.Ma_max := 0.0;
   char_stat.Cp := 0.0;
   char_stat.Cp_min := 0.0;
   char_stat.Cp_max := 0.0;
   char_stat.Hx := 0.0;
   char_stat.Hx_min := 0.0;
   char_stat.Hx_max := 0.0;
   char_stat.Ap := 0.0;
   char_stat.Hd := 0.0;
   for count := 1 to MaxTalents do
      cha.Able[count] := '';

   for count := 1 to MaxAbility do
      cha.Abilities[count] := '';

      cha.Studied1 := '';
      cha.Studied2 := '';
      cha.Studied3 := '';
end;

procedure Tform1.InitRaces;
var
   count, stat_count: integer;
begin
   count :=1;
   stat_count :=1;
   Race[count].Name     := 'black';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'yellow';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'orange';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'red';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hairy';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'bald';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'peaceful';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'warlike';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'city-bred';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wandering';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'amazon';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'male-chauvinist';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'good';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'evil';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'practical';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mad';
   Race[count].Plural   := 'men';
   Race[count].Common   := 'human';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'hominis';
   Race[count].Pref     := 'hum';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nasty';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'coarse-hair';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'sharp-tooth';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'fanged';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'claw';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'tough';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'greedy';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'quarrelsome';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'good';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'harsh';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'militant';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountain';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hut';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'kingdom';
   Race[count].Plural   := 'orcs';
   Race[count].Common   := 'orc';
   Race[count].Language := 'orcish';
   Race[count].Latin    := 'orcanthropus';
   Race[count].Pref     := 'orc';
   Race[count].Sufi     := 'orc';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'slender';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'uncommon';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'influential';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'forest';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountain-peak';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'proud';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'aloof';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'humble';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'elvish';
   Race[count].Latin    := 'albus';
   Race[count].Pref     := 'elf';
   Race[count].Sufi     := 'elf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'underground';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].Pref     := 'dwar';
   Race[count].Sufi     := 'warf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dignified';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].Pref     := 'dwar';
   Race[count].Sufi     := 'warf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'boisterous';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].Pref     := 'dwar';
   Race[count].Sufi     := 'warf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'earthy';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].Pref     := 'dwar';
   Race[count].Sufi     := 'warf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'drinking';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].Pref     := 'dwar';
   Race[count].Sufi     := 'warf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gold-digger';
   Race[count].Plural   := 'dwarves';
   Race[count].Common   := 'dwarf';
   Race[count].Language := 'dwarvish';
   Race[count].Latin    := 'dweorh';
   Race[count].Pref     := 'dwar';
   Race[count].Sufi     := 'warf';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'bad';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'proud';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'intelligent';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'crafty';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ruthless';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'civil';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'merchant';
   Race[count].Plural   := 'goblins';
   Race[count].Common   := 'goblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'gob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'big';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'stupid';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'servant';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'simple';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'brutal';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'cruel';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'bad';
   Race[count].Plural   := 'hobgoblins';
   Race[count].Common   := 'hobgoblin';
   Race[count].Language := 'goblish';
   Race[count].Latin    := 'kobalos';
   Race[count].Pref     := 'hob';
   Race[count].Sufi     := 'lin';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'peaceful';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].Pref     := 'half';
   Race[count].Sufi     := 'ling';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'rural';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].Pref     := 'half';
   Race[count].Sufi     := 'ling';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'venturing';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].Pref     := 'half';
   Race[count].Sufi     := 'ling';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'nimble';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].Pref     := 'half';
   Race[count].Sufi     := 'ling';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hardy';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].Pref     := 'half';
   Race[count].Sufi     := 'ling';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'friendly';
   Race[count].Plural   := 'halflings';
   Race[count].Common   := 'halfling';
   Race[count].Language := 'hobbish';
   Race[count].Latin    := 'holbytela';
   Race[count].Pref     := 'half';
   Race[count].Sufi     := 'ling';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'quarreling';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'unruly';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'moronic';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hunter';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gatherer';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'villa';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'alley';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'quarreling';
   Race[count].Plural   := 'prootwaddles';
   Race[count].Common   := 'prootwaddle';
   Race[count].Language := 'prootish';
   Race[count].Latin    := 'pradix miscere';
   Race[count].Pref     := 'proot';
   Race[count].Sufi     := 'waddle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'grassland';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].Pref     := 'cen';
   Race[count].Sufi     := 'taur';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'woodland';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].Pref     := 'cen';
   Race[count].Sufi     := 'taur';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'forester';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].Pref     := 'cen';
   Race[count].Sufi     := 'taur';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'civilized';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].Pref     := 'cen';
   Race[count].Sufi     := 'taur';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'barbarian';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].Pref     := 'cen';
   Race[count].Sufi     := 'taur';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wino';
   Race[count].Plural   := 'centaurs';
   Race[count].Common   := 'centaur';
   Race[count].Language := 'centauri';
   Race[count].Latin    := 'centaurus';
   Race[count].Pref     := 'cen';
   Race[count].Sufi     := 'taur';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'simpleton';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'titanus';
   Race[count].Pref     := 'gian';
   Race[count].Sufi     := 'giant';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'quiet';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'titanus';
   Race[count].Pref     := 'gian';
   Race[count].Sufi     := 'giant';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gardener';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'titanus';
   Race[count].Pref     := 'gian';
   Race[count].Sufi     := 'giant';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'outcast';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'titanus';
   Race[count].Pref     := 'gian';
   Race[count].Sufi     := 'giant';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'surly';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'titanus';
   Race[count].Pref     := 'gian';
   Race[count].Sufi     := 'giant';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'murderous';
   Race[count].Plural   := 'giants';
   Race[count].Common   := 'giant';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'titanus';
   Race[count].Pref     := 'gian';
   Race[count].Sufi     := 'giant';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'tough';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'tribal';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountainous';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ruin-dwelling';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'jewel-collector';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'guard';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'trustworthy';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'sullen';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'suspicious';
   Race[count].Plural   := 'gargoyles';
   Race[count].Common   := 'gargoyle';
   Race[count].Language := 'goyleish';
   Race[count].Latin    := 'aqua oris';
   Race[count].Pref     := 'gar';
   Race[count].Sufi     := 'goyle';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'fearsome';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'disliked';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'shunned';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'loyal';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'reserved';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'touchy';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'duelist';
   Race[count].Plural   := 'reptile men';
   Race[count].Common   := 'reptile man';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'reptilis';
   Race[count].Pref     := 'rept';
   Race[count].Sufi     := 'tile';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pond';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'meerish';
   Race[count].Latin    := 'meros hominis';
   Race[count].Pref     := 'mer';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'lake';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'meerish';
   Race[count].Latin    := 'meros hominis';
   Race[count].Pref     := 'mer';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'sea';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'meerish';
   Race[count].Latin    := 'meros hominis';
   Race[count].Pref     := 'mer';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'ocean';
   Race[count].Plural   := 'mermen';
   Race[count].Common   := 'merman';
   Race[count].Language := 'meerish';
   Race[count].Latin    := 'meros hominis';
   Race[count].Pref     := 'mer';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := 1;

   inc(count);
   Race[count].Name     := 'deep';
   Race[count].Plural   := 'elves';
   Race[count].Common   := 'elf';
   Race[count].Language := 'sea elvish';
   Race[count].Latin    := 'meros hominis';
   Race[count].Pref     := 'mer';
   Race[count].Sufi     := 'man';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'Fame';
   Race[count].N := 3;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'white';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gon';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'status';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'grey';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gon';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'status';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'black';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gon';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'status';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'brown';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gon';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'status';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'red';
   Race[count].Plural   := 'dragons';
   Race[count].Common   := 'dragon';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gon';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'status';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'greater';
   Race[count].Plural   := 'demons';
   Race[count].Common   := 'demon';
   Race[count].Language := 'demonic';
   Race[count].Latin    := 'daemonies';
   Race[count].Pref     := 'daem';
   Race[count].Sufi     := 'mon';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'dishonesty';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'lesser';
   Race[count].Plural   := 'demons';
   Race[count].Common   := 'demon';
   Race[count].Language := 'demonic';
   Race[count].Latin    := 'daemonies';
   Race[count].Pref     := 'daem';
   Race[count].Sufi     := 'mon';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'dishonesty';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'shy';
   Race[count].Plural   := 'sasquatch';
   Race[count].Common   := 'sasquatch';
   Race[count].Language := 'salishan';
   Race[count].Latin    := 'yeti';
   Race[count].Pref     := 'daem';
   Race[count].Sufi     := 'sas';
   Race[count].Hand     := 'quatch';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'meaness';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'shy';
   Race[count].Plural   := 'yeti';
   Race[count].Common   := 'yeti';
   Race[count].Language := 'tibetan';
   Race[count].Latin    := 'yeti';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'meaness';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'servant';
   Race[count].Plural   := 'wyverns';
   Race[count].Common   := 'wyvern';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'vipera';
   Race[count].Pref     := 'wyver';
   Race[count].Sufi     := 'vern';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'magic-lust';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'enchantment-using';
   Race[count].Plural   := 'wyverns';
   Race[count].Common   := 'wyvern';
   Race[count].Language := 'draconian';
   Race[count].Latin    := 'vipera';
   Race[count].Pref     := 'wyver';
   Race[count].Sufi     := 'vern';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'magic-lust';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'ally';
   Race[count].Plural   := 'wraiths';
   Race[count].Common   := 'wraith';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'phasma';
   Race[count].Pref     := 'wraith';
   Race[count].Sufi     := 'wraith';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'wants';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wizard';
   Race[count].Plural   := 'wraiths';
   Race[count].Common   := 'wraith';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'phasma';
   Race[count].Pref     := 'wraith';
   Race[count].Sufi     := 'wraith';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'wants';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'single';
   Race[count].Plural   := 'trolls';
   Race[count].Common   := 'troll';
   Race[count].Language := 'troll speech';
   Race[count].Latin    := 'troller';
   Race[count].Pref     := 'tro';
   Race[count].Sufi     := 'troll';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'treasure';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'paired';
   Race[count].Plural   := 'trolls';
   Race[count].Common   := 'troll';
   Race[count].Language := 'troll speech';
   Race[count].Latin    := 'troller';
   Race[count].Pref     := 'tro';
   Race[count].Sufi     := 'troll';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'treasure';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'smelly';
   Race[count].Plural   := 'troglodytes';
   Race[count].Common   := 'troglodyte';
   Race[count].Language := 'troll speech';
   Race[count].Latin    := 'troglodyte';
   Race[count].Pref     := 'trog';
   Race[count].Sufi     := 'lodyte';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'treasure';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'greedy';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'swamp';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dishonest';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'cowardly';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'man-eater';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ambush';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'sneak-attack';
   Race[count].Plural   := 'octopi';
   Race[count].Common   := 'octopus';
   Race[count].Language := 'oktopous';
   Race[count].Latin    := 'mollusk';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'pus';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'muscled skin';
   Race[count].Fame     := 'greed';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'strong';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'neanderthalese';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].Pref     := 'octo';
   Race[count].Sufi     := 'neander';
   Race[count].Hand     := 'thal';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'surly';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'surly';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'neanderthalese';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].Pref     := 'neander';
   Race[count].Sufi     := 'thal';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'surly';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'villager';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'neanderthalese';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].Pref     := 'neander';
   Race[count].Sufi     := 'thal';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'surly';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dwarf-slave';
   Race[count].Plural   := 'neanderthals';
   Race[count].Common   := 'neanderthal';
   Race[count].Language := 'neanderthalese';
   Race[count].Latin    := 'neanderthalensis';
   Race[count].Pref     := 'neander';
   Race[count].Sufi     := 'thal';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'surly';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'stupid';
   Race[count].Plural   := 'ogres';
   Race[count].Common   := 'ogre';
   Race[count].Language := 'giantish';
   Race[count].Latin    := 'orcus';
   Race[count].Pref     := 'ogre';
   Race[count].Sufi     := 'ogre';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'viciousness';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'loathesome';
   Race[count].Plural   := 'ghouls';
   Race[count].Common   := 'ghoul';
   Race[count].Language := 'ghoulish';
   Race[count].Latin    := 'orcus';
   Race[count].Pref     := 'ghoul';
   Race[count].Sufi     := 'ghoul';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'hatred';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'group';
   Race[count].Plural   := 'ghouls';
   Race[count].Common   := 'ghoul';
   Race[count].Language := 'ghoulish';
   Race[count].Latin    := 'orcus';
   Race[count].Pref     := 'ghoul';
   Race[count].Sufi     := 'ghoul';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'hatred';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'dim-tunnel';
   Race[count].Plural   := 'shadowights';
   Race[count].Common   := 'shadowight';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'orcus';
   Race[count].Pref     := 'shadow';
   Race[count].Sufi     := 'wight';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'xenophobia';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'subterrain';
   Race[count].Plural   := 'shadowights';
   Race[count].Common   := 'shadowight';
   Race[count].Language := 'toungs';
   Race[count].Latin    := 'orcus';
   Race[count].Pref     := 'shadow';
   Race[count].Sufi     := 'wight';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'xenophobia';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'hydra';
   Race[count].Common   := 'hydra';
   Race[count].Language := 'hydroxinian';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'hydra';
   Race[count].Sufi     := 'hydra';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'skepticism';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'large';
   Race[count].Plural   := 'hydra';
   Race[count].Common   := 'hydra';
   Race[count].Language := 'hydroxinian';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'hydra';
   Race[count].Sufi     := 'hydra';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'skepticism';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'obnoxious';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'basil';
   Race[count].Sufi     := 'lisk';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'obnoxious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'comfort';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'basil';
   Race[count].Sufi     := 'lisk';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'obnoxious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'wealthy';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'basil';
   Race[count].Sufi     := 'lisk';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'obnoxious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'powerful';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'basil';
   Race[count].Sufi     := 'lisk';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'obnoxious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'ever-hungry';
   Race[count].Plural   := 'basilisk';
   Race[count].Common   := 'basilisk';
   Race[count].Language := 'baslisk';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'basil';
   Race[count].Sufi     := 'lisk';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'obnoxious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'rich soil';
   Race[count].Plural   := 'gnomes';
   Race[count].Common   := 'gnome';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'terra';
   Race[count].Pref     := 'gnome';
   Race[count].Sufi     := 'gnome';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'deep underground';
   Race[count].Plural   := 'gnomes';
   Race[count].Common   := 'gnome';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'terra';
   Race[count].Pref     := 'gnome';
   Race[count].Sufi     := 'gnome';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'dark forest';
   Race[count].Plural   := 'gnomes';
   Race[count].Common   := 'gnome';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'terra';
   Race[count].Pref     := 'gnome';
   Race[count].Sufi     := 'gnome';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'deep cavern rock';
   Race[count].Plural   := 'gnomes';
   Race[count].Common   := 'gnome';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'terra';
   Race[count].Pref     := 'terra';
   Race[count].Sufi     := 'terra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountain rock';
   Race[count].Plural   := 'gnomes';
   Race[count].Common   := 'gnome';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'terra';
   Race[count].Pref     := 'terra';
   Race[count].Sufi     := 'terra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'stony skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'metal ore';
   Race[count].Plural   := 'gnomes';
   Race[count].Common   := 'gnome';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'terra';
   Race[count].Pref     := 'terra';
   Race[count].Sufi     := 'terra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'metal skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'high atmosphere';
   Race[count].Plural   := 'sylphs';
   Race[count].Common   := 'sylph';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'aries';
   Race[count].Pref     := 'aries';
   Race[count].Sufi     := 'aries';
   Race[count].Hand     := 'wind';
   Race[count].Skin     := 'tempurature';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'canyon wind';
   Race[count].Plural   := 'sylphs';
   Race[count].Common   := 'sylph';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'aries';
   Race[count].Pref     := 'aries';
   Race[count].Sufi     := 'aries';
   Race[count].Hand     := 'wind';
   Race[count].Skin     := 'tempurature';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mountain peak';
   Race[count].Plural   := 'sylphs';
   Race[count].Common   := 'sylph';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'aries';
   Race[count].Pref     := 'aries';
   Race[count].Sufi     := 'aries';
   Race[count].Hand     := 'wind';
   Race[count].Skin     := 'tempurature';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'volcano';
   Race[count].Plural   := 'salamanders';
   Race[count].Common   := 'salamander';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'pyro';
   Race[count].Pref     := 'pyro';
   Race[count].Sufi     := 'pyro';
   Race[count].Hand     := 'burning hand';
   Race[count].Skin     := 'fire skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'gas flare';
   Race[count].Plural   := 'salamanders';
   Race[count].Common   := 'salamander';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'pyro';
   Race[count].Pref     := 'pyro';
   Race[count].Sufi     := 'pyro';
   Race[count].Hand     := 'burning hand';
   Race[count].Skin     := 'fire skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'conflagration';
   Race[count].Plural   := 'salamanders';
   Race[count].Common   := 'salamander';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'pyro';
   Race[count].Pref     := 'pyro';
   Race[count].Sufi     := 'pyro';
   Race[count].Hand     := 'burning hand';
   Race[count].Skin     := 'fire skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'old fire place';
   Race[count].Plural   := 'salamanders';
   Race[count].Common   := 'salamander';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'pyro';
   Race[count].Pref     := 'pyro';
   Race[count].Sufi     := 'pyro';
   Race[count].Hand     := 'burning hand';
   Race[count].Skin     := 'fire skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'white water';
   Race[count].Plural   := 'undines';
   Race[count].Common   := 'undine';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'hydra';
   Race[count].Sufi     := 'hydra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'watery skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'deep lake';
   Race[count].Plural   := 'undines';
   Race[count].Common   := 'undine';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'hydra';
   Race[count].Sufi     := 'hydra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'watery skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'steam';
   Race[count].Plural   := 'undines';
   Race[count].Common   := 'undine';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'hydra';
   Race[count].Sufi     := 'hydra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'steam skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'ice';
   Race[count].Plural   := 'undines';
   Race[count].Common   := 'undine';
   Race[count].Language := 'wizard''s toung';
   Race[count].Latin    := 'hydra';
   Race[count].Pref     := 'hydra';
   Race[count].Sufi     := 'hydra';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'ice skin';
   Race[count].Fame     := 'capricious';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'darkness';
   Race[count].Plural   := 'apep';
   Race[count].Common   := 'apep';
   Race[count].Language := 'popis';
   Race[count].Latin    := 'apopis';
   Race[count].Pref     := 'apep';
   Race[count].Sufi     := 'pep';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'hunger';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nag';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'riding';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'light';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'mustang';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pony';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'draft';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'clydesdale';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'percheron';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'war';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'donkey';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'mule';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'horse';
   Race[count].Sufi     := 'horse';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'unicorn';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'uni';
   Race[count].Sufi     := 'corn';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'pegasus';
   Race[count].Plural   := 'horses';
   Race[count].Common   := 'horse';
   Race[count].Language := 'equestria';
   Race[count].Latin    := 'equestrian';
   Race[count].Pref     := 'pega';
   Race[count].Sufi     := 'gasus';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'indricotherium';
   Race[count].Common   := 'indricotherium';
   Race[count].Language := 'old equestria';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'indricoth';
   Race[count].Sufi     := 'cotherium';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'elephants';
   Race[count].Common   := 'elephant';
   Race[count].Language := 'elephant';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'eleph';
   Race[count].Sufi     := 'phant';
   Race[count].Hand     := 'stomp';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := '';
   Race[count].Plural   := 'mammoths';
   Race[count].Common   := 'mammoth';
   Race[count].Language := 'mammoth';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'mam';
   Race[count].Sufi     := 'moth';
   Race[count].Hand     := 'stomp';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'oxen';
   Race[count].Common   := 'ox';
   Race[count].Language := 'oxen';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'ox';
   Race[count].Sufi     := 'ox';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := '';
   Race[count].Plural   := 'yaks';
   Race[count].Common   := 'yak';
   Race[count].Language := 'yak';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'yak';
   Race[count].Sufi     := 'yak';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := '';
   Race[count].Plural   := 'caraboa';
   Race[count].Common   := 'carabo';
   Race[count].Language := 'carabo';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'carab';
   Race[count].Sufi     := 'raboa';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'water';
   Race[count].Plural   := 'buffalos';
   Race[count].Common   := 'buffalo';
   Race[count].Language := 'buffalo';
   Race[count].Latin    := 'bison';
   Race[count].Pref     := 'buf';
   Race[count].Sufi     := 'falo';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := '';
   Race[count].Plural   := 'camels';
   Race[count].Common   := 'camel';
   Race[count].Language := 'camel';
   Race[count].Latin    := 'mamailian';
   Race[count].Pref     := 'buf';
   Race[count].Sufi     := 'cam';
   Race[count].Hand     := 'mel';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'riding';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'reptile';
   Race[count].Latin    := 'reptish';
   Race[count].Pref     := 'liz';
   Race[count].Sufi     := 'zard';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'saurian';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'reptile';
   Race[count].Latin    := 'reptish';
   Race[count].Pref     := 'liz';
   Race[count].Sufi     := 'zard';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'walker';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'reptile';
   Race[count].Latin    := 'reptish';
   Race[count].Pref     := 'liz';
   Race[count].Sufi     := 'zard';
   Race[count].Hand     := 'kick';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'hawk';
   Race[count].Plural   := 'birds';
   Race[count].Common   := 'bird';
   Race[count].Language := 'avian';
   Race[count].Latin    := 'diatryma';
   Race[count].Pref     := 'bird';
   Race[count].Sufi     := 'bird';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'feathers';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'flightless';
   Race[count].Plural   := 'birds';
   Race[count].Common   := 'bird';
   Race[count].Language := 'avian';
   Race[count].Latin    := 'diatryma';
   Race[count].Pref     := 'bird';
   Race[count].Sufi     := 'bird';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'feathers';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'enormous';
   Race[count].Plural   := 'birds';
   Race[count].Common   := 'bird';
   Race[count].Language := 'avian';
   Race[count].Latin    := 'roc';
   Race[count].Pref     := 'bird';
   Race[count].Sufi     := 'bird';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'feathers';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'rare';
   Race[count].Plural   := 'gryphons';
   Race[count].Common   := 'gryphon';
   Race[count].Language := 'gryphon';
   Race[count].Latin    := 'gryphon';
   Race[count].Pref     := 'gryph';
   Race[count].Sufi     := 'phon';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'solitary';
   Race[count].Plural   := 'gryphons';
   Race[count].Common   := 'gryphon';
   Race[count].Language := 'gryphon';
   Race[count].Latin    := 'gryphon';
   Race[count].Pref     := 'gryph';
   Race[count].Sufi     := 'phon';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'partner';
   Race[count].Plural   := 'dolphins';
   Race[count].Common   := 'dolphin';
   Race[count].Language := 'dolphin';
   Race[count].Latin    := 'dolphin';
   Race[count].Pref     := 'dolph';
   Race[count].Sufi     := 'phin';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'temper';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'grey';
   Race[count].Plural   := 'wolves';
   Race[count].Common   := 'wolf';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'wolf';
   Race[count].Sufi     := 'wolf';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'dire';
   Race[count].Plural   := 'wolves';
   Race[count].Common   := 'wolf';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'wolf';
   Race[count].Sufi     := 'wolf';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'shepherd';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'wolfhound';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'hunting';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'HPR';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'hound';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'flushing';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'pointer';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'retriever';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'dogs';
   Race[count].Common   := 'dog';
   Race[count].Language := 'canine';
   Race[count].Latin    := 'canine';
   Race[count].Pref     := 'dog';
   Race[count].Sufi     := 'dog';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'cave';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].Pref     := 'bear';
   Race[count].Sufi     := 'bear';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'kodiak';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].Pref     := 'bear';
   Race[count].Sufi     := 'bear';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'grizzly';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].Pref     := 'bear';
   Race[count].Sufi     := 'bear';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'black';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].Pref     := 'bear';
   Race[count].Sufi     := 'bear';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'cinnamon';
   Race[count].Plural   := 'bears';
   Race[count].Common   := 'bear';
   Race[count].Language := 'patiri';
   Race[count].Latin    := 'ursus';
   Race[count].Pref     := 'bear';
   Race[count].Sufi     := 'bear';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'lion';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].Pref     := 'lion';
   Race[count].Sufi     := 'lion';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'tiger';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].Pref     := 'tiger';
   Race[count].Sufi     := 'tiger';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'sabertooth';
   Race[count].Plural   := 'tigers';
   Race[count].Common   := 'tiger';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].Pref     := 'saber';
   Race[count].Sufi     := 'tooth';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'jaguar';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].Pref     := 'jag';
   Race[count].Sufi     := 'guar';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'pet';
   Race[count].Plural   := 'cats';
   Race[count].Common   := 'cat';
   Race[count].Language := 'meyow';
   Race[count].Latin    := 'feline';
   Race[count].Pref     := 'cat';
   Race[count].Sufi     := 'cat';
   Race[count].Hand     := 'paw';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'great';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].Pref     := 'ape';
   Race[count].Sufi     := 'ape';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'baboon';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].Pref     := 'bab';
   Race[count].Sufi     := 'boon';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'chimpanzee';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].Pref     := 'chimp';
   Race[count].Sufi     := 'panzee';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'monkey';
   Race[count].Plural   := 'apes';
   Race[count].Common   := 'ape';
   Race[count].Language := 'apeish';
   Race[count].Latin    := 'apious';
   Race[count].Pref     := 'monkey';
   Race[count].Sufi     := 'monkey';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'theif';
   Race[count].Plural   := 'slinkers';
   Race[count].Common   := 'slinker';
   Race[count].Language := 'slinky';
   Race[count].Latin    := 'slinkus';
   Race[count].Pref     := 'slinker';
   Race[count].Sufi     := 'slinker';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pet';
   Race[count].Plural   := 'slinkers';
   Race[count].Common   := 'slinker';
   Race[count].Language := 'slinky';
   Race[count].Latin    := 'slinkus';
   Race[count].Pref     := 'slinker';
   Race[count].Sufi     := 'slinker';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'group';
   Race[count].Plural   := 'dragonets';
   Race[count].Common   := 'dragonet';
   Race[count].Language := 'dracus';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gonet';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'pet';
   Race[count].Plural   := 'dragonets';
   Race[count].Common   := 'dragonet';
   Race[count].Language := 'dracus';
   Race[count].Latin    := 'draco';
   Race[count].Pref     := 'drag';
   Race[count].Sufi     := 'gonet';
   Race[count].Hand     := 'claw';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'trained';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'stone';
   Race[count].Plural   := 'beetle';
   Race[count].Common   := 'beetle';
   Race[count].Language := 'silicus';
   Race[count].Latin    := 'beetlus';
   Race[count].Pref     := 'beetle';
   Race[count].Sufi     := 'beetle';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'carapace';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'spiders';
   Race[count].Common   := 'spider';
   Race[count].Language := 'spindle';
   Race[count].Latin    := 'arachnid';
   Race[count].Pref     := 'spider';
   Race[count].Sufi     := 'spider';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'scorpions';
   Race[count].Common   := 'scorpion';
   Race[count].Language := 'scorpious';
   Race[count].Latin    := 'scorpio';
   Race[count].Pref     := 'scorp';
   Race[count].Sufi     := 'pion';
   Race[count].Hand     := 'claws';
   Race[count].Skin     := 'carapace';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'basic';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'spyder';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'low render';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'termagant';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'phlanxe';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'gantua';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'myrmidon';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'plunge';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'worker';
   Race[count].Plural   := 'hymenopterans';
   Race[count].Common   := 'hymenopteran';
   Race[count].Language := 'hymen';
   Race[count].Latin    := 'hymenopterus';
   Race[count].Pref     := 'bug';
   Race[count].Sufi     := 'bug';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'large';
   Race[count].Plural   := 'snakes';
   Race[count].Common   := 'snake';
   Race[count].Language := 'serpent';
   Race[count].Latin    := 'serpio';
   Race[count].Pref     := 'snake';
   Race[count].Sufi     := 'snake';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'snakes';
   Race[count].Common   := 'snake';
   Race[count].Language := 'serpent';
   Race[count].Latin    := 'serpio';
   Race[count].Pref     := 'snake';
   Race[count].Sufi     := 'snake';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'monster';
   Race[count].Plural   := 'snakes';
   Race[count].Common   := 'snake';
   Race[count].Language := 'serpent';
   Race[count].Latin    := 'serpio';
   Race[count].Pref     := 'snake';
   Race[count].Sufi     := 'snake';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'lizards';
   Race[count].Common   := 'lizard';
   Race[count].Language := 'saurian';
   Race[count].Latin    := 'saurus';
   Race[count].Pref     := 'liz';
   Race[count].Sufi     := 'zar';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'goo';
   Race[count].Common   := 'goo';
   Race[count].Language := 'slime';
   Race[count].Latin    := 'goous';
   Race[count].Pref     := 'goo';
   Race[count].Sufi     := 'goo';
   Race[count].Hand     := 'goo';
   Race[count].Skin     := 'goo';
   Race[count].Fame     := 'goo';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'medium';
   Race[count].Plural   := 'goo';
   Race[count].Common   := 'goo';
   Race[count].Language := 'slime';
   Race[count].Latin    := 'goous';
   Race[count].Pref     := 'goo';
   Race[count].Sufi     := 'goo';
   Race[count].Hand     := 'goo';
   Race[count].Skin     := 'goo';
   Race[count].Fame     := 'goo';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'large';
   Race[count].Plural   := 'goo';
   Race[count].Common   := 'goo';
   Race[count].Language := 'slime';
   Race[count].Latin    := 'goous';
   Race[count].Pref     := 'goo';
   Race[count].Sufi     := 'goo';
   Race[count].Hand     := 'goo';
   Race[count].Skin     := 'goo';
   Race[count].Fame     := 'goo';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'carnivorous';
   Race[count].Plural   := 'piranhas';
   Race[count].Common   := 'piranha';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'piran';
   Race[count].Sufi     := 'ranha';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nuaghty';
   Race[count].Plural   := 'minos';
   Race[count].Common   := 'mino';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mino';
   Race[count].Sufi     := 'mino';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'scales';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'salt water';
   Race[count].Plural   := 'sharks';
   Race[count].Common   := 'shark';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'shark';
   Race[count].Sufi     := 'shark';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'turtles';
   Race[count].Common   := 'turtle';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'turt';
   Race[count].Sufi     := 'tles';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'monster';
   Race[count].Plural   := 'turtles';
   Race[count].Common   := 'turtle';
   Race[count].Language := 'reptish';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'turt';
   Race[count].Sufi     := 'tles';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'uncle teeth';
   Race[count].Common   := 'uncle teeth';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'uncle';
   Race[count].Sufi     := 'teeth';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'giant';
   Race[count].Plural   := 'clams';
   Race[count].Common   := 'clam';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'clam';
   Race[count].Sufi     := 'clam';
   Race[count].Hand     := 'shell';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'shell';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'salt water';
   Race[count].Plural   := 'kraken';
   Race[count].Common   := 'kraken';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'krak';
   Race[count].Sufi     := 'ken';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'fresh water';
   Race[count].Plural   := 'kraken';
   Race[count].Common   := 'kraken';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'krak';
   Race[count].Sufi     := 'ken';
   Race[count].Hand     := 'tenticle';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'small';
   Race[count].Plural   := 'crocodiles';
   Race[count].Common   := 'crocodile';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'croc';
   Race[count].Sufi     := 'codile';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'bloodtree';
   Race[count].Plural   := 'roots';
   Race[count].Common   := 'roots';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'blood';
   Race[count].Sufi     := 'tree';
   Race[count].Hand     := 'needle';
   Race[count].Skin     := 'bark';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'am';
   Race[count].Plural   := 'bushes';
   Race[count].Common   := 'bush';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'am';
   Race[count].Sufi     := 'bush';
   Race[count].Hand     := 'pod';
   Race[count].Skin     := 'leaves';
   Race[count].Fame     := 'aggresive';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'edible';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mush';
   Race[count].Sufi     := 'room';
   Race[count].Hand     := 'spore';
   Race[count].Skin     := 'cap';
   Race[count].Fame     := 'stalk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'hallucinogenic';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mush';
   Race[count].Sufi     := 'room';
   Race[count].Hand     := 'spore';
   Race[count].Skin     := 'cap';
   Race[count].Fame     := 'stalk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'poisonous';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mush';
   Race[count].Sufi     := 'room';
   Race[count].Hand     := 'spore';
   Race[count].Skin     := 'cap';
   Race[count].Fame     := 'stalk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'poison gas';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mush';
   Race[count].Sufi     := 'room';
   Race[count].Hand     := 'spore';
   Race[count].Skin     := 'cap';
   Race[count].Fame     := 'stalk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'explosive';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mush';
   Race[count].Sufi     := 'room';
   Race[count].Hand     := 'spore';
   Race[count].Skin     := 'cap';
   Race[count].Fame     := 'stalk';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'berserker';
   Race[count].Plural   := 'mushrooms';
   Race[count].Common   := 'mushroom';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'mush';
   Race[count].Sufi     := 'room';
   Race[count].Hand     := 'spore';
   Race[count].Skin     := 'cap';
   Race[count].Fame     := 'stalk';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'green';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'slime';
   Race[count].Sufi     := 'slime';
   Race[count].Hand     := 'slime';
   Race[count].Skin     := 'slime';
   Race[count].Fame     := 'slime';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'red';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'slime';
   Race[count].Sufi     := 'slime';
   Race[count].Hand     := 'slime';
   Race[count].Skin     := 'slime';
   Race[count].Fame     := 'slime';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'brown';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'slime';
   Race[count].Sufi     := 'slime';
   Race[count].Hand     := 'slime';
   Race[count].Skin     := 'slime';
   Race[count].Fame     := 'slime';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'silver';
   Race[count].Plural   := 'slimes';
   Race[count].Common   := 'slime';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'slime';
   Race[count].Sufi     := 'slime';
   Race[count].Hand     := 'slime';
   Race[count].Skin     := 'slime';
   Race[count].Fame     := 'slime';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'group';
   Race[count].Plural   := 'rats';
   Race[count].Common   := 'rat';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'rat';
   Race[count].Sufi     := 'rat';
   Race[count].Hand     := 'slime';
   Race[count].Skin     := 'slime';
   Race[count].Fame     := 'slime';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'vampire';
   Race[count].Plural   := 'bats';
   Race[count].Common   := 'bat';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'bat';
   Race[count].Sufi     := 'bat';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'fur';
   Race[count].Fame     := 'swarm';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'swarm';
   Race[count].Plural   := 'spiders';
   Race[count].Common   := 'spider';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'spider';
   Race[count].Sufi     := 'spider';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'skin';
   Race[count].Fame     := 'swarm';
   Race[count].N := stat_count;

   inc(count);
   Race[count].Name     := 'swarm';
   Race[count].Plural   := 'wasps';
   Race[count].Common   := 'wasp';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'wasp';
   Race[count].Sufi     := 'wasp';
   Race[count].Hand     := 'sting';
   Race[count].Skin     := 'body';
   Race[count].Fame     := 'swarm';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'jumping';
   Race[count].Plural   := 'scuttles';
   Race[count].Common   := 'scuttle';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'scut';
   Race[count].Sufi     := 'tle';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'shell';
   Race[count].Fame     := 'swarm';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'flocking';
   Race[count].Plural   := 'piranhakeets';
   Race[count].Common   := 'piranhakeet';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'piran';
   Race[count].Sufi     := 'keet';
   Race[count].Hand     := 'bite';
   Race[count].Skin     := 'feathers';
   Race[count].Fame     := 'swarm';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'wall climber';
   Race[count].Plural   := 'scorpions';
   Race[count].Common   := 'scorpion';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'scorp';
   Race[count].Sufi     := 'pion';
   Race[count].Hand     := 'sting';
   Race[count].Skin     := 'carapace';
   Race[count].Fame     := 'swarm';
   Race[count].N := stat_count;

   inc(count);
   inc(stat_count);
   Race[count].Name     := 'nuisance';
   Race[count].Plural   := 'children';
   Race[count].Common   := 'child';
   Race[count].Language := 'ixthy';
   Race[count].Latin    := 'ixthus';
   Race[count].Pref     := 'child';
   Race[count].Sufi     := 'child';
   Race[count].Hand     := 'hand';
   Race[count].Skin     := 'armor';
   Race[count].Fame     := 'curiosity';
   Race[count].N := stat_count;

   RaceCurrentTotal := count;
   InitRaceStats;
end;

procedure Tform1.InitRaceStats;
var
   count: integer;
begin
   count := 1; {men}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := 25;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {orc}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {elf}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {dwarf}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 6;
   Stat[count].Dx_min   := 6;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {goblin}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 6;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {hobgoblin}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 6;
   Stat[count].Dx_min   := 6;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {halfling}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := 20;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 6;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {prootwaddle}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 6;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {centaur}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 2;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {giant}
   Stat[count].St       := 25;
   Stat[count].St_min   := 25;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 9;
   Stat[count].Dx_min   := 9;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 10;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {gargoyle}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := 10;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.4375;

   inc(count); {reptile men}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.5000;

   inc(count); {white dragon}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.2083;

   inc(count);{grey dragon}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 12;
   Stat[count].Iq_min   := 12;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.2155;

   inc(count);{black dragon}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 16;
   Stat[count].Iq_min   := 16;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 4;
   Stat[count].Hx_min   := 4;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.1825;

   inc(count);{brown dragon}
   Stat[count].St       := 60;
   Stat[count].St_min   := 60;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 20;
   Stat[count].Iq_min   := 20;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 7;
   Stat[count].Hx_min   := 7;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 5;
   Stat[count].Hd       := 0.1166;

   inc(count);{red dragon}
   Stat[count].St       := 100;
   Stat[count].St_min   := 100;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 24;
   Stat[count].Iq_min   := 24;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 14;
   Stat[count].Hx_min   := 14;
   Stat[count].Hx_max   := 14;
   Stat[count].Ap       := 6;
   Stat[count].Hd       := 0.0850;

   inc(count); {greater demon}
   Stat[count].St       := 100;
   Stat[count].St_min   := 100;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 20;
   Stat[count].Iq_min   := 20;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := MAX;
   Stat[count].Ma_min   := MAX;
   Stat[count].Ma_max   := MAX;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 4;
   Stat[count].Hd       := 0.1400;

   inc(count); {lesser demon}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 14;
   Stat[count].Iq_min   := 14;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := MAX;
   Stat[count].Ma_min   := MAX;
   Stat[count].Ma_max   := MAX;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.1400;

   inc(count); {sasquatch}
   Stat[count].St       := 18;
   Stat[count].St_min   := 18;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.2500;

   inc(count); {wyvern}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 12;
   Stat[count].Iq_min   := 12;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 3;
   Stat[count].Ma_min   := 3;
   Stat[count].Ma_max   := 3;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.1944;

   inc(count); {wraith}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := 25;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 1;
   Stat[count].Ma_min   := 1;
   Stat[count].Ma_max   := 1;
   Stat[count].Cp       := 8;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {troll}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 11;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2333;

   inc(count); {troglodyte}
   Stat[count].St       := 13;
   Stat[count].St_min   := 13;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2333;

   inc(count); {octopus}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 15;
   Stat[count].Dx_min   := 15;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.0900;

   inc(count); {neanderthal}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {ogres}
   Stat[count].St       := 42;
   Stat[count].St_min   := 42;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 6;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 5;
   Stat[count].Hx_min   := 5;
   Stat[count].Hx_max   := 5;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {ghoul}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {shadowight}
   Stat[count].St       := 5;
   Stat[count].St_min   := 5;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 5;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {hydra}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 4;
   Stat[count].Hx_min   := 4;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1500;

   inc(count); {hydra}
   Stat[count].St       := 60;
   Stat[count].St_min   := 60;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 10;
   Stat[count].Iq_min   := 10;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 7;
   Stat[count].Hx_min   := 7;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1083;

   inc(count); {basilisk}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.3500;

   inc(count); {soil elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.6228;

   inc(count); {stone elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 4;
   Stat[count].Hd       := 0.6785;

   inc(count); {metal ore elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 5;
   Stat[count].Hd       := 0.8728;

   inc(count); {sylph elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.0000;

   inc(count); {fire elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.3728;

   inc(count); {water elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.0001;

   inc(count); {steam elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {ice elemental}
   Stat[count].St       := 14;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3728;

   inc(count); {apep}
   Stat[count].St       := 40;
   Stat[count].St_min   := 40;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 6;
   Stat[count].Hx_min   := 6;
   Stat[count].Hx_max   := 6;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.1750;

   inc(count); {nag horse}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {riding horse}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 24;
   Stat[count].Ma_min   := 24;
   Stat[count].Ma_max   := 24;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2045;

   inc(count); {light horse}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 30;
   Stat[count].Ma_min   := 30;
   Stat[count].Ma_max   := 30;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1750;

   inc(count); {draft horse}
   Stat[count].St       := 26;
   Stat[count].St_min   := 26;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 22;
   Stat[count].Ma_min   := 22;
   Stat[count].Ma_max   := 22;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {warhorse}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 24;
   Stat[count].Ma_min   := 24;
   Stat[count].Ma_max   := 24;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3333;

   inc(count); {donkey}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 15;
   Stat[count].Dx_min   := 15;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 16;
   Stat[count].Ma_min   := 16;
   Stat[count].Ma_max   := 16;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2428;

   inc(count); {mule horse}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2045;

   inc(count); {unicorn horse}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 30;
   Stat[count].Ma_min   := 30;
   Stat[count].Ma_max   := 30;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2750;

   inc(count); {pegasus horse}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 22;
   Stat[count].Ma_min   := 22;
   Stat[count].Ma_max   := 22;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2045;

   inc(count); {indri mammal}
   Stat[count].St       := 40;
   Stat[count].St_min   := 40;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 8;
   Stat[count].Hx_min   := 8;
   Stat[count].Hx_max   := 10;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.2625;

   inc(count); {elephant mammal}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 9;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 16;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 10;
   Stat[count].Hx_min   := 10;
   Stat[count].Hx_max   := 10;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.2100;

   inc(count); {oxen mammal}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.2333;

   inc(count); {camel mammal}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1875;

   inc(count); {lizard reptile}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.3000;

   inc(count); {saurian reptile}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := 11;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 16;
   Stat[count].Ma_min   := 16;
   Stat[count].Ma_max   := 16;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.2333;

   inc(count); {walker reptile}
   Stat[count].St       := 22;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 24;
   Stat[count].Ma_min   := 24;
   Stat[count].Ma_max   := 24;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1750;

   inc(count); {hawk bird}
   Stat[count].St       := 2;
   Stat[count].St_min   := 2;
   Stat[count].St_max   := 8;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 26;
   Stat[count].Ma_min   := 26;
   Stat[count].Ma_max   := 26;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.5045;

   inc(count); {diatryma bird}
   Stat[count].St       := 22;
   Stat[count].St_min   := 22;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 22;
   Stat[count].Ma_min   := 22;
   Stat[count].Ma_max   := 22;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2045;

   inc(count); {roc bird}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 30;
   Stat[count].Ma_min   := 30;
   Stat[count].Ma_max   := 30;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2333;

   inc(count); {gryphon}
   Stat[count].St       := 26;
   Stat[count].St_min   := 26;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 8;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3076;

   inc(count); {dolphin}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 11;
   Stat[count].Iq_min   := 9;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {wolf}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4500;

   inc(count); {dire wolf}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4375;

   inc(count); {big dog}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4500;

   inc(count); {wolfhound}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4500;

   inc(count); {hunting dog}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4166;

   inc(count); {spaniel dog}
   Stat[count].St       := 3;
   Stat[count].St_min   := 3;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1666;

   inc(count); {gray hound}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4166;

   inc(count); {flushing dog}
   Stat[count].St       := 5;
   Stat[count].St_min   := 5;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1666;

   inc(count); {pointer dog}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1666;

   inc(count); {retriever dog}
   Stat[count].St       := 3;
   Stat[count].St_min   := 3;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1666;

   inc(count); {small dog}
   Stat[count].St       := 3;
   Stat[count].St_min   := 3;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1666;

   inc(count); {cave bears}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.3166;

   inc(count); {kodiak bears}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.4300;

   inc(count); {black bears}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.3500;

   inc(count); {lion cats}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.3333;

   inc(count); {tiger cats}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 15;
   Stat[count].Dx_min   := 15;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.3600;

   inc(count); {sabertooth cats}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.2666;

   inc(count); {jaguar cats}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.3750;

   inc(count); {little cats}
   Stat[count].St       := 4;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3750;

   inc(count); {great ape}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2700;

   inc(count); {baboon ape}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3628;

   inc(count); {chimpanzee ape}
   Stat[count].St       := 14;
   Stat[count].St_min   := 14;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3214;

   inc(count); {monkey ape}
   Stat[count].St       := 4;
   Stat[count].St_min   := 2;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3750;

   inc(count); {slinker}
   Stat[count].St       := 2;
   Stat[count].St_min   := 2;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 14;
   Stat[count].Ma_min   := 14;
   Stat[count].Ma_max   := 14;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3750;

   inc(count); {dragonet}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 14;
   Stat[count].Dx_min   := 14;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 7;
   Stat[count].Ma_min   := 7;
   Stat[count].Ma_max   := 7;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3750;

   inc(count); {stone beetle}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 2;
   Stat[count].Iq_min   := 2;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 4;
   Stat[count].Hd       := 0.2000;

   inc(count); {giant spider}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.0625;

   inc(count); {giant scorpion}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.1750;

   inc(count); {basic}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 12;
   Stat[count].Iq_min   := 12;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {spyders}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 7;
   Stat[count].Iq_min   := 7;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 1;
   Stat[count].Hd       := 0.4375;

   inc(count); {low renders}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4500;

   inc(count); {termagants}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 11;
   Stat[count].Dx_min   := 11;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4500;

   inc(count); {phlanxes}
   Stat[count].St       := 16;
   Stat[count].St_min   := 16;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 2;
   Stat[count].Hd       := 0.4375;

   inc(count); {gantuas}
   Stat[count].St       := 24;
   Stat[count].St_min   := 24;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 3;
   Stat[count].Hd       := 0.3958;

   inc(count); {myrmidon}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {plunges}
   Stat[count].St       := 8;
   Stat[count].St_min   := 8;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 16;
   Stat[count].Dx_min   := 16;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 7;
   Stat[count].Ma_min   := 7;
   Stat[count].Ma_max   := 7;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.4375;

   inc(count); {WORKERS}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 8;
   Stat[count].Dx_min   := 8;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 8;
   Stat[count].Iq_min   := 8;
   Stat[count].Iq_max   := MAX;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.1250;

   inc(count); {large snake}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2500;

   inc(count); {giant snake}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 5;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.3750;

   inc(count); {monster snake}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 6;
   Stat[count].Hx_min   := 6;
   Stat[count].Hx_max   := 10;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2333;

   inc(count); {lizard}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 5;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := MAX;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.2330;

   inc(count); {goo}
   Stat[count].St       := MAX;
   Stat[count].St_min   := MAX;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 2;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.0000;

   inc(count); {goo}
   Stat[count].St       := MAX;
   Stat[count].St_min   := MAX;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 3;
   Stat[count].Ma_min   := 3;
   Stat[count].Ma_max   := 3;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.0000;

   inc(count); {goo}
   Stat[count].St       := MAX;
   Stat[count].St_min   := MAX;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 2;
   Stat[count].Ma_min   := 2;
   Stat[count].Ma_max   := 2;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 5;
   Stat[count].Hx_min   := 5;
   Stat[count].Hx_max   := 14;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 0.0000;

   inc(count); {piranha}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 1.0000;

   inc(count); {naughty minnow}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;
   Stat[count].Hd       := 1.5000;

   inc(count); {shark}
   Stat[count].St       := 28;
   Stat[count].St_min   := 28;
   Stat[count].St_max   := 28;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 20;
   Stat[count].Ma_min   := 20;
   Stat[count].Ma_max   := 20;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 14;
   Stat[count].Ap       := 0;

   inc(count); {giant snapping turtles}
   Stat[count].St       := 36;
   Stat[count].St_min   := 36;
   Stat[count].St_max   := 36;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := 12;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 3;
   Stat[count].Hx_min   := 3;
   Stat[count].Hx_max   := 6;
   Stat[count].Ap       := 4;

   inc(count); {giant snapping turtles}
   Stat[count].St       := 70;
   Stat[count].St_min   := 70;
   Stat[count].St_max   := 70;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := 12;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 7;
   Stat[count].Hx_min   := 7;
   Stat[count].Hx_max   := 7;
   Stat[count].Ap       := 7;

   inc(count); {uncle teeth}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := 50;
   Stat[count].Dx       := 13;
   Stat[count].Dx_min   := 13;
   Stat[count].Dx_max   := 13;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 4;
   Stat[count].Hx_min   := 4;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 2;

   inc(count); {giant clam}
   Stat[count].St       := 50;
   Stat[count].St_min   := 50;
   Stat[count].St_max   := 50;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 0;
   Stat[count].Iq_min   := 0;
   Stat[count].Iq_max   := 0;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 4;
   Stat[count].Ap       := 1;

   inc(count); {kraken}
   Stat[count].St       := 60;
   Stat[count].St_min   := 60;
   Stat[count].St_max   := 60;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 4;
   Stat[count].Iq_min   := 4;
   Stat[count].Iq_max   := 4;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 6;
   Stat[count].Hx_min   := 6;
   Stat[count].Hx_max   := 6;
   Stat[count].Ap       := 2;

   inc(count); {crocodile}
   Stat[count].St       := 20;
   Stat[count].St_min   := 20;
   Stat[count].St_max   := MAX;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := MAX;
   Stat[count].Iq       := 5;
   Stat[count].Iq_min   := 5;
   Stat[count].Iq_max   := 5;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 2;
   Stat[count].Hx_min   := 2;
   Stat[count].Hx_max   := 3;
   Stat[count].Ap       := 3;

   inc(count); {bloodtree}
   Stat[count].St       := 10;
   Stat[count].St_min   := 10;
   Stat[count].St_max   := 10;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 0;
   Stat[count].Iq_min   := 0;
   Stat[count].Iq_max   := 0;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {am bush}
   Stat[count].St       := 6;
   Stat[count].St_min   := 6;
   Stat[count].St_max   := 10;
   Stat[count].Dx       := 12;
   Stat[count].Dx_min   := 12;
   Stat[count].Dx_max   := 12;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := -MAX;
   Stat[count].Cp_max   := MAX;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 2;

   inc(count); {mushroom}
   Stat[count].St       := 0;
   Stat[count].St_min   := 0;
   Stat[count].St_max   := 0;
   Stat[count].Dx       := 0;
   Stat[count].Dx_min   := 0;
   Stat[count].Dx_max   := 0;
   Stat[count].Iq       := 0;
   Stat[count].Iq_min   := 0;
   Stat[count].Iq_max   := 0;
   Stat[count].Ma       := 0;
   Stat[count].Ma_min   := 0;
   Stat[count].Ma_max   := 0;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 0;
   Stat[count].Hx_min   := 0;
   Stat[count].Hx_max   := 0;
   Stat[count].Ap       := 0;

   inc(count); {green slime}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := 20;
   Stat[count].Dx       := 1;
   Stat[count].Dx_min   := 1;
   Stat[count].Dx_max   := 1;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 2;
   Stat[count].Ma_min   := 2;
   Stat[count].Ma_max   := 2;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {brown slime}
   Stat[count].St       := 30;
   Stat[count].St_min   := 30;
   Stat[count].St_max   := 30;
   Stat[count].Dx       := 1;
   Stat[count].Dx_min   := 1;
   Stat[count].Dx_max   := 1;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 2;
   Stat[count].Ma_min   := 2;
   Stat[count].Ma_max   := 2;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {silver slime}
   Stat[count].St       := 12;
   Stat[count].St_min   := 12;
   Stat[count].St_max   := 20;
   Stat[count].Dx       := 1;
   Stat[count].Dx_min   := 1;
   Stat[count].Dx_max   := 1;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 6;
   Stat[count].Ma       := 6;
   Stat[count].Ma_min   := 6;
   Stat[count].Ma_max   := 6;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {rats}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {scuttles}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 9;
   Stat[count].Dx_min   := 9;
   Stat[count].Dx_max   := 9;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 4;
   Stat[count].Ma_min   := 4;
   Stat[count].Ma_max   := 4;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {piranhakeets}
   Stat[count].St       := 1;
   Stat[count].St_min   := 1;
   Stat[count].St_max   := 1;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 10;
   Stat[count].Ma_min   := 10;
   Stat[count].Ma_max   := 10;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {rats}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := 4;
   Stat[count].Dx       := 10;
   Stat[count].Dx_min   := 10;
   Stat[count].Dx_max   := 10;
   Stat[count].Iq       := 1;
   Stat[count].Iq_min   := 1;
   Stat[count].Iq_max   := 1;
   Stat[count].Ma       := 12;
   Stat[count].Ma_min   := 12;
   Stat[count].Ma_max   := 12;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   inc(count); {children}
   Stat[count].St       := 4;
   Stat[count].St_min   := 4;
   Stat[count].St_max   := 4;
   Stat[count].Dx       := 5;
   Stat[count].Dx_min   := 5;
   Stat[count].Dx_max   := 5;
   Stat[count].Iq       := 6;
   Stat[count].Iq_min   := 6;
   Stat[count].Iq_max   := 7;
   Stat[count].Ma       := 8;
   Stat[count].Ma_min   := 8;
   Stat[count].Ma_max   := 8;
   Stat[count].Cp       := 0;
   Stat[count].Cp_min   := 0;
   Stat[count].Cp_max   := 0;
   Stat[count].Hx       := 1;
   Stat[count].Hx_min   := 1;
   Stat[count].Hx_max   := 1;
   Stat[count].Ap       := 0;

   InitRaceBodyPart;
end;

procedure TForm1.InitRaceBodyPart;
var
   count: integer;
begin
   for count := 1 to MaxRaceStats do
   begin
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.blood       :=      0.0;        {deci lieters}
      body[count].part.aura        :=      0.0;        {reaction mod}
      body[count].part.spells      :=      0.0;        {spell casting}
      body[count].part.head        :=      0.0;        {whole }
      body[count].part.ear         :=      0.0;        {whole}
      body[count].part.ear_drum    :=      0.0;        {accute hearing}
      body[count].part.ear_min     :=      0.0;        {min hz can hear}
      body[count].part.ear_max     :=      0.0;        {max hz can hear}
      body[count].part.eye         :=      0.0;        {whole}
      body[count].part.retina      :=      0.0;        {number of photoreceptors}
      body[count].part.eyeFFR      :=      0.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=      0.0;        {distinquish 2 points at N microns apart}
      body[count].part.eye_diameter :=     0.0;        {cm across}
      body[count].part.eye_lenses  :=      0.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=      0.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.0;        {% rods, remainder are cones}
      body[count].part.eye_sound   :=      0.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.0;        {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=      0.0;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      0.0;        {eye lids per eye}
      body[count].part.brain       :=      0.0;        {whole}
      body[count].part.hair        :=      0.0;        {number of hairs on head}
      body[count].part.wisker      :=      0.0;        {length of hairs}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.mouth       :=      0.0;        {number of}
      body[count].part.TasteBudsRoof  :=   0.0;        {number of}
      body[count].part.TastebudsToung :=   0.0;        {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tooth       :=      0.0;        {number of}
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.neck        :=      0.0;        {number of}
      body[count].part.esophagus   :=      0.0;        {maximum MH voice carries}
      body[count].part.voice_box   :=      0.0;        {language ability}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.nose        :=      0.0;        {number of}
      body[count].part.probiscus   :=      0.0;        {protrusion to head size ratio}
      body[count].part.sinus       :=      0.0;        {sq cm of olfactory membrane}
      body[count].part.body        :=      0.0;        {presence of}
      body[count].part.skin        :=      0.0;        {presence of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.trunk       :=      0.0;        {centi meter circumference }
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.backbone    :=      0.0;        {number of vertebra}
      body[count].part.rib         :=      0.0;        {number of pairs}
      body[count].part.gallbladder :=      0.0;        {presence of & absorbancy ratio to 1}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.heart       :=      0.0;        {presence of}
      body[count].part.liver       :=      0.0;        {presence of & absorbancy ratio to 1}
      body[count].part.kidney      :=      0.0;        {filtration quality}
      body[count].part.lung        :=      0.0;        {volume of co2 produce per turn}
      body[count].part.intestin_lessor     := 0.0;     {length in cm}
      body[count].part.intestin_greater    := 0.0;     {length in cm}
      body[count].part.stomache    :=      0.0;        {acid damage}
      body[count].part.limb        :=      0.0;        {number of}
      body[count].part.arm         :=      0.0;        {number of}
      body[count].part.hand        :=      0.0;        {number of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.leg         :=      0.0;        {number of}
      body[count].part.TasteBudsLeg:=      0.0;        {number of}
      body[count].part.foot        :=      0.0;        {number of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.toenail     :=      0.0;        {number of}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.root        :=      0.0;        {depth}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.tail        :=      0.0;        {length}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.stinger     :=      0.0;        {damage of poison}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
   end;
   count := 0;

   inc(count);  {men}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 14400000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.056;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {orc}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     48.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=   1000.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {elf}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=     -0.1;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {dwarf}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {goblin}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {hobgoblin}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {halfling}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      1.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.07;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {prootwaddle}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 1440000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {centaur}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      0.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      1.0;        {presence of}
      body[count].part.hoof        :=      2.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 2.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 2.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      4.0;        {number of}
      body[count].part.limb        :=      6.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      0.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      1.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.0;        {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {giant}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      2.1;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {gargoyle}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=    -75.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.0;        {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=    400.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.01;       {length}
      body[count].part.talon       :=      0.4375;     {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.0;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      2.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {reptile men}
      body[count].part.antenna     :=      0.0;        {number of}
      body[count].part.arm         :=      2.0;        {number of}
      body[count].part.aura        :=      0.0;        {reaction mod for others}
      body[count].part.awe         :=      0.0;        {reaction mod to others}
      body[count].part.backbone    :=     64.0;        {number of vertebra}
      body[count].part.beard       :=      0.0;        {number of shaves}
      body[count].part.blood       :=     70.0;        {deci lieters}
      body[count].part.body        :=      1.0;        {presence of}
      body[count].part.bone        :=      0.0;        {density (affects shatter, flying, char weight}
      body[count].part.brain       := 144000000.0;   {number of brain cells}
      body[count].part.branch      :=      0.0;        {number of}
      body[count].part.chitin      :=      0.0;        {presence of}
      body[count].part.claw        :=      0.0;        {mult}
      body[count].part.claw_socket :=      0.0;        {mult}
      body[count].part.chromosomes :=     46.0;        {total number, or pairs x2}
      body[count].part.ear         :=      2.0;        {whole}
      body[count].part.ear_drum    :=     30.0;        {accute hearing}
      body[count].part.ear_min     :=     64.0;        {min hz can hear}
      body[count].part.ear_max     :=  23000.0;        {max hz can hear}
      body[count].part.esophagus   :=     20.0;        {maximum MH voice carries}
      body[count].part.eye         :=      2.0;        {whole}
      body[count].part.eyeFFR      :=     60.0;        {Flicker Fusion Rate, human = 60 a second}
      body[count].part.eye2Pmicron :=    100.0;        {distinquish 2 points at N microns apart}
      body[count].part.retina      := 125000000.0;     {number of photoreceptors}
      body[count].part.eye_diameter :=     2.5;        {cm across}
      body[count].part.eye_lenses  :=      1.0;        {a bee would have 4,400}
      body[count].part.eye_vision  :=     20.0;        {20/N vision 5 = x4, 40 = 0.5}
      body[count].part.eye_rods    :=      0.156;      {mult for rods, remainder are cones}
      body[count].part.eye_sound   :=      1.0;        {range of echolocation}
      body[count].part.eye_electro :=      0.005;      {threshold N uV/cm sensitivity}
      body[count].part.eye_stalks  :=     -2.5;        {cm extrusion from the head}
      body[count].part.eye_lids    :=      1.0;        {eye lids per eye}
      body[count].part.fang        :=      0.0;        {D vs. ST to save vs. poison}
      body[count].part.feather     :=      0.0;        {presence of}
      body[count].part.fin         :=      0.0;        {number of}
      body[count].part.fluke       :=      0.0;        {swim mult}
      body[count].part.foot        :=      2.0;        {number of}
      body[count].part.fur         :=      0.0;        {presence of}
      body[count].part.gallbladder :=      0.2;        {kg character weight mod}
      body[count].part.GallBladder_IronOxide := 0.0;   {worker bees and Gargoyles, detect magnetic fields}
      body[count].part.gills       :=      0.0;        {depth effective to}
      body[count].part.hair        :=      0.33334;    {weight in kg}
      body[count].part.hand        :=      2.0;        {number of}
      body[count].part.head        :=      1.0;        {whole }
      body[count].part.heart       :=      3.0;        {kg of}
      body[count].part.hide        :=      0.0;        {presence of}
      body[count].part.hoof        :=      0.0;        {run mult}
      body[count].part.horn        :=      0.0;        {number of}
      body[count].part.intestin_greater    := 1.0;     {length over body lenth}
      body[count].part.intestin_lessor     := 1.0;     {length over body lenth}
      body[count].part.kidney      :=      2.0;        {filtration quality}
      body[count].part.leaf        :=      0.0;        {weight per twig}
      body[count].part.leather     :=      0.0;        {presence of}
      body[count].part.leg         :=      2.0;        {number of}
      body[count].part.limb        :=      4.0;        {number of}
      body[count].part.liver       :=      1.0;        {presence of & absorbancy ratio to 1}
      body[count].part.lung        :=      2.0;        {volume of co2 produce per turn}
      body[count].part.mouth       :=      1.0;        {number of}
      body[count].part.neck        :=      1.0;        {number of}
      body[count].part.nose        :=      1.0;        {number of}
      body[count].part.nucleous    :=      0.0;        {presence of}
      body[count].part.probiscus   :=      0.16;       {protrusion to head size ratio}
      body[count].part.rib         :=     13.0;        {number of pairs}
      body[count].part.root        :=      0.01;       {depth}
      body[count].part.scales      :=      0.0;        {presence of}
      body[count].part.shell       :=      0.0;        {presence of}
      body[count].part.sinus       :=      2.0;        {sq cm of olfactory membrane}
      body[count].part.skin        :=      1.0;        {presence of}
      body[count].part.spells      :=     20.0;        {spell casting}
      body[count].part.spinner     :=      0.0;        {fineness of web strand 1/x meters diameter}
      body[count].part.spleen      :=      0.2;        {smell range in hexes}
      body[count].part.stalk       :=      0.0;        {flexibility of}
      body[count].part.stem        :=      0.0;        {0 = dried, 1= hydro, 2= weaping/running sap}
      body[count].part.stinger     :=      0.0;        {avg damage of poison}
      body[count].part.stomache    :=      1.0;        {avg acid damage}
      body[count].part.tail        :=      0.7;       {length}
      body[count].part.talon       :=      0.0;        {mult}
      body[count].part.TasteBudsLeg   :=        0.0;   {number of}
      body[count].part.TasteBudsRoof  :=        0.0;   {number of}
      body[count].part.TastebudsToung :=    10000.0;   {number of}
      body[count].part.TastebudsWiskers := 0.0;        {use wiskers to find food}
      body[count].part.TasteBudsAntena  := 0.0;        {use antenna to detect chemicals}
      body[count].part.TasteBudsBody    := 0.0;        {earth worm is covered with them}
      body[count].part.tenticle    :=      0.0;        {number of}
      body[count].part.toenail     :=      0.05;       {weight of in kg}
      body[count].part.tooth       :=     32.0;        {number of}
      body[count].part.trunk       :=    100.0;        {centi meter circumference }
      body[count].part.tusk        :=      0.0;        {number of}
      body[count].part.twig        :=      0.0;        {weight per branch}
      body[count].part.voice_box   :=      1.0;        {language ability}
      body[count].part.wing        :=      0.0;        {fly mult}
      body[count].part.wisker      :=      1.0;        {cm length of hairs}

   inc(count); {white dragon}

   inc(count);{grey dragon}

   inc(count);{black dragon}

   inc(count);{brown dragon}

   inc(count);{red dragon}

   inc(count); {greater demon}

   inc(count); {lesser demon}

   inc(count); {sasquatch}

   inc(count); {wyvern}

   inc(count); {wraith}

   inc(count); {troll}

   inc(count); {troglodyte}

   inc(count); {octopus}

   inc(count); {neanderthal}

   inc(count); {ogres}

   inc(count); {ghoul}

   inc(count); {shadowight}

   inc(count); {hydra}

   inc(count); {hydra}

   inc(count); {basilisk}

   inc(count); {soil elemental}

   inc(count); {rock elemental}

   inc(count); {metal ore elemental}

   inc(count); {air elemental}

   inc(count); {fire elemental}

   inc(count); {water elemental}

   inc(count); {steam elemental}

   inc(count); {ice elemental}

   inc(count); {apep}

   inc(count); {nag horse}

   inc(count); {riding horse}

   inc(count); {light horse}

   inc(count); {draft horse}

   inc(count); {warhorse}

   inc(count); {donkey}

   inc(count); {mule horse}

   inc(count); {unicorn horse}

   inc(count); {pegasus horse}

   inc(count); {indri mammal}

   inc(count); {elephant mammal}

   inc(count); {oxen mammal}

   inc(count); {camel mammal}

   inc(count); {lizard reptile}

   inc(count); {saurian reptile}

   inc(count); {walker reptile}

   inc(count); {hawk bird}

   inc(count); {diatryma bird}

   inc(count); {roc bird}

   inc(count); {gryphon}

   inc(count); {dolphin}

   inc(count); {wolf}

   inc(count); {dire wolf}

   inc(count); {big dog}

   inc(count); {wolfhound}

   inc(count); {hunting dog}

   inc(count); {spaniel dog}

   inc(count); {gray hound}

   inc(count); {flushing dog}

   inc(count); {pointer dog}

   inc(count); {retriever dog}

   inc(count); {small dog}

   inc(count); {cave bears}

   inc(count); {kodiak bears}

   inc(count); {black bears}

   inc(count); {lion cats}

   inc(count); {tiger cats}

   inc(count); {sabertooth cats}

   inc(count); {jaguar cats}

   inc(count); {little cats}

   inc(count); {great ape}

   inc(count); {baboon ape}

   inc(count); {chimpanzee ape}

   inc(count); {monkey ape}

   inc(count); {slinker}

   inc(count); {dragonet}

   inc(count); {stone beetle}

   inc(count); {giant spider}

   inc(count); {giant scorpion}

   inc(count); {basic}

   inc(count); {spyders}

   inc(count); {low renders}

   inc(count); {termagants}

   inc(count); {phlanxes}

   inc(count); {gantuas}

   inc(count); {myrmidon}

   inc(count); {plunges}

   inc(count); {WORKERS}

   inc(count); {large snake}

   inc(count); {giant snake}

   inc(count); {monster snake}

   inc(count); {lizard}

   inc(count); {goo}

   inc(count); {goo}

   inc(count); {goo}

   inc(count); {piranha}

   inc(count); {naughty minnow}

   inc(count); {shark}

   inc(count); {giant snapping turtles}

   inc(count); {giant snapping turtles}

   inc(count); {uncle teeth}

   inc(count); {giant clam}

   inc(count); {kraken}

   inc(count); {crocodile}

   inc(count); {bloodtree}

   inc(count); {am bush}

   inc(count); {mushroom}

   inc(count); {green slime}

   inc(count); {brown slime}

   inc(count); {silver slime}

   inc(count); {rats}

   inc(count); {scuttles}

   inc(count); {piranhakeets}

   inc(count); {rats}

   inc(count); {children}
end;

function TForm1.FindTalent(s: shortString): UINT;
var
   count, found: integer;
begin
   found := -1;
   Result := 0;
   for count := TalentCurrentTotal downto 1 do
   begin
      if Talent[count].list.Name = s then
         found := count;
   end;
   if found > 0 then result := found;
end;

procedure TForm1.InitTalents;
var
   count: integer;
begin
{
      Name: shortString;
      NameN,
      Pre1N, pre2N, Pre1orN, pre2orN,
      PreInc1N, PreInc2N,
      costToWize,
      costToHero: UINT;
      cast: char; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
      JobQual: char; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
      category: char; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
      listed, HandRequired: boolean; // False if not, and only implied

}
   count := 0;

   inc(count);
   Talent[count].list.Name          := 'St 12+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 13+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 12+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 14+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 13+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 15+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 14+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 16+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 15+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 18+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 16+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 20+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 18+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 24+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 20+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 26+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 24+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'St 28+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('St 26+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Dx 12+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Dx 13+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Dx 12+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Dx 14+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Dx 13+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Dx 15+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Dx 14+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Dx 16+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Dx 15+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 10+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 11+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 10+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 12+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 11+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 13+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 12+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 14+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 13+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 15+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 14+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 16+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 15+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 17+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 16+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 18+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 17+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 19+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 18+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 20+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 19+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 21+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 20+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 22+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 21+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 23+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 22+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 24+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 23+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'Iq 25+';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('Iq 24+');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '2 years military experience';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '5 years as seargent';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('2 years military experience');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '3 languages';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '2 weapon skills';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '3 weapon skills';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('2 weapon skills');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '4 weapon skills';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('3 weapon skills');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '5 weapon skills';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('4 weapon skills');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '6 weapon skills';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('5 weapon skills');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '5 combat spells';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '6 combat spells';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('5 combat spells');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 0;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '7 combat spells';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('6 combat spells');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '8 combat spells';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('7 combat spells');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := ' '; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'knife';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a';
   Talent[count].list.JobQual       := 'w';
   Talent[count].list.category      := ' ';
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sword';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('knife');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a';
   Talent[count].list.JobQual       := 'w';
   Talent[count].list.category      := ' ';
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'axe';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a';
   Talent[count].list.JobQual       := 'w';
   Talent[count].list.category      := ' ';
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'ax/mace';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('axe');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'pole weapons';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'bow';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'crossbow';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sheild';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 7;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // ' ' = non spell, 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'thrown weapons';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'naginata';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('pole weapons');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'boomerang';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('thrown weapons');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'bola';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('thrown weapons');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'net and trident';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('pole weapons');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sha-ken';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('thrown weapons');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'cestus';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'quarterstaff';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'lasso';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'whip';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'nunchunks';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'spear thrower';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('pole weapons');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := FindTalent('thrown weapons');
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'guns';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sex appeal';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'running';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'horsemanship';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'seamanship';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'boating';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'farming';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'literacy';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'swimming';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'diving';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('swimming');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'priest';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'bard';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'detect traps';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'charisma';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'alertness';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'acute hearing';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'silent movement';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'animal handler';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'recognize value';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'driver';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'missile weapons';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'climbing';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'warrior';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('St 14+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'veteran';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('St 16+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'beekeeper';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'butcher';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'carpenter';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'draper';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fisherman';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'tanner';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'baker';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'brewer';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'cook';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'gardener';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'joiner';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'leatherworker';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'potter';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sculptor';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'vitner';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'wood-carver';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'artist/calligrapher';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 3;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fencing';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('Dx 14+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'remove traps';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('detect traps');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'new followers';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('charisma');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'diplomacy';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'naturalist';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'tracking';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'acrobatics';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('Dx 12+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'business sense';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'amrourer';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'unarmed combat I';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('Dx 13+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'mimic';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'engineer';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'thief';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;
   inc(count);
   Talent[count].list.Name          := 'architect/builder';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'goldsmith';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('recognize value');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'shipbuilder';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('seamanship');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'two weapons';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('Dx 13+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'w'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'courtly graces';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'monster followers I';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'tactics';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'physicker';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'detection of lies';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'vet';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'mechanician';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('remove traps');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'expert horsemanship';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('horsemanship');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'woodsman';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('naturalist');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'expert naturalist';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('naturalist');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'monster followers II';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('monster followers I');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'spying';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('silent movement');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'assess value';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('recognize value');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 2;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'captain';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('seamanship');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'ventriloquist';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'unarmed combat II';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('unarmed combat I');
   Talent[count].list.pre2N         := FindTalent('Dx 14+');
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'master thief';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('theif');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'master armourer';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('armourer');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'chemist';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'master mechanician';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('mechanician');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'scholar';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('literacy');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 3;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'strategist';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('tactics');
   Talent[count].list.pre2N         := FindTalent('2 years military experience');
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'mathematician';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('literacy');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'master physicker';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('physicker');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'disguise';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'theologian';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('priest');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'unarmed combat III';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('unarmed combat II');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'unarmed combat IV';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('unarmed combat III');
   Talent[count].list.pre2N         := FindTalent('Dx 15+');
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'unarmed combat V';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('unarmed combat IV');
   Talent[count].list.pre2N         := FindTalent('Dx 16+');
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 6;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'alchemy';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 3;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'master bard';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('bard');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 4;
   Talent[count].list.costToHero    := 2;
   Talent[count].list.cast          := 'a'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := ' '; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'theives'' argot';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('master theif');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sorcerers'' toung';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := FindTalent('Iq 17+');
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 0;
   Talent[count].list.costToHero    := 0;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'toungs';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'orcish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'elvish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'high elvish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'dwarvish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'old dwarvish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'goblish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'hobbish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'prootish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'centauri';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'goyleish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'reptish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'meerish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sea elvish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'draconian';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'demonic';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'salishan';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'popis';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'equestria';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'tibetian';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'troll speech';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'oktopous';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'neanderthalese';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'ghoulish';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'hydroxian';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'basilisk';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fog runes';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 6;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 1;
   Talent[count].list.cast          := 'l'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := ' '; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'disbeleive';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 3;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := False;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'staff';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'magic fist';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'm'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := True;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'blur';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'slow movement';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'drop weapon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'image';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'detect magic';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'light';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 8;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'clumsiness';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'confusion';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'avert';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'aid';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sumon wolf';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'reveal magic';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fire';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'detect life';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'darkness';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'dark vision';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 9;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'trip';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'speed movement';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon myrmidon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'dazzle';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'shadow';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'shock shield';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'ward';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'trailtwister';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'far vision';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'detect enemies';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'lock/knock';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 10;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sleep';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon bear';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'control animal';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'illusion';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'reverse missiles';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'rope';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'create wall';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'destroy creation';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'silent movement';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'persuasiveness';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'staff to snake';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'reveal/conceal';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 11;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'freeze';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fireball';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'm'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'invisibility';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'blast';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'mage sight';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'break weapon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '3-hex fire';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := findTalent('fire');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '3-hex shadow';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('shadow');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'analyze magic';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'magic rainstorm';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'drain strength';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'repair';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'eyes behind';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 12;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'flight';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon gargoyle';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'control person';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'stone flesh';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'slippery floor';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'stop';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '4-hex image';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('image');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '3-hex wall';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('wall');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fireproofing';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'c'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'sticky floor';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'curse';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'open tunnel';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'telekinesis';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'control elemental';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 13;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'lightning';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'm'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon giant';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '4-hex illusion';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('illusion');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'remove thrown spell';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'dispel illusions';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'spell shield';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'glamor';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'fresh air';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'weapon/armor enchantment';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'telepathy';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon lesser demon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'explosive gem';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 14;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'iron flesh';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'teleport';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon small dragon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'giant rope';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '7-hex shadow';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('4-hex shadow');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '7-hex image';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('4-hex image');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'megahex avert';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := findTalent('avert');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'calling';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'hammertouch';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'unnoticeability';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'pentagram';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'create gate';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'astral projection';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 15;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '7-hex illusion';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('4-hex illusion');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon dragon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'death spell';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '7-hex fire';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('3-hex fire');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := '7-hex wall';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('3-hex wall');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'megahex sleep';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('sleep');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'trance';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'long-distance telepathy';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'write scroll';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'create/destroy elemental';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'staff of power';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 16;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'summon demon';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'geas';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'insubstantiality';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'dissolve enchantment';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'remove cursed object';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'expunge';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'spellsniffer';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'cleansing';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'the little death';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'blast trap';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 17;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'shapeshifting';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 18;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'wizard''s wrath';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 18;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'm'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'control gate';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 18;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 'c'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'lesser magic item creation';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 18;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'megahex freeze';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := FindTalent('freeze');
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 18;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'long-distance teleport';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 19;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'zombie';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 19;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'revival';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 19;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'b'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 't'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'greater magic item creation';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 20;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'word of command';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 20;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'i'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

   inc(count);
   Talent[count].list.Name          := 'possession';
   Talent[count].list.NameN         := count;
   Talent[count].list.Pre1N         := 0;
   Talent[count].list.pre2N         := 0;
   Talent[count].list.Pre1orN       := 0;
   Talent[count].list.pre2orN       := 0;
   Talent[count].list.PreInc1N      := 0;
   Talent[count].list.PreInc2N      := 0;
   Talent[count].list.IQ            := 20;
   Talent[count].list.costToWize    := 1;
   Talent[count].list.costToHero    := 3;
   Talent[count].list.cast          := 'j'; // 'a' = able/talent, 'l' = language, 'j' = spell/majic
   Talent[count].list.JobQual       := 'e'; // 'w' = war talent, 'e' = entertainment, 'i' = literacy, 'b' = battle spell
   Talent[count].list.category      := 's'; // 't' = thrown, 'm' = missile, 'c' = creation/contact, 's' = special
   Talent[count].list.listed        := True;
   Talent[count].list.HandRequired  := False;
   TalentCurrentTotal :=  count;

end;

procedure TForm1.FirstChoice;
var
   s: shortString;
begin
   RichEdit1.Lines.Clear;
   s := 'Father:________________________      Class: _________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Mother:________________________      Class: _________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);

   RichEdit1.SelStart := 7;
   RichEdit1.SelLength := 0;
end;

procedure TForm1.BlankSheet;
var
   s: shortString;
begin
   RichEdit1.Lines.Clear;
   s := 'Name:____________________ Sex:___________            ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Race: ________________________       Class: _________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                Cp: ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   S := 'St:____(____)   Bare hand:_______  |Wounds:         |';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Dx:____(____)   Armor:___________  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Iq:____(____)   _________________  |Fatigue:        |';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ma:____(____)   Fame:____________  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                    --Abilities--';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Studied:_____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
//   if Length(Studied_string) > some_total then
//   s := '        _____________________________________________' else
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                   --Equipment--';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ready weapon(s)  ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Secondary weapon ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                 ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'On belt _____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Hidden (where) ______________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Worn ________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Total kg ___________  including pack ________________';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ma-2______ Ma-4,Dx-1_______Ma-6,Dx-2_______Max_______';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Ep: ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '   Accessory                  |    Location     | kg ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := 'Five magic items (in order)                          ';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(1)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(2)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(3)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(4)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '(5)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '                   -- Notes --';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth);
   RichEdit1.Lines.Add(s);

   RichEdit1.SelStart := 7;
   RichEdit1.SelLength := 0;
end;

procedure TForm1.FullSheet;
var
   s, t: shortString;
   center, center2: integer;
begin
   RichEdit1.Lines.Clear;
      RichEdit1.SelStart := 0;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];
 t  := char_act.Name;
   center := (WidthRaceName -Length(t)) div 2;
   t := StringOfChar(' ', center) +t;
   t := t + StringOfChar(' ', WidthRaceName -Length(t));
   s := 'Name:' +t;
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'   Equipment Packed           |    Location     | kg ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Name;
      RichEdit1.SelLength := c.NameW;
      s := RichEdit1.SelText;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Name +c.NameW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

 t  := char_race.Name;
   center := (WidthRaceName -Length(t)) div 2;
   t := StringOfChar(' ', center) +t;
   t := t + StringOfChar(' ', WidthRaceName -Length(t));
   s := 'Race:' +t;
 t  := char_act.sex;
   center := (WidthSex -Length(t)) div 2;
   t := StringOfChar(' ', center) +t;
   t := t + StringOfChar(' ', WidthSex -Length(t));
   s := s+' Sex:' +t;
 t  := char_act.Classi;
   center := (WidthClass -Length(t)) div 2;
   t := StringOfChar(' ', center) +t;
   t := t + StringOfChar(' ', WidthClass -Length(t));
   s := s+' Class:' +t;

   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.race;
      RichEdit1.SelLength := c.raceW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Sex;
      RichEdit1.SelLength := c.SexW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Classi;
      RichEdit1.SelLength := c.ClassiW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip1A;
//      RichEdit1.SelLength := c.Equip1AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc1A;
//      RichEdit1.SelLength := c.Eq_loc1AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg1A;
//      RichEdit1.SelLength := c.Eq_kg1AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg1A +c.Eq_kg1AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   if char_stat.Cp <> 0 then
   begin
 t  := getStat(char_stat.Cp);
   s := 'Extra points'+t;
   end else begin
   s := ''; end;
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Equip1B;
      RichEdit1.SelLength := c.Equip1BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc1B;
      RichEdit1.SelLength := c.Eq_loc1BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg1B;
      RichEdit1.SelLength := c.Eq_kg1BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg1B +c.Eq_kg1BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];


   s := '                                    ________________ ';
   s := s +StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
//      RichEdit1.SelStart := c.Equip2A;
//      RichEdit1.SelLength := c.Equip2AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc2A;
//      RichEdit1.SelLength := c.Eq_loc2AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg2A;
//      RichEdit1.SelLength := c.Eq_kg2AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg2A +c.Eq_kg2AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];


 t  := getStat(char_stat.St);
   s := 'St:'+t+'(____)   ';
 t  := char_race.hand +':';
   center2 := Length(t);
   center := (c.HdW -center2 -Length( GetDamage(char_stat.Hd, char_stat.st) )) div 2;
 t := t +StringOfChar(' ', center);
 t := t +GetDamage(char_stat.Hd, char_stat.st);
   s := s + t;
   s := s +StringOfChar(' ', c.HdW - Length(t));
   s := s+ '  |Wounds:         |';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.St;
      RichEdit1.SelLength := c.StW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.St_adj;
      RichEdit1.SelLength := c.St_adjW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Hd +center2;
      RichEdit1.SelLength := c.HdW -center2;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip2B;
      RichEdit1.SelLength := c.Equip2BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc2B;
      RichEdit1.SelLength := c.Eq_loc2BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg2B;
      RichEdit1.SelLength := c.Eq_kg2BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg2B +c.Eq_kg2BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '                                   |                |';
   s := s +StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
//      RichEdit1.SelStart := c.Equip3A;
//      RichEdit1.SelLength := c.Equip3AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc3A;
//      RichEdit1.SelLength := c.Eq_loc3AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg3A;
//      RichEdit1.SelLength := c.Eq_kg3AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg3A +c.Eq_kg3AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];


 t  := getStat(char_stat.Dx);
   s := 'Dx:'+t+'(____)   ';
 t  := char_race.skin +':';
   center2 := Length(t);
   center := (c.ApW -center2 -Length( getStat(char_stat.Ap) )) div 2;
 t := t +StringOfChar(' ', center);
 t := t +getStat(char_stat.Ap);
   s := s +t;
   s := s +StringOfChar(' ', c.ApW - Length(t));
   s := s +'  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Dx;
      RichEdit1.SelLength := c.DxW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Dx_adj;
      RichEdit1.SelLength := c.Dx_adjW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Ap +center2;
      RichEdit1.SelLength := c.ApW -center2;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Wounds2;
      RichEdit1.SelLength := c.Wounds2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip3B;
      RichEdit1.SelLength := c.Equip3BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc3B;
      RichEdit1.SelLength := c.Eq_loc3BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg3B;
      RichEdit1.SelLength := c.Eq_kg3BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg3B +c.Eq_kg3BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '                                    ________________ ';
   s := s +StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
//      RichEdit1.SelStart := c.Equip4A;
//      RichEdit1.SelLength := c.Equip4AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc4A;
//      RichEdit1.SelLength := c.Eq_loc4AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg4A;
//      RichEdit1.SelLength := c.Eq_kg4AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg4A +c.Eq_kg4AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

 t  := getStat(char_stat.Iq);
   s := 'Iq:'+t+'(____)   ';
 t  := 'Job:';
   center2 := Length(t);
   center := (c.JobW -center2 -Length( '' )) div 2;
 t := t +StringOfChar(' ', center);
 t := t +'';
   s := s +t;
   s := s +StringOfChar(' ', c.JobW - Length(t));
   s := s +'  |Fatigue:        |';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Iq;
      RichEdit1.SelLength := c.IqW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Iq_adj;
      RichEdit1.SelLength := c.Iq_adjW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Job+center2;
      RichEdit1.SelLength := c.JobW-center2;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip4B;
      RichEdit1.SelLength := c.Equip4BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc4B;
      RichEdit1.SelLength := c.Eq_loc4BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg4B;
      RichEdit1.SelLength := c.Eq_kg4BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg4B +c.Eq_kg4BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '                                   |                |';
   s := s +StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
//      RichEdit1.SelStart := c.Equip5A;
//      RichEdit1.SelLength := c.Equip5AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc5A;
//      RichEdit1.SelLength := c.Eq_loc5AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg5A;
//      RichEdit1.SelLength := c.Eq_kg5AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg5A +c.Eq_kg5AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];


 t  := getStat(char_stat.Ma);
 t  := getStat(char_stat.Iq);
   s := 'Ma:'+t+'(____)   ';
 t  := char_race.fame +':';
   center2 := Length(t);
   center := (c.SilverW -center2 -Length( '' )) div 2;
 t := t +StringOfChar(' ', center);
 t := t +'';
   s := s +t;
   s := s +StringOfChar(' ', c.SilverW - Length(t));
   s := s +'  |________________|';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Ma;
      RichEdit1.SelLength := c.MaW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Ma_adj;
      RichEdit1.SelLength := c.Ma_adjW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.silver +center2;
      RichEdit1.SelLength := c.silverW -center2;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Fatigue2;
      RichEdit1.SelLength := c.Fatigue2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip5B;
      RichEdit1.SelLength := c.Equip5BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc5B;
      RichEdit1.SelLength := c.Eq_loc5BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg5B;
      RichEdit1.SelLength := c.Eq_kg5BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg5B +c.Eq_kg5BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

 if round(char_stat.Hx) > 1 then
 begin
 t  := getStat(char_stat.Hx);
   s := 'Hex'+t;
 end else begin
   s := '';
 end;
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
//      RichEdit1.SelStart := c.Equip6A;
//      RichEdit1.SelLength := c.Equip6AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc6A;
//      RichEdit1.SelLength := c.Eq_loc6AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg6A;
//      RichEdit1.SelLength := c.Eq_kg6AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg6A +c.Eq_kg6AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '                    --Abilities--';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Equip6B;
      RichEdit1.SelLength := c.Equip6BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc6B;
      RichEdit1.SelLength := c.Eq_loc6BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg6B;
      RichEdit1.SelLength := c.Eq_kg6BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg6B +c.Eq_kg6BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able1;
      RichEdit1.SelLength := c.Able1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip7A;
//      RichEdit1.SelLength := c.Equip7AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc7A;
//      RichEdit1.SelLength := c.Eq_loc7AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg7A;
//      RichEdit1.SelLength := c.Eq_kg7AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg7A +c.Eq_kg7AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able2;
      RichEdit1.SelLength := c.Able2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip7B;
      RichEdit1.SelLength := c.Equip7BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc7B;
      RichEdit1.SelLength := c.Eq_loc7BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg7B;
      RichEdit1.SelLength := c.Eq_kg7BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg7B +c.Eq_kg7BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able3;
      RichEdit1.SelLength := c.Able3W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip8A;
//      RichEdit1.SelLength := c.Equip8AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc8A;
//      RichEdit1.SelLength := c.Eq_loc8AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg8A;
//      RichEdit1.SelLength := c.Eq_kg8AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg8A +c.Eq_kg8AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able4;
      RichEdit1.SelLength := c.Able4W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip8B;
      RichEdit1.SelLength := c.Equip8BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc8B;
      RichEdit1.SelLength := c.Eq_loc8BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg8B;
      RichEdit1.SelLength := c.Eq_kg8BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg8B +c.Eq_kg8BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able5;
      RichEdit1.SelLength := c.Able5W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip9A;
//      RichEdit1.SelLength := c.Equip9AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc9A;
//      RichEdit1.SelLength := c.Eq_loc9AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg9A;
//      RichEdit1.SelLength := c.Eq_kg9AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg9A +c.Eq_kg9AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able6;
      RichEdit1.SelLength := c.Able6W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip9B;
      RichEdit1.SelLength := c.Equip9BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc9B;
      RichEdit1.SelLength := c.Eq_loc9BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg9B;
      RichEdit1.SelLength := c.Eq_kg9BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg9B +c.Eq_kg9BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able7;
      RichEdit1.SelLength := c.Able7W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip10A;
//      RichEdit1.SelLength := c.Equip10AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc10A;
//      RichEdit1.SelLength := c.Eq_loc10AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg10A;
//      RichEdit1.SelLength := c.Eq_kg10AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg10A +c.Eq_kg10AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able8;
      RichEdit1.SelLength := c.Able8W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip10B;
      RichEdit1.SelLength := c.Equip10BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc10B;
      RichEdit1.SelLength := c.Eq_loc10BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg10B;
      RichEdit1.SelLength := c.Eq_kg10BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg10B +c.Eq_kg10BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able9;
      RichEdit1.SelLength := c.Able9W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip11A;
//      RichEdit1.SelLength := c.Equip11AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc11A;
//      RichEdit1.SelLength := c.Eq_loc11AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg11A;
//      RichEdit1.SelLength := c.Eq_kg11AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg11A +c.Eq_kg11AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able10;
      RichEdit1.SelLength := c.Able10W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip11B;
      RichEdit1.SelLength := c.Equip11BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc11B;
      RichEdit1.SelLength := c.Eq_loc11BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg11B;
      RichEdit1.SelLength := c.Eq_kg11BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg11B +c.Eq_kg11BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able11;
      RichEdit1.SelLength := c.Able11W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip12A;
//      RichEdit1.SelLength := c.Equip12AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc12A;
//      RichEdit1.SelLength := c.Eq_loc12AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg12A;
//      RichEdit1.SelLength := c.Eq_kg12AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg12A +c.Eq_kg12AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able12;
      RichEdit1.SelLength := c.Able12W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip12B;
      RichEdit1.SelLength := c.Equip12BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc12B;
      RichEdit1.SelLength := c.Eq_loc12BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg12B;
      RichEdit1.SelLength := c.Eq_kg12BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg12B +c.Eq_kg12BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able13;
      RichEdit1.SelLength := c.Able13W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip13A;
//      RichEdit1.SelLength := c.Equip13AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc13A;
//      RichEdit1.SelLength := c.Eq_loc13AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg13A;
//      RichEdit1.SelLength := c.Eq_kg13AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg13A +c.Eq_kg13AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able14;
      RichEdit1.SelLength := c.Able14W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip13B;
      RichEdit1.SelLength := c.Equip13BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc13B;
      RichEdit1.SelLength := c.Eq_loc13BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg13B;
      RichEdit1.SelLength := c.Eq_kg13BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg13B +c.Eq_kg13BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able15;
      RichEdit1.SelLength := c.Able15W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip14A;
//      RichEdit1.SelLength := c.Equip14AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc14A;
//      RichEdit1.SelLength := c.Eq_loc14AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg14A;
//      RichEdit1.SelLength := c.Eq_kg14AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg14A +c.Eq_kg14AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Able16;
      RichEdit1.SelLength := c.Able16W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Equip14B;
      RichEdit1.SelLength := c.Equip14BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc14B;
      RichEdit1.SelLength := c.Eq_loc14BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg14B;
      RichEdit1.SelLength := c.Eq_kg14BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg14B +c.Eq_kg14BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'Studied:_____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Study1;
      RichEdit1.SelLength := c.Study1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Equip15A;
//      RichEdit1.SelLength := c.Equip15AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc15A;
//      RichEdit1.SelLength := c.Eq_loc15AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg15A;
//      RichEdit1.SelLength := c.Eq_kg15AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg15A +c.Eq_kg15AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Equip15B;
      RichEdit1.SelLength := c.Equip15BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc15B;
      RichEdit1.SelLength := c.Eq_loc15BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg15B;
      RichEdit1.SelLength := c.Eq_kg15BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg15B +c.Eq_kg15BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];


   s := '                   --Epuipment--';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
//      RichEdit1.SelStart := c.Equip16A;
//      RichEdit1.SelLength := c.Equip16AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_loc16A;
//      RichEdit1.SelLength := c.Eq_loc16AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.Eq_kg16A;
//      RichEdit1.SelLength := c.Eq_kg16AW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg16A +c.Eq_kg16AW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   if char_race.hand = 'tenticle' then
   s := '                 ___________________________  kg:____'
   else s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s +'______________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
   if char_race.hand = 'tenticle' then
   begin
      RichEdit1.SelStart := c.ready0;
      RichEdit1.SelLength := c.ready0W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.ready0_kg;
      RichEdit1.SelLength := c.ready0W_kg;
      RichEdit1.SelAttributes.Style := [fsUnderline];
   end;

      RichEdit1.SelStart := c.Equip16B;
      RichEdit1.SelLength := c.Equip16BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_loc16B;
      RichEdit1.SelLength := c.Eq_loc16BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg16B;
      RichEdit1.SelLength := c.Eq_kg16BW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Eq_kg16B +c.Eq_kg16BW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'Ready weapon(s)  ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.ready1;
      RichEdit1.SelLength := c.ready1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.ready1_kg;
      RichEdit1.SelLength := c.ready1W_kg;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.ready1_kg +c.ready1W_kg;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '                 ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.ready2;
      RichEdit1.SelLength := c.ready2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.ready2_kg;
      RichEdit1.SelLength := c.ready2W_kg;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.ready2_kg +c.ready2W_kg;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'Secondary weapon ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '   Five magic items (in order)';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Second1;
      RichEdit1.SelLength := c.Second1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Second1_kg;
      RichEdit1.SelLength := c.Second1W_kg;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Second1_kg +c.Second1W_kg;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '                 ___________________________  kg:____';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Second2;
      RichEdit1.SelLength := c.Second2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Second2_kg;
      RichEdit1.SelLength := c.Second2W_kg;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi1A;
//      RichEdit1.SelLength := c.mi1AW ;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi1_locA;
//      RichEdit1.SelLength := c.mi1_locAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi1_kgA;
//      RichEdit1.SelLength := c.mi1_kgAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi1_kgA +c.mi1_kgAW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'On belt _____________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '(1)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Belt1;
      RichEdit1.SelLength := c.Belt1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi1B;
      RichEdit1.SelLength := c.mi1BW ;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi1_locB;
      RichEdit1.SelLength := c.mi1_locBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi1_kgB;
      RichEdit1.SelLength := c.mi1_kgBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi1_kgB +c.mi1_kgBW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Belt2;
      RichEdit1.SelLength := c.Belt2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi2A;
//      RichEdit1.SelLength := c.mi2AW ;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi2_locA;
//      RichEdit1.SelLength := c.mi2_locAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi2_kgA;
//      RichEdit1.SelLength := c.mi2_kgAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi2_kgA +c.mi2_kgAW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'Hidden (where) ______________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '(2)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Hidden1;
      RichEdit1.SelLength := c.Hidden1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi2B;
      RichEdit1.SelLength := c.mi2BW ;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi2_locB;
      RichEdit1.SelLength := c.mi2_locBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi2_kgB;
      RichEdit1.SelLength := c.mi2_kgBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi2_kgB +c.mi2_kgBW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Hidden2;
      RichEdit1.SelLength := c.Hidden2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi3A;
//      RichEdit1.SelLength := c.mi3AW ;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi3_locA;
//      RichEdit1.SelLength := c.mi3_locAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi3_kgA;
//      RichEdit1.SelLength := c.mi3_kgAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi3_kgA +c.mi3_kgAW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'Worn ________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '(3)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Worn1;
      RichEdit1.SelLength := c.Worn1W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi3B;
      RichEdit1.SelLength := c.mi3BW ;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi3_locB;
      RichEdit1.SelLength := c.mi3_locBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi3_kgB;
      RichEdit1.SelLength := c.mi3_kgBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi3_kgB +c.mi3_kgBW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '_____________________________________________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Worn2;
      RichEdit1.SelLength := c.Worn2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi4A;
//      RichEdit1.SelLength := c.mi4AW ;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi4_locA;
//      RichEdit1.SelLength := c.mi4_locAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi4_kgA;
//      RichEdit1.SelLength := c.mi4_kgAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi4_kgA +c.mi4_kgAW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '(4)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.mi4B;
      RichEdit1.SelLength := c.mi4BW ;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi4_locB;
      RichEdit1.SelLength := c.mi4_locBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi4_kgB;
      RichEdit1.SelLength := c.mi4_kgBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi4_kgB +c.mi4_kgBW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := 'Total kg ___________  including pack ________________';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '                              |                 |    ';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.TotalKg;
      RichEdit1.SelLength := c.TotalKgW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Pack;
      RichEdit1.SelLength := c.PackW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi5A;
//      RichEdit1.SelLength := c.mi5AW ;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi5_locA;
//      RichEdit1.SelLength := c.mi5_locAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

//      RichEdit1.SelStart := c.mi5_kgA;
//      RichEdit1.SelLength := c.mi5_kgAW;
//      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi5_kgA +c.mi5_kgAW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];


   s := 'Ma-2______ Ma-4,Dx-1_______Ma-6,Dx-2_______Max_______';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '(5)___________________________|_________________|____';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
      RichEdit1.SelStart := c.Ma_2;
      RichEdit1.SelLength := c.Ma_2W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Ma4;
      RichEdit1.SelLength := c.Ma4_W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Ma6;
      RichEdit1.SelLength := c.Ma6_W;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.Max;
      RichEdit1.SelLength := c.MaxW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi5B;
      RichEdit1.SelLength := c.mi5BW ;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi5_locB;
      RichEdit1.SelLength := c.mi5_locBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi5_kgB;
      RichEdit1.SelLength := c.mi5_kgBW;
      RichEdit1.SelAttributes.Style := [fsUnderline];

      RichEdit1.SelStart := c.mi5_kgB +c.mi5_kgBW;
      RichEdit1.SelLength := 0;
      RichEdit1.SelAttributes.Style := [ ];

   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + '                   -- Notes --';
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
   s := 'Experience:';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);
   //
   //
   s := '';
   s := s + StringOfChar(' ',SheetCharWidth -Length(s));
   s := s + StringOfChar(' ',SheetCharWidth2 -Length(s)-1);
   s := s +'|';
   RichEdit1.Lines.Add(s);

   RichEdit1.SelStart := 7;
   RichEdit1.SelLength := 0;
end;

procedure TForm1.FormCreate(Sender: TObject);
begin
   InitCapture;
   InitRaces;
   InitChar;
   ListRaces;
   InitTalents;
   Printer.Orientation := poLandscape;
end;

procedure TForm1.BirthChar;
var
   count: integer;
   s: shortString;
begin
{  char_race: TRaces;
  char_stat: TRaceStats;
  char_body: TBodyParts;}
 if (father > 0) and
    (mother > 0) then
 begin
  if father = mother then
  begin
     char_race.Name     := GetRaceName(father);
     char_race.Plural   := Race[father].Plural;
     char_race.common   := Race[father].common;
     char_race.language := Race[father].language;
     char_race.latin    := Race[father].latin;
     char_race.hand     := Race[father].hand;
     char_race.skin     := Race[father].skin;
     char_race.fame     := Race[father].fame;
     char_race.N        := Race[father].N ;

     char_stat.St       := Stat[Race[father].N].St;
     char_stat.St_min   := Stat[Race[father].N].St_min;
     char_stat.St_max   := Stat[Race[father].N].St_max;
     char_stat.Dx       := Stat[Race[father].N].Dx;
     char_stat.Dx_min   := Stat[Race[father].N].Dx_min;
     char_stat.Dx_max   := Stat[Race[father].N].Dx_max;
     char_stat.Iq       := Stat[Race[father].N].Iq;
     char_stat.Iq_min   := Stat[Race[father].N].Iq_min;
     char_stat.Iq_max   := Stat[Race[father].N].Iq_max;
     char_stat.Ma       := Stat[Race[father].N].Ma;
     char_stat.Ma_min   := Stat[Race[father].N].Ma_min;
     char_stat.Ma_max   := Stat[Race[father].N].Ma_max;
     char_stat.Cp       := Stat[Race[father].N].Cp;
     char_stat.Cp_min   := Stat[Race[father].N].Cp_min;
     char_stat.Cp_max   := Stat[Race[father].N].Cp_max;
     char_stat.Hx       := Stat[Race[father].N].Hx;
     char_stat.Hx_min   := Stat[Race[father].N].Hx_min;
     char_stat.Hx_max   := Stat[Race[father].N].Hx_max;
     char_stat.Ap       := Stat[Race[father].N].Ap;
     char_stat.Hd       := Stat[Race[father].N].Hd;

  end else begin
     if Race[mother].n = Race[father].n then
     char_race.Name     := GetRaceName(father)
     else
     char_race.Name     :=  Race[father].Pref +Race[mother].Sufi;
     if length(char_race.Name) > WidthRaceName then
     begin
        s := char_race.Name;
        char_race.Name := '';
        for count := 1 to 24 do
            char_race.Name := char_race.Name + s[count];
     end;
     char_race.Plural   := Race[father].Plural;
     char_race.common   := Race[father].common;
     char_race.language := Race[father].language;
     char_race.latin    := Race[father].latin +' ' +Race[mother].latin;
     char_race.hand     := Race[mother].hand;
     char_race.skin     := Race[mother].skin;
     char_race.fame     := Race[father].fame;
     char_race.N        := Race[father].N;

     char_stat.St       := (Stat[Race[father].N].St +Stat[Race[mother].N].St) /2;
     char_stat.St_min   := (Stat[Race[father].N].St_min + Stat[Race[mother].N].St_min) /2;
     char_stat.St_max   := (Stat[Race[father].N].St_max + Stat[Race[mother].N].St_max) /2;
     char_stat.Dx       := (Stat[Race[father].N].Dx + Stat[Race[mother].N].Dx) /2;
     char_stat.Dx_min   := (Stat[Race[father].N].Dx_min + Stat[Race[mother].N].Dx_min) /2;
     char_stat.Dx_max   := (Stat[Race[father].N].Dx_max + Stat[Race[mother].N].Dx_max) /2;
     char_stat.Iq       := (Stat[Race[father].N].Iq + Stat[Race[mother].N].Iq) /2;
     char_stat.Iq_min   := (Stat[Race[father].N].Iq_min + Stat[Race[mother].N].Iq_min) /2;
     char_stat.Iq_max   := (Stat[Race[father].N].Iq_max + Stat[Race[mother].N].Iq_max) /2;
     char_stat.Ma       := (Stat[Race[father].N].Ma + Stat[Race[mother].N].Ma) /2;
     char_stat.Ma_min   := (Stat[Race[father].N].Ma_min + Stat[Race[mother].N].Ma_min) /2;
     char_stat.Ma_max   := (Stat[Race[father].N].Ma_max + Stat[Race[mother].N].Ma_max) /2;
     char_stat.Cp       := (Stat[Race[father].N].Cp + Stat[Race[mother].N].Cp) /2;
     char_stat.Cp_min   := (Stat[Race[father].N].Cp_min + Stat[Race[mother].N].Cp_min) /2;
     char_stat.Cp_max   := (Stat[Race[father].N].Cp_max + Stat[Race[mother].N].Cp_max) /2;
     char_stat.Hx       := (Stat[Race[father].N].Hx + Stat[Race[mother].N].Hx) /2;
     char_stat.Hx_min   := (Stat[Race[father].N].Hx_min + Stat[Race[mother].N].Hx_min) /2;
     char_stat.Hx_max   := (Stat[Race[father].N].Hx_max + Stat[Race[mother].N].Hx_max) /2;
     char_stat.Ap       := (Stat[Race[father].N].Ap + Stat[Race[mother].N].Ap) /2;
     char_stat.Hd       := (Stat[Race[father].N].Hd + Stat[Race[mother].N].Hd) /2;

  end;
  FullSheet;
  end else begin
     initChar;
  end;
end;

function TForm1.SelectRace(count: integer): integer;
var
   t, test, compare: shortstring;
   count2, found: integer;
begin
   t := ListBox1.Items.Strings[count-1];
   test := '';
   for count2 := 1 to WidthRaceName do
       test := test + t[count2];
   found := 0;

   if Button1.Caption = 'alphabetical' then
   begin
      for count2 := 1 to RaceCurrentTotal do
      begin
         compare := GetRaceNameIndex(count2);
         if test = compare then found := count2;
      end;
   end else begin
      for count2 := 1 to RaceCurrentTotal do
      begin
         compare := GetRaceName(count2);
         if test = compare then found := count2;
      end;
   end;
   Result := found;
end;

procedure TForm1.SelectParent(count: integer);
var
   t, test, compare: shortstring;
   count2, found: integer;
begin
   Form1.Caption := IntToStr(count);

   t := ListBox1.Items.Strings[count-1];
   test := '';
   for count2 := 1 to WidthRaceName do
       test := test + t[count2];
   found := 0;

   if Button1.Caption = 'alphabetical' then
   begin
      for count2 := 1 to RaceCurrentTotal do
      begin
         compare := GetRaceNameIndex(count2);
         if test = compare then found := count2;
      end;
   end else begin
      for count2 := 1 to RaceCurrentTotal do
      begin
         compare := GetRaceName(count2);
         if test = compare then found := count2;
      end;
   end;

   case sentence of
    0: begin
         Form1.Caption := GetRaceName(found);
         Father := found;
         if mother <> 0 then
         begin
            BirthChar;
            Sentence := 2;
         end else begin
            sentence := 1;
         end;
       end;
    1: begin
         Form1.Caption := GetRaceName(found);
         Mother := found;
         if Father <> 0 then
         begin
            BirthChar;
            Sentence := 2;
         end else begin
            sentence := 0;
         end;
       end;
   end; // case sentence of
end;

function TForm1.GetRaceName(count: integer): shortString;
begin
      if Race[count].Name = '' then
      result := Race[count].Common else
      result := Race[count].Name +' ' +Race[count].Common;
      result := result + StringOfChar(' ',WidthRaceName -Length(result));
end;

function TForm1.GetRaceNameIndex(count: integer): shortString;
begin
      if Race[count].Name = '' then
      result := Race[count].Common else
      result := Race[count].Common +', ' +Race[count].Name;
      result := result + StringOfChar(' ',WidthRaceName -Length(result));
end;

function TForm1.GetStat(number: double): shortString;
var
   temp: integer;
begin
   result := '';
   temp := round(number);
   if temp <> 0 then
   begin
      if temp >= max then result := '~~~ ' else
         result := IntToStr(temp);
   end;
   result := StringOfChar(' ', 4-Length(result)) +Result;
end;

function TForm1.GetDamage(number: double; st: double): shortString;
var
  avg: double;
  d, m: integer;
begin
   result := '    ';
   avg := number * st;
   d := round(avg / 3.5);
   m := round((avg * 2-(d *6) -d)/2);
   case m of
     -3..-1:  result := IntToStr(m);
          0:  result := '  ';
      1.. 3:  result := '+'+IntToStr(m);
   end;
   case d of
    -MAX..0:  result := '  '+result;
     1..MAX:  result := IntToStr(d)+result;
   end;

   result := StringOfChar(' ', 4 - Length(result)) + result;
end;

procedure TForm1.ListFormats;
begin
   ListBox1.Items.Clear;

   if TabSheetFormat.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   ListBox1.Items.Add('c.name' +'  ' +IntToStr(c.name));
   ListBox1.Items.Add('c.nameW' +'  ' +IntToStr(c.nameW));
   ListBox1.Items.Add('c.race' +'  ' +IntToStr(c.race));
   ListBox1.Items.Add('c.raceW' +'  ' +IntToStr(c.raceW));
   ListBox1.Items.Add('c.sex' +'  ' +IntToStr(c.sex));
   ListBox1.Items.Add('c.sexW' +'  ' +IntToStr(c.sexW));
   ListBox1.Items.Add('c.classi' +'  ' +IntToStr(c.classi));
   ListBox1.Items.Add('c.classiW' +'  ' +IntToStr(c.classiW));
   ListBox1.Items.Add('c.cp' +'  ' +IntToStr(c.cp));
   ListBox1.Items.Add('c.CpW' +'  ' +IntToStr(c.CpW));
   ListBox1.Items.Add('c.cp_adj' +'  ' +IntToStr(c.cp_adj));
   ListBox1.Items.Add('c.cp_adjW' +'  ' +IntToStr(c.cp_adjW));
   ListBox1.Items.Add('c.St' +'  ' +IntToStr(c.St));
   ListBox1.Items.Add('c.StW' +'  ' +IntToStr(c.StW));
   ListBox1.Items.Add('c.St_adj' +'  ' +IntToStr(c.St_adj));
   ListBox1.Items.Add('c.St_adjW' +'  ' +IntToStr(c.St_adjW));
   ListBox1.Items.Add('c.Hd' +'  ' +IntToStr(c.Hd));
   ListBox1.Items.Add('c.HdW' +'  ' +IntToStr(c.HdW));
   ListBox1.Items.Add('c.wounds1' +'  ' +IntToStr(c.wounds1));
   ListBox1.Items.Add('c.wounds1W' +'  ' +IntToStr(c.wounds1W));
   ListBox1.Items.Add('c.wounds2' +'  ' +IntToStr(c.wounds2));
   ListBox1.Items.Add('c.wounds2W' +'  ' +IntToStr(c.wounds2W));
   ListBox1.Items.Add('c.Dx' +'  ' +IntToStr(c.Dx));
   ListBox1.Items.Add('c.DxW' +'  ' +IntToStr(c.DxW));
   ListBox1.Items.Add('c.Dx_adj' +'  ' +IntToStr(c.Dx_adj));
   ListBox1.Items.Add('c.Dx_adjW' +'  ' +IntToStr(c.Dx_adjW));
   ListBox1.Items.Add('c.Ap' +'  ' +IntToStr(c.Ap));
   ListBox1.Items.Add('c.ApW' +'  ' +IntToStr(c.ApW));
   ListBox1.Items.Add('c.wounds3' +'  ' +IntToStr(c.wounds3));
   ListBox1.Items.Add('c.wounds3W' +'  ' +IntToStr(c.wounds3W));
   ListBox1.Items.Add('c.Iq' +'  ' +IntToStr(c.Iq));
   ListBox1.Items.Add('c.IqW' +'  ' +IntToStr(c.IqW));
   ListBox1.Items.Add('c.Iq_adj' +'  ' +IntToStr(c.Iq_adj));
   ListBox1.Items.Add('c.Iq_adjW' +'  ' +IntToStr(c.Iq_adjW));
   ListBox1.Items.Add('c.Job' +'  ' +IntToStr(c.Job));
   ListBox1.Items.Add('c.JobW' +'  ' +IntToStr(c.JobW));
   ListBox1.Items.Add('c.fatigue1' +'  ' +IntToStr(c.fatigue1));
   ListBox1.Items.Add('c.fatigue1W' +'  ' +IntToStr(c.fatigue1W));
   ListBox1.Items.Add('c.fatigue2' +'  ' +IntToStr(c.fatigue2));
   ListBox1.Items.Add('c.fatigue2W' +'  ' +IntToStr(c.fatigue2W));
   ListBox1.Items.Add('c.Ma' +'  ' +IntToStr(c.Ma));
   ListBox1.Items.Add('c.MaW' +'  ' +IntToStr(c.MaW));
   ListBox1.Items.Add('c.Ma_adj' +'  ' +IntToStr(c.Ma_adj));
   ListBox1.Items.Add('c.Ma_adjW' +'  ' +IntToStr(c.Ma_adjW));
   ListBox1.Items.Add('c.silver' +'  ' +IntToStr(c.silver));
   ListBox1.Items.Add('c.silverW' +'  ' +IntToStr(c.silverW));
   ListBox1.Items.Add('c.Fatigue3' +'  ' +IntToStr(c.Fatigue3));
   ListBox1.Items.Add('c.fatigue3W' +'  ' +IntToStr(c.fatigue3W));
   ListBox1.Items.Add('c.Hx' +'  ' +IntToStr(c.Hx));
   ListBox1.Items.Add('c.HxW' +'  ' +IntToStr(c.HxW));
   ListBox1.Items.Add('c.Able1' +'  ' +IntToStr(c.Able1));
   ListBox1.Items.Add('c.Able1W' +'  ' +IntToStr(c.Able1W));
   ListBox1.Items.Add('c.Able2' +'  ' +IntToStr(c.Able2));
   ListBox1.Items.Add('c.Able2W' +'  ' +IntToStr(c.Able2W));
   ListBox1.Items.Add('c.Able3' +'  ' +IntToStr(c.Able3));
   ListBox1.Items.Add('c.Able3W' +'  ' +IntToStr(c.Able3W));
   ListBox1.Items.Add('c.Able4' +'  ' +IntToStr(c.Able4));
   ListBox1.Items.Add('c.Able4W' +'  ' +IntToStr(c.Able4W));
   ListBox1.Items.Add('c.Able5' +'  ' +IntToStr(c.Able5));
   ListBox1.Items.Add('c.Able5W' +'  ' +IntToStr(c.Able5W));
   ListBox1.Items.Add('c.Able6' +'  ' +IntToStr(c.Able6));
   ListBox1.Items.Add('c.Able6W' +'  ' +IntToStr(c.Able6W));
   ListBox1.Items.Add('c.Able7' +'  ' +IntToStr(c.Able7));
   ListBox1.Items.Add('c.Able7W' +'  ' +IntToStr(c.Able7W));
   ListBox1.Items.Add('c.Able8' +'  ' +IntToStr(c.Able8));
   ListBox1.Items.Add('c.Able8W' +'  ' +IntToStr(c.Able8W));
   ListBox1.Items.Add('c.Able9' +'  ' +IntToStr(c.Able9));
   ListBox1.Items.Add('c.Able9W' +'  ' +IntToStr(c.Able9W));
   ListBox1.Items.Add('c.Able10' +'  ' +IntToStr(c.Able10));
   ListBox1.Items.Add('c.Able10W' +'  ' +IntToStr(c.Able10W));
   ListBox1.Items.Add('c.Able11' +'  ' +IntToStr(c.Able11));
   ListBox1.Items.Add('c.Able11W' +'  ' +IntToStr(c.Able11W));
   ListBox1.Items.Add('c.Able12' +'  ' +IntToStr(c.Able12));
   ListBox1.Items.Add('c.Able12W' +'  ' +IntToStr(c.Able12W));
   ListBox1.Items.Add('c.Able13' +'  ' +IntToStr(c.Able13));
   ListBox1.Items.Add('c.Able13W' +'  ' +IntToStr(c.Able13W));
   ListBox1.Items.Add('c.Able14' +'  ' +IntToStr(c.Able14));
   ListBox1.Items.Add('c.Able14W' +'  ' +IntToStr(c.Able14W));
   ListBox1.Items.Add('c.Able15' +'  ' +IntToStr(c.Able15));
   ListBox1.Items.Add('c.Able15W' +'  ' +IntToStr(c.Able15W));
   ListBox1.Items.Add('c.Able16' +'  ' +IntToStr(c.Able16));
   ListBox1.Items.Add('c.Able16W' +'  ' +IntToStr(c.Able16W));
   ListBox1.Items.Add('c.study1' +'  ' +IntToStr(c.study1));
   ListBox1.Items.Add('c.study1W' +'  ' +IntToStr(c.study1W));
   ListBox1.Items.Add('c.study2' +'  ' +IntToStr(c.study2));
   ListBox1.Items.Add('c.study2W' +'  ' +IntToStr(c.study2W));
   ListBox1.Items.Add('c.ready0' +'  ' +IntToStr(c.ready0));
   ListBox1.Items.Add('c.ready0W' +'  ' +IntToStr(c.ready0W));
   ListBox1.Items.Add('c.ready0_kg' +'  ' +IntToStr(c.ready0_kg));
   ListBox1.Items.Add('c.ready0W_kg' +'  ' +IntToStr(c.ready0W_kg));
   ListBox1.Items.Add('c.ready1' +'  ' +IntToStr(c.ready1));
   ListBox1.Items.Add('c.ready1W' +'  ' +IntToStr(c.ready1W));
   ListBox1.Items.Add('c.ready1_kg' +'  ' +IntToStr(c.ready1_kg));
   ListBox1.Items.Add('c.ready1W_kg' +'  ' +IntToStr(c.ready1W_kg));
   ListBox1.Items.Add('c.ready2' +'  ' +IntToStr(c.ready2));
   ListBox1.Items.Add('c.ready2W' +'  ' +IntToStr(c.ready2W));
   ListBox1.Items.Add('c.ready2_kg' +'  ' +IntToStr(c.ready2_kg));
   ListBox1.Items.Add('c.ready2W_kg' +'  ' +IntToStr(c.ready2W_kg));
   ListBox1.Items.Add('c.Second1' +'  ' +IntToStr(c.Second1));
   ListBox1.Items.Add('c.Second1W' +'  ' +IntToStr(c.Second1W));
   ListBox1.Items.Add('c.Second1_kg' +'  ' +IntToStr(c.Second1_kg));
   ListBox1.Items.Add('c.Second1W_kg' +'  ' +IntToStr(c.Second1W_kg));
   ListBox1.Items.Add('c.Second2' +'  ' +IntToStr(c.Second2));
   ListBox1.Items.Add('c.Second2W' +'  ' +IntToStr(c.Second2W));
   ListBox1.Items.Add('c.Second2_kg' +'  ' +IntToStr(c.Second2_kg));
   ListBox1.Items.Add('c.Second2W_kg' +'  ' +IntToStr(c.Second2W_kg));
   ListBox1.Items.Add('c.Belt1' +'  ' +IntToStr(c.Belt1));
   ListBox1.Items.Add('c.Belt1W' +'  ' +IntToStr(c.Belt1W));
   ListBox1.Items.Add('c.Belt2' +'  ' +IntToStr(c.Belt2));
   ListBox1.Items.Add('c.Belt2W' +'  ' +IntToStr(c.Belt2W));
   ListBox1.Items.Add('c.Hidden1' +'  ' +IntToStr(c.Hidden1));
   ListBox1.Items.Add('c.Hidden1W' +'  ' +IntToStr(c.Hidden1W));
   ListBox1.Items.Add('c.Hidden2' +'  ' +IntToStr(c.Hidden2));
   ListBox1.Items.Add('c.Hidden2W' +'  ' +IntToStr(c.Hidden2W));
   ListBox1.Items.Add('c.Worn1' +'  ' +IntToStr(c.Worn1));
   ListBox1.Items.Add('c.Worn1W' +'  ' +IntToStr(c.Worn1W));
   ListBox1.Items.Add('c.Worn2' +'  ' +IntToStr(c.Worn2));
   ListBox1.Items.Add('c.Worn2W' +'  ' +IntToStr(c.Worn2W));
   ListBox1.Items.Add('c.TotalKg' +'  ' +IntToStr(c.TotalKg));
   ListBox1.Items.Add('c.TotalKgW' +'  ' +IntToStr(c.TotalKgW));
   ListBox1.Items.Add('c.Pack' +'  ' +IntToStr(c.Pack));
   ListBox1.Items.Add('c.PackW' +'  ' +IntToStr(c.PackW));
   ListBox1.Items.Add('c.Ma_2' +'  ' +IntToStr(c.Ma_2));
   ListBox1.Items.Add('c.Ma_2W' +'  ' +IntToStr(c.Ma_2W));
   ListBox1.Items.Add('c.Ma4' +'  ' +IntToStr(c.Ma4));
   ListBox1.Items.Add('c.Ma4_W' +'  ' +IntToStr(c.Ma4_W));
   ListBox1.Items.Add('c.Ma6' +'  ' +IntToStr(c.Ma6));
   ListBox1.Items.Add('c.Ma6_W' +'  ' +IntToStr(c.Ma6_W));
   ListBox1.Items.Add('c.Max' +'  ' +IntToStr(c.Max));
   ListBox1.Items.Add('c.MaxW' +'  ' +IntToStr(c.MaxW));
   ListBox1.Items.Add('c.Ep1' +'  ' +IntToStr(c.Ep1));
   ListBox1.Items.Add('c.Ep1W' +'  ' +IntToStr(c.Ep1W));
   ListBox1.Items.Add('c.Ep2' +'  ' +IntToStr(c.Ep2));
   ListBox1.Items.Add('c.Ep2W' +'  ' +IntToStr(c.Ep2W));
   ListBox1.Items.Add('c.Ep3' +'  ' +IntToStr(c.Ep3));
   ListBox1.Items.Add('c.Ep3W' +'  ' +IntToStr(c.Ep3W));

   ListBox1.Items.Add('c.Equip1A' +'  ' +IntToStr(c.Equip1A));
   ListBox1.Items.Add('c.Equip1AW' +'  ' +IntToStr(c.Equip1AW));
   ListBox1.Items.Add('c.Eq_loc1A' +'  ' +IntToStr(c.Eq_loc1A));
   ListBox1.Items.Add('c.Eq_loc1AW' +'  ' +IntToStr(c.Eq_loc1AW));
   ListBox1.Items.Add('c.Eq_kg1A' +'  ' +IntToStr(c.Eq_kg1A));
   ListBox1.Items.Add('c.Eq_kg1AW' +'  ' +IntToStr(c.Eq_kg1AW));
   ListBox1.Items.Add('c.Equip1B' +'  ' +IntToStr(c.Equip1B));
   ListBox1.Items.Add('cEquip1BW.' +'  ' +IntToStr(c.Equip1BW));
   ListBox1.Items.Add('c.Eq_loc1B' +'  ' +IntToStr(c.Eq_loc1B));
   ListBox1.Items.Add('c.Eq_loc1BW' +'  ' +IntToStr(c.Eq_loc1BW));
   ListBox1.Items.Add('c.Eq_kg1B' +'  ' +IntToStr(c.Eq_kg1B));
   ListBox1.Items.Add('c.Eq_kg1BW' +'  ' +IntToStr(c.Eq_kg1BW));

   ListBox1.Items.Add('c.Equip2A' +'  ' +IntToStr(c.Equip2A));
   ListBox1.Items.Add('c.Equip2AW' +'  ' +IntToStr(c.Equip2AW));
   ListBox1.Items.Add('c.Eq_loc2A' +'  ' +IntToStr(c.Eq_loc2A));
   ListBox1.Items.Add('c.Eq_loc2AW' +'  ' +IntToStr(c.Eq_loc2AW));
   ListBox1.Items.Add('c.Eq_kg2A' +'  ' +IntToStr(c.Eq_kg2A));
   ListBox1.Items.Add('c.Eq_kg2AW' +'  ' +IntToStr(c.Eq_kg2AW));
   ListBox1.Items.Add('c.Equip2B' +'  ' +IntToStr(c.Equip2B));
   ListBox1.Items.Add('cEquip2BW.' +'  ' +IntToStr(c.Equip2BW));
   ListBox1.Items.Add('c.Eq_loc2B' +'  ' +IntToStr(c.Eq_loc2B));
   ListBox1.Items.Add('c.Eq_loc2BW' +'  ' +IntToStr(c.Eq_loc2BW));
   ListBox1.Items.Add('c.Eq_kg2B' +'  ' +IntToStr(c.Eq_kg2B));
   ListBox1.Items.Add('c.Eq_kg2BW' +'  ' +IntToStr(c.Eq_kg2BW));

   ListBox1.Items.Add('c.Equip3A' +'  ' +IntToStr(c.Equip3A));
   ListBox1.Items.Add('c.Equip3AW' +'  ' +IntToStr(c.Equip3AW));
   ListBox1.Items.Add('c.Eq_loc3A' +'  ' +IntToStr(c.Eq_loc3A));
   ListBox1.Items.Add('c.Eq_loc3AW' +'  ' +IntToStr(c.Eq_loc3AW));
   ListBox1.Items.Add('c.Eq_kg3A' +'  ' +IntToStr(c.Eq_kg3A));
   ListBox1.Items.Add('c.Eq_kg3AW' +'  ' +IntToStr(c.Eq_kg3AW));
   ListBox1.Items.Add('c.Equip3B' +'  ' +IntToStr(c.Equip3B));
   ListBox1.Items.Add('cEquip3BW.' +'  ' +IntToStr(c.Equip3BW));
   ListBox1.Items.Add('c.Eq_loc3B' +'  ' +IntToStr(c.Eq_loc3B));
   ListBox1.Items.Add('c.Eq_loc3BW' +'  ' +IntToStr(c.Eq_loc3BW));
   ListBox1.Items.Add('c.Eq_kg3B' +'  ' +IntToStr(c.Eq_kg3B));
   ListBox1.Items.Add('c.Eq_kg3BW' +'  ' +IntToStr(c.Eq_kg3BW));

   ListBox1.Items.Add('c.Equip4A' +'  ' +IntToStr(c.Equip4A));
   ListBox1.Items.Add('c.Equip4AW' +'  ' +IntToStr(c.Equip4AW));
   ListBox1.Items.Add('c.Eq_loc4A' +'  ' +IntToStr(c.Eq_loc4A));
   ListBox1.Items.Add('c.Eq_loc4AW' +'  ' +IntToStr(c.Eq_loc4AW));
   ListBox1.Items.Add('c.Eq_kg4A' +'  ' +IntToStr(c.Eq_kg4A));
   ListBox1.Items.Add('c.Eq_kg4AW' +'  ' +IntToStr(c.Eq_kg4AW));
   ListBox1.Items.Add('c.Equip4B' +'  ' +IntToStr(c.Equip4B));
   ListBox1.Items.Add('cEquip4BW.' +'  ' +IntToStr(c.Equip4BW));
   ListBox1.Items.Add('c.Eq_loc4B' +'  ' +IntToStr(c.Eq_loc4B));
   ListBox1.Items.Add('c.Eq_loc4BW' +'  ' +IntToStr(c.Eq_loc4BW));
   ListBox1.Items.Add('c.Eq_kg4B' +'  ' +IntToStr(c.Eq_kg4B));
   ListBox1.Items.Add('c.Eq_kg4BW' +'  ' +IntToStr(c.Eq_kg4BW));

   ListBox1.Items.Add('c.Equip5A' +'  ' +IntToStr(c.Equip5A));
   ListBox1.Items.Add('c.Equip5AW' +'  ' +IntToStr(c.Equip5AW));
   ListBox1.Items.Add('c.Eq_loc5A' +'  ' +IntToStr(c.Eq_loc5A));
   ListBox1.Items.Add('c.Eq_loc5AW' +'  ' +IntToStr(c.Eq_loc5AW));
   ListBox1.Items.Add('c.Eq_kg5A' +'  ' +IntToStr(c.Eq_kg5A));
   ListBox1.Items.Add('c.Eq_kg5AW' +'  ' +IntToStr(c.Eq_kg5AW));
   ListBox1.Items.Add('c.Equip5B' +'  ' +IntToStr(c.Equip5B));
   ListBox1.Items.Add('cEquip5BW.' +'  ' +IntToStr(c.Equip5BW));
   ListBox1.Items.Add('c.Eq_loc5B' +'  ' +IntToStr(c.Eq_loc5B));
   ListBox1.Items.Add('c.Eq_loc5BW' +'  ' +IntToStr(c.Eq_loc5BW));
   ListBox1.Items.Add('c.Eq_kg5B' +'  ' +IntToStr(c.Eq_kg5B));
   ListBox1.Items.Add('c.Eq_kg5BW' +'  ' +IntToStr(c.Eq_kg5BW));

   ListBox1.Items.Add('c.Equip6A' +'  ' +IntToStr(c.Equip6A));
   ListBox1.Items.Add('c.Equip6AW' +'  ' +IntToStr(c.Equip6AW));
   ListBox1.Items.Add('c.Eq_loc6A' +'  ' +IntToStr(c.Eq_loc6A));
   ListBox1.Items.Add('c.Eq_loc6AW' +'  ' +IntToStr(c.Eq_loc6AW));
   ListBox1.Items.Add('c.Eq_kg6A' +'  ' +IntToStr(c.Eq_kg6A));
   ListBox1.Items.Add('c.Eq_kg6AW' +'  ' +IntToStr(c.Eq_kg6AW));
   ListBox1.Items.Add('c.Equip6B' +'  ' +IntToStr(c.Equip6B));
   ListBox1.Items.Add('cEquip6BW.' +'  ' +IntToStr(c.Equip6BW));
   ListBox1.Items.Add('c.Eq_loc6B' +'  ' +IntToStr(c.Eq_loc6B));
   ListBox1.Items.Add('c.Eq_loc6BW' +'  ' +IntToStr(c.Eq_loc6BW));
   ListBox1.Items.Add('c.Eq_kg6B' +'  ' +IntToStr(c.Eq_kg6B));
   ListBox1.Items.Add('c.Eq_kg6BW' +'  ' +IntToStr(c.Eq_kg6BW));

   ListBox1.Items.Add('c.Equip7A' +'  ' +IntToStr(c.Equip7A));
   ListBox1.Items.Add('c.Equip7AW' +'  ' +IntToStr(c.Equip7AW));
   ListBox1.Items.Add('c.Eq_loc7A' +'  ' +IntToStr(c.Eq_loc7A));
   ListBox1.Items.Add('c.Eq_loc7AW' +'  ' +IntToStr(c.Eq_loc7AW));
   ListBox1.Items.Add('c.Eq_kg7A' +'  ' +IntToStr(c.Eq_kg7A));
   ListBox1.Items.Add('c.Eq_kg7AW' +'  ' +IntToStr(c.Eq_kg7AW));
   ListBox1.Items.Add('c.Equip7B' +'  ' +IntToStr(c.Equip7B));
   ListBox1.Items.Add('cEquip7BW.' +'  ' +IntToStr(c.Equip7BW));
   ListBox1.Items.Add('c.Eq_loc7B' +'  ' +IntToStr(c.Eq_loc7B));
   ListBox1.Items.Add('c.Eq_loc7BW' +'  ' +IntToStr(c.Eq_loc7BW));
   ListBox1.Items.Add('c.Eq_kg7B' +'  ' +IntToStr(c.Eq_kg7B));
   ListBox1.Items.Add('c.Eq_kg7BW' +'  ' +IntToStr(c.Eq_kg7BW));

   ListBox1.Items.Add('c.Equip8A' +'  ' +IntToStr(c.Equip8A));
   ListBox1.Items.Add('c.Equip8AW' +'  ' +IntToStr(c.Equip8AW));
   ListBox1.Items.Add('c.Eq_loc8A' +'  ' +IntToStr(c.Eq_loc8A));
   ListBox1.Items.Add('c.Eq_loc8AW' +'  ' +IntToStr(c.Eq_loc8AW));
   ListBox1.Items.Add('c.Eq_kg8A' +'  ' +IntToStr(c.Eq_kg8A));
   ListBox1.Items.Add('c.Eq_kg8AW' +'  ' +IntToStr(c.Eq_kg8AW));
   ListBox1.Items.Add('c.Equip8B' +'  ' +IntToStr(c.Equip8B));
   ListBox1.Items.Add('cEquip8BW.' +'  ' +IntToStr(c.Equip8BW));
   ListBox1.Items.Add('c.Eq_loc8B' +'  ' +IntToStr(c.Eq_loc8B));
   ListBox1.Items.Add('c.Eq_loc8BW' +'  ' +IntToStr(c.Eq_loc8BW));
   ListBox1.Items.Add('c.Eq_kg8B' +'  ' +IntToStr(c.Eq_kg8B));
   ListBox1.Items.Add('c.Eq_kg8BW' +'  ' +IntToStr(c.Eq_kg8BW));

   ListBox1.Items.Add('c.Equip9A' +'  ' +IntToStr(c.Equip9A));
   ListBox1.Items.Add('c.Equip9AW' +'  ' +IntToStr(c.Equip9AW));
   ListBox1.Items.Add('c.Eq_loc9A' +'  ' +IntToStr(c.Eq_loc9A));
   ListBox1.Items.Add('c.Eq_loc9AW' +'  ' +IntToStr(c.Eq_loc9AW));
   ListBox1.Items.Add('c.Eq_kg9A' +'  ' +IntToStr(c.Eq_kg9A));
   ListBox1.Items.Add('c.Eq_kg9AW' +'  ' +IntToStr(c.Eq_kg9AW));
   ListBox1.Items.Add('c.Equip9B' +'  ' +IntToStr(c.Equip9B));
   ListBox1.Items.Add('cEquip9BW.' +'  ' +IntToStr(c.Equip9BW));
   ListBox1.Items.Add('c.Eq_loc9B' +'  ' +IntToStr(c.Eq_loc9B));
   ListBox1.Items.Add('c.Eq_loc9BW' +'  ' +IntToStr(c.Eq_loc9BW));
   ListBox1.Items.Add('c.Eq_kg9B' +'  ' +IntToStr(c.Eq_kg9B));
   ListBox1.Items.Add('c.Eq_kg9BW' +'  ' +IntToStr(c.Eq_kg9BW));

   ListBox1.Items.Add('c.Equip10A' +'  ' +IntToStr(c.Equip10A));
   ListBox1.Items.Add('c.Equip10AW' +'  ' +IntToStr(c.Equip10AW));
   ListBox1.Items.Add('c.Eq_loc10A' +'  ' +IntToStr(c.Eq_loc10A));
   ListBox1.Items.Add('c.Eq_loc10AW' +'  ' +IntToStr(c.Eq_loc10AW));
   ListBox1.Items.Add('c.Eq_kg10A' +'  ' +IntToStr(c.Eq_kg10A));
   ListBox1.Items.Add('c.Eq_kg10AW' +'  ' +IntToStr(c.Eq_kg10AW));
   ListBox1.Items.Add('c.Equip10B' +'  ' +IntToStr(c.Equip10B));
   ListBox1.Items.Add('cEquip10BW.' +'  ' +IntToStr(c.Equip10BW));
   ListBox1.Items.Add('c.Eq_loc10B' +'  ' +IntToStr(c.Eq_loc10B));
   ListBox1.Items.Add('c.Eq_loc10BW' +'  ' +IntToStr(c.Eq_loc10BW));
   ListBox1.Items.Add('c.Eq_kg10B' +'  ' +IntToStr(c.Eq_kg10B));
   ListBox1.Items.Add('c.Eq_kg10BW' +'  ' +IntToStr(c.Eq_kg10BW));

   ListBox1.Items.Add('c.Equip11A' +'  ' +IntToStr(c.Equip11A));
   ListBox1.Items.Add('c.Equip11AW' +'  ' +IntToStr(c.Equip11AW));
   ListBox1.Items.Add('c.Eq_loc11A' +'  ' +IntToStr(c.Eq_loc11A));
   ListBox1.Items.Add('c.Eq_loc11AW' +'  ' +IntToStr(c.Eq_loc11AW));
   ListBox1.Items.Add('c.Eq_kg11A' +'  ' +IntToStr(c.Eq_kg11A));
   ListBox1.Items.Add('c.Eq_kg11AW' +'  ' +IntToStr(c.Eq_kg11AW));
   ListBox1.Items.Add('c.Equip11B' +'  ' +IntToStr(c.Equip11B));
   ListBox1.Items.Add('cEquip11BW.' +'  ' +IntToStr(c.Equip11BW));
   ListBox1.Items.Add('c.Eq_loc11B' +'  ' +IntToStr(c.Eq_loc11B));
   ListBox1.Items.Add('c.Eq_loc11BW' +'  ' +IntToStr(c.Eq_loc11BW));
   ListBox1.Items.Add('c.Eq_kg11B' +'  ' +IntToStr(c.Eq_kg11B));
   ListBox1.Items.Add('c.Eq_kg11BW' +'  ' +IntToStr(c.Eq_kg11BW));

   ListBox1.Items.Add('c.Equip12A' +'  ' +IntToStr(c.Equip12A));
   ListBox1.Items.Add('c.Equip12AW' +'  ' +IntToStr(c.Equip12AW));
   ListBox1.Items.Add('c.Eq_loc12A' +'  ' +IntToStr(c.Eq_loc12A));
   ListBox1.Items.Add('c.Eq_loc12AW' +'  ' +IntToStr(c.Eq_loc12AW));
   ListBox1.Items.Add('c.Eq_kg12A' +'  ' +IntToStr(c.Eq_kg12A));
   ListBox1.Items.Add('c.Eq_kg12AW' +'  ' +IntToStr(c.Eq_kg12AW));
   ListBox1.Items.Add('c.Equip12B' +'  ' +IntToStr(c.Equip12B));
   ListBox1.Items.Add('cEquip12BW.' +'  ' +IntToStr(c.Equip12BW));
   ListBox1.Items.Add('c.Eq_loc12B' +'  ' +IntToStr(c.Eq_loc12B));
   ListBox1.Items.Add('c.Eq_loc12BW' +'  ' +IntToStr(c.Eq_loc12BW));
   ListBox1.Items.Add('c.Eq_kg12B' +'  ' +IntToStr(c.Eq_kg12B));
   ListBox1.Items.Add('c.Eq_kg12BW' +'  ' +IntToStr(c.Eq_kg12BW));

   ListBox1.Items.Add('c.Equip13A' +'  ' +IntToStr(c.Equip13A));
   ListBox1.Items.Add('c.Equip13AW' +'  ' +IntToStr(c.Equip13AW));
   ListBox1.Items.Add('c.Eq_loc13A' +'  ' +IntToStr(c.Eq_loc13A));
   ListBox1.Items.Add('c.Eq_loc13AW' +'  ' +IntToStr(c.Eq_loc13AW));
   ListBox1.Items.Add('c.Eq_kg13A' +'  ' +IntToStr(c.Eq_kg13A));
   ListBox1.Items.Add('c.Eq_kg13AW' +'  ' +IntToStr(c.Eq_kg13AW));
   ListBox1.Items.Add('c.Equip13B' +'  ' +IntToStr(c.Equip13B));
   ListBox1.Items.Add('cEquip13BW.' +'  ' +IntToStr(c.Equip13BW));
   ListBox1.Items.Add('c.Eq_loc13B' +'  ' +IntToStr(c.Eq_loc13B));
   ListBox1.Items.Add('c.Eq_loc13BW' +'  ' +IntToStr(c.Eq_loc13BW));
   ListBox1.Items.Add('c.Eq_kg13B' +'  ' +IntToStr(c.Eq_kg13B));
   ListBox1.Items.Add('c.Eq_kg13BW' +'  ' +IntToStr(c.Eq_kg13BW));

   ListBox1.Items.Add('c.Equip14A' +'  ' +IntToStr(c.Equip14A));
   ListBox1.Items.Add('c.Equip14AW' +'  ' +IntToStr(c.Equip14AW));
   ListBox1.Items.Add('c.Eq_loc14A' +'  ' +IntToStr(c.Eq_loc14A));
   ListBox1.Items.Add('c.Eq_loc14AW' +'  ' +IntToStr(c.Eq_loc14AW));
   ListBox1.Items.Add('c.Eq_kg14A' +'  ' +IntToStr(c.Eq_kg14A));
   ListBox1.Items.Add('c.Eq_kg14AW' +'  ' +IntToStr(c.Eq_kg14AW));
   ListBox1.Items.Add('c.Equip14B' +'  ' +IntToStr(c.Equip14B));
   ListBox1.Items.Add('cEquip14BW.' +'  ' +IntToStr(c.Equip14BW));
   ListBox1.Items.Add('c.Eq_loc14B' +'  ' +IntToStr(c.Eq_loc14B));
   ListBox1.Items.Add('c.Eq_loc14BW' +'  ' +IntToStr(c.Eq_loc14BW));
   ListBox1.Items.Add('c.Eq_kg14B' +'  ' +IntToStr(c.Eq_kg14B));
   ListBox1.Items.Add('c.Eq_kg14BW' +'  ' +IntToStr(c.Eq_kg14BW));

   ListBox1.Items.Add('c.Equip15A' +'  ' +IntToStr(c.Equip15A));
   ListBox1.Items.Add('c.Equip15AW' +'  ' +IntToStr(c.Equip15AW));
   ListBox1.Items.Add('c.Eq_loc15A' +'  ' +IntToStr(c.Eq_loc15A));
   ListBox1.Items.Add('c.Eq_loc15AW' +'  ' +IntToStr(c.Eq_loc15AW));
   ListBox1.Items.Add('c.Eq_kg15A' +'  ' +IntToStr(c.Eq_kg15A));
   ListBox1.Items.Add('c.Eq_kg15AW' +'  ' +IntToStr(c.Eq_kg15AW));
   ListBox1.Items.Add('c.Equip15B' +'  ' +IntToStr(c.Equip15B));
   ListBox1.Items.Add('c.Equip15BW' +'  ' +IntToStr(c.Equip15BW));
   ListBox1.Items.Add('c.Eq_loc15B' +'  ' +IntToStr(c.Eq_loc15B));
   ListBox1.Items.Add('c.Eq_loc15BW' +'  ' +IntToStr(c.Eq_loc15BW));
   ListBox1.Items.Add('c.Eq_kg15B' +'  ' +IntToStr(c.Eq_kg15B));
   ListBox1.Items.Add('c.Eq_kg15BW' +'  ' +IntToStr(c.Eq_kg15BW));

   ListBox1.Items.Add('c.Equip16A' +'  ' +IntToStr(c.Equip16A));
   ListBox1.Items.Add('c.Equip16AW' +'  ' +IntToStr(c.Equip16AW));
   ListBox1.Items.Add('c.Eq_loc16A' +'  ' +IntToStr(c.Eq_loc16A));
   ListBox1.Items.Add('c.Eq_loc16AW' +'  ' +IntToStr(c.Eq_loc16AW));
   ListBox1.Items.Add('c.Eq_kg16A' +'  ' +IntToStr(c.Eq_kg16A));
   ListBox1.Items.Add('c.Eq_kg16AW' +'  ' +IntToStr(c.Eq_kg16AW));
   ListBox1.Items.Add('c.Equip16B' +'  ' +IntToStr(c.Equip16B));
   ListBox1.Items.Add('c.Equip16BW' +'  ' +IntToStr(c.Equip16BW));
   ListBox1.Items.Add('c.Eq_loc16B' +'  ' +IntToStr(c.Eq_loc16B));
   ListBox1.Items.Add('c.Eq_loc16BW' +'  ' +IntToStr(c.Eq_loc16BW));
   ListBox1.Items.Add('c.Eq_kg16B' +'  ' +IntToStr(c.Eq_kg16B));
   ListBox1.Items.Add('c.Eq_kg16BW' +'  ' +IntToStr(c.Eq_kg16BW));


   ListBox1.Items.Add('c.mi1A' +'  ' +IntToStr(c.mi1A));
   ListBox1.Items.Add('c.mi1AW' +'  ' +IntToStr(c.mi1AW));
   ListBox1.Items.Add('c.mi1_locA' +'  ' +IntToStr(c.mi1_locA));
   ListBox1.Items.Add('c.mi1_locAW' +'  ' +IntToStr(c.mi1_locAW));
   ListBox1.Items.Add('c.mi1_kgA' +'  ' +IntToStr(c.mi1_kgA));
   ListBox1.Items.Add('c.mi1_kgAW' +'  ' +IntToStr(c.mi1_kgAW));
   ListBox1.Items.Add('c.mi1B' +'  ' +IntToStr(c.mi1B));
   ListBox1.Items.Add('c.mi1BW' +'  ' +IntToStr(c.mi1BW));
   ListBox1.Items.Add('c.mi1_locB' +'  ' +IntToStr(c.mi1_locB));
   ListBox1.Items.Add('c.mi1_locBW' +'  ' +IntToStr(c.mi1_locBW));
   ListBox1.Items.Add('c.mi1_kgB' +'  ' +IntToStr(c.mi1_kgB));
   ListBox1.Items.Add('c.mi1_kgBW' +'  ' +IntToStr(c.mi1_kgBW));

   ListBox1.Items.Add('c.mi2A' +'  ' +IntToStr(c.mi2A));
   ListBox1.Items.Add('c.mi2AW' +'  ' +IntToStr(c.mi2AW));
   ListBox1.Items.Add('c.mi2_locA' +'  ' +IntToStr(c.mi2_locA));
   ListBox1.Items.Add('c.mi2_locAW' +'  ' +IntToStr(c.mi2_locAW));
   ListBox1.Items.Add('c.mi2_kgA' +'  ' +IntToStr(c.mi2_kgA));
   ListBox1.Items.Add('c.mi2_kgAW' +'  ' +IntToStr(c.mi2_kgAW));
   ListBox1.Items.Add('c.mi2B' +'  ' +IntToStr(c.mi2B));
   ListBox1.Items.Add('c.mi2BW' +'  ' +IntToStr(c.mi2BW));
   ListBox1.Items.Add('c.mi2_locB' +'  ' +IntToStr(c.mi2_locB));
   ListBox1.Items.Add('c.mi2_locBW' +'  ' +IntToStr(c.mi2_locBW));
   ListBox1.Items.Add('c.mi2_kgB' +'  ' +IntToStr(c.mi2_kgB));
   ListBox1.Items.Add('c.mi2_kgBW' +'  ' +IntToStr(c.mi2_kgBW));

   ListBox1.Items.Add('c.mi3A' +'  ' +IntToStr(c.mi3A));
   ListBox1.Items.Add('c.mi3AW' +'  ' +IntToStr(c.mi3AW));
   ListBox1.Items.Add('c.mi3_locA' +'  ' +IntToStr(c.mi3_locA));
   ListBox1.Items.Add('c.mi3_locAW' +'  ' +IntToStr(c.mi3_locAW));
   ListBox1.Items.Add('c.mi3_kgA' +'  ' +IntToStr(c.mi3_kgA));
   ListBox1.Items.Add('c.mi3_kgAW' +'  ' +IntToStr(c.mi3_kgAW));
   ListBox1.Items.Add('c.mi3B' +'  ' +IntToStr(c.mi3B));
   ListBox1.Items.Add('c.mi3BW' +'  ' +IntToStr(c.mi3BW));
   ListBox1.Items.Add('c.mi3_locB' +'  ' +IntToStr(c.mi3_locB));
   ListBox1.Items.Add('c.mi3_locBW' +'  ' +IntToStr(c.mi3_locBW));
   ListBox1.Items.Add('c.mi3_kgB' +'  ' +IntToStr(c.mi3_kgB));
   ListBox1.Items.Add('c.mi3_kgBW' +'  ' +IntToStr(c.mi3_kgBW));

   ListBox1.Items.Add('c.mi4A' +'  ' +IntToStr(c.mi4A));
   ListBox1.Items.Add('c.mi4AW' +'  ' +IntToStr(c.mi4AW));
   ListBox1.Items.Add('c.mi4_locA' +'  ' +IntToStr(c.mi4_locA));
   ListBox1.Items.Add('c.mi4_locAW' +'  ' +IntToStr(c.mi4_locAW));
   ListBox1.Items.Add('c.mi4_kgA' +'  ' +IntToStr(c.mi4_kgA));
   ListBox1.Items.Add('c.mi4_kgAW' +'  ' +IntToStr(c.mi4_kgAW));
   ListBox1.Items.Add('c.mi4B' +'  ' +IntToStr(c.mi4B));
   ListBox1.Items.Add('c.mi4BW' +'  ' +IntToStr(c.mi4BW));
   ListBox1.Items.Add('c.mi4_locB' +'  ' +IntToStr(c.mi4_locB));
   ListBox1.Items.Add('c.mi4_locBW' +'  ' +IntToStr(c.mi4_locBW));
   ListBox1.Items.Add('c.mi4_kgB' +'  ' +IntToStr(c.mi4_kgB));
   ListBox1.Items.Add('c.mi4_kgBW' +'  ' +IntToStr(c.mi4_kgBW));

   ListBox1.Items.Add('c.mi5A' +'  ' +IntToStr(c.mi5A));
   ListBox1.Items.Add('c.mi5AW' +'  ' +IntToStr(c.mi5AW));
   ListBox1.Items.Add('c.mi5_locA' +'  ' +IntToStr(c.mi5_locA));
   ListBox1.Items.Add('c.mi5_locAW' +'  ' +IntToStr(c.mi5_locAW));
   ListBox1.Items.Add('c.mi5_kgA' +'  ' +IntToStr(c.mi5_kgA));
   ListBox1.Items.Add('c.mi5_kgAW' +'  ' +IntToStr(c.mi5_kgAW));
   ListBox1.Items.Add('c.mi5B' +'  ' +IntToStr(c.mi5B));
   ListBox1.Items.Add('c.mi5BW' +'  ' +IntToStr(c.mi5BW));
   ListBox1.Items.Add('c.mi5_locB' +'  ' +IntToStr(c.mi5_locB));
   ListBox1.Items.Add('c.mi5_locBW' +'  ' +IntToStr(c.mi5_locBW));
   ListBox1.Items.Add('c.mi5_kgB' +'  ' +IntToStr(c.mi5_kgB));
   ListBox1.Items.Add('c.mi5_kgBW' +'  ' +IntToStr(c.mi5_kgBW));

   ListBox1.Items.Add('c.note1' +'  ' +IntToStr(c.note1));
   ListBox1.Items.Add('c.note1W' +'  ' +IntToStr(c.note1W));
   ListBox1.Items.Add('c.note2' +'  ' +IntToStr(c.note2));
   ListBox1.Items.Add('c.note2W' +'  ' +IntToStr(c.note2W));
   ListBox1.Items.Add('c.note3' +'  ' +IntToStr(c.note3));
   ListBox1.Items.Add('c.note3W' +'  ' +IntToStr(c.note3W));
end;

procedure TForm1.ListName;
begin
   ListBox1.Items.Clear;

   if TabSheetName.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure Tform1.ListRaces;
var
  count, total: integer;
  s, t: ShortString;
begin
   listBox1.Items.Clear;
   if TabSheetRace.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   for count := 1 to RaceCurrentTotal do
   begin
      s := '';
      if Button1.Caption = 'alphabetical' then
         s := s + GetRaceNameIndex(count) else
         s := s + GetRaceName(count);

      if Stat[Race[count].N].St = 0 then
      t := '' else if Stat[Race[count].N].St >= MAX then
      t := '~' else
      t := IntToStr(round(Stat[Race[count].N].St));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Dx = 0 then
      t := '' else if Stat[Race[count].N].Dx >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Dx));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Iq = 0 then
      t := '' else if Stat[Race[count].N].Iq >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Iq));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Ma = 0 then
      t := '' else if Stat[Race[count].N].Ma >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Ma));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Cp = 0 then
      t := '' else if Stat[Race[count].N].Cp >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Cp));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;
      if Stat[Race[count].N].Ap = 0 then
      t := '' else if Stat[Race[count].N].Ap >= MAX then
      t := '~' else
      t := IntToStr(Round(Stat[Race[count].N].Ap));
      s := s + StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;


      total := Round(Stat[Race[count].N].St);
      total := total +Round(Stat[Race[count].N].Dx);
      total := total +Round(Stat[Race[count].N].Iq);
      total := total +Round(Stat[Race[count].N].Cp);
      t := IntToStr(total);
      s := s +  StringOfChar(' ',WidthRaceSt -Length(t));
      s := s + t;

      s := s + '  '+GetDamage(Stat[Race[count].N].Hd, Stat[Race[count].N].St);
      s := s + StringOfChar(' ',SheetRaceWidth - length(s));
      ListBox1.Items.Add(s);
   end;
end;

procedure TForm1.ListSex;
begin
   ListBox1.Items.Clear;

   if TabSheetSex.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListClass;
begin
   ListBox1.Items.Clear;

   if TabSheetClass.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListStrength;
var
   count: integer;
   s: string;
begin
   ListBox1.Items.Clear;

   if TabSheetStrength.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   for count := 1 to RaceCurrentTotal do
   begin
      s := GetStat(Stat[Race[count].N].St);
      s := s + '    ';
      s := s + GetRaceNameIndex(count);
      ListBox1.Items.Add(s);
   end;
end;

procedure TForm1.ListDexterity;
var
   count: integer;
   s: string;
begin
   ListBox1.Items.Clear;

   if TabSheetDexterity.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   for count := 1 to RaceCurrentTotal do
   begin
      s := GetStat(Stat[Race[count].N].Dx);
      s := s + '    ';
      s := s + GetRaceNameIndex(count);
      ListBox1.Items.Add(s);
   end;
end;

procedure TForm1.ListInteligence;
var
   count: integer;
   s: string;
begin
   ListBox1.Items.Clear;

   if TabSheetInteligence.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   for count := 1 to RaceCurrentTotal do
   begin
      s := GetStat(Stat[Race[count].N].Iq);
      s := s + '    ';
      s := s + GetRaceNameIndex(count);
      ListBox1.Items.Add(s);
   end;
end;

procedure TForm1.ListMovement;
var
   count: integer;
   s: string;
   d: double;
begin
   ListBox1.Items.Clear;

   if TabSheetMove.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   for count := 1 to RaceCurrentTotal do
   begin
      s := GetStat(Stat[Race[count].N].Ma);
      s := s + '    ';
      s := s + GetRaceNameIndex(count);
      ListBox1.Items.Add(s);
      d := count /2;
      if d <>  (count div 2) then
      begin
         ListBox1.ItemIndex := (count-1);
        // listbox1.Items.
      end;
   end;
end;

procedure TForm1.ListHand;
begin
   ListBox1.Items.Clear;

   if TabSheetHand.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListArmor;
begin
   ListBox1.Items.Clear;

   if TabSheetArmor.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListJob;
begin
   ListBox1.Items.Clear;

   if TabSheetJob.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListSilver;
begin
   ListBox1.Items.Clear;

   if TabSheetSilver.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListWounds;
begin
   ListBox1.Items.Clear;

   if TabSheetWounds.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListFatigue;
begin
   ListBox1.Items.Clear;

   if TabSheetFatigue.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListAble;
var
   count: integer;
   s : shortString;
begin
   ListBox1.Items.Clear;

   if TabSheetAble.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;

   if char_act.Classi = 'wizard' then
   begin
      for count := 1 to talentCurrentTotal do
      begin
         if Talent[count].list.Listed then
         begin
            if Talent[count].list.category = ' ' then
               s := Talent[count].list.name +'('+
                    IntToStr(Talent[count].list.costToWize) +')'
            else
               s := Talent[count].list.name +'('+
                    Talent[count].list.category +')';
            ListBox1.Items.Add(s);
         end;
      end;
   end else begin
      for count := 1 to talentCurrentTotal do
      begin
         if Talent[count].list.Listed then
         begin
            if Talent[count].list.category = ' ' then
               s := Talent[count].list.name +'('+
                    IntToStr(Talent[count].list.costToHero) +')'
            else
               s := Talent[count].list.name +'('+
                    Talent[count].list.category +')';
            ListBox1.Items.Add(s);
         end;
      end;
   end;
end;

procedure TForm1.ListStudy;
begin
   ListBox1.Items.Clear;

   if TabSheetStudy.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListReady;
begin
   ListBox1.Items.Clear;

   if TabSheetReady.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListSecond;
begin
   ListBox1.Items.Clear;

   if TabSheetSecond.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListBelt;
begin
   ListBox1.Items.Clear;

   if TabSheetBelt.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListHidden;
begin
   ListBox1.Items.Clear;

   if TabSheetHidden.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListWorn;
begin
   ListBox1.Items.Clear;

   if TabSheetWorn.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListKg;
begin
   ListBox1.Items.Clear;

   if TabSheetKg.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListExperience;
begin
   ListBox1.Items.Clear;

   if TabSheetExperience.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListPack;
begin
   ListBox1.Items.Clear;

   if TabSheetPack.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListMagic1;
begin
   ListBox1.Items.Clear;

   if TabSheetMagic1.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListMagic2;
begin
   ListBox1.Items.Clear;

   if TabSheetMagic2.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListMagic3;
begin
   ListBox1.Items.Clear;

   if TabSheetMagic3.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListMagic4;
begin
   ListBox1.Items.Clear;

   if TabSheetMagic4.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListMagic5;
begin
   ListBox1.Items.Clear;

   if TabSheetMagic5.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;

procedure TForm1.ListNotes;
begin
   ListBox1.Items.Clear;

   if TabSheetNotes.Tag = 0 then
   begin
      Button1.Caption := 'alphabetical';
      ListBox1.Sorted := True;
   end else begin
      Button1.Caption := 'book format';
      ListBox1.Sorted := False;
   end;
end;


procedure TForm1.New1Click(Sender: TObject);
begin
   InitChar;
end;

procedure TForm1.ListBox1MouseUp(Sender: TObject; Button: TMouseButton;
  Shift: TShiftState; X, Y: Integer);
var
  APoint: TPoint;
begin
  APoint.X := X;
  APoint.Y := Y;
  SelectParent(ListBox1.ItemAtPos(APoint, True) +1);
end;

procedure TForm1.Button1Click(Sender: TObject);
begin
   if Button1.Caption = 'alphabetical' then
   begin
      ListBox1.Sorted := False;
      Button1.Caption := 'book format';
      case GetActivePage of
        0: begin
              TabSheetFormat.Tag := 1;
              ListFormats;
           end;
        1: begin
              TabSheetName.Tag := 1;
              ListFormats;
           end;
        2: begin
              TabSheetRace.Tag := 1;
              ListRaces;
           end;
        3: begin
              TabSheetSex.Tag := 1;
              ListSex;
           end;
        4: begin
              TabSheetClass.Tag := 1;
              ListClass;
           end;
        5: begin
              TabSheetStrength.Tag := 1;
              ListStrength;
           end;
        6: begin
              TabSheetDexterity.Tag := 1;
              ListDexterity;
           end;
        7: begin
              TabSheetInteligence.Tag := 1;
              ListInteligence;
           end;
        8: begin
              TabSheetMove.Tag := 1;
              ListMovement;
           end;
        9: begin
              TabSheetHand.Tag := 1;
              ListHand;
           end;
        10: begin
              TabSheetArmor.Tag := 1;
              ListArmor;
           end;
        11: begin
              TabSheetJob.Tag := 1;
              ListJob;
           end;
        12: begin
              TabSheetSilver.Tag := 1;
              ListSilver;
           end;
        13: begin
              TabSheetWounds.Tag := 1;
              ListWounds;
           end;
        14: begin
              TabSheetFatigue.Tag := 1;
              ListFatigue;
           end;
        15: begin
              TabSheetAble.Tag := 1;
              ListAble;
           end;
        16: begin
              TabSheetStudy.Tag := 1;
              ListStudy;
           end;
        17: begin
              TabSheetReady.Tag := 1;
              ListReady;
           end;
        18: begin
              TabSheetSecond.Tag := 1;
              ListSecond;
           end;
        19: begin
              TabSheetBelt.Tag := 1;
              ListBelt;
           end;
        20: begin
              TabSheetHidden.Tag := 1;
              ListHidden;
           end;
        21: begin
              TabSheetWorn.Tag := 1;
              ListWorn;
           end;
        22: begin
              TabSheetKg.Tag := 1;
              ListKg;
           end;
        23: begin
              TabSheetExperience.Tag := 1;
              ListExperience;
           end;
        24: begin
              TabSheetPack.Tag := 1;
              ListPack;
           end;
        25: begin
              TabSheetMagic1.Tag := 1;
              ListMagic1;
           end;
        26: begin
              TabSheetMagic2.Tag := 1;
              ListMagic2;
           end;
        27: begin
              TabSheetMagic3.Tag := 1;
              ListMagic3;
           end;
        28: begin
              TabSheetMagic4.Tag := 1;
              ListMagic4;
           end;
        29: begin
              TabSheetMagic5.Tag := 1;
              ListMagic5;
           end;
        30: begin
              TabSheetNotes.Tag := 1;
              ListNotes;
           end;
      end;
   end else begin
      ListBox1.Sorted := True;
      Button1.Caption := 'alphabetical';
      case GetActivePage of
        0: begin
              TabSheetFormat.Tag := 0;
              ListFormats;
           end;
        1: begin
              TabSheetName.Tag := 0;
              ListFormats;
           end;
        2: begin
              TabSheetRace.Tag := 0;
              ListRaces;
           end;
        3: begin
              TabSheetSex.Tag := 0;
              ListSex;
           end;
        4: begin
              TabSheetClass.Tag := 0;
              ListClass;
           end;
        5: begin
              TabSheetStrength.Tag := 0;
              ListStrength;
           end;
        6: begin
              TabSheetDexterity.Tag := 0;
              ListDexterity;
           end;
        7: begin
              TabSheetInteligence.Tag := 0;
              ListInteligence;
           end;
        8: begin
              TabSheetMove.Tag := 0;
              ListMovement;
           end;
        9: begin
              TabSheetHand.Tag := 0;
              ListHand;
           end;
        10: begin
              TabSheetArmor.Tag := 0;
              ListArmor;
           end;
        11: begin
              TabSheetJob.Tag := 0;
              ListJob;
           end;
        12: begin
              TabSheetSilver.Tag := 0;
              ListSilver;
           end;
        13: begin
              TabSheetWounds.Tag := 0;
              ListWounds;
           end;
        14: begin
              TabSheetFatigue.Tag := 0;
              ListFatigue;
           end;
        15: begin
              TabSheetAble.Tag := 0;
              ListAble;
           end;
        16: begin
              TabSheetStudy.Tag := 0;
              ListStudy;
           end;
        17: begin
              TabSheetReady.Tag := 0;
              ListReady;
           end;
        18: begin
              TabSheetSecond.Tag := 0;
              ListSecond;
           end;
        19: begin
              TabSheetBelt.Tag := 0;
              ListBelt;
           end;
        20: begin
              TabSheetHidden.Tag := 0;
              ListHidden;
           end;
        21: begin
              TabSheetWorn.Tag := 0;
              ListWorn;
           end;
        22: begin
              TabSheetKg.Tag := 0;
              ListKg;
           end;
        23: begin
              TabSheetExperience.Tag := 0;
              ListExperience;
           end;
        24: begin
              TabSheetPack.Tag := 0;
              ListPack;
           end;
        25: begin
              TabSheetMagic1.Tag := 0;
              ListMagic1;
           end;
        26: begin
              TabSheetMagic2.Tag := 0;
              ListMagic2;
           end;
        27: begin
              TabSheetMagic3.Tag := 0;
              ListMagic3;
           end;
        28: begin
              TabSheetMagic4.Tag := 0;
              ListMagic4;
           end;
        29: begin
              TabSheetMagic5.Tag := 0;
              ListMagic5;
           end;
        30: begin
              TabSheetNotes.Tag := 0;
              ListNotes;
           end;
      end;
   end;
end;

procedure TForm1.ToolButton1Click(Sender: TObject);
begin
   New1Click(Self);
end;

procedure TForm1.Button2Click(Sender: TObject);
begin
   If SaveDialog1.Execute then
      Memo1.Lines.SaveToFile(SaveDialog1.FileName);
end;

procedure TForm1.RichEdit1KeyPress(Sender: TObject; var Key: Char);
begin
   case key of
   'q': Memo1.lines.Add(IntToStr(RichEdit1.SelStart)+', '+IntToStr(RichEdit1.SelLength));
   #13: begin
           case ceta of
           0: begin
                 c.name := RichEdit1.SelStart;
                 c.nameW := RichEdit1.SelLength;
                 Memo1.Lines.Add('race');
                 inc(ceta); end;
           1: begin
                 c.race := RichEdit1.SelStart;
                 c.raceW := RichEdit1.SelLength;
                 Memo1.Lines.Add('sex');
                 inc(ceta); end;
           2: begin
                 c.sex := RichEdit1.SelStart;
                 c.sexW := RichEdit1.SelLength;
                 Memo1.Lines.Add('class');
                 inc(ceta); end;
           3: begin
                 c.classi := RichEdit1.SelStart;
                 c.classiW := RichEdit1.SelLength;
                 Memo1.Lines.Add('cp');
                 inc(ceta); end;
           4: begin
                 c.cp := RichEdit1.SelStart;
                 c.CpW := RichEdit1.SelLength;
                 Memo1.Lines.Add('cp_adj');
                 inc(ceta); end;
           5: begin
                 c.cp_adj := RichEdit1.SelStart;
                 c.cp_adjW := RichEdit1.SelLength;
                 Memo1.Lines.Add('St');
                 inc(ceta); end;
           6: begin
                 c.St := RichEdit1.SelStart;
                 c.StW := RichEdit1.SelLength;
                 Memo1.Lines.Add('St_adj');
                 inc(ceta); end;
           7: begin
                 c.St_adj := RichEdit1.SelStart;
                 c.St_adjW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Hd');
                 inc(ceta); end;
           8: begin
                 c.Hd := RichEdit1.SelStart;
                 c.HdW := RichEdit1.SelLength;
                 Memo1.Lines.Add('wounds1');
                 inc(ceta); end;
           9: begin
                 c.wounds1 := RichEdit1.SelStart;
                 c.wounds1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('wounds2');
                 inc(ceta); end;
           10: begin
                 c.wounds2 := RichEdit1.SelStart;
                 c.wounds2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Dx');
                 inc(ceta); end;
           11: begin
                 c.Dx := RichEdit1.SelStart;
                 c.DxW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Dx_adj');
                 inc(ceta); end;
           12: begin
                 c.Dx_adj := RichEdit1.SelStart;
                 c.Dx_adjW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Ap');
                 inc(ceta); end;
           13: begin
                 c.Ap := RichEdit1.SelStart;
                 c.ApW := RichEdit1.SelLength;
                 Memo1.Lines.Add('wounds3');
                 inc(ceta); end;
           14: begin
                 c.wounds2 := RichEdit1.SelStart;
                 c.wounds2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Iq');
                 inc(ceta); end;
           15: begin
                 c.Iq := RichEdit1.SelStart;
                 c.IqW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Iq_adj');
                 inc(ceta); end;
           16: begin
                 c.Iq_adj := RichEdit1.SelStart;
                 c.Iq_adjW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Job');
                 inc(ceta); end;
           17: begin
                 c.Job := RichEdit1.SelStart;
                 c.JobW := RichEdit1.SelLength;
                 Memo1.Lines.Add('fatigue');
                 inc(ceta); end;
           18: begin
                 c.fatigue1 := RichEdit1.SelStart;
                 c.fatigue1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('fatigue2');
                 inc(ceta); end;
           19: begin
                 c.fatigue2 := RichEdit1.SelStart;
                 c.fatigue2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Ma');
                 inc(ceta); end;
           20: begin
                 c.Ma := RichEdit1.SelStart;
                 c.MaW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Ma_adj');
                 inc(ceta); end;
           21: begin
                 c.Ma_adj := RichEdit1.SelStart;
                 c.Ma_adjW := RichEdit1.SelLength;
                 Memo1.Lines.Add('silver');
                 inc(ceta); end;
           22: begin
                 c.silver := RichEdit1.SelStart;
                 c.silverW := RichEdit1.SelLength;
                 Memo1.Lines.Add('fatigue3');
                 inc(ceta); end;
           23: begin
                 c.Fatigue2 := RichEdit1.SelStart;
                 c.fatigue2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Hx');
                 inc(ceta); end;
           24: begin
                 c.Hx := RichEdit1.SelStart;
                 c.HxW := RichEdit1.SelLength;
                 Memo1.Lines.Add('able1');
                 inc(ceta); end;
           25: begin
                 c.Able1 := RichEdit1.SelStart;
                 c.Able1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able2');
                 inc(ceta); end;
           26: begin
                 c.Able2 := RichEdit1.SelStart;
                 c.Able2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able3');
                 inc(ceta); end;
           27: begin
                 c.Able3 := RichEdit1.SelStart;
                 c.Able3W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able4');
                 inc(ceta); end;
           28: begin
                 c.Able4 := RichEdit1.SelStart;
                 c.Able4W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able5');
                 inc(ceta); end;
           29: begin
                 c.Able5 := RichEdit1.SelStart;
                 c.Able5W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able6');
                 inc(ceta); end;
           30: begin
                 c.Able6 := RichEdit1.SelStart;
                 c.Able6W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able7');
                 inc(ceta); end;
           31: begin
                 c.Able7 := RichEdit1.SelStart;
                 c.Able7W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able8');
                 inc(ceta); end;
           32: begin
                 c.Able8 := RichEdit1.SelStart;
                 c.Able8W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able9');
                 inc(ceta); end;
           33: begin
                 c.Able9 := RichEdit1.SelStart;
                 c.Able9W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able10');
                 inc(ceta); end;
           34: begin
                 c.Able10 := RichEdit1.SelStart;
                 c.Able10W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able11');
                 inc(ceta); end;
           35: begin
                 c.Able11 := RichEdit1.SelStart;
                 c.Able11W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able12');
                 inc(ceta); end;
           36: begin
                 c.Able12 := RichEdit1.SelStart;
                 c.Able12W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able13');
                 inc(ceta); end;
           37: begin
                 c.Able13 := RichEdit1.SelStart;
                 c.Able13W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able14');
                 inc(ceta); end;
           38: begin
                 c.Able14 := RichEdit1.SelStart;
                 c.Able14W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able15');
                 inc(ceta); end;
           39: begin
                 c.Able15 := RichEdit1.SelStart;
                 c.Able15W := RichEdit1.SelLength;
                 Memo1.Lines.Add('able16');
                 inc(ceta); end;
           40: begin
                 c.Able16 := RichEdit1.SelStart;
                 c.Able16W := RichEdit1.SelLength;
                 Memo1.Lines.Add('study');
                 inc(ceta); end;
           41: begin
                 c.study1 := RichEdit1.SelStart;
                 c.study1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('study2');
                 inc(ceta); end;
           42: begin
                 c.study2 := RichEdit1.SelStart;
                 c.study2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('ready0');
                 inc(ceta); end;
           43: begin
                 c.ready0 := RichEdit1.SelStart;
                 c.ready0W := RichEdit1.SelLength;
                 Memo1.Lines.Add('ready0_kg');
                 inc(ceta); end;
           44: begin
                 c.ready0_kg := RichEdit1.SelStart;
                 c.ready0W_kg := RichEdit1.SelLength;
                 Memo1.Lines.Add('ready1');
                 inc(ceta); end;
           45: begin
                 c.ready1 := RichEdit1.SelStart;
                 c.ready1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('ready1_kg');
                 inc(ceta); end;
           46: begin
                 c.ready1_kg := RichEdit1.SelStart;
                 c.ready1W_kg := RichEdit1.SelLength;
                 Memo1.Lines.Add('ready2');
                 inc(ceta); end;
           47: begin
                 c.ready2 := RichEdit1.SelStart;
                 c.ready2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('ready2_kg');
                 inc(ceta); end;
           48: begin
                 c.ready2_kg := RichEdit1.SelStart;
                 c.ready2W_kg := RichEdit1.SelLength;
                 Memo1.Lines.Add('secondary');
                 inc(ceta); end;
           49: begin
                 c.Second1 := RichEdit1.SelStart;
                 c.Second1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('second1_kg');
                 inc(ceta); end;
           50: begin
                 c.Second1_kg := RichEdit1.SelStart;
                 c.Second1W_kg := RichEdit1.SelLength;
                 Memo1.Lines.Add('second2');
                 inc(ceta); end;
           51: begin
                 c.Second2 := RichEdit1.SelStart;
                 c.Second2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('second2_kg');
                 inc(ceta); end;
           52: begin
                 c.Second2_kg := RichEdit1.SelStart;
                 c.Second2W_kg := RichEdit1.SelLength;
                 Memo1.Lines.Add('belt');
                 inc(ceta); end;
           53: begin
                 c.Belt1 := RichEdit1.SelStart;
                 c.Belt1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('belt2');
                 inc(ceta); end;
           54: begin
                 c.Belt2 := RichEdit1.SelStart;
                 c.Belt2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('hidden');
                 inc(ceta); end;
           55: begin
                 c.Hidden1 := RichEdit1.SelStart;
                 c.Hidden1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('hidden2');
                 inc(ceta); end;
           56: begin
                 c.Hidden2 := RichEdit1.SelStart;
                 c.Hidden2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('worn');
                 inc(ceta); end;
           57: begin
                 c.Worn1 := RichEdit1.SelStart;
                 c.Worn1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('worn2');
                 inc(ceta); end;
           58: begin
                 c.Worn2 := RichEdit1.SelStart;
                 c.Worn2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('totalKg');
                 inc(ceta); end;
           59: begin
                 c.TotalKg := RichEdit1.SelStart;
                 c.TotalKgW := RichEdit1.SelLength;
                 Memo1.Lines.Add('pack');
                 inc(ceta); end;
           60: begin
                 c.Pack := RichEdit1.SelStart;
                 c.PackW := RichEdit1.SelLength;
                 Memo1.Lines.Add('ma_2');
                 inc(ceta); end;
           61: begin
                 c.Ma_2 := RichEdit1.SelStart;
                 c.Ma_2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('ma_4');
                 inc(ceta); end;
           62: begin
                 c.Ma4 := RichEdit1.SelStart;
                 c.Ma4_W := RichEdit1.SelLength;
                 Memo1.Lines.Add('ma_6');
                 inc(ceta); end;
           63: begin
                 c.Ma6 := RichEdit1.SelStart;
                 c.Ma6_W := RichEdit1.SelLength;
                 Memo1.Lines.Add('max');
                 inc(ceta); end;
           64: begin
                 c.Max := RichEdit1.SelStart;
                 c.MaxW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Ep1');
                 inc(ceta); end;
           65: begin
                 c.Ep1 := RichEdit1.SelStart;
                 c.Ep1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Ep2');
                 inc(ceta); end;
           66: begin
                 c.Ep2 := RichEdit1.SelStart;
                 c.Ep2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Ep3');
                 inc(ceta); end;
           67: begin
                 c.Ep3 := RichEdit1.SelStart;
                 c.Ep3W := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip1A');
                 inc(ceta); end;
           68: begin
                 c.Equip1A := RichEdit1.SelStart;
                 c.Equip1AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc1A');
                 inc(ceta); end;
           69: begin
                 c.Eq_loc1A := RichEdit1.SelStart;
                 c.Eq_loc1AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg1A');
                 inc(ceta); end;
           70: begin
                 c.Eq_kg1A := RichEdit1.SelStart;
                 c.Eq_kg1AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip1B');
                 inc(ceta); end;
           71: begin
                 c.Equip1B := RichEdit1.SelStart;
                 c.Equip1BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc1B');
                 inc(ceta); end;
           72: begin
                 c.Eq_loc1B := RichEdit1.SelStart;
                 c.Eq_loc1BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg1B');
                 inc(ceta); end;
           73: begin
                 c.Eq_kg1B := RichEdit1.SelStart;
                 c.Eq_kg1BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip2A');
                 inc(ceta); end;
           74: begin
                 c.Equip2A := RichEdit1.SelStart;
                 c.Equip2AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc2A');
                 inc(ceta); end;
           75: begin
                 c.Eq_loc2A := RichEdit1.SelStart;
                 c.Eq_loc2AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg2A');
                 inc(ceta); end;
           76: begin
                 c.Eq_kg2A := RichEdit1.SelStart;
                 c.Eq_kg2AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip2B');
                 inc(ceta); end;
           77: begin
                 c.Equip2B := RichEdit1.SelStart;
                 c.Equip2BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc2B');
                 inc(ceta); end;
           78: begin
                 c.Eq_loc2B := RichEdit1.SelStart;
                 c.Eq_loc2BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg2B');
                 inc(ceta); end;
           79: begin
                 c.Eq_kg2B := RichEdit1.SelStart;
                 c.Eq_kg2BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip3A');
                 inc(ceta); end;
           80: begin
                 c.Equip3A := RichEdit1.SelStart;
                 c.Equip3AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc3A');
                 inc(ceta); end;
           81: begin
                 c.Eq_loc3A := RichEdit1.SelStart;
                 c.Eq_loc3AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg3A');
                 inc(ceta); end;
           82: begin
                 c.Eq_kg3A := RichEdit1.SelStart;
                 c.Eq_kg3AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip3B');
                 inc(ceta); end;
           83: begin
                 c.Equip3B := RichEdit1.SelStart;
                 c.Equip3BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc3B');
                 inc(ceta); end;
           84: begin
                 c.Eq_loc3B := RichEdit1.SelStart;
                 c.Eq_loc3BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg3B');
                 inc(ceta); end;
           85: begin
                 c.Eq_kg3B := RichEdit1.SelStart;
                 c.Eq_kg3BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip4A');
                 inc(ceta); end;
           86: begin
                 c.Equip4A := RichEdit1.SelStart;
                 c.Equip4AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc4A');
                 inc(ceta); end;
           87: begin
                 c.Eq_loc4A := RichEdit1.SelStart;
                 c.Eq_loc4AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg4A');
                 inc(ceta); end;
           88: begin
                 c.Eq_kg4A := RichEdit1.SelStart;
                 c.Eq_kg4AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip4B');
                 inc(ceta); end;
           89: begin
                 c.Equip4B := RichEdit1.SelStart;
                 c.Equip4BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc4B');
                 inc(ceta); end;
           90: begin
                 c.Eq_loc4B := RichEdit1.SelStart;
                 c.Eq_loc4BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg24');
                 inc(ceta); end;
           91: begin
                 c.Eq_kg4B := RichEdit1.SelStart;
                 c.Eq_kg4BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip5A');
                 inc(ceta); end;
           92: begin
                 c.Equip5A := RichEdit1.SelStart;
                 c.Equip5AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc5A');
                 inc(ceta); end;
           93: begin
                 c.Eq_loc5A := RichEdit1.SelStart;
                 c.Eq_loc5AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg5A');
                 inc(ceta); end;
           94: begin
                 c.Eq_kg5A := RichEdit1.SelStart;
                 c.Eq_kg5AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip5B');
                 inc(ceta); end;
           95: begin
                 c.Equip5B := RichEdit1.SelStart;
                 c.Equip5BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc5B');
                 inc(ceta); end;
           96: begin
                 c.Eq_loc5B := RichEdit1.SelStart;
                 c.Eq_loc5BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg5B');
                 inc(ceta); end;
           97: begin
                 c.Eq_kg5B := RichEdit1.SelStart;
                 c.Eq_kg5BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip6A');
                 inc(ceta); end;
           98: begin
                 c.Equip6A := RichEdit1.SelStart;
                 c.Equip6AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc6A');
                 inc(ceta); end;
           99: begin
                 c.Eq_loc6A := RichEdit1.SelStart;
                 c.Eq_loc6AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg6A');
                 inc(ceta); end;
          100: begin
                 c.Eq_kg6A := RichEdit1.SelStart;
                 c.Eq_kg6AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip6B');
                 inc(ceta); end;
          101: begin
                 c.Equip6B := RichEdit1.SelStart;
                 c.Equip6BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc6B');
                 inc(ceta); end;
          102: begin
                 c.Eq_loc6B := RichEdit1.SelStart;
                 c.Eq_loc6BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg6B');
                 inc(ceta); end;
          103: begin
                 c.Eq_kg6B := RichEdit1.SelStart;
                 c.Eq_kg6BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip7A');
                 inc(ceta); end;
          104: begin
                 c.Equip7A := RichEdit1.SelStart;
                 c.Equip7AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc7A');
                 inc(ceta); end;
          105: begin
                 c.Eq_loc7A := RichEdit1.SelStart;
                 c.Eq_loc7AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg7A');
                 inc(ceta); end;
          106: begin
                 c.Eq_kg7A := RichEdit1.SelStart;
                 c.Eq_kg7AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip7B');
                 inc(ceta); end;
          107: begin
                 c.Equip7B := RichEdit1.SelStart;
                 c.Equip7BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc7B');
                 inc(ceta); end;
          108: begin
                 c.Eq_loc7B := RichEdit1.SelStart;
                 c.Eq_loc7BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg7B');
                 inc(ceta); end;
          109: begin
                 c.Eq_kg7B := RichEdit1.SelStart;
                 c.Eq_kg7BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip8A');
                 inc(ceta); end;
          110: begin
                 c.Equip8A := RichEdit1.SelStart;
                 c.Equip8AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc8A');
                 inc(ceta); end;
          111: begin
                 c.Eq_loc8A := RichEdit1.SelStart;
                 c.Eq_loc8AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg8A');
                 inc(ceta); end;
          112: begin
                 c.Eq_kg8A := RichEdit1.SelStart;
                 c.Eq_kg8AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip8B');
                 inc(ceta); end;
          113: begin
                 c.Equip8B := RichEdit1.SelStart;
                 c.Equip8BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc8B');
                 inc(ceta); end;
          114: begin
                 c.Eq_loc8B := RichEdit1.SelStart;
                 c.Eq_loc8BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg8B');
                 inc(ceta); end;
          115: begin
                 c.Eq_kg8B := RichEdit1.SelStart;
                 c.Eq_kg8BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip9A');
                 inc(ceta); end;
          116: begin
                 c.Equip9A := RichEdit1.SelStart;
                 c.Equip9AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc9A');
                 inc(ceta); end;
          117: begin
                 c.Eq_loc9A := RichEdit1.SelStart;
                 c.Eq_loc9AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg9A');
                 inc(ceta); end;
          118: begin
                 c.Eq_kg9A := RichEdit1.SelStart;
                 c.Eq_kg9AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip9B');
                 inc(ceta); end;
          119: begin
                 c.Equip9B := RichEdit1.SelStart;
                 c.Equip9BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc9B');
                 inc(ceta); end;
          120: begin
                 c.Eq_loc9B := RichEdit1.SelStart;
                 c.Eq_loc9BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg9B');
                 inc(ceta); end;
          121: begin
                 c.Eq_kg9B := RichEdit1.SelStart;
                 c.Eq_kg9BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip10A');
                 inc(ceta); end;
          122: begin
                 c.Equip10A := RichEdit1.SelStart;
                 c.Equip10AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc10A');
                 inc(ceta); end;
          123: begin
                 c.Eq_loc10A := RichEdit1.SelStart;
                 c.Eq_loc10AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg10A');
                 inc(ceta); end;
          124: begin
                 c.Eq_kg10A := RichEdit1.SelStart;
                 c.Eq_kg10AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip10B');
                 inc(ceta); end;
           125: begin
                 c.Equip10B := RichEdit1.SelStart;
                 c.Equip10BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc10B');
                 inc(ceta); end;
          126: begin
                 c.Eq_loc10B := RichEdit1.SelStart;
                 c.Eq_loc10BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg10B');
                 inc(ceta); end;
          127: begin
                 c.Eq_kg10B := RichEdit1.SelStart;
                 c.Eq_kg10BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip11A');
                 inc(ceta); end;
          128: begin
                 c.Equip11A := RichEdit1.SelStart;
                 c.Equip11AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc11A');
                 inc(ceta); end;
          129: begin
                 c.Eq_loc11A := RichEdit1.SelStart;
                 c.Eq_loc11AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg11A');
                 inc(ceta); end;
          130: begin
                 c.Eq_kg11A := RichEdit1.SelStart;
                 c.Eq_kg11AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip11B');
                 inc(ceta); end;
           131: begin
                 c.Equip11B := RichEdit1.SelStart;
                 c.Equip11BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc11B');
                 inc(ceta); end;
          132: begin
                 c.Eq_loc11B := RichEdit1.SelStart;
                 c.Eq_loc11BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg11B');
                 inc(ceta); end;
          133: begin
                 c.Eq_kg11B := RichEdit1.SelStart;
                 c.Eq_kg11BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip12A');
                 inc(ceta); end;
          134: begin
                 c.Equip12A := RichEdit1.SelStart;
                 c.Equip12AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc12A');
                 inc(ceta); end;
          135: begin
                 c.Eq_loc12A := RichEdit1.SelStart;
                 c.Eq_loc12AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg12A');
                 inc(ceta); end;
          136: begin
                 c.Eq_kg12A := RichEdit1.SelStart;
                 c.Eq_kg12AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip12B');
                 inc(ceta); end;
           137: begin
                 c.Equip12B := RichEdit1.SelStart;
                 c.Equip12BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc12B');
                 inc(ceta); end;
          138: begin
                 c.Eq_loc12B := RichEdit1.SelStart;
                 c.Eq_loc12BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg12B');
                 inc(ceta); end;
          139: begin
                 c.Eq_kg12B := RichEdit1.SelStart;
                 c.Eq_kg12BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip13A');
                 inc(ceta); end;
          140: begin
                 c.Equip13A := RichEdit1.SelStart;
                 c.Equip13AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc13A');
                 inc(ceta); end;
          141: begin
                 c.Eq_loc13A := RichEdit1.SelStart;
                 c.Eq_loc13AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg13A');
                 inc(ceta); end;
          142: begin
                 c.Eq_kg13A := RichEdit1.SelStart;
                 c.Eq_kg13AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip13B');
                 inc(ceta); end;
           143: begin
                 c.Equip13B := RichEdit1.SelStart;
                 c.Equip13BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc13B');
                 inc(ceta); end;
          144: begin
                 c.Eq_loc13B := RichEdit1.SelStart;
                 c.Eq_loc13BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg13B');
                 inc(ceta); end;
          145: begin
                 c.Eq_kg13B := RichEdit1.SelStart;
                 c.Eq_kg13BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip14A');
                 inc(ceta); end;
          146: begin
                 c.Equip14A := RichEdit1.SelStart;
                 c.Equip14AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc14A');
                 inc(ceta); end;
          147: begin
                 c.Eq_loc14A := RichEdit1.SelStart;
                 c.Eq_loc14AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg14A');
                 inc(ceta); end;
          148: begin
                 c.Eq_kg14A := RichEdit1.SelStart;
                 c.Eq_kg14AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip14B');
                 inc(ceta); end;
           149: begin
                 c.Equip14B := RichEdit1.SelStart;
                 c.Equip14BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc14B');
                 inc(ceta); end;
          150: begin
                 c.Eq_loc14B := RichEdit1.SelStart;
                 c.Eq_loc14BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg14B');
                 inc(ceta); end;
          151: begin
                 c.Eq_kg14B := RichEdit1.SelStart;
                 c.Eq_kg14BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip15A');
                 inc(ceta); end;
          152: begin
                 c.Equip15A := RichEdit1.SelStart;
                 c.Equip15AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc15A');
                 inc(ceta); end;
          153: begin
                 c.Eq_loc15A := RichEdit1.SelStart;
                 c.Eq_loc15AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg15A');
                 inc(ceta); end;
          154: begin
                 c.Eq_kg15A := RichEdit1.SelStart;
                 c.Eq_kg15AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip15B');
                 inc(ceta); end;
           155: begin
                 c.Equip15B := RichEdit1.SelStart;
                 c.Equip15BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc15B');
                 inc(ceta); end;
          156: begin
                 c.Eq_loc15B := RichEdit1.SelStart;
                 c.Eq_loc15BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg15B');
                 inc(ceta); end;
          157: begin
                 c.Eq_kg15B := RichEdit1.SelStart;
                 c.Eq_kg15BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip16A');
                 inc(ceta); end;
          158: begin
                 c.Equip16A := RichEdit1.SelStart;
                 c.Equip16AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc16A');
                 inc(ceta); end;
          159: begin
                 c.Eq_loc16A := RichEdit1.SelStart;
                 c.Eq_loc16AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg16A');
                 inc(ceta); end;
          160: begin
                 c.Eq_kg16A := RichEdit1.SelStart;
                 c.Eq_kg16AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('Equip16B');
                 inc(ceta); end;
           161: begin
                 c.Equip16B := RichEdit1.SelStart;
                 c.Equip16BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_loc16B');
                 inc(ceta); end;
          162: begin
                 c.Eq_loc16B := RichEdit1.SelStart;
                 c.Eq_loc16BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('eq_kg16B');
                 inc(ceta); end;
          163: begin
                 c.Eq_kg16B := RichEdit1.SelStart;
                 c.Eq_kg16BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi1A');
                 inc(ceta); end;
           164: begin
                 c.mi1A := RichEdit1.SelStart;
                 c.mi1AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi1_locA');
                 inc(ceta); end;
           165: begin
                 c.mi1_locA := RichEdit1.SelStart;
                 c.mi1_locAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi1_kgA');
                 inc(ceta); end;
           166: begin
                 c.mi1_kgA := RichEdit1.SelStart;
                 c.mi1_kgAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi1B');
                 inc(ceta); end;
           167: begin
                 c.mi1B := RichEdit1.SelStart;
                 c.mi1BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi1_locB');
                 inc(ceta); end;
           168: begin
                 c.mi1_locB := RichEdit1.SelStart;
                 c.mi1_locBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi1_kgB');
                 inc(ceta); end;
           169: begin
                 c.mi1_kgB := RichEdit1.SelStart;
                 c.mi1_kgBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi2A');
                 inc(ceta); end;
           170: begin
                 c.mi2A := RichEdit1.SelStart;
                 c.mi2AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi2_locA');
                 inc(ceta); end;
           171: begin
                 c.mi2_locA := RichEdit1.SelStart;
                 c.mi2_locAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi2_kgA');
                 inc(ceta); end;
           172: begin
                 c.mi2_kgA := RichEdit1.SelStart;
                 c.mi2_kgAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi2B');
                 inc(ceta); end;
           173: begin
                 c.mi2B := RichEdit1.SelStart;
                 c.mi2BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi2_locB');
                 inc(ceta); end;
           174: begin
                 c.mi2_locB := RichEdit1.SelStart;
                 c.mi2_locBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi2_kgB');
                 inc(ceta); end;
           175: begin
                 c.mi2_kgB := RichEdit1.SelStart;
                 c.mi2_kgBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi3A');
                 inc(ceta); end;
           176: begin
                 c.mi3A := RichEdit1.SelStart;
                 c.mi3AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi3_locA');
                 inc(ceta); end;
           177: begin
                 c.mi3_locA := RichEdit1.SelStart;
                 c.mi3_locAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi3_kgA');
                 inc(ceta); end;
           178: begin
                 c.mi3_kgA := RichEdit1.SelStart;
                 c.mi3_kgAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi3B');
                 inc(ceta); end;
           179: begin
                 c.mi3B := RichEdit1.SelStart;
                 c.mi3BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi3_locB');
                 inc(ceta); end;
           180: begin
                 c.mi3_locB := RichEdit1.SelStart;
                 c.mi3_locBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi3_kgB');
                 inc(ceta); end;
           181: begin
                 c.mi3_kgB := RichEdit1.SelStart;
                 c.mi3_kgBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi4A');
                 inc(ceta); end;
           182: begin
                 c.mi4A := RichEdit1.SelStart;
                 c.mi4AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi4_locA');
                 inc(ceta); end;
           183: begin
                 c.mi4_locA := RichEdit1.SelStart;
                 c.mi4_locAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi4_kgA');
                 inc(ceta); end;
           184: begin
                 c.mi4_kgA := RichEdit1.SelStart;
                 c.mi4_kgAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi4B');
                 inc(ceta); end;
           185: begin
                 c.mi4B := RichEdit1.SelStart;
                 c.mi4BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi4_locB');
                 inc(ceta); end;
           186: begin
                 c.mi4_locB := RichEdit1.SelStart;
                 c.mi4_locBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi4_kgB');
                 inc(ceta); end;
           187: begin
                 c.mi4_kgB := RichEdit1.SelStart;
                 c.mi4_kgBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi5A');
                 inc(ceta); end;
           188: begin
                 c.mi5A := RichEdit1.SelStart;
                 c.mi5AW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi5_locA');
                 inc(ceta); end;
           189: begin
                 c.mi5_locA := RichEdit1.SelStart;
                 c.mi5_locAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi5_kgA');
                 inc(ceta); end;
           190: begin
                 c.mi5_kgA := RichEdit1.SelStart;
                 c.mi5_kgAW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi5B');
                 inc(ceta); end;
           191: begin
                 c.mi5B := RichEdit1.SelStart;
                 c.mi5BW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi5_locB');
                 inc(ceta); end;
           192: begin
                 c.mi5_locB := RichEdit1.SelStart;
                 c.mi5_locBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('mi5_kgB');
                 inc(ceta); end;
           193: begin
                 c.mi5_kgB := RichEdit1.SelStart;
                 c.mi5_kgBW := RichEdit1.SelLength;
                 Memo1.Lines.Add('note1');
                 inc(ceta); end;
           194: begin
                 c.note1 := RichEdit1.SelStart;
                 c.note1W := RichEdit1.SelLength;
                 Memo1.Lines.Add('note2');
                 inc(ceta); end;
           195: begin
                 c.note2 := RichEdit1.SelStart;
                 c.note2W := RichEdit1.SelLength;
                 Memo1.Lines.Add('note3');
                 inc(ceta); end;
           196: begin
                 c.note3 := RichEdit1.SelStart;
                 c.note3W := RichEdit1.SelLength;
                 Memo1.Lines.Add('cograts !!!!');
                 inc(ceta); end;
           end; // case ceta
         end; // end #13: begin
   end; // end case key of
end;

procedure TForm1.Button3Click(Sender: TObject);
var
   SaveStream: TFileStream;
   value: integer;
begin
   SaveDialog1.InitialDir := Fn;
   SaveDialog1.FileName := 'sheet capture.int';
   if SaveDialog1.Execute then
   begin
      SaveStream := TFileStream.Create( SaveDialog1.FileName, FmOpenWrite or FmCreate);
      try
      value := c.name; SaveStream.Write(value, sizeof(Integer));
      value := c.nameW; SaveStream.Write(value, sizeof(Integer));
      value := c.race; SaveStream.Write(value, sizeof(Integer));
      value := c.raceW; SaveStream.Write(value, sizeof(Integer));
      value := c.sex; SaveStream.Write(value, sizeof(Integer));
      value := c.sexW; SaveStream.Write(value, sizeof(Integer));
      value := c.classi; SaveStream.Write(value, sizeof(Integer));
      value := c.classiW; SaveStream.Write(value, sizeof(Integer));
      value := c.cp; SaveStream.Write(value, sizeof(Integer));
      value := c.CpW; SaveStream.Write(value, sizeof(Integer));
      value := c.cp_adj; SaveStream.Write(value, sizeof(Integer));
      value := c.cp_adjW; SaveStream.Write(value, sizeof(Integer));
      value := c.St; SaveStream.Write(value, sizeof(Integer));
      value := c.StW; SaveStream.Write(value, sizeof(Integer));
      value := c.St_adj; SaveStream.Write(value, sizeof(Integer));
      value := c.St_adjW; SaveStream.Write(value, sizeof(Integer));
      value := c.Hd; SaveStream.Write(value, sizeof(Integer));
      value := c.HdW; SaveStream.Write(value, sizeof(Integer));
      value := c.wounds1; SaveStream.Write(value, sizeof(Integer));
      value := c.wounds1W; SaveStream.Write(value, sizeof(Integer));
      value := c.wounds2; SaveStream.Write(value, sizeof(Integer));
      value := c.wounds2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Dx; SaveStream.Write(value, sizeof(Integer));
      value := c.DxW; SaveStream.Write(value, sizeof(Integer));
      value := c.Dx_adj; SaveStream.Write(value, sizeof(Integer));
      value := c.Dx_adjW; SaveStream.Write(value, sizeof(Integer));
      value := c.Ap; SaveStream.Write(value, sizeof(Integer));
      value := c.ApW; SaveStream.Write(value, sizeof(Integer));
      value := c.wounds3; SaveStream.Write(value, sizeof(Integer));
      value := c.wounds3W; SaveStream.Write(value, sizeof(Integer));
      value := c.Iq; SaveStream.Write(value, sizeof(Integer));
      value := c.IqW; SaveStream.Write(value, sizeof(Integer));
      value := c.Iq_adj; SaveStream.Write(value, sizeof(Integer));
      value := c.Iq_adjW; SaveStream.Write(value, sizeof(Integer));
      value := c.Job; SaveStream.Write(value, sizeof(Integer));
      value := c.JobW; SaveStream.Write(value, sizeof(Integer));
      value := c.fatigue1; SaveStream.Write(value, sizeof(Integer));
      value := c.fatigue1W; SaveStream.Write(value, sizeof(Integer));
      value := c.fatigue2; SaveStream.Write(value, sizeof(Integer));
      value := c.fatigue2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma; SaveStream.Write(value, sizeof(Integer));
      value := c.MaW; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma_adj; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma_adjW; SaveStream.Write(value, sizeof(Integer));
      value := c.silver; SaveStream.Write(value, sizeof(Integer));
      value := c.silverW; SaveStream.Write(value, sizeof(Integer));
      value := c.Fatigue3; SaveStream.Write(value, sizeof(Integer));
      value := c.fatigue3W; SaveStream.Write(value, sizeof(Integer));
      value := c.Hx; SaveStream.Write(value, sizeof(Integer));
      value := c.HxW; SaveStream.Write(value, sizeof(Integer));
      value := c.Able1; SaveStream.Write(value, sizeof(Integer));
      value := c.Able1W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able2; SaveStream.Write(value, sizeof(Integer));
      value := c.Able2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able3; SaveStream.Write(value, sizeof(Integer));
      value := c.Able3W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able4; SaveStream.Write(value, sizeof(Integer));
      value := c.Able4W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able5; SaveStream.Write(value, sizeof(Integer));
      value := c.Able5W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able6; SaveStream.Write(value, sizeof(Integer));
      value := c.Able6W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able7; SaveStream.Write(value, sizeof(Integer));
      value := c.Able7W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able8; SaveStream.Write(value, sizeof(Integer));
      value := c.Able8W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able9; SaveStream.Write(value, sizeof(Integer));
      value := c.Able9W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able10; SaveStream.Write(value, sizeof(Integer));
      value := c.Able10W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able11; SaveStream.Write(value, sizeof(Integer));
      value := c.Able11W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able12; SaveStream.Write(value, sizeof(Integer));
      value := c.Able12W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able13; SaveStream.Write(value, sizeof(Integer));
      value := c.Able13W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able14; SaveStream.Write(value, sizeof(Integer));
      value := c.Able14W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able15; SaveStream.Write(value, sizeof(Integer));
      value := c.Able15W; SaveStream.Write(value, sizeof(Integer));
      value := c.Able16; SaveStream.Write(value, sizeof(Integer));
      value := c.Able16W; SaveStream.Write(value, sizeof(Integer));
      value := c.study1; SaveStream.Write(value, sizeof(Integer));
      value := c.study1W; SaveStream.Write(value, sizeof(Integer));
      value := c.study2; SaveStream.Write(value, sizeof(Integer));
      value := c.study2W; SaveStream.Write(value, sizeof(Integer));
      value := c.ready0; SaveStream.Write(value, sizeof(Integer));
      value := c.ready0W; SaveStream.Write(value, sizeof(Integer));
      value := c.ready0_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.ready0W_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.ready1; SaveStream.Write(value, sizeof(Integer));
      value := c.ready1W; SaveStream.Write(value, sizeof(Integer));
      value := c.ready1_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.ready1W_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.ready2; SaveStream.Write(value, sizeof(Integer));
      value := c.ready2W; SaveStream.Write(value, sizeof(Integer));
      value := c.ready2_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.ready2W_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.Second1; SaveStream.Write(value, sizeof(Integer));
      value := c.Second1W; SaveStream.Write(value, sizeof(Integer));
      value := c.Second1_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.Second1W_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.Second2; SaveStream.Write(value, sizeof(Integer));
      value := c.Second2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Second2_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.Second2W_kg; SaveStream.Write(value, sizeof(Integer));
      value := c.Belt1; SaveStream.Write(value, sizeof(Integer));
      value := c.Belt1W; SaveStream.Write(value, sizeof(Integer));
      value := c.Belt2; SaveStream.Write(value, sizeof(Integer));
      value := c.Belt2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Hidden1; SaveStream.Write(value, sizeof(Integer));
      value := c.Hidden1W; SaveStream.Write(value, sizeof(Integer));
      value := c.Hidden2; SaveStream.Write(value, sizeof(Integer));
      value := c.Hidden2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Worn1; SaveStream.Write(value, sizeof(Integer));
      value := c.Worn1W; SaveStream.Write(value, sizeof(Integer));
      value := c.Worn2; SaveStream.Write(value, sizeof(Integer));
      value := c.Worn2W; SaveStream.Write(value, sizeof(Integer));
      value := c.TotalKg; SaveStream.Write(value, sizeof(Integer));
      value := c.TotalKgW; SaveStream.Write(value, sizeof(Integer));
      value := c.Pack; SaveStream.Write(value, sizeof(Integer));
      value := c.PackW; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma_2; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma_2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma4; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma4_W; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma6; SaveStream.Write(value, sizeof(Integer));
      value := c.Ma6_W; SaveStream.Write(value, sizeof(Integer));
      value := c.Max; SaveStream.Write(value, sizeof(Integer));
      value := c.MaxW; SaveStream.Write(value, sizeof(Integer));
      value := c.Ep1; SaveStream.Write(value, sizeof(Integer));
      value := c.Ep1W; SaveStream.Write(value, sizeof(Integer));
      value := c.Ep2; SaveStream.Write(value, sizeof(Integer));
      value := c.Ep2W; SaveStream.Write(value, sizeof(Integer));
      value := c.Ep3; SaveStream.Write(value, sizeof(Integer));
      value := c.Ep3W; SaveStream.Write(value, sizeof(Integer));
      value := c.Equip1A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip1AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc1A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc1AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg1A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg1AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip1B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip1BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc1B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc1BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg1B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg1BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip2A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip2AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc2A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc2AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg2A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg2AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip2B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip2BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc2B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc2BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg2B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg2BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip3A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip3AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc3A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc3AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg3A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg3AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip3B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip3BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc3B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc3BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg3B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg3BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip4A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip4AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc4A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc4AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg4A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg4AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip4B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip4BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc4B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc4BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg4B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg4BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip5A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip5AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc5A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc5AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg5A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg5AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip5B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip5BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc5B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc5BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg5B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg5BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip6A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip6AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc6A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc6AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg6A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg6AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip6B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip6BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc6B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc6BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg6B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg6BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip7A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip7AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc7A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc7AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg7A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg7AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip7B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip7BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc7B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc7BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg7B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg7BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip8A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip8AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc8A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc8AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg8A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg8AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip8B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip8BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc8B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc8BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg8B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg8BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip9A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip9AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc9A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc9AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg9A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg9AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip9B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip9BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc9B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc9BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg9B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg9BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip10A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip10AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc10A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc10AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg10A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg10AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip10B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip10BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc10B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc10BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg10B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg10BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip11A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip11AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc11A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc11AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg11A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg11AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip11B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip11BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc11B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc11BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg11B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg11BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip12A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip12AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc12A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc12AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg12A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg12AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip12B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip12BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc12B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc12BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg12B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg12BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip13A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip13AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc13A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc13AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg13A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg13AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip13B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip13BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc13B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc13BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg13B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg13BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip14A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip14AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc14A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc14AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg14A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg14AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip14B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip14BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc14B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc14BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg14B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg14BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip15A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip15AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc15A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc15AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg15A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg15AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip15B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip15BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc15B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc15BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg15B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg15BW;   SaveStream.Write(value, sizeof(Integer));

      value := c.Equip16A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip16AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc16A;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc16AW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg16A;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg16AW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Equip16B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Equip16BW;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc16B;   SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_loc16BW;  SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg16B;    SaveStream.Write(value, sizeof(Integer));
      value := c.Eq_kg16BW;   SaveStream.Write(value, sizeof(Integer));


      value := c.mi1A;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi1AW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_locA;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_locAW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_kgA;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_kgAW;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi1B;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi1BW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_locB;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_locBW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_kgB;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi1_kgBW;  SaveStream.Write(value, sizeof(Integer));

      value := c.mi2A;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi2AW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_locA;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_locAW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_kgA;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_kgAW;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi2B;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi2BW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_locB;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_locBW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_kgB;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi2_kgBW;  SaveStream.Write(value, sizeof(Integer));

      value := c.mi3A;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi3AW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_locA;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_locAW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_kgA;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_kgAW;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi3B;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi3BW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_locB;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_locBW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_kgB;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi3_kgBW;  SaveStream.Write(value, sizeof(Integer));

      value := c.mi4A;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi4AW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_locA;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_locAW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_kgA;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_kgAW;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi4B;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi4BW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_locB;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_locBW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_kgB;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi4_kgBW;  SaveStream.Write(value, sizeof(Integer));

      value := c.mi5A;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi5AW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_locA;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_locAW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_kgA;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_kgAW;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi5B;      SaveStream.Write(value, sizeof(Integer));
      value := c.mi5BW;     SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_locB;  SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_locBW; SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_kgB;   SaveStream.Write(value, sizeof(Integer));
      value := c.mi5_kgBW;  SaveStream.Write(value, sizeof(Integer));

      value := c.note1; SaveStream.Write(value, sizeof(Integer));
      value := c.note1W; SaveStream.Write(value, sizeof(Integer));
      value := c.note2; SaveStream.Write(value, sizeof(Integer));
      value := c.note2W; SaveStream.Write(value, sizeof(Integer));
      value := c.note3; SaveStream.Write(value, sizeof(Integer));
      value := c.note3W; SaveStream.Write(value, sizeof(Integer));

      finally
         SaveStream.Free;
      end;
   end;
end;

procedure TForm1.CopyClick(Sender: TObject);
begin
   RichEdit1.ReadOnly := False;
   RichEdit1.CopyToClipboard;
   RichEdit1.ReadOnly := True;
end;

procedure TForm1.PrintSetup1Click(Sender: TObject);
begin
   PrinterSetupDialog1.Execute;
end;

procedure TForm1.Print1Click(Sender: TObject);
var
   last_start, last_length: integer;
begin
   if PrintDialog1.Execute then
   begin
        last_start := RichEdit1.SelStart;
        last_length := RichEdit1.SelLength;
        RichEdit1.SelectAll;
        RichEdit1.SelAttributes.Size := 10;
      RichEdit1.Print('');
        RichEdit1.SelAttributes.Size := 8;
        RichEdit1.SelStart := last_start;
        RichEdit1.SelLength := last_length;
   end;
end;

procedure TForm1.ToolButton3Click(Sender: TObject);
begin
   Print1.Click;
end;

procedure TForm1.Print2Click(Sender: TObject);
begin
   Print1.Click;
end;

procedure TForm1.OutputtoText1Click(Sender: TObject);
begin
   SaveDialog1.InitialDir := Fn;
   if char_act.Name <> '' then
      SaveDialog1.FileName := char_act.Name +'.txt' else
      SaveDialog1.FileName := '.txt';
   if SaveDialog1.Execute then
   begin
      RichEdit1.PlainText := True;
      RichEdit1.Lines.SaveToFile(SaveDialog1.FileName);
      RichEdit1.PlainText := False;
   end;
end;

procedure TForm1.BitBtn1Click(Sender: TObject);
begin
   if ceta > 0 then
      ceta := ceta -1
   else
      ceta := ceta +195;

           case (ceta-1) of
           0: Memo1.Lines.Add('race');
           1: Memo1.Lines.Add('sex');
           2: Memo1.Lines.Add('class');
           3: Memo1.Lines.Add('cp');
           4: Memo1.Lines.Add('cp_adj');
           5: Memo1.Lines.Add('St');
           6: Memo1.Lines.Add('St_adj');
           7: Memo1.Lines.Add('Hd');
           8: Memo1.Lines.Add('wounds1');
           9: Memo1.Lines.Add('wounds2');
           10: Memo1.Lines.Add('Dx');
           11: Memo1.Lines.Add('Dx_adj');
           12: Memo1.Lines.Add('Ap');
           13: Memo1.Lines.Add('wounds3');
           14: Memo1.Lines.Add('Iq');
           15: Memo1.Lines.Add('Iq_adj');
           16: Memo1.Lines.Add('Job');
           17: Memo1.Lines.Add('fatigue');
           18: Memo1.Lines.Add('fatigue2');
           19: Memo1.Lines.Add('Ma');
           20: Memo1.Lines.Add('Ma_adj');
           21: Memo1.Lines.Add('silver');
           22: Memo1.Lines.Add('fatigue3');
           23: Memo1.Lines.Add('Hx');
           24: Memo1.Lines.Add('able1');
           25: Memo1.Lines.Add('able2');
           26: Memo1.Lines.Add('able3');
           27: Memo1.Lines.Add('able4');
           28: Memo1.Lines.Add('able5');
           29: Memo1.Lines.Add('able6');
           30: Memo1.Lines.Add('able7');
           31: Memo1.Lines.Add('able8');
           32: Memo1.Lines.Add('able9');
           33: Memo1.Lines.Add('able10');
           34: Memo1.Lines.Add('able11');
           35: Memo1.Lines.Add('able12');
           36: Memo1.Lines.Add('able13');
           37: Memo1.Lines.Add('able14');
           38: Memo1.Lines.Add('able15');
           39: Memo1.Lines.Add('able16');
           40: Memo1.Lines.Add('study');
           41: Memo1.Lines.Add('study2');
           42: Memo1.Lines.Add('ready0');
           43: Memo1.Lines.Add('ready0_kg');
           44: Memo1.Lines.Add('ready1');
           45: Memo1.Lines.Add('ready1_kg');
           46: Memo1.Lines.Add('ready2');
           47: Memo1.Lines.Add('ready2_kg');
           48: Memo1.Lines.Add('secondary');
           49: Memo1.Lines.Add('secondary_kg');
           50: Memo1.Lines.Add('second2');
           51: Memo1.Lines.Add('second2_kg');
           52: Memo1.Lines.Add('belt');
           53: Memo1.Lines.Add('belt2');
           54: Memo1.Lines.Add('hidden');
           55: Memo1.Lines.Add('hidden2');
           56: Memo1.Lines.Add('worn');
           57: Memo1.Lines.Add('worn2');
           58: Memo1.Lines.Add('totalKg');
           59: Memo1.Lines.Add('pack');
           60: Memo1.Lines.Add('ma_2');
           61: Memo1.Lines.Add('ma_4');
           62: Memo1.Lines.Add('ma_6');
           63: Memo1.Lines.Add('max');
           64: Memo1.Lines.Add('Ep1');
           65: Memo1.Lines.Add('Ep2');
           66: Memo1.Lines.Add('Ep3');
           67: Memo1.Lines.Add('Equip1A');
           68: Memo1.Lines.Add('eq_loc1A');
           69: Memo1.Lines.Add('eq_kg1A');
           70: Memo1.Lines.Add('Equip1B');
           71: Memo1.Lines.Add('eq_loc1B');
           72: Memo1.Lines.Add('eq_kg1B');
           73: Memo1.Lines.Add('Equip2A');
           74: Memo1.Lines.Add('eq_loc2A');
           75: Memo1.Lines.Add('eq_kg2A');
           76: Memo1.Lines.Add('Equip2B');
           77: Memo1.Lines.Add('eq_loc2B');
           78: Memo1.Lines.Add('eq_kg2B');
           79: Memo1.Lines.Add('Equip3B');
           80: Memo1.Lines.Add('eq_loc3A');
           81: Memo1.Lines.Add('eq_kg3A');
           82: Memo1.Lines.Add('Equip3B');
           83: Memo1.Lines.Add('eq_loc3B');
           84: Memo1.Lines.Add('eq_kg3B');
           85: Memo1.Lines.Add('Equip4B');
           86: Memo1.Lines.Add('eq_loc4A');
           87: Memo1.Lines.Add('eq_kg4A');
           88: Memo1.Lines.Add('Equip4B');
           89: Memo1.Lines.Add('eq_loc4B');
           90: Memo1.Lines.Add('eq_kg24');
           91: Memo1.Lines.Add('Equip5B');
           92: Memo1.Lines.Add('eq_loc5A');
           93: Memo1.Lines.Add('eq_kg5A');
           94: Memo1.Lines.Add('Equip5B');
           95: Memo1.Lines.Add('eq_loc5B');
           96: Memo1.Lines.Add('eq_kg5B');
           97: Memo1.Lines.Add('Equip6B');
           98: Memo1.Lines.Add('eq_loc6A');
           99: Memo1.Lines.Add('eq_kg6A');
          100: Memo1.Lines.Add('Equip6B');
          101: Memo1.Lines.Add('eq_loc6B');
          102: Memo1.Lines.Add('eq_kg6B');
          103: Memo1.Lines.Add('Equip7B');
          104: Memo1.Lines.Add('eq_loc7A');
          105: Memo1.Lines.Add('eq_kg7A');
          106: Memo1.Lines.Add('Equip7B');
          107: Memo1.Lines.Add('eq_loc7B');
          108: Memo1.Lines.Add('eq_kg7B');
          109: Memo1.Lines.Add('Equip8B');
          110: Memo1.Lines.Add('eq_loc8A');
          111: Memo1.Lines.Add('eq_kg8A');
          112: Memo1.Lines.Add('Equip8B');
          113: Memo1.Lines.Add('eq_loc8B');
          114: Memo1.Lines.Add('eq_kg8B');
          115: Memo1.Lines.Add('Equip9B');
          116: Memo1.Lines.Add('eq_loc9A');
          117: Memo1.Lines.Add('eq_kg9A');
          118: Memo1.Lines.Add('Equip9B');
          119: Memo1.Lines.Add('eq_loc9B');
          120: Memo1.Lines.Add('eq_kg9B');
          121: Memo1.Lines.Add('Equip10B');
          122: Memo1.Lines.Add('eq_loc10A');
          123: Memo1.Lines.Add('eq_kg10A');
          124: Memo1.Lines.Add('Equip10B');
          125: Memo1.Lines.Add('eq_loc10B');
          126: Memo1.Lines.Add('eq_kg10B');
          127: Memo1.Lines.Add('Equip11B');
          128: Memo1.Lines.Add('eq_loc11A');
          129: Memo1.Lines.Add('eq_kg11A');
          130: Memo1.Lines.Add('Equip11B');
          131: Memo1.Lines.Add('eq_loc11B');
          132: Memo1.Lines.Add('eq_kg11B');
          133: Memo1.Lines.Add('Equip12B');
          134: Memo1.Lines.Add('eq_loc12A');
          135: Memo1.Lines.Add('eq_kg12A');
          136: Memo1.Lines.Add('Equip12B');
          137: Memo1.Lines.Add('eq_loc12B');
          138: Memo1.Lines.Add('eq_kg12B');
          139: Memo1.Lines.Add('Equip13B');
          140: Memo1.Lines.Add('eq_loc13A');
          141: Memo1.Lines.Add('eq_kg13A');
          142: Memo1.Lines.Add('Equip13B');
          143: Memo1.Lines.Add('eq_loc13B');
          144: Memo1.Lines.Add('eq_kg13B');
          145: Memo1.Lines.Add('Equip14B');
          146: Memo1.Lines.Add('eq_loc14A');
          147: Memo1.Lines.Add('eq_kg14A');
          148: Memo1.Lines.Add('Equip14B');
          149: Memo1.Lines.Add('eq_loc14B');
          150: Memo1.Lines.Add('eq_kg14B');
          151: Memo1.Lines.Add('Equip15B');
          152: Memo1.Lines.Add('eq_loc15A');
          153: Memo1.Lines.Add('eq_kg15A');
          154: Memo1.Lines.Add('Equip15B');
          155: Memo1.Lines.Add('eq_loc15B');
          156: Memo1.Lines.Add('eq_kg15B');
          157: Memo1.Lines.Add('Equip16B');
          158: Memo1.Lines.Add('eq_loc16A');
          159: Memo1.Lines.Add('eq_kg16A');
          160: Memo1.Lines.Add('Equip16B');
          161: Memo1.Lines.Add('eq_loc16B');
          162: Memo1.Lines.Add('eq_kg16B');
          163: Memo1.Lines.Add('mi1A');
          164: Memo1.Lines.Add('mi1_locA');
          165: Memo1.Lines.Add('mi1_kgA');
          166: Memo1.Lines.Add('mi1B');
           167: Memo1.Lines.Add('mi1_locB');
           168: Memo1.Lines.Add('mi1_kgB');
           169: Memo1.Lines.Add('mi2A');
           170: Memo1.Lines.Add('mi2_locA');
           171: Memo1.Lines.Add('mi2_kgA');
           172: Memo1.Lines.Add('mi2B');
           173: Memo1.Lines.Add('mi2_locB');
           174: Memo1.Lines.Add('mi2_kgB');
           175: Memo1.Lines.Add('mi3A');
           176: Memo1.Lines.Add('mi3_locA');
           177: Memo1.Lines.Add('mi3_kgA');
           178: Memo1.Lines.Add('mi3B');
           179: Memo1.Lines.Add('mi3_locB');
           180: Memo1.Lines.Add('mi3_kgB');
           181: Memo1.Lines.Add('mi4A');
           182: Memo1.Lines.Add('mi4_locA');
           183: Memo1.Lines.Add('mi4_kgA');
           184: Memo1.Lines.Add('mi4B');
           185: Memo1.Lines.Add('mi4_locB');
           186: Memo1.Lines.Add('mi4_kgB');
           187: Memo1.Lines.Add('mi5A');
           188: Memo1.Lines.Add('mi5_locA');
           189: Memo1.Lines.Add('mi5_kgA');
           190: Memo1.Lines.Add('mi5B');
           191: Memo1.Lines.Add('mi5_locB');
           192: Memo1.Lines.Add('mi5_kgB');
           193: Memo1.Lines.Add('note1');
           194: Memo1.Lines.Add('note2');
           195: Memo1.Lines.Add('note3');
           end; // case ceta
end;

procedure TForm1.BitBtn2Click(Sender: TObject);
begin
   if ceta < 195 then
      ceta := ceta +1
   else
      ceta := ceta -195;

           case (ceta-1) of
           0: Memo1.Lines.Add('race');
           1: Memo1.Lines.Add('sex');
           2: Memo1.Lines.Add('class');
           3: Memo1.Lines.Add('cp');
           4: Memo1.Lines.Add('cp_adj');
           5: Memo1.Lines.Add('St');
           6: Memo1.Lines.Add('St_adj');
           7: Memo1.Lines.Add('Hd');
           8: Memo1.Lines.Add('wounds1');
           9: Memo1.Lines.Add('wounds2');
           10: Memo1.Lines.Add('Dx');
           11: Memo1.Lines.Add('Dx_adj');
           12: Memo1.Lines.Add('Ap');
           13: Memo1.Lines.Add('wounds3');
           14: Memo1.Lines.Add('Iq');
           15: Memo1.Lines.Add('Iq_adj');
           16: Memo1.Lines.Add('Job');
           17: Memo1.Lines.Add('fatigue');
           18: Memo1.Lines.Add('fatigue2');
           19: Memo1.Lines.Add('Ma');
           20: Memo1.Lines.Add('Ma_adj');
           21: Memo1.Lines.Add('silver');
           22: Memo1.Lines.Add('fatigue3');
           23: Memo1.Lines.Add('Hx');
           24: Memo1.Lines.Add('able1');
           25: Memo1.Lines.Add('able2');
           26: Memo1.Lines.Add('able3');
           27: Memo1.Lines.Add('able4');
           28: Memo1.Lines.Add('able5');
           29: Memo1.Lines.Add('able6');
           30: Memo1.Lines.Add('able7');
           31: Memo1.Lines.Add('able8');
           32: Memo1.Lines.Add('able9');
           33: Memo1.Lines.Add('able10');
           34: Memo1.Lines.Add('able11');
           35: Memo1.Lines.Add('able12');
           36: Memo1.Lines.Add('able13');
           37: Memo1.Lines.Add('able14');
           38: Memo1.Lines.Add('able15');
           39: Memo1.Lines.Add('able16');
           40: Memo1.Lines.Add('study');
           41: Memo1.Lines.Add('study2');
           42: Memo1.Lines.Add('ready0');
           43: Memo1.Lines.Add('ready0_kg');
           44: Memo1.Lines.Add('ready1');
           45: Memo1.Lines.Add('ready1_kg');
           46: Memo1.Lines.Add('ready2');
           47: Memo1.Lines.Add('ready2_kg');
           48: Memo1.Lines.Add('secondary');
           49: Memo1.Lines.Add('secondary_kg');
           50: Memo1.Lines.Add('second2');
           51: Memo1.Lines.Add('second2_kg');
           52: Memo1.Lines.Add('belt');
           53: Memo1.Lines.Add('belt2');
           54: Memo1.Lines.Add('hidden');
           55: Memo1.Lines.Add('hidden2');
           56: Memo1.Lines.Add('worn');
           57: Memo1.Lines.Add('worn2');
           58: Memo1.Lines.Add('totalKg');
           59: Memo1.Lines.Add('pack');
           60: Memo1.Lines.Add('ma_2');
           61: Memo1.Lines.Add('ma_4');
           62: Memo1.Lines.Add('ma_6');
           63: Memo1.Lines.Add('max');
           64: Memo1.Lines.Add('Ep1');
           65: Memo1.Lines.Add('Ep2');
           66: Memo1.Lines.Add('Ep3');
           67: Memo1.Lines.Add('Equip1A');
           68: Memo1.Lines.Add('eq_loc1A');
           69: Memo1.Lines.Add('eq_kg1A');
           70: Memo1.Lines.Add('Equip1B');
           71: Memo1.Lines.Add('eq_loc1B');
           72: Memo1.Lines.Add('eq_kg1B');
           73: Memo1.Lines.Add('Equip2A');
           74: Memo1.Lines.Add('eq_loc2A');
           75: Memo1.Lines.Add('eq_kg2A');
           76: Memo1.Lines.Add('Equip2B');
           77: Memo1.Lines.Add('eq_loc2B');
           78: Memo1.Lines.Add('eq_kg2B');
           79: Memo1.Lines.Add('Equip3B');
           80: Memo1.Lines.Add('eq_loc3A');
           81: Memo1.Lines.Add('eq_kg3A');
           82: Memo1.Lines.Add('Equip3B');
           83: Memo1.Lines.Add('eq_loc3B');
           84: Memo1.Lines.Add('eq_kg3B');
           85: Memo1.Lines.Add('Equip4B');
           86: Memo1.Lines.Add('eq_loc4A');
           87: Memo1.Lines.Add('eq_kg4A');
           88: Memo1.Lines.Add('Equip4B');
           89: Memo1.Lines.Add('eq_loc4B');
           90: Memo1.Lines.Add('eq_kg24');
           91: Memo1.Lines.Add('Equip5B');
           92: Memo1.Lines.Add('eq_loc5A');
           93: Memo1.Lines.Add('eq_kg5A');
           94: Memo1.Lines.Add('Equip5B');
           95: Memo1.Lines.Add('eq_loc5B');
           96: Memo1.Lines.Add('eq_kg5B');
           97: Memo1.Lines.Add('Equip6B');
           98: Memo1.Lines.Add('eq_loc6A');
           99: Memo1.Lines.Add('eq_kg6A');
          100: Memo1.Lines.Add('Equip6B');
          101: Memo1.Lines.Add('eq_loc6B');
          102: Memo1.Lines.Add('eq_kg6B');
          103: Memo1.Lines.Add('Equip7B');
          104: Memo1.Lines.Add('eq_loc7A');
          105: Memo1.Lines.Add('eq_kg7A');
          106: Memo1.Lines.Add('Equip7B');
          107: Memo1.Lines.Add('eq_loc7B');
          108: Memo1.Lines.Add('eq_kg7B');
          109: Memo1.Lines.Add('Equip8B');
          110: Memo1.Lines.Add('eq_loc8A');
          111: Memo1.Lines.Add('eq_kg8A');
          112: Memo1.Lines.Add('Equip8B');
          113: Memo1.Lines.Add('eq_loc8B');
          114: Memo1.Lines.Add('eq_kg8B');
          115: Memo1.Lines.Add('Equip9B');
          116: Memo1.Lines.Add('eq_loc9A');
          117: Memo1.Lines.Add('eq_kg9A');
          118: Memo1.Lines.Add('Equip9B');
          119: Memo1.Lines.Add('eq_loc9B');
          120: Memo1.Lines.Add('eq_kg9B');
          121: Memo1.Lines.Add('Equip10B');
          122: Memo1.Lines.Add('eq_loc10A');
          123: Memo1.Lines.Add('eq_kg10A');
          124: Memo1.Lines.Add('Equip10B');
          125: Memo1.Lines.Add('eq_loc10B');
          126: Memo1.Lines.Add('eq_kg10B');
          127: Memo1.Lines.Add('Equip11B');
          128: Memo1.Lines.Add('eq_loc11A');
          129: Memo1.Lines.Add('eq_kg11A');
          130: Memo1.Lines.Add('Equip11B');
          131: Memo1.Lines.Add('eq_loc11B');
          132: Memo1.Lines.Add('eq_kg11B');
          133: Memo1.Lines.Add('Equip12B');
          134: Memo1.Lines.Add('eq_loc12A');
          135: Memo1.Lines.Add('eq_kg12A');
          136: Memo1.Lines.Add('Equip12B');
          137: Memo1.Lines.Add('eq_loc12B');
          138: Memo1.Lines.Add('eq_kg12B');
          139: Memo1.Lines.Add('Equip13B');
          140: Memo1.Lines.Add('eq_loc13A');
          141: Memo1.Lines.Add('eq_kg13A');
          142: Memo1.Lines.Add('Equip13B');
          143: Memo1.Lines.Add('eq_loc13B');
          144: Memo1.Lines.Add('eq_kg13B');
          145: Memo1.Lines.Add('Equip14B');
          146: Memo1.Lines.Add('eq_loc14A');
          147: Memo1.Lines.Add('eq_kg14A');
          148: Memo1.Lines.Add('Equip14B');
          149: Memo1.Lines.Add('eq_loc14B');
          150: Memo1.Lines.Add('eq_kg14B');
          151: Memo1.Lines.Add('Equip15B');
          152: Memo1.Lines.Add('eq_loc15A');
          153: Memo1.Lines.Add('eq_kg15A');
          154: Memo1.Lines.Add('Equip15B');
          155: Memo1.Lines.Add('eq_loc15B');
          156: Memo1.Lines.Add('eq_kg15B');
          157: Memo1.Lines.Add('Equip16B');
          158: Memo1.Lines.Add('eq_loc16A');
          159: Memo1.Lines.Add('eq_kg16A');
          160: Memo1.Lines.Add('Equip16B');
          161: Memo1.Lines.Add('eq_loc16B');
          162: Memo1.Lines.Add('eq_kg16B');
          163: Memo1.Lines.Add('mi1A');
          164: Memo1.Lines.Add('mi1_locA');
          165: Memo1.Lines.Add('mi1_kgA');
          166: Memo1.Lines.Add('mi1B');
           167: Memo1.Lines.Add('mi1_locB');
           168: Memo1.Lines.Add('mi1_kgB');
           169: Memo1.Lines.Add('mi2A');
           170: Memo1.Lines.Add('mi2_locA');
           171: Memo1.Lines.Add('mi2_kgA');
           172: Memo1.Lines.Add('mi2B');
           173: Memo1.Lines.Add('mi2_locB');
           174: Memo1.Lines.Add('mi2_kgB');
           175: Memo1.Lines.Add('mi3A');
           176: Memo1.Lines.Add('mi3_locA');
           177: Memo1.Lines.Add('mi3_kgA');
           178: Memo1.Lines.Add('mi3B');
           179: Memo1.Lines.Add('mi3_locB');
           180: Memo1.Lines.Add('mi3_kgB');
           181: Memo1.Lines.Add('mi4A');
           182: Memo1.Lines.Add('mi4_locA');
           183: Memo1.Lines.Add('mi4_kgA');
           184: Memo1.Lines.Add('mi4B');
           185: Memo1.Lines.Add('mi4_locB');
           186: Memo1.Lines.Add('mi4_kgB');
           187: Memo1.Lines.Add('mi5A');
           188: Memo1.Lines.Add('mi5_locA');
           189: Memo1.Lines.Add('mi5_kgA');
           190: Memo1.Lines.Add('mi5B');
           191: Memo1.Lines.Add('mi5_locB');
           192: Memo1.Lines.Add('mi5_kgB');
           193: Memo1.Lines.Add('note1');
           194: Memo1.Lines.Add('note2');
           195: Memo1.Lines.Add('note3');
           end; // case ceta

end;

procedure TForm1.upDateTapSheetRace;
var
   count, choice: integer;
begin
   if pageControl1.ActivePage <> TabSheetRace then
      pageControl1.ActivePage := TabSheetRace;

   choice := -1;
   for count := RaceCurrentTotal downto 1 do
   begin
       if ListBox1.Selected[count-1] then
          choice := count;
   end;
   if (choice > -1) and
      (choice <= RaceCurrentTotal) then
   begin
      count := SelectRace(choice);
      Label9.Caption := GetRaceName(count);
      if body[count].part.hand > 0 then Label14.Caption := 'Yes'
                                   else Label14.Caption := 'No';
      if (body[count].part.spells > 0) and
         (Stat[count].Iq_min > 7) then Label15.Caption := 'Yes'
                                  else Label15.Caption := 'No';
      if body[count].part.voice_box > 0 then Label16.Caption := 'Yes'
                                        else Label16.Caption := 'No';
      Label17.Caption := FloatToStr(body[count].part.aura);
   end else
      Label9.Caption := '';
end;

procedure TForm1.ListBox1KeyUp(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
   case key of
    VK_UP: begin
             upDateTapSheetRace;
           end;
    VK_RIGHT: begin
             upDateTapSheetRace;
           end;
    VK_DOWN: begin
             upDateTapSheetRace;
           end;
    VK_LEFT: begin
             upDateTapSheetRace;
           end;
    ord(#13): selectParent(ListBox1.ItemIndex +1);
   end;
end;

function TForm1.GetActivePage: integer;
begin
   result := -1;
   if PageControl1.ActivePage = TabSheetFormat then Result := 0;
   if PageControl1.ActivePage = TabSheetName then Result := 1;
   if PageControl1.ActivePage = TabSheetRace then Result := 2;
   if PageControl1.ActivePage = TabSheetSex then Result := 3;
   if PageControl1.ActivePage = TabSheetClass then Result := 4;
   if PageControl1.ActivePage = TabSheetStrength then Result := 5;
   if PageControl1.ActivePage = TabSheetDexterity then Result := 6;
   if PageControl1.ActivePage = TabSheetInteligence then Result := 7;
   if PageControl1.ActivePage = TabSheetMove then Result := 8;
   if PageControl1.ActivePage = TabSheetHand then Result := 9;
   if PageControl1.ActivePage = TabSheetArmor then Result := 10;
   if PageControl1.ActivePage = TabSheetJob then Result := 11;
   if PageControl1.ActivePage = TabSheetSilver then Result := 12;
   if PageControl1.ActivePage = TabSheetWounds then Result := 13;
   if PageControl1.ActivePage = TabSheetFatigue then Result := 14;
   if PageControl1.ActivePage = TabSheetAble then Result := 15;
   if PageControl1.ActivePage = TabSheetStudy then Result := 16;
   if PageControl1.ActivePage = TabSheetReady then Result := 17;
   if PageControl1.ActivePage = TabSheetSecond then Result := 18;
   if PageControl1.ActivePage = TabSheetBelt then Result := 19;
   if PageControl1.ActivePage = TabSheetHidden then Result := 20;
   if PageControl1.ActivePage = TabSheetWorn then Result := 21;
   if PageControl1.ActivePage = TabSheetKg then Result := 22;
   if PageControl1.ActivePage = TabSheetExperience then Result := 23;
   if PageControl1.ActivePage = TabSheetPack then Result := 24;
   if PageControl1.ActivePage = TabSheetMagic1 then Result := 25;
   if PageControl1.ActivePage = TabSheetMagic2 then Result := 26;
   if PageControl1.ActivePage = TabSheetMagic3 then Result := 27;
   if PageControl1.ActivePage = TabSheetMagic4 then Result := 28;
   if PageControl1.ActivePage = TabSheetMagic5 then Result := 29;
   if PageControl1.ActivePage = TabSheetNotes then Result := 30;
end;

procedure TForm1.PageControl1Change(Sender: TObject);
begin
      case GetActivePage of
        0: begin
              ListFormats;
           end;
        1: begin
              ListName;
           end;
        2: begin
              ListRaces;
           end;
        3: begin
              ListSex;
           end;
        4: begin
              ListClass;
           end;
        5: begin
              ListStrength;
           end;
        6: begin
              ListDexterity;
           end;
        7: begin
              ListInteligence;
           end;
        8: begin
              ListMovement;
           end;
        9: begin
              ListHand;
           end;
        10: begin
              ListArmor;
           end;
        11: begin
              ListJob;
           end;
        12: begin
              ListSilver;
           end;
        13: begin
              ListWounds;
           end;
        14: begin
              ListFatigue;
           end;
        15: begin
              ListAble;
           end;
        16: begin
              ListStudy;
           end;
        17: begin
              ListReady;
           end;
        18: begin
              ListSecond;
           end;
        19: begin
              ListBelt;
           end;
        20: begin
              ListHidden;
           end;
        21: begin
              ListWorn;
           end;
        22: begin
              ListKg;
           end;
        23: begin
              ListExperience;
           end;
        24: begin
              ListPack;
           end;
        25: begin
              ListMagic1;
           end;
        26: begin
              ListMagic2;
           end;
        27: begin
              ListMagic3;
           end;
        28: begin
              ListMagic4;
           end;
        29: begin
              ListMagic5;
           end;
        30: begin
              ListNotes;
           end;
      end;
end;

procedure TForm1.ListBox1DrawItem(Control: TWinControl; Index: Integer;
  Rect: TRect; State: TOwnerDrawState);
var
  myColor: TColor;
  myBrush: TBrush;
begin
  myBrush := TBrush.Create;
  with (Control as TListBox).Canvas do
  begin
    if not Odd(Index) then
      myColor := clWhite
    else
      myColor := clSilver;

    myBrush.Style := bsSolid;
    myBrush.Color := myColor;
    Windows.FillRect(handle, Rect, myBrush.Handle);
    Brush.Style := bsClear;
    TextOut(Rect.Left, Rect.Top,
            (Control as TListBox).Items[Index]);
    MyBrush.Free;
  end;
end;

end.
